March 8, 1995

Pltfilter is a package to plot filter responses.  It can plot impulse
response and frequency responses for a number of filter types.

Filter types:
  - Finite impulse response digital filter
  - All-pole digital filter
  - Cascaded second-order infinite impulse response filter sections
  - Cascaded second-order analog filter sections

Plot Devices:
 - PostScript file
 - PostScript file sent directly to a printer
 - Tektronix terminal (e.g. xterm terminal emulator)
 - Regis graphics terminal (e.g. VT240 terminal, dxterm terminal emulator)
 - Unix plot file

Pltfilter is available by anonymous ftp from TSP.EE.McGill.CA
in directory pub/tsp/pltfilter.

=============
Peter Kabal
Department of Electrical Engineering
McGill University
Montreal, Quebec
+1 514 398-7130   +1 514 398-4470 Fax
kabal@TSP.EE.McGill.CA

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DRWHAX (IX0, IY0, LENX, XMIN, XMAX,
*                        ATICK, ALABEL, NTICK, IFN)
*
*
* Purpose:
*     Draw a labelled horizontal axis
*
*
* Description:
*     A horizontal axis with tick marks to mark intervals is drawn from
*     the given origin.  This routine uses the character size in effect
*     to determine the character size for the labels.  In addition,
*     axis tick marks scale with the height of the characters.
*
*
* Parameters:
* I ->  IX0    - X coordinate of the start of the axis (plotting units)
* I ->  IY0    - Y coordinate of the start of the axis (plotting units)
* I ->  LENX   - Length of the axis (plotting units)
* R ->  XMIN   - Data value corresponding to the start of the axis
*                (data units)
* R ->  XMAX   - Data value corresponding to the end of the axis
*                (data units)
* R ->  ATICK  - Array of data values at which ticks are to be placed.
*                If a data value lies outside the range spanned by the
*                axis [XMIN to XMAX], the corresponding tick is not
*                drawn.
* C ->  ALABEL - Character array of labels to be placed beside the tick
*                marks.  The labels are centered above or below the
*                ticks.  For the purpose of determining the length of
*                the label, a null character if present, marks the end
*                of the string.  The label array is in one-to-one
*                correspondence with the array of tick locations.  Even
*                for an unlabelled axis,  whether a label has zero
*                length or not affects the size of the corresponding
*                axis tick.
* I ->  NTICK  - The absolute value of NTICK is the number of ticks
*                specified in ATICK.  If NTICK is positive, the
*                corresponding labels are drawn above or below the
*                ticks. If NTICK is negative, only the ticks are drawn.
* I ->  IFN    - Control variable,
*                   Positive - Axis ticks are drawn above the axis.
*                              Labels are drawn below the axis.
*                   Zero -     Axis ticks are drawn on both sides of
*                              the axis.  Labels are drawn below the
*                              axis.
*                   Negative - Axis ticks are drawn below the axis.
*                              Labels are drawn above the axis.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:27:47 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DRWHAX (IX0, IY0, LENX, XMIN, XMAX,
     -                   ATICK, ALABEL, NTICK, IFN)


      REAL W0,W1,YSP
      PARAMETER (W0=0.3333333333,W1=0.5,YSP=0.8333333333)

      INTEGER IX0,IY0,LENX,NTICK,IFN
      INTEGER IW,IH,IW0,IW1,IYS,IYD0,IYU0,IYD1,IYU1,
     -        ICENT,IY,I,IX,NC
      INTEGER LENNUL

      REAL XMIN,XMAX
      REAL ATICK(*)
      REAL ANG,PVX

      CHARACTER*(*) ALABEL(*)


* Draw the axis
      CALL XYVECT(IX0,IY0,IX0+LENX,IY0)

* Determine the offsets for ticks and labels
* IYD0 and IYU0 are used for unlabelled ticks, while
* IYD1 and IYU1 are used for labelled ticks
      CALL GETCHR(IW,IH,ANG)
      CALL SETCHR(IW,IH,0.0)
      IW0=NINT(W0*IH)
      IW1=NINT(W1*IH)
      IYS=NINT(YSP*IH)
      IF (IFN.GT.0) THEN
        IYD0=0
        IYU0=+IW0
        IYD1=0
        IYU1=+IW1
        ICENT=5
        IY=-IYS
      ELSE IF (IFN.LT.0) THEN
        IYD0=-IW0
        IYU0=0
        IYD1=-IW1
        IYU1=0
        ICENT=3
        IY=+IYS
      ELSE
        IYD0=-IW0
        IYU0=+IW0
        IYD1=-IW1
        IYU1=+IW1
        ICENT=5
        IY=-IYS
      END IF


      PVX=LENX/(XMAX-XMIN)
      DO 100 I=1,ABS(NTICK)

        IX=NINT((ATICK(I)-XMIN)*PVX)
        IF (IX.GE.0 .AND. IX.LE.LENX) THEN

* Find the length of the label string
          NC=LENNUL(ALABEL(I))
          IF (NC.GT.0) THEN

* Labelled ticks
* Centre the label string above or below the tick
            CALL XYVECT(IX0+IX,IY0+IYD1,IX0+IX,IY0+IYU1)
            IF (NTICK.GT.0)
     -        CALL PLTEXT(IX0+IX,IY0+IY,ICENT,ALABEL(I)(1:NC))

          ELSE

* Unlabelled ticks
            CALL XYVECT(IX0+IX,IY0+IYD0,IX0+IX,IY0+IYU0)

          END IF

        END IF

 100  CONTINUE

* Restore the character angle
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE ABSCAL (X, NPT, XMIN, XMAX, NFREQ, IPLOT, IFAXIS,
*                         XLABEL, NCXL, XUNITS, NCXU)
*
*
* Purpose:
*     Determine an abscissa scale for a filter response plot
*
*
* Description:
*     The abscissa can represent either frequency or time.  If the
*     frequency scale can be expressed in kHz, MHz or GHz, appropriate
*     scaling of the minimum and maximum frequency values is done.  The
*     time scale, if it can be expressed in ms, us, ns, or ps is also
*     scaled.
*
*
* Parameters:
* R <-> X      - Abscissa samples, returned scaled if necessary
* I ->  NPT    - Number of samples
* R <-> XMIN   - Minimum value, returned scaled if necessary
* R <-> XMAX   - Maximum value, returned scaled if necessary
* L ->  NFREQ  - Logical variable, .TRUE. if normalized frequency is
*                being used.
* I ->  IPLOT  - Type of plot,
*                1 - linear amplitude
*                2 - dB amplitude
*                3 - log amplitude
*                4 - group delay
*                5 - phase response
*                6 - radian phase
*                7 - impulse response
* I ->  IFAXIS - Frequency axis options,
*                0 - linear frequency (Hz)
*                1 - log frequency (Hz)
*                2 - linear radian frequency
*                3 - log radian frequency
* C <-  XLABEL - "Normalized Frequency", "Frequency" or
*                "Time"
* I <-  NCXL   - Number of characters in XLABEL (max 24)
* C <-  XUNITS - "Hz", "kHz", "MHz", or "GHz" for frequency axes,
*                "P rad" for radian frequency axes,
*                "samples", "sec", "ms", "us", "ns", or "ps" for
*                time axes
* I <-  NCXU   - Number of characters in XUNITS (max 7)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:45:26 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE ABSCAL (X, NPT, XMIN, XMAX, NFREQ, IPLOT, IFAXIS,
     -                   XLABEL, NCXL, XUNITS, NCXU)


      INTEGER TICKV,EXACTV
      PARAMETER (TICKV=1,EXACTV=2)
      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -           IMPLR=7)
      INTEGER LINS,LOGS,CFREQ,RFREQ
      PARAMETER (LINS=0,LOGS=1,CFREQ=0,RFREQ=1)

      INTEGER NPT,IPLOT,IFAXIS,NCXL,NCXU
      INTEGER ILL,IUL,ILOG,IRAD,IEXP
      INTEGER IEXPSC,LENSTR

      LOGICAL NFREQ

      CHARACTER*(*) XLABEL,XUNITS
      CHARACTER*1 CPI,CMU

      REAL X(NPT)
      REAL XMIN,XMAX
      REAL VMIN,VMAX,SF


* Get the exponent of the scaling factor
      VMIN=XMIN
      VMAX=XMAX
      ILL=EXACTV
      IUL=EXACTV
      IF (VMIN.GE.VMAX) THEN
        CALL AMINMX(X,NPT,VMIN,VMAX)
        ILL=TICKV
        IUL=TICKV
      END IF
      ILOG=MOD(IFAXIS,2)
      IRAD=MOD(IFAXIS/2,2)
      IEXP=IEXPSC(VMIN,VMAX,ILL,IUL,ILOG)

* Frequency axes
      IF (IPLOT.NE.IMPLR) THEN

        IF (NFREQ) THEN
          XLABEL='Normalized Frequency'
          IF (IRAD.EQ.CFREQ) THEN
            XUNITS='Hz'
            SF=1.
          ELSE
            CPI=CHAR(182)
            XUNITS=CPI//' rad'
            SF=2.
          END IF

* Scale frequency range to kHz, MHz or GHz
        ELSE IF (IRAD.EQ.CFREQ) THEN
          XLABEL='Frequency'
          IF (IEXP.EQ.3) THEN
            XUNITS='kHz'
            SF=1E-3
          ELSE IF (IEXP.EQ.6) THEN
            XUNITS='MHz'
            SF=1E-6
          ELSE IF (IEXP.EQ.9) THEN
            XUNITS='GHz'
            SF=1E-9
          ELSE
            XUNITS='Hz'
            SF=1.
          END IF

* Radian frequency
        ELSE
          XLABEL='Frequency'
          CPI=CHAR(182)
          XUNITS=CPI//' rad'
          SF=2.

        END IF

* Time response
      ELSE

        IF (NFREQ) THEN
          XLABEL='Normalized Time'
          XUNITS='samples'
          SF=1.

* Scale time range to ms, us, ns, or ps
        ELSE
          XLABEL='Time'
          IF (IEXP.EQ.-3) THEN
            XUNITS='ms'
            SF=1E+3
          ELSE IF (IEXP.EQ.-6) THEN
            CMU=CHAR(181)
            XUNITS=CMU//'s'
            SF=1E+6
          ELSE IF (IEXP.EQ.-9) THEN
            XUNITS='ns'
            SF=1E+9
          ELSE IF (IEXP.EQ.-12) THEN
            XUNITS='ps'
            SF=1E+12
          ELSE
            XUNITS='sec'
            SF=1.
          END IF

        END IF

      END IF

* Scale the data
      IF (SF.NE.1.) THEN
        XMIN=SF*XMIN
        XMAX=SF*XMAX
        CALL VSMULN(X,SF,X,NPT)
      END IF

* See if a power of ten annotation will be added
      IEXP=IEXPSC(SF*VMIN,SF*VMAX,ILL,IUL,ILOG)

* Return the number of characters in the strings
      NCXL=LENSTR(XLABEL)
      IF (IEXP.NE.0) NCXL=NCXL+6
      NCXU=LENSTR(XUNITS)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE LOCEXT (Y, NPT, MXNEXT, IEXT, NEXT)
*
*
* Purpose:
*     Find the local extrema in a vector of values
*
*
* Description:
*     This subroutine examines an array of data for local extema.  The
*     positions of these extrema is recorded in an array of indices.
*     The absolute value of each index gives the position of an
*     extremum (1 to NPT), while the sign indicates whether the
*     extremum is a maximum (positive) or a minimum (negative).  For
*     an extremum which is in a region of constant values, the mid-
*     epoint is returned (rounded down for an even number of constant
*     values).  For an array which is entirely constant, the number of
*     extrema is set to zero.
*
*
* Parameters:
* R ->  Y      - Input array of data values
* I ->  NPT    - Number of data values
* I ->  MXNEXT - Maximum number of extrema to be found
* I <-  IEXT   - Array of indices.  The absolute value of each element
*                indicates the postion of an extremum,
*                1 <= ABS(IEXT(i)) <= NPT.  The sign of the elements
*                indicate whether the extremum is a maximum or a
*                minimum.  The indices are returned in ascending order,
*                with alternating signs.
* I <-  NEXT   - Number of extrema found.  Note that NEXT may be zero
*                if the data values are constant and NEXT can be larger
*                than MXNEXT.  In this case IEXT contains the locations
*                first MXNEXT extrema.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:24:23 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE LOCEXT (Y, NPT, MXNEXT, IEXT, NEXT)


      INTEGER NPT,MXNEXT,NEXT
      INTEGER L,IBC,MAXS,I
      INTEGER IEXT(MXNEXT)

      REAL Y(NPT)


* Search for extrema in the array
* MAXS indicates whether searching for a maximum or a minimum
* +1 maximum, -1 minimum, 0 any change
* IBC records the position of the last value which was different
* from its predecessor.  It is used to find the midpoint of a
* constant region.
      L=0
      IBC=1
      MAXS=0
      DO 100 I=2,NPT

        IF (Y(I).LT.Y(I-1)) THEN
          IF (MAXS.GE.0) THEN
            L=L+1
            IF (L.LE.MXNEXT) IEXT(L)=+((I-1-IBC)/2+IBC)
          END IF
          MAXS=-1
          IBC=I
        ELSE IF (Y(I).GT.Y(I-1)) THEN
          IF (MAXS.LE.0) THEN
            L=L+1
            IF (L.LE.MXNEXT) IEXT(L)=-((I-1-IBC)/2+IBC)
          END IF
          MAXS=+1
          IBC=I
        END IF

 100  CONTINUE

* Check the last point
      IF (NPT.GT.1) THEN
        IF (Y(NPT).LT.Y(NPT-1)) THEN
          L=L+1
          IF (L.LE.MXNEXT) IEXT(L)=-NPT
        ELSE IF (Y(NPT).GT.Y(NPT-1)) THEN
          L=L+1
          IF (L.LE.MXNEXT) IEXT(L)=+NPT
        ELSE
          IF (MAXS.GT.0) THEN
            L=L+1
            IF (L.LE.MXNEXT) IEXT(L)=+((NPT-IBC)/2+IBC)
          ELSE IF (MAXS.LT.0) THEN
            L=L+1
            IF (L.LE.MXNEXT) IEXT(L)=-((NPT-IBC)/2+IBC)
          END IF
        END IF
      END IF

* Return the number of extrema found
      NEXT=L


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSYERR (STRING)
*
*
* Purpose:
*     Print a system error message and stop
*
*
* Description:
*     This routine prints a system error message.  The system error
*     message is printed using PERROR.  The preamble string is obtained
*     from the command name portion of the command line.  After
*     printing the system error message, the input string is printed
*     on the standard error unit (unit 0), and execution is terminated
*     by invoking EXIT(255).
*
*
* Parameters:
* C ->  STRING - Message string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:44:12 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSYERR (STRING)


      INTEGER NC

      CHARACTER*(*) STRING
      CHARACTER*255 IMAGNM


* Get the name of the command used to invoke the program
      CALL GETIMG(IMAGNM,NC)

* Print the system error message
      CALL PERROR(IMAGNM(1:NC))
      CALL HALT(STRING)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GETUSR (USERNM, NC)
*
*
* Purpose:
*     Get the user name
*
*
* Description:
*     This routine returns a string containing the host machine and
*     user name in the form "user@host".  The host name may be a simple
*     name or the fully qualified internet name, depending on the
*     string returned by the system function HOSTNM.
*
*
* Parameters:
* C <-  USERNM - Output string
* I <-  NC     - Number of characters set in USERNM
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:44:01 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GETUSR (USERNM, NC)


      INTEGER NC
      INTEGER ISTAT,NCH,NCU
      INTEGER LENBLK

      CHARACTER*(*) USERNM
      CHARACTER*40 USER
      CHARACTER*256 HOST

      INTEGER HOSTNM


* Get the host name
      ISTAT=HOSTNM(HOST)
      IF (ISTAT.NE.0)
     -  CALL PSYERR('GETUSR - System error return from HOSTNM')
      NCH=LENBLK(HOST)

* Get the user name
* First try the environment variable USER, then the GETLOG system function,
* and then the environment variable LOGNAME
      CALL GETENV('USER',USER)
      NCU=LENBLK(USER)
      IF (NCU.EQ.0) THEN
        CALL GETLOG(USER)
        NCU=LENBLK(USER)
        IF (NCU.EQ.0) THEN
          CALL GETENV('LOGNAME',USER)
          NCU=LENBLK(USER)
        END IF
      END IF

* Copy the host and user names to the output string
      USERNM=USER(1:NCU)//'@'//HOST(1:NCH)
      NC=NCH+NCU+1
      IF (NC.GT.LEN(USERNM)) THEN
        CALL WARN('GETUSR - Output string truncated')
        NC=LEN(USERNM)
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GETDAT (DATTIM)
*
*
* Purpose:
*     Get the date and time as a string
*
*
* Description:
*     This routine returns a string containing the date and time. The
*     format of the returned string depends on the length of the
*     string.
*       24 characters or more:
*         Sun May 11 13:55:45 1988
*       20-23 characters:
*         May 11 13:55:45 1988
*       17-19 characters:
*         May 11 13:55 1988
*       11-18 characters:
*         May 11 1988
*
*
* Parameters:
* C <-  DATTIM - Output character string containing the date and time.
*                The full length string is 24 characters long.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:43:55 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GETDAT (DATTIM)


      INTEGER LEND

      CHARACTER*(*) DATTIM
      CHARACTER*24 STIME


* Get the date and time
      CALL FDATE(STIME)

* Selectively leave out parts of the date/time
      LEND=LEN(DATTIM)
      IF (LEND.GE.24) THEN
        DATTIM=STIME
      ELSE IF (LEND.GE.20) THEN
        DATTIM=STIME(5:)
      ELSE IF (LEND.GE.17) THEN
        DATTIM=STIME(5:16)//STIME(20:)
      ELSE IF (LEND.GE.11) THEN
        DATTIM=STIME(5:10)//STIME(20:)
      ELSE
        DATTIM=STIME(5:10)//STIME(20:)
        CALL WARN('GETDAT - Output string truncated')
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     integer function iceil (k, l)
*
*
* Purpose:
*     Calculate the ceiling function of a ratio of integers
*
*
* Description:
*     This function calculate the ceiling function of k/l.  It returns
*     the smallest integer that is greater than or equal to the
*     quotient.
*
*
* Parameters:
* I <-  iceil - Resultant value
*
* I ->  k     - Numerator integer value
* I ->  l     - Denominator integer value
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:26:39 $
*
*
*-----------------------------------------------------------------------

      integer function iceil (k, l)


      integer k,l
      integer la,ka


* Find the signs of the input terms
* Find ka and la, such that ka/la=k/l where la is positive
      if (l.gt.0) then
        la=l
        ka=k
      else
        la=-l
        ka=-k
      end if

* Integer division forms the correct result for negative numbers
      if (ka.le.0) then
        iceil=ka/la
      else
        iceil=(ka-1)/la +1
       end if


      return

      end

*--------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE QPRINT (FNAME, QNAME, FORM, DELF, NOTF)
*
*
* PURPOSE:
*	This routine queues a print job to a specified queue.
*
*
* DESCRIPTION:
*	This routine queues a print job. The form to be used, and the
*	delete and notify flags can be specified.
*
*
* PARAMETERS:
* ->	FNAME  - File name
* ->	QNAME  - Queue name. A null string gives SYS$PRINT.
* ->	FORM   - Character string specifying the form to be used,
*	         A null string gives the default form.
* ->	DELF   - Logical value. DELF should be set to .TRUE. if the
*	         file is to be deleted after printing.
* ->	NOTF   - Logical value. NOTF should be set to .TRUE. if the
*	         notification of print job status is to be broadcase
*	         to the caller.
*
* ROUTINES REQUIRED:
*	LENSTR - Find the length of a string
*	LIB$SIGNAL - Signal an error condition
*	MESS   - Write a message
*	SYS$SNDJBCW - System routine to queue a job
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	89/04/03
*
*
* UPDATES:
*
*
*--------------------------INRS-Telecommunications---------------------------

	SUBROUTINE QPRINT (FNAME, QNAME, FORM, DELF, NOTF)


	INCLUDE '($SJCDEF)'

* Define item list and status block
	STRUCTURE /ITMLST/
	  UNION
	    MAP
	      INTEGER*2 BUFLEN,ITMCOD
	      INTEGER*4 BUFADR,RETADR
	    END MAP
	    MAP
	      INTEGER*4 END_LIST
	    END MAP
	  END UNION
	END STRUCTURE

	STRUCTURE /IOSBLK/
	  INTEGER*4 STS,ZEROED
	END STRUCTURE

	RECORD /ITMLST/ SUBMIT_LIST(7)
	RECORD /IOSBLK/ IOSB

	CHARACTER*(*) FNAME,QNAME,FORM
	CHARACTER*255 JOB_STATUS

	INTEGER*4 SYS$SNDJBCW,ISTAT

	INTEGER*2 NCJS

	LOGICAL NOTF,DELF


* Fill in the item list
	SUBMIT_LIST(1).BUFLEN=LENSTR(QNAME)
	SUBMIT_LIST(1).ITMCOD=SJC$_QUEUE
	SUBMIT_LIST(1).BUFADR=%LOC(QNAME)
	SUBMIT_LIST(1).RETADR=0

	SUBMIT_LIST(2).BUFLEN=LENSTR(FNAME)
	SUBMIT_LIST(2).ITMCOD=SJC$_FILE_SPECIFICATION
	SUBMIT_LIST(2).BUFADR=%LOC(FNAME)
	SUBMIT_LIST(2).RETADR=0

	SUBMIT_LIST(3).BUFLEN=0
	IF (NOTF) THEN
	  SUBMIT_LIST(3).ITMCOD=SJC$_NOTIFY
	ELSE
	  SUBMIT_LIST(3).ITMCOD=SJC$_NO_NOTIFY
	END IF
	SUBMIT_LIST(3).BUFADR=0
	SUBMIT_LIST(3).RETADR=0

	SUBMIT_LIST(4).BUFLEN=0
	IF (DELF) THEN
	  SUBMIT_LIST(4).ITMCOD=SJC$_DELETE_FILE
	ELSE
	  SUBMIT_LIST(4).ITMCOD=SJC$_NO_DELETE_FILE
	END IF
	SUBMIT_LIST(4).BUFADR=0
	SUBMIT_LIST(4).RETADR=0

	SUBMIT_LIST(5).BUFLEN=LEN(JOB_STATUS)
	SUBMIT_LIST(5).ITMCOD=SJC$_JOB_STATUS_OUTPUT
	SUBMIT_LIST(5).BUFADR=%LOC(JOB_STATUS)
	SUBMIT_LIST(5).RETADR=%LOC(NCJS)

	IF (LENSTR(FORM).GT.0) THEN
	  SUBMIT_LIST(6).BUFLEN=LENSTR(FORM)
	  SUBMIT_LIST(6).ITMCOD=SJC$_FORM_NAME
	  SUBMIT_LIST(6).BUFADR=%LOC(FORM)
	  SUBMIT_LIST(6).RETADR=0
	  NITEM=6
	ELSE
	  NITEM=5
	END IF

	SUBMIT_LIST(NITEM+1).END_LIST=0

* Call the system service
	ISTAT=SYS$SNDJBCW(,%VAL(SJC$_ENTER_FILE),,SUBMIT_LIST,IOSB,,)
	IF (ISTAT) ISTAT=IOSB.STS

	IF (.NOT.ISTAT) CALL LIB$SIGNAL(%VAL(ISTAT))

	IF (NOTF) THEN
	  CALL MESS(JOB_STATUS(1:NCJS))
	END IF


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION INDEXR (STRING, PATTRN)
*
*
* Purpose:
*     Find the last occurrence of a string in a string
*
*
* Description:
*     This routine returns the index of the last occurrence of a
*     string.  It uses the Fortran function INDEX to determine the
*     index corresponding to the last match.
*
*
* Parameters:
* I <-  INDEXR - Position of the last match. The value zero is returned
*                if there is no match.
*
* C ->  STRING - Input string
* C ->  PATTRN - Pattern string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:00 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION INDEXR (STRING, PATTRN)


      INTEGER IND,LENS,I

      CHARACTER*(*) STRING,PATTRN


      IND=0
      LENS=LEN(STRING)

 100  IF (IND.LT.LENS) THEN
        I=INDEX(STRING(IND+1:),PATTRN)
        IF (I.EQ.0) GO TO 200
        IND=IND+I
      GO TO 100
      END IF

 200  INDEXR=IND


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PFSETY (IPLOT, FLTTYP, H, NCOF, SFREQ, X, Y, NPT)
*
*
* Purpose:
*     Set the array of ordinate values for a filter response
*
*
* Description:
*     This routine sets the Y-array for a filter response plot.
*
*
* Parameters:
* I ->  IPLOT  - Type of plot,
*                1 - linear amplitude
*                2 - dB amplitude
*                3 - log amplitude
*                4 - group delay
*                5 - phase response
*                6 - radian phase
*                7 - impulse response
* C ->  FLTTYP - Character string indicating the type of filter,
*                ALL - all-pole filter
*                CAS - cascade analog filter
*                FIR - finite impulse response filter
*                IIR - infinite impulse response filter
*                WIN - window response
* R ->  H      - Array of filter coefficients
* I ->  NCOF   - Number of filter coefficients
* R ->  SFREQ  - Sampling frequency
* R ->  X      - Input array of abscissa values at which the response
*                is to be calculated
* R <-  Y      - Output array of response values
* I ->  NPT    - Number of abscissa and response values
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:46:25 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PFSETY (IPLOT, FLTTYP, H, NCOF, SFREQ, X, Y, NPT)


      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -           IMPLR=7)
      REAL PI
      PARAMETER (PI=3.141 592 654)

      INTEGER IPLOT,NCOF,NPT
      INTEGER IST

      CHARACTER*(*) FLTTYP

      REAL H(0:NCOF-1),X(0:NPT-1),Y(0:NPT-1)
      REAL SFREQ

      EXTERNAL FMAGRP,GDELRP,PHASRP
      REAL FMAGRP,GDELRP,PHASRP

* All-pole filter warning message
      IF (FLTTYP.EQ.'ALL' .AND. H(0).NE.1.0)
     -    CALL WARN('PFSETY - Non-unity first coefficient')

* Calculate the frequency response
      IF (IPLOT.EQ.LINAR .OR. IPLOT.EQ.LOGAR .OR. IPLOT.EQ.DBAR) THEN
        CALL FRRESP(X,Y,NPT,H,NCOF,FLTTYP,SFREQ,FMAGRP)
        IF (IPLOT.EQ.DBAR) CALL VDBV(Y,Y,NPT)

* Calculate the group delay
      ELSE IF (IPLOT.EQ.DELYR) THEN
        CALL FRRESP(X,Y,NPT,H,NCOF,FLTTYP,SFREQ,GDELRP)

* Calculate the phase response
      ELSE IF (IPLOT.EQ.PHASD .OR. IPLOT.EQ.PHASR) THEN
        CALL FRRESP(X,Y,NPT,H,NCOF,FLTTYP,SFREQ,PHASRP)
        IF (IPLOT.EQ.PHASD) THEN
          CALL VSMULN(Y,180./PI,Y,NPT)
        ELSE
          CALL VSMULN(Y,1./PI,Y,NPT)
        END IF

* Calculate the impulse response
      ELSE IF (IPLOT.EQ.IMPLR) THEN
        IST=NINT(X(0)*SFREQ)
        CALL IMPLRP(H,NCOF,FLTTYP,IST,Y,NPT)

* Unknown plot option
      ELSE
        CALL HALT('PFSETY - Invalid plot option')

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE SFPW10 (IX0, IY0, ICENT, IEXP)
*
*
* Purpose:
*     Plot a power of 10 scale factor
*
*
* Description:
*     This subroutine prints a scale factor of the form 10**IEXP at a
*     given location on a plot.  The scale factor is printed at the
*     current character plotting angle.  This routine also uses the
*     character size in effect to determine the character sizew.
*
*
* Parameters:
* I ->  IX0    - X coordinate of the lower right hand corner of the
*                scale factor
* I ->  IY0    - Y coordinate of the lower right hand corner of the
*                scale factor
* I ->  ICENT  - Centering option specifying the location of reference
*                point for the plotted text.  The plotted text can be
*                considered to be contained in a box.  ICENT specifies
*                the position of the reference point in that box as
*                shown in the table below.  The designations (left,
*                centre, right and top, centre, bottom) refer to
*                positions of the box containing the string before the
*                string is rotated to the desired plotting angle.
*                          Left     Centre    Right
*                    Top     2---------5---------8
*                    Centre  1         4         7
*                    Bottom  0---------3---------6
* I ->  IEXP   - Exponent of the scale factor
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:59 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE SFPW10 (IX0, IY0, ICENT, IEXP)


      INTEGER IX0,IY0,ICENT,IEXP
      INTEGER NC,IW,IH,ICENTW,ICENTH,IXR,IYR,IXC,IYC,IWN,IHN

      REAL ANG,W,H,Y,X

      CHARACTER*3 SLABEL


* Convert the exponent to a character string
      CALL LABEL(REAL(IEXP),3,SLABEL,NC)

* Get the character size and angle

* Format:
*                                       . . . . .   . o o o .
*                                       .       .   o.      o
*            . . . o . . . .o.o.o.o. .  .       .   .       o
*  . . . . . .  o  o     . o       o .  o o o o o   .   o o .
*  .       . .     o     . o       o .  .       .   .       o
*  o       o .     o     . o       o .  .       .   o       o
*  . o   o . .     o     . o       o .  . . . . .   . o o o .
*  .   o   . .     o     . o       o .
*  . o   o . .     o     . o       o .
*  o . . . o .     o     . o       o .
*            .     o     . o       o .  |----(1.5*n-0.5)----|
*            . .o. o .o. . .o.o.o.o. .
*
*  |--(1)--|-|---(1.5)---|---(1.5)---|--|--(1)--|---|--(1)--|
*  |      (1/4)                      (3/8)      (1/2)       |
*  a          units of character widths                     b
*
* The width of the plotted characters is (4.125+1.5*n)*W,
* where n is the number of characters in the representation of the
* exponent and W is the character width for the small characters.
* The height of the plotted characters is 1.75*H where H is the
* height of the small characters

* Width centering
      CALL GETCHR(IW,IH,ANG)
      ICENTW=ICENT/3
      IF (ICENTW.EQ.0) THEN
        W=0.0
      ELSE IF (ICENTW.EQ.1) THEN
        W=(2.0625+0.75*NC)*IW
      ELSE
        W=(4.125+1.5*NC)*IW
      END IF

* Height centering
      ICENTH=MOD(ICENT,3)
      IF (ICENTH.EQ.0) THEN
        H=0.0
      ELSE IF (ICENTH.EQ.1) THEN
        H=0.875*IH
      ELSE
        H=1.75*IH
      END IF

* Calculate the rotated offset
* (IXC,IYC) is in the lower left hand corner
      CALL ROTPTC(W,H,ANG,IXR,IYR)
      IXC=IX0-IXR
      IYC=IY0-IYR

* Print the scale factor
*   Small characters
      Y=0.25*IH
      CALL ROTPTC(0.0,Y,ANG,IXR,IYR)
      CALL PLTEXT(IXC+IXR,IYC+IYR,0,'x')

      X=4.625*IW
      Y=0.75*IH
      CALL ROTPTC(X,Y,ANG,IXR,IYR)
      CALL PLTEXT(IXC+IXR,IYC+IYR,0,SLABEL(1:NC))

*   Large characters: set the character size
      IWN=NINT(1.5*IW)
      IHN=NINT(1.5*IH)
      CALL SETCHR(IWN,IHN,ANG)

      X=1.25*IW
      CALL ROTPTC(X,0.0,ANG,IXR,IYR)
      CALL PLTEXT(IXC+IXR,IYC+IYR,0,'1')

      X=2.75*IW
      CALL ROTPTC(X,0.0,ANG,IXR,IYR)
      CALL PLTEXT(IXC+IXR,IYC+IYR,0,'0')

* Restore the character sizes
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE AMINMX (X, N, XMIN, XMAX)
*
*
* Purpose:
*     Accumulate the minimum and maximum values in an array
*
*
* Description:
*     Given initial minimum and maximum values, this routine determines
*     the minimum and maximum of these given values and the values in
*     an array of values.
*
*
* Parameters:
* R ->  X      -  Input array
* I ->  N      -  Number of elements of X
* R <-> XMIN   -  Minimum value.  On input the given minimum, on output
*                 the smaller of the input value and the minimum valued
*                 element in the array.
* R <-> XMAX   -  Maximum value.  On input the given maximum, on output
*                 the larger of the input value and the maximum valued
*                 element in the array.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 14:47:39 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE AMINMX (X, N, XMIN, XMAX)


      INTEGER N
      INTEGER I

      REAL XMIN,XMAX
      REAL X(*)


* Update the minimum and maximum values
      DO 100 I=1,N
        XMAX=MAX(X(I),XMAX)
        XMIN=MIN(X(I),XMIN)
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     COMPLEX FUNCTION RSPIIR (F, H, NSECT)
*
*
* Purpose:
*     Find the frequency response for an cascade IIR filter
*
*
* Description:
*     This function calculates the frequency response of an IIR filter
*     specified by its coefficients.  The filter is a cascade of second
*     order sections, with the z-transform of the i'th filter section
*     given as
*
*                h(1,i)*z**2 + h(2,i)*z + h(3,i)
*       H(i,z) = ------------------------------- .
*                   z**2 + h(4,i)*z + h(5,i)
*
*     The frequency response is the product of such sections, evaluated
*     with z=exp(j2 pi f).
*
*
* Parameters:
* X <-  RSPIIR - Resulting complex valued response
*
* R ->  F      - Normalized frequency (normally in the range 0 to 0.5)
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:21:59 $
*
*
*-----------------------------------------------------------------------

      COMPLEX FUNCTION RSPIIR (F, H, NSECT)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NSECT
      INTEGER K

      COMPLEX Z

      REAL F
      REAL H(5,*)


* Form the product of the response of each second order section
      Z=CMPLX(COS(PI2*F),SIN(PI2*F))
      RSPIIR=1.
      DO 100 K=1,NSECT
        RSPIIR=RSPIIR *
     -           ( ( H(1,K)*Z**2 + H(2,K)*Z + H(3,K) ) /
     -                    ( Z**2 + H(4,K)*Z + H(5,K) ) )
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE WHTEXT (STRING, W, H)
*
*
* Purpose:
*     Find the plot width and height of a text string
*
*
* Description:
*     This routine determines the width and height of a box containing
*     a given text string.  The widths and heights of the individual
*     letters are set by calling routine SETCHR.
*
*     This routine checks for the presence of special control
*     characters in the text string.
*                         Control  ASCII
*        Character         Key     Code     Function
*      NUL (null)         CTRL-@     0   null character
*      LF (line feed)     CTRL-J,   10   start a new line
*      VT (vertical tab)  CTRL-K,   11   start small characters
*      SO (shift out)     CTRL-N,   14   end superscript, subscript
*                                        or small characters
*      SI (shift in)      CTRL-O,   15   start superscripts
*      SUB (substitute)   CTRL-Z,   26   start subscripts
*
*     The NUL character (ASCII 0) is treated as a zero width character
*     of normal height.  The line feed character NL marks the end of a
*     line of characters.  Lines of characters are stacked vertically
*     (from top to bottom), a fixed distance apart stacked vertically
*     (from top to bottom), a fixed distance apart (1.5 times the
*     standard character height), with each line of text left
*     justified.
*
*     The VT control character turns on small character mode.  These
*     characters are of reduced size.   The SO character or the LF
*     character terminates small character mode.  The SI character
*     starts superscript mode.  Superscript characters are raised
*     above the baseline and are plotted at a reduced size.  The SUB
*     character starts subscript mode.  Subscript characters are
*     lowered below the baseline and are plotted at a reduced size.
*     Both superscripts and subscripts are turned off with SO or LF
*     control characters.
*
*     Each character in the text string is assigned a height, width
*     and depth.  Heights and depths are measured with respect to the
*     baseline of the character.  The depth of a character is ignored
*     in computing the size of the text box.  For each line of text,
*     the characters are stacked side by side with extra space inserted
*     between characters.  The  size of the text box for a line is
*     determined by the maximum height of any character in the line and
*     sum of the widths of the characters and spacing in the line.
*     Lines of text are stacked a fixed distance apart.  The height of
*     the overall box is determined from the height of the top line,
*     plus the interline spacing for each of the remaining lines of
*     text.  The width of the overall box is the maximum of the widths
*     of the text lines.
*
*
* Parameters:
* C ->  STRING - Character string to be plotted.  This string may
*                include control characters to turn on and turn off
*                superscript or subscript characters and split text
*                into lines.
* R <-  W      - Width of the text in plotting units
* R <-  H      - Height of the text in plotting units
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:31:02 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE WHTEXT (STRING, W, H)


      INTEGER ICNWL,ICSML,ICSUP,ICSUB,ICNOR
      PARAMETER (ICNWL=10,ICSML=11,ICSUP=15,ICSUB=26,ICNOR=14)

* Character spacing and size parameterization

* CHNOR  - height of a normal character
* CHSML  - height of a small character
* CRSUP  - vertical offset for superscript characters
* CRSUB  - vertical offset for subscript characters
* CWNOR  - width of a normal character
* CWSML  - width of a small character
* CSPNN  - spacing inserted between normal characters
* CSPSS  - spacing inserted between small characters
* CSPNS  - spacing inserted between a normal and a small character
* CSPSN  - spacing inserted between a small and a normal character
* CBLSP  - baseline skip between lines of text
      REAL CHNOR,CHSML,CRSUP,CRSUB,CWNOR,CWSML,
     -     CSPNN,CSPSS,CSPNS,CSPSN,CBLSP
      PARAMETER (CHNOR=1.0,CHSML=0.75*CHNOR,
     -           CWNOR=1.0,CWSML=0.75*CWNOR,
     -           CRSUP=0.5,CRSUB=-0.25,
     -           CSPNN=0.5,CSPSS=(CWSML/CWNOR)*CSPNN,
     -           CSPNS=0.5*(CSPNN+CSPSS),CSPSN=CSPNS,
     -           CBLSP=1.5*CHNOR)

      INTEGER ISIZ,IPRS,I,IW,IH

      CHARACTER*(*) STRING

      REAL W,H
      REAL WL,HL,WT,HT,HH,ANG

      REAL CSPACE(0:1,-1:1)
      REAL CWIDTH(0:1)
      DATA CSPACE/0.0,0.0,CSPNN,CSPNS,CSPSN,CSPSS/
      DATA CWIDTH/CWNOR,CWSML/


* Accumulate normalized widths and find the maximum height
      ISIZ=0
      IPRS=-1
      HL=0.0
      WL=0.0
      HT=0.0
      WT=0.0
      HH=CHNOR
      DO 100 I=1,LEN(STRING)
        IF (STRING(I:I).EQ.CHAR(ICSML)) THEN
          ISIZ=1
          HH=CHSML
        ELSE IF (STRING(I:I).EQ.CHAR(ICSUP)) THEN
          ISIZ=1
          HH=CRSUP+CHSML
        ELSE IF (STRING(I:I).EQ.CHAR(ICSUB)) THEN
          ISIZ=1
          HH=CRSUB+CHSML
        ELSE IF (STRING(I:I).EQ.CHAR(ICNOR)) THEN
          ISIZ=0
          HH=CHNOR
        ELSE IF (STRING(I:I).EQ.CHAR(ICNWL)) THEN
          WT=MAX(WT,WL)
          HT=HT+HL
          ISIZ=0
          HH=CHNOR
          IPRS=-1
          HL=CBLSP
          WL=0.0
        ELSE
          HL=MAX(HL,HH)
          IF (STRING(I:I).NE.CHAR(0))
     -      WL=WL + CSPACE(ISIZ,IPRS)+CWIDTH(ISIZ)
          IPRS=ISIZ
        END IF
 100  CONTINUE

* Implicit end of line
      WT=MAX(WT,WL)
      HT=HT+HL

* Get the character size to denormalize the size
      CALL GETCHR(IW,IH,ANG)
      W=WT*IW
      H=HT*IH


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSXY (IX, IY, LINEWD)
*
*
* Purpose:
*     Generate a Postscript plot file vector
*
*
* Description:
*     This routine writes a plot vector to a Postscript plot file.  The
*     plot commands written to the file make use of Postscript macros
*     defined by routine PSHEAD.  Subroutine PSHEAD also initializes
*     variables in common area PSBBOX which tally bounding box
*     information.
*
*     This routine must be initialized with a call which has LINEWD=0
*     to establish the initial plotting position.  Redundant calls with
*     LINEWD=0 do not generate Postscript vectors.  Collinear vectors
*     are collapsed.  In order to accomplish this, Postscript vectors
*     lag by at least one call to this routine.  A final call with
*     LINEWD=0 must be used to push out any remaining vectors.
*
*     This routine updates the bounding box information which reflects
*     the extent of visible vectors, i.e. those with non-zero line
*     width.
*
*
* Parameters:
* I ->  IX     - X coordinate in plotting units (0 to 4095)
* I ->  IY     - Y coordinate in plotting units (0 to 4095)
* I ->  LINEWD - Line width in plotting units
*                0 - no plot vector is generated
*                negative - a white vector of width -LINEWD is
*                           generated
*                positive - a black vector of width LINEWD is
*                           generated
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:29:36 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSXY (IX, IY, LINEWD)


      INTEGER IX,IY,LINEWD
      INTEGER IDX1,IDY1,IDX2,IDY2

      INTEGER IXP,IYP,LWP,IXS,IYS
      SAVE IXP,IYP,LWP,IXS,IYS

      INTEGER LUNPS,IPRTPS
      CHARACTER*255 FNAMPS
      COMMON /PSCOM/ LUNPS,IPRTPS,FNAMPS

      DATA IXP,IYP,LWP/0,0,0/


      IF (LINEWD.EQ.0) THEN

* Pen up, check if previously down
        IF (LWP.NE.0) CALL PSVECT(LUNPS,IXP,IYP,LWP)

      ELSE IF (LWP.EQ.0) THEN

* Pen down, previously up
* Set the start position of a collinear segment
        CALL PSVECT(LUNPS,IXP,IYP,LWP)
        IXS=IXP
        IYS=IYP

      ELSE

* Pen down, previously down
* Bypass collinear segments (including segments of zero length)
* The test for collinearity involves a check of slopes and a check
* that the two vectors are in the same direction.
        IDX1=IXP-IXS
        IDY1=IYP-IYS
        IDX2=IX-IXP
        IDY2=IY-IYP

* Each of IDX1, IDY1, IDX2, and IDY2 can be negative, zero or positive.
* Tests: S: (IDX2*IDY1==IDY2*IDX1)  slope check
*        X: (IDX1*IDX2>=0)          X-direction check
*        Y: (IDY1*IDY2>=0)          Y-direction check
* (1) For non-zero increments, if the slopes match, then IDX1*IDX2 and
*     IDY1*IDY2 are either both positive or both negative.  Then X=Y.
*     A full test for collinearity is (S .AND. X).
* (2) Zero length segments can be considered to be collinear with any
*     other segment.  Consider a zero length segment, IDX1=IDY1=0.  The
*     slope check works.  The direction checks also work since they
*     include a check against zero.  Note that X=Y.  The same argument
*     shows that if IDX2=IY2=0, the checks also work.  The full test
*     for collinearity is (S .AND. X).
* (3) Horizontal lines, IDY1=IDY2=0.  The slope check and the
*     Y-direction checks are automatically satisfied.  The X-direction
*     check must also be satisfied.  A full test for collinearity is X.
* (4) Vertical lines, IDX1=IDX2=0.  The slope check and the X-direction
*     checks are automatically satisfied.  The Y-direction check must
*     also be satisfied.  A full test for collinearity is Y.
* (5) A single zero increment will fail the slope check.
* (6) Two zero increments such as IDX1=IDY2=0 or IDX2=IDY1=0 will fail
*     the slope check.  The other cases of two zero increments are
*     covered above.
* (7) The cases of three or four zero increments involve zero length
*     segments and revert to the tests as covered above.
* Summarizing, a full check for collinearity that will cover all cases
* is (S .AND. X .AND. Y).
        IF ((IDX2*IDY1.NE.IDY2*IDX1) .OR.
     -      (IDX1*IDX2.LT.0) .OR.
     -      (IDY1*IDY2.LT.0)) THEN
          IXS=IXP
          IYS=IYP
          CALL PSVECT(LUNPS,IXP,IYP,LWP)
        END IF

      END IF

* Save the present coordinates for the next time
      IXP=IX
      IYP=IY
      LWP=LINEWD


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GETIMG (IMAGNM, NC)
*
*
* Purpose:
*     Get the image name
*
*
* Description:
*     This routine returns a string containing the name of the image
*     running.  This is determined from the command line by stripping
*     off the path name information from the first part of the command
*     line.
*
*
* Parameters:
* C <-  IMAGNM - Output string
* I <-  NC     - Number of characters set in IMAGNM
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:43:58 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GETIMG (IMAGNM, NC)


      INTEGER NC
      INTEGER IE,IS
      INTEGER LENSTR,INDEXR

      CHARACTER*(*) IMAGNM
      CHARACTER*255 COMD


* Get the image name, omitting the path name
      CALL GETARG(0,COMD)
      IE=LENSTR(COMD)
      IS=INDEXR(COMD,'/')+1
      IE=MAX(IS,IE)

      IMAGNM=COMD(IS:IE)
      NC=IE-IS+1


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE AXLIMS (V, IDIM, NPT, NVECT, VMIN, VMAX,
*                        ATICK, NTICK, IAX, DMIN, DMAX)
*
*
* Purpose:
*     Find limits for a plot axis
*
*
* Description:
*     This routine finds the minimum and maximum values for an axis.
*     The minimum and maximum values are determined by from the
*     following (in the indicated order).
*       1. VMIN and VMAX (if these differ)
*       2. min(V(i,j)) and max(V(i,j)) (if these differ)
*       3. min(ATICK(i)) and max(ATICK(i)) (if these differ)
*       4. default values
*
*
* Parameters:
* R ->  V      - Two dimensional array of data values.  V(1,1) through
*                V(NPT,1) represent one data vector, V(1,2) through
*                Y(NPT,2) represent another data vector, and so on.
* I ->  IDIM   - First dimension of the input array V
* I ->  NPT    - Number of values per vector (less than or equal to
*                IDIM)
* I ->  NVECT  - Number of vectors contained in V
* R ->  VMIN   - Minimum data value
* R ->  VMAX   - Maximum data value
*                Note: Normally VMAX is not equal to VMIN.  If VMAX is
*                      equal to VMIN, the data range will be chosen to
*                      include this data value.
* R -> ATICK   - Array of data values corresponding to axis ticks.
*                For ITICK=1, this array is used to determine the data
*                range if the data range cannot be determined from
*                VMIN and VMAX, or the input data array.
* I ->  NTICK  - Number of values in the array ATICK.  This value is
*                used if ITICK=1.
* I <-> IAX    - Option value.  The option value has five components.
*                IAX = ILL + 4*IUL + 16*ITICK + 32*ILABEL + 64*ILOG
*                ILL    = 0 - default value.  On output, ILL will be
*                             set to to 1 (if (VMAX = VMIN) or 2 (if
*                             VMAX != VMIN).
*                         1 - The lower limit of the graph is to be a
*                             tick value less than or equal to VMIN
*                         2 - The lower limit of the graph is VMIN
*                IUL    = 0 - default value.  On output, IUL will be
*                             set to to 1 (if (VMAX = VMIN) or 2 (if
*                             VMAX != VMIN).
*                         1 - The upper limit of the graph is to be a
*                             tick value greater than or equal to VMAX
*                         2 - The upper limit of the graph is VMAX
*                ITICK  = 0 - Ticks are not supplied as input
*                         1 - Ticks are supplied as input
*                ILABEL = 0,1 not used
*                ILOG   = 0 - Linear scale
*                         1 - Logarithmic scale
* R <-  DMIN   - Lower limit for the graph
* R <-  DMAX   - Upper limit for the graph
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.8 $  $Date: 1995/03/08 15:30:19 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE AXLIMS (V, IDIM, NPT, NVECT, VMIN, VMAX,
     -                   ATICK, NTICK, IAX, DMIN, DMAX)


      INTEGER DEFAULT,TICKV,EXACTV,INP,LINS,LOGS
      PARAMETER (DEFAULT=0,TICKV=1,EXACTV=2,INP=1,LINS=0,LOGS=1)

      INTEGER IDIM,NPT,NVECT,NTICK,IAX
      INTEGER ILL,IUL,ITICK,ILABEL,ILOG,J
      INTEGER IFLORX,ICEILX

      REAL VMIN,VMAX,DMIN,DMAX
      REAL V(IDIM,*),ATICK(*)
      REAL D


* Separate the axis option codes
      ILL=MOD(IAX,4)
      IUL=MOD(IAX/4,4)
      ITICK=MOD(IAX/16,2)
      ILABEL=MOD(IAX/32,2)
      ILOG=MOD(IAX/64,2)

*==========
* Resolve the default limit options
      IF (ILL.EQ.DEFAULT) THEN
        IF (VMIN.EQ.VMAX) THEN
          ILL=TICKV
        ELSE
          ILL=EXACTV
        END IF
      END IF
      IF (IUL.EQ.DEFAULT) THEN
        IF (VMIN.EQ.VMAX) THEN
          IUL=TICKV
        ELSE
          IUL=EXACTV
        END IF
      END IF

*==========
* If data limits are undefined, search the data array
      DMIN=VMIN
      DMAX=VMAX
      IF (DMIN.EQ.DMAX) THEN
        DO 120 J=1,NVECT
          CALL AMINMX(V(1,J),NPT,DMIN,DMAX)
 120    CONTINUE
      END IF

* If data limits are still undefined, try to get the limits from
* the tick array
      IF (DMIN.EQ.DMAX .AND. ITICK.EQ.INP) THEN
        CALL AMINMX(ATICK,NTICK,DMIN,DMAX)
      END IF

*==========
* Check log scale limits, warn and fix up
      IF (ILOG.NE.LINS) THEN
        IF (DMIN.LE.0.0) THEN
          DMIN=MAX(0.1*DMAX,0.1)
          CALL WARN('AXLIMS - Log scale, nonpositive value')
        END IF
        IF (DMAX.LE.0.0) THEN
          DMAX=10.*DMIN
          CALL WARN('AXLIMS - Log scale, nonpositive value')
        END IF
      END IF

* Limits still undefined, set the limits
      IF (DMIN.EQ.DMAX) THEN
        IF (ILOG.EQ.LINS) THEN

          IF (ILL.EQ.EXACTV) THEN
            IF (DMIN.LT.0.0) THEN
              DMAX=0.0
            ELSE IF (DMIN.GT.0.0) THEN
              DMIN=0.0
            ELSE
              DMIN=0.0
              DMAX=+1.
            END IF
          ELSE
            IF (DMIN.LT.0.0) THEN
              DMIN=1.5*DMIN
              DMAX=0.0
            ELSE IF (DMIN.GT.0.0) THEN
              DMIN=0.0
              DMAX=1.5*DMAX
            ELSE
              DMIN=0.0
              DMAX=+1.
            END IF
          END IF

        ELSE
          D=LOG10(DMIN)
          DMIN=10.**IFLORX(D)
          IF (ILL.EQ.EXACTV) THEN
            IF (DMIN.EQ.DMAX) DMAX=10.*DMIN
          ELSE
            DMAX=10.**ICEILX(D)
            IF (DMIN.EQ.DMAX) THEN
              DMIN=0.1*DMIN
              DMAX=10.*DMAX
            END IF
          END IF

        END IF
      END IF

*==========
* Reconstruct the axis option code
      IAX=ILL+4*IUL+16*ITICK+32*ILABEL+64*ILOG


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION EVCINT (X, X1, X2, Y1, Y2, D1, D2)
*
*
* Purpose:
*     Evaluate a cubic, given values and derivatives
*
*
* Description:
*     This function calculates the value of an interpolating cubic for
*     a given abscissa value.  The cubic is specified in terms of its
*     values and derivatives at two points.
*
*
* Parameters:
* R <-  EVCINT - Output value
*
* R ->  X      - Abscissa value at which the cubic is to be evalutated
* R ->  X1     - Abscissa value at the first point
* R ->  X2     - Abscissa value at the second point
* R ->  Y1     - Value at the first point
* R ->  Y2     - Value at the second point
* R ->  D1     - Derivative at the first point
* R ->  D2     - Derivative at the second point
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:25:39 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION EVCINT (X, X1, X2, Y1, Y2, D1, D2)


      REAL X,X1,X2,Y1,Y2,D1,D2
      REAL DX,S,DD1,DD2,XI


* Check for distinct X values
      DX=X2-X1
      IF (DX.EQ.0.0)
     -  CALL HALT('EVCINT - Abscissa values not distinct')


      S=(Y2-Y1)/DX
      DD1=(D1-S)/DX
      DD2=(D2-S)/DX

* Evaluate the cubic
      XI=X-X1
      EVCINT=Y1 + XI*(D1 + XI*(-(DD1+DD2+DD1) + XI*((DD1+DD2)/DX)))


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE XYDRAW (IX, IY)
*
*
* Purpose:
*     Draw a vector
*
*
* Description:
*     This subroutine draws a vector from the previous pen position
*     to a new pen position.  The width of the vector is set by the
*     routine SETPLW.
*       LWIDTH > 0 - Draw a visible vector using the vector rendition.
*                    The width of the line can only be varied for some
*                    plot devices.
*       LWIDTH = 0 - Move the plot pen without drawing a line
*       LWIDTH < 0 - Draw a visible vector using the background
*                    rendition.  On some devices, the action is the
*                    same as moving the plot pen without drawing a
*                    line.
*
*
* Parameters:
* R ->  IX     - X coordinate of the new pen position (0 to 4095)
* R ->  IY     - Y coordinate of the new pen position (0 to 4095)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:08 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE XYDRAW (IX, IY)


      INTEGER IX,IY
      INTEGER LWIDTH

* Plot device flags common area
      LOGICAL PS,TK,UN,VT
      COMMON /DEVCOM/ PS,TK,UN,VT


      CALL GETPLW(LWIDTH)
      IF (PS) CALL PSXY(IX,IY,LWIDTH)
      IF (TK) CALL TKXY(IX,IY,LWIDTH)
      IF (UN) CALL UNXY(IX,IY,LWIDTH)
      IF (VT) CALL VTXY(IX,IY,LWIDTH)
      CALL SETPOS(IX,IY)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VTXY (IX, IY, LWIDTH)
*
*
* Purpose:
*     Write a ReGIS display vector
*
*
* Description:
*     This routine accepts a pair of X-Y coordinates as input.  A
*     string of ReGIS commands in constructed which is then sent to
*     the terminal.
*
*
* Parameters:
* I ->  IX     - X coordinate in plotting units (0 to 4095)
* I ->  IY     - Y coordinate in plotting units (0 to 4095)
* I ->  LWIDTH - Line width (plot units).  A zero width line indicates
*                an invisible line.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:11 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VTXY (IX, IY, LWIDTH)


      INTEGER DARK,VIS
      PARAMETER (DARK=0,VIS=1)

      INTEGER IX,IY,LWIDTH

* ReGIS parameters
      INTEGER IXOFF,IXMUL,IXDIV,IYOFF,IYMUL,IYDIV
      PARAMETER (IXOFF=80,IXMUL=5,IXDIV=32,
     -           IYOFF=480,IYMUL=-5,IYDIV=32)

      INTEGER LUNVT
      CHARACTER*255 FNAMVT
      COMMON /VTCOM/ LUNVT,FNAMVT


      IF (LWIDTH.NE.0) THEN
        CALL VTVECT(LUNVT,IX*IXMUL/IXDIV+IXOFF,
     -                    IY*IYMUL/IYDIV+IYOFF,VIS)
      ELSE
        CALL VTVECT(LUNVT,IX*IXMUL/IXDIV+IXOFF,
     -                    IY*IYMUL/IYDIV+IYOFF,DARK)
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE AXSCAL (VMIN, VMAX, IAX, DMIN, DMAX,
*                        ATICK, ALABEL, NTICK, IEXP)
*
*
* Purpose:
*     Find a plot axis scale and fill in ticks and labels
*
*
* Description:
*     This routine finds an appropriate axis scale in terms of the
*     scaling between data units and plotting units.  Optionally, an
*     array of axis values corresponding to locations for axis ticks is
*     generated.
*
*     For linear scaling, the tick values generated are uniformly
*     spaced.  The character labels corresponding to these ticks are
*     also generated.  Normally only every second tick has a non-null
*     label.
*
*     For logarithmic scaling, the tick values correspond to the decade
*     points 10**n, and for a data range encompassing a small number
*     of decades, intermediate ticks at 2*10**n and 5*10**n are also
*     generated.  For a single decade, ticks at 2*10**n, 3*10**n, ...,
*     9*10**n are generated.  The decade points are always labelled.
*     If the number of decades is small, intermediate ticks are also
*     labelled.
*
*
* Parameters:
* R ->  VMIN   - Minimum data value to be plotted
* R ->  VMAX   - Maximum data value to be plotted
*                Note: Normally VMAX is not equal to VMIN.
* I ->  IAX    - Option value.  The option value has five components.
*                IXAX = ILL + 4*IUL + 16*ITICK + 32*ILABEL + 64*ILOG
*                ILL    = 1 - The lower limit of the graph is to be a
*                             tick value less than or equal to VMIN
*                         2 - The lower limit of the graph is VMIN
*                IUL    = 1 - The upper limit of the graph is to be a
*                             tick value greater than or equal to VMAX
*                         2 - The upper limit of the graph is VMAX
*                ITICK  = 0 - Ticks are generated by this routine
*                         1 - Ticks are supplied as input
*                ILABEL = 0 - Label values are generated by this
*                             routine
*                         1 - Label values are supplied as input.  This
*                             option is incompatible with ITICK=0.
*                ILOG   = 0 - Linear scale
*                         1 - Logarithmic scale
* R <-  DMIN   - Data value corresponding to the beginning of the axis
* R <-  DMAX   - Data value corresponding to the end of the axis
* R <-  ATICK  - Array of data values corresponding to the ticks.  This
*                array is set by this routine for ITICK=0.
* C <-  ALABEL - Character array of labels corresponding to the ticks.
*                These are in one-to-one correspondence with the array
*                of tick values.  Each element of ALABEL should be at
*                least 11 characters in length.  This array is not
*                altered for ILABEL=1.  For ILABEL=0, NTICK labels are
*                generated.  Each of the generated labels is terminated
*                with a null character if it is shorter than the length
*                of the array elements.
* I <-> NTICK  - Number of tick values generated (up to 64).  This is
*                an output value for ITICK=0.  For ITICK=1, NTICK is an
*                input value used to determine the number of tick
*                values in ATICK.
* I <-  IEXP   - Exponent for the axis labels.  The value of the tick
*                corresponding to an axis label is the value coded in
*                the label string times 10**IEXP.  IEXP is returned as
*                a multiple of 3. Note that IEXP will be zero if all of
*                the labels can be represented in 4 significant digits.
*                IEXP is set to zero if the labels are specified
*                (ILABEL=0) and/or if the axis is logarithmic (ILOG=1).
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:27:34 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE AXSCAL (VMIN, VMAX, IAX, DMIN, DMAX,
     -                   ATICK, ALABEL, NTICK, IEXP)


      INTEGER TICKV,EXACTV,INP,LINS,LOGS
      INTEGER NPL
      REAL EPS
      PARAMETER (TICKV=1,EXACTV=2,INP=1,LINS=0,LOGS=1)
      PARAMETER (NPL=6,EPS=1E-5)

      INTEGER IAX,NTICK,IEXP,NAX
      INTEGER ILL,IUL,ITICK,ILABEL,ILOG,NC,I

      REAL VMIN,VMAX,DMIN,DMAX
      REAL TMIN,TMAX,FIRSTV,DELTAV,VLMIN,VLMAX
      REAL FLOORX,CEILX
      REAL ATICK(*)

      CHARACTER*(NPL) CSTR
      CHARACTER*(*) ALABEL(*)


* Separate the axis option codes
      ILL=MOD(IAX,4)
      IUL=MOD(IAX/4,4)
      ITICK=MOD(IAX/16,2)
      ILABEL=MOD(IAX/32,2)
      ILOG=MOD(IAX/64,2)

*==========
* Find appropriate axis limits
      DMIN=MIN(VMIN,VMAX)
      DMAX=MAX(VMIN,VMAX)

* Ticks supplied, find tick values which bound [DMIN, DMAX]
      IF (ITICK.EQ.INP) THEN
        IF (ILL.EQ.TICKV) THEN
          CALL VGLB(ATICK,NTICK,DMIN,TMIN,I)
          DMIN=TMIN
        END IF
        IF (IUL.EQ.TICKV) THEN
          CALL VLUB(ATICK,NTICK,DMAX,TMAX,I)
          DMAX=TMAX
        END IF
        IF (ILABEL.NE.INP) THEN
          DO 100 I=1,NTICK
            CALL LABEL(ATICK(I),NPL,CSTR,NC)
            ALABEL(I)=CSTR(1:NC)//CHAR(0)
 100      CONTINUE
        END IF
        IEXP=0


* Axis definition, linear axis
      ELSE IF (ILOG.EQ.LINS) THEN
        CALL FNDSCL(DMIN,DMAX,4,12,NAX,FIRSTV,DELTAV)
        IF (ILL.EQ.TICKV) DMIN=FIRSTV
        IF (IUL.EQ.TICKV) DMAX=NAX*DELTAV+FIRSTV
        NTICK=NAX+1
        CALL AXTICK(FIRSTV,DELTAV,NTICK,ATICK,ALABEL,IEXP)

* Axis definition, log axis
      ELSE
        IF (DMIN.LE.0.0) THEN
          DMIN=MAX(0.1*DMAX,0.1)
          CALL WARN('AXSCAL - Log scale, nonpositive value')
        END IF
        IF (DMAX.LE.0.0) THEN
          DMAX=10.*DMIN
          CALL WARN('AXSCAL - Log scale, nonpositive value')
        END IF
        VLMIN=LOG10(DMIN)
        VLMAX=LOG10(DMAX)
        IF (ILL.EQ.TICKV) VLMIN=FLOORX(VLMIN+EPS)
        IF (IUL.EQ.TICKV) THEN
          VLMAX=MAX(CEILX(VLMAX-EPS),CEILX(VLMIN))
          IF (VLMIN.GE.VLMAX) VLMAX=VLMAX+1.
        END IF
        DMIN=10.**VLMIN
        DMAX=10.**VLMAX
        CALL LOGTIC(DMIN,DMAX,ATICK,ALABEL,NTICK)
        IEXP=0
      END IF

* Reverse the axis if necessary
      IF (VMIN.GT.VMAX) THEN
        TMIN=DMIN
        DMIN=DMAX
        DMAX=TMIN
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLINIT (DEVICE, OPTION)
*
*
* Purpose:
*     Initialize a plot
*
*
* Description:
*     This subroutine initializes the given plotting device.  PLINIT
*     may be called several times for different devices.  In addition
*     PLINIT may be called in the middle of a plot to change the
*     options associated with a device.  Subroutine PLEND should be
*     called to terminate plotting.
*
*     The display surface is discretized into a grid which is nominally
*     4096 by 4096 units (0 to 4095 in each of the X and Y directions).
*     Before plotting, the pen position is at (0,0).
*
*
* Parameters:
* C ->  DEVICE - Character string specifying the plotting device.  This
*                name is subject to case conversion.
*             LW or PS - Postscript file.
*                  This routine initializes the Postscript plot.  It
*                  writes a Postscript header to the plot file.  The
*                  mapping is set to give 600 plotting units per inch
*                  and an X offset of 0.5 inches and a Y offset of
*                  2 inches.  For device LW, the Postscript file is
*                  queued for printing on a Postscript printer and
*                  subsequently deleted.
*             TK - Tektronix display terminal.
*                  This routine leaves the Tektronix terminal in
*                  graphics mode.  Any other I/O to the Tektronix
*                  terminal should be avoided while plotting is in
*                  progress.  A call to PLEND at the end of plotting
*                  will reset the Tektronix terminal to alpha-numeric
*                  mode.  The Tektronix terminal has a resolution of
*                  1024 points horizontally and 780 points vertically.
*                  These are mapped such that the full plotting range
*                  (0 to 4095) is visible horizontally while
*                  vertically only points in the range 0 to 3120 are
*                  visible.
*             UN - Standard Unix plot file.
*                  This routine initializes the plot file.  The plot
*                  area is defined to be in the area from (0,0) to
*                  (4095,4095).
*             VT - ReGIS terminal.
*                  This routine sets the terminal to ReGIS graphics
*                  mode.  Any other I/O to the terminal should be
*                  avoided while plotting is in progress.  A call to
*                  PLEND at the end of plotting will exit ReGIS mode.
*                  The terminal has a resolution of 800 points
*                  horizontally and 480 points vertically.  These are
*                  mapped such that the full plotting range (0 to 4095)
*                  is visible horizontally (valid range is -512 to
*                  4607) while vertically, the valid ordinate range is
*                  0 to 3071.  Coordinates outside this range are
*                  clipped.
* C ->  OPTION - Character string specifying the options.  Options are
*                separated by commas and/or whitespace (blanks, tabs,
*                or nulls).  If any option is omitted, the default
*                value is used.  An all blank string gives the default
*                values.  The same keyword may appear more than once,
*                with the last instance taking precedence.  The
*                available options are specific to the particular
*                device being selected.  Device options generally
*                remain in effect unless explicitly overridden by
*                another call to PLINIT.  However, the CLEAR and
*                OVERLAY options apply only to one invokation of
*                PLINIT.
*          for DEVICE=LW or PS
*                FILENAME=name - Specifies the name of the file to
*                  which plot data is sent.  The file name is not used
*                  if this plot device is already active.  The special
*                  file name "*" can be  used to direct output to the
*                  standard output (Fortran unit 6).  The default file
*                  name for files which are not sent to the printer
*                  is derived from the name of the image (xxx.epsf
*                  where xxx is the image name).  For files sent
*                  for printing, a unique temporary file name is
*                  created.
*                PRINT or NOPRINT - Specifies whether the Postscript
*                  file is to be queued for printing.  The default is
*                  PRINT for device LW and NOPRINT for device PS.
*          for DEVICE=TK
*                CLEAR - The screen is erased.  CLEAR is the default
*                  option if this plot device is not active.
*                OVERLAY - The screen is not erased.  OVERLAY is the
*                  default option if this plot device is already
*                 active.
*                FILENAME=name - Specifies the name of the file or
*                  terminal to which plot data is sent.  The file name
*                  is not used if this plot device is already active.
*                  The special file name "*" can be  used to direct
*                  output to the standard output (Fortran unit 6).  The
*                  default file name is "/dev/tty".
*         for DEVICE=UN
*                FILENAME=name - Specifies the name of the file to
*                  which plot data is sent.  The file name is not used
*                  if this plot device is already active.  The special
*                  file name "*" can be  used to direct output to the
*                  standard output (Fortran unit 6).  The default file
*                  name is "unplot.dat".
*          for DEVICE=VT
*                CLEAR - The screen is erased.  CLEAR is the default
*                  option if this plot device is not active.
*                OVERLAY - The screen is not erased.  OVERLAY is the
*                  default option if this plot device is already
*                  active.
*                FILENAME=name - Specifies the name of the file or
*                  terminal to which plot data is sent.  The file name
*                  is not used if this plot device is already active.
*                  The special file name "*" can be  used to direct
*                  output to the standard output (Fortran unit 6).
*                  The default file name is "/dev/tty".
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:28:15 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLINIT (DEVICE, OPTION)


      INTEGER NC
      INTEGER IX0,IY0
      INTEGER LENSTR

      CHARACTER*(*) DEVICE,OPTION
      CHARACTER*80 TNAME
      CHARACTER*256 SOPT

* Plot device flags common area
      LOGICAL PS,TK,UN,VT
      COMMON /DEVCOM/ PS,TK,UN,VT


* Reset the pen position at the beginning of a plot
* Initialize the line width, graph size and character size
      IF (.NOT.(PS .OR. TK .OR. UN .OR. VT)) THEN
        CALL SETPOS(0,0)
        CALL SETPLW(6)
        CALL SETCHR(32,48,0.0)
        CALL SETGRS(720,440,3240,2400)
      END IF


* Search for a match to the device
      TNAME=DEVICE
      CALL UPCASE(TNAME,TNAME)
      CALL STTRIM(OPTION,SOPT,NC)

      IF (TNAME.EQ.'LW') THEN
        CALL PSINIT('PRINT '//SOPT(1:NC))
        PS=.TRUE.

      ELSE IF (TNAME.EQ.'PS') THEN
        CALL PSINIT(SOPT(1:NC))
        PS=.TRUE.

      ELSE IF (TNAME.EQ.'TK') THEN
        CALL TKINIT(SOPT(1:NC))
        TK=.TRUE.

      ELSE IF (TNAME.EQ.'UN') THEN
        CALL UNINIT(SOPT(1:NC))
        UN=.TRUE.

      ELSE IF (TNAME.EQ.'VT') THEN
        CALL VTINIT(SOPT(1:NC))
        VT=.TRUE.

      ELSE
        NC=LENSTR(TNAME)
        CALL HALT('PLINIT - invalid plotting device: '//TNAME(1:NC))

      END IF

* Update the plot position
      CALL GETPOS(IX0,IY0)
      CALL XYMOVE(IX0,IY0)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FNDSCL (FMIN, FMAX, MINLEN, MAXLEN, LENAX, FV, DV)
*
*
* Purpose:
*     Find the axis intervals for a plot
*
*
* Description:
*     This routine chooses an axis suitable for plotting a range of
*     data.  The axis is specified by the number of axis intervals, the
*     axis starting value and the increment for each interval.
*
*     A scaling based on the maximum axis length is chosen.  Any
*     excess intervals at the ends are trimmed, but leaving at least
*     the minimum number of axis intervals.  The number of intervals
*     chosen is made even, subject to the constrains of the minimum
*     and maximum number of intervals.  (An even number of intervals
*     gives an odd number of ticks; often only every second tick is
*     labelled.)  If there are unused intervals, the axis is shifted
*     to either place zero at either end or to try to make the axis
*     more symmetrical about zero.
*
*
* Parameters:
* R ->  FMIN   - Minimum data value
* R ->  FMAX   - Maximum data value
* I ->  MINLEN - Minimum number of axis intervals (intervals between
*                axis tick marks)
* I ->  MAXLEN - Maximum number of axis intervals
* I <-  LENAX  - Number of axis intervals used.  This value will be
*                less than or equal to MAXLEN.  This value is even if
*                possible.
* R <-  FV     - Data value corresponding to the start of the axis
* R <-  DV     - Number of data units per axis interval
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:27:56 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FNDSCL (FMIN, FMAX, MINLEN, MAXLEN, LENAX, FV, DV)


      REAL EPS
      PARAMETER (EPS=1E-4)

      INTEGER MINLEN,MAXLEN,LENAX
      INTEGER L

      REAL FMIN,FMAX,FV,DV


* Choose an axis scale
      CALL SCALE(FMIN,FMAX,REAL(MAXLEN),FV,DV)
      LENAX=(FMAX-FV)/DV+(1.-EPS)

      IF (MOD(LENAX,2).NE.0) LENAX=LENAX+1
      IF (LENAX.LT.MINLEN) LENAX=MINLEN
      IF (LENAX.GT.MAXLEN) LENAX=MAXLEN

* Adjust the axis to have the origin at the lower edge
      IF (FMIN.GE.0.0 .AND. FMAX.LE.(LENAX+EPS)*DV) THEN
        FV=0.0

* Adjust the axis to have the origin at the upper edge
      ELSE IF (FMAX.LE.0.0 .AND. FMIN.GE.-(LENAX+EPS)*DV) THEN
        FV=-LENAX*DV

* Centre the axis
      ELSE
        L=NINT(0.5*( ( FV+LENAX*DV-FMAX)-(FMIN-FV) )/DV )
        FV=FV-L*DV

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION GDLIIR (F, H, NSECT)
*
*
* Purpose:
*     Find the group delay for a cascade IIR filter
*
*
* Description:
*     This function calculates the group delay of an IIR filter
*     specified by its coefficients.  The filter is a cascade of second
*     order sections, with the z-transform of the i'th filter section
*     given as
*
*                h(1,i)*z**2 + h(2,i)*z + h(3,i)
*       H(i,z) = ------------------------------- .
*                   z**2 + h(4,i)*z + h(5,i)
*
*     The group delay in seconds at frequency f for a filter with
*     sampling frequency Fs can be calculated as
*
*       T = GDLIIR(f/Fs,H,NSECT) / Fs  .
*
*
* Parameters:
* R <-  GDLIIR - Group delay in samples
*
* R ->  F      - Normalized frequency (normally in the range 0 to 0.5)
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.8 $  $Date: 1995/03/08 15:21:14 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION GDLIIR (F, H, NSECT)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NSECT
      INTEGER K

      REAL F
      REAL GDLSEC
      REAL COSW,SINW
      REAL H(5,*)


* Add the group delay of each second order section
      COSW = COS(PI2*F)
      SINW = SIN(PI2*F)
      GDLIIR = 0.0

      DO 100 K=1,NSECT

* The transfer function is
*
*                h(1,k)*z**2 + h(2,k)*z + h(3,k)
*         H(z) = -------------------------------
*                  z**2 + h(4,k)*z + h(5,k)

* Delay due to the numerator less the delay due to the denominator
	GDLIIR=GDLIIR + (GDLSEC(H(1,K),H(2,K),H(3,K),COSW,SINW) -
     -                   GDLSEC(1.0,H(4,K),H(5,K),COSW,SINW))

 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DRWVAX (IX0, IY0, LENY, YMIN, YMAX,
*                        ATICK, ALABEL, NTICK, IFN)
*
*
* Purpose:
*     Draw a labelled vertical axis
*
*
* Description:
*     A vertical axis with tick marks to mark intervals is drawn from
*     the given origin.  This routine uses the character size in effect
*     to determine the character size for the labels.  In addition,
*     axis tick marks scale with the width of the characters.
*
*
* Parameters:
* I ->  IX0    - X coordinate of the start of the axis (plotting units)
* I ->  IY0    - Y coordinate of the start of the axis (plotting units)
* I ->  LENY   - Length of the axis (plotting units)
* R ->  YMIN   - Data value corresponding to the start of the axis
*                (data units)
* R ->  YMAX   - Data value corresponding to the end of the axis
*                (data units)
* R ->  ATICK  - Array of data values at which ticks are to be placed.
*                If a data value lies outside the range spanned by the
*                axis [YMIN to YMAX], the corresponding tick is not
*                drawn.
* C ->  ALABEL - Character array of labels to be placed beside the tick
*                marks.  The labels are centered beside the ticks.  For
*                the purpose of determining the length of the label,
*                a null character if present, marks the end of the
*                string.  The label array is in one-to-one
*                correspondence with the array of tick locations.
* I ->  NTICK  - The absolute value of NTICK is the number of ticks
*                specified in ATICK.  If NTICK is positive, the
*                corresponding labels are drawn above or below the
*                ticks. If NTICK is negative, only the ticks are drawn.
* I ->  IFN    - Control variable,
*                   Positive - Axis ticks are drawn to the right of the
*                              axis.  Labels are drawn to the left of
*                              the axis.
*                   Zero -     Axis ticks are drawn on both sides of
*                              the axis.  Labels are drawn to the left
*                              of the axis.
*                   Negative - Axis ticks are to the left of the axis.
*                              Labels are drawn to the right of the
*                              axis.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:27:50 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DRWVAX (IX0, IY0, LENY, YMIN, YMAX,
     -                   ATICK, ALABEL, NTICK, IFN)


      REAL W0,W1,XSP0,XSP1
      PARAMETER (W0=0.5,W1=0.75,XSP0=1.0,XSP1=1.5)

      INTEGER IX0,IY0,LENY,NTICK,IFN
      INTEGER IW,IH,IW0,IW1,IXS0,IXS1,IXL0,IXR0,IXL1,IXR1,
     -        ICENT,IX,I,IY,NC
      INTEGER LENNUL

      REAL YMIN,YMAX
      REAL ATICK(*)
      REAL ANG,PVY

      CHARACTER*(*) ALABEL(*)


* Draw the axis
      CALL XYVECT(IX0,IY0,IX0,IY0+LENY)

* Determine the offsets for ticks
* IXL0 and IXL0 are used for unlabelled ticks, while
* IXR1 and IXR1 are used for labelled ticks
      CALL GETCHR(IW,IH,ANG)
      CALL SETCHR(IW,IH,0.0)
      IW0=NINT(W0*IW)
      IW1=NINT(W1*IW)
      IXS0=NINT(XSP0*IW)
      IXS1=NINT(XSP1*IW)
      IF (IFN.GT.0) THEN
        IXL0=0
        IXR0=+IW0
        IXL1=0
        IXR1=+IW1
        ICENT=7
        IX=-IXS0
      ELSE IF (IFN.LT.0) THEN
        IXL0=-IW0
        IXR0=0
        IXL1=-IW1
        IXR1=0
        ICENT=1
        IX=+IXS0
      ELSE
        IXL0=-IW0
        IXR0=+IW0
        IXL1=-IW1
        IXR1=+IW1
        ICENT=7
        IX=-IXS1
      END IF


      PVY=LENY/(YMAX-YMIN)
      DO 100 I=1,ABS(NTICK)

        IY=NINT((ATICK(I)-YMIN)*PVY)
        IF (IY.GE.0 .AND. IY.LE.LENY) THEN

* Find the length of the label string
          NC=LENNUL(ALABEL(I))
          IF (NC.GT.0) THEN

* Labelled ticks
* Right or left justify the label beside the tick
            CALL XYVECT(IX0+IXL1,IY0+IY,IX0+IXR1,IY0+IY)
            IF (NTICK.GT.0) THEN
              CALL PLTEXT(IX0+IX,IY0+IY,ICENT,ALABEL(I)(1:NC))
            END IF

          ELSE

* Unlabelled ticks
            CALL XYVECT(IX0+IXL0,IY0+IY,IX0+IXR0,IY0+IY)

          END IF
        END IF

 100  CONTINUE

* Restore the character angle
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE SCALE (FMIN, FMAX, AXLEN, FIRSTV, DELTAV)
*
*
* Purpose:
*     Determine a plotting scale
*
*
* Description:
*     This routine determines a starting value and an increment for an
*     axis suitable for plotting a range of data values.  The scale
*     increment corresponding to axis intervals is chosen to be of the
*     form 1, 2 or 5 times 10**N.  The lower limit of the axis is the
*     largest integer multiple of the axis increment greater than or
*     equal to the lower limit of the data range.
*
*     The scale increment is chosen to be the smallest value of the
*     form 1, 2 or 5 time a power of ten, which gives a range which
*     spans the data limits with an axis length less than or equal to
*     the given value.
*
*     To allow for imprecision in the data range limits, a small
*     compensation is made at the top and bottom ends of the data
*     range.  The lower limit is a multiple of the increment which is
*     less than or equal to the lower limit of the data range plus a
*     small value.  The upper end of the axis is required to be larger
*     than the upper limit of the data range less a small value.
*
*
* Parameters:
* R ->  FMIN   - Minimum data value.  The order of the parameters FMIN
*                and FMAX may be interchanged.
* R ->  FMAX   - Maximum data value.  If FMIN is equal to FMAX, the
*                range of the data is assumed to be 0 to FMAX (or 0 to
*                1 if FMAX is zero).
* R ->  AXLEN  - Length of the axis in intervals (at least two)
* R <-  FIRSTV - Lower limit of the axis.  FIRSTV is a multiple of
*                DELTAV less than or equal to FMIN.
* R <-  DELTAV - Number of data units per axis interval
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:28:47 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE SCALE (FMIN, FMAX, AXLEN, FIRSTV, DELTAV)


      REAL EPS
      PARAMETER (EPS=1E-4)

      INTEGER J
      INTEGER IFLORX

      REAL FMIN,FMAX,AXLEN,FIRSTV,DELTAV
      REAL AMIN,AMAX,DEL,P,DV,FV
      REAL FLOORX

      REAL EVEN(5)
      DATA EVEN/1.,2.,5.,10.,20./


* Determine the minimum and maximum data values
      IF (FMAX.GT.FMIN) THEN
        AMAX=FMAX
        AMIN=FMIN

      ELSE
        AMIN=FMAX
        AMAX=FMIN
        IF (AMAX.EQ.AMIN) THEN

          IF (AMAX.GT.0.0) THEN
            AMIN=0.0
          ELSE IF (AMAX.LT.0.0) THEN
            AMAX=0.0
          ELSE
            AMAX=1.0
          END IF

        END IF

      END IF

* The requirements are
*   n*Del <= Amin < Amax <=  n*Del + a*Del                       (1)
* where a=AXLEN, Del=DELTAV, and n*Del=FIRSTV

* For the lower limit,
*   n*Del <= Amin < (n+1)*Del.
* Let b*Del = Amin - n*Del.  Then 0 <= b < 1.
* For the upper limit,
*   Amax - Amin <= Del*(a-b), or  Del >= (Amax-Amin)/(a-b).
*
* Both Del and b are unknown.  Let
*  Del'=(Amax-Amin)/a .
* This Del' will satisfy (1) if Amin is a multiple of Del' (i.e., b=0).
* For Amin a multiple of Del', n=Amin/Del'.  If Amin is not a multiple
* of Del', the axis must be shifted, decreasing n by one.  Now the
* limit inequality may not be satisfied.  If it is not satisfied,
*   (Amax-Amin)/a = Del' < (Amax-Amin)/(a-b) < (Amax-Amin)/(a-1).
* Consider another value Del, satisfying Del/Del' >= a/(a-1).  Then,
* Del >= (Amax-Amin)/(a-1).  This value of Del satisfies (1) for
* n=floor[Amin/Del].

* We are looking for nice values Del.  The nice values increase by at
* least a factor of two between adjacent values.  Assume a >= 2.  Then
* a "nice" Del which is at most twice as large as Del' will satisfy
* (1).

* The power of ten scale factor must also be determined.  Nominally
* this is determined as M = floor[log10 (Del)].  The value Del is
* unknown at this point.  However, Del >= Del'.  Find
*   M = floor [ log10(Del') ].
* Let P=10**M.  Del'=P*D', where 1 <= D' < 10.
* With the normalization, we are looking for a nice value D which
* satisfies (1) with Del=P*D.  This nice-valued D is at most twice as
* large as D'.  The search loop tests values of D equal to 1, 2, 5, 10,
* and 20.  This set of values values guarantees that there is a D which
* is at least twice D'.
*
* An ancient Fortran compiler had an inaccurate LOG10 function; it did
* not return an integer value for powers of 10.  To avoid problems near
* integer values of the log10 function, M is calculated as
*   M = floor[ log10 (Del') + e ], where e is a small positive value.
* With this value of M and P=10**M, the normalized value D' is in the
* range 10**(-e) <= D' < 10*10**(-e).  The nice values D equal to 1, 2,
* 5, 10, and 20 are still appropriate.

* Finally the test (1) is modified to allow for some imprecision in
* Amin and Amax,
*   n*Del <= Amin + e*Del  and  Amax - e*Del <=  n*Del + a*Del .

      DEL=(AMAX-AMIN)/AXLEN
      P=10.**IFLORX(LOG10(DEL)+EPS)

* Search for a scale interval (EVEN(J)) larger than DEL
      DO 300 J=1,5
        DV=P*EVEN(J)
        IF (DV.GE.DEL) THEN

* The starting value must be a multiple of DV
* Check that the axis spans the data
          FV=FLOORX(AMIN/DV+EPS)*DV
          IF (AMAX.LE.FV+(AXLEN+EPS)*DV) GO TO 400

        END IF

 300  CONTINUE
      CALL WARN('SCALE - Number of intervals too small')

 400  FIRSTV=FV
      DELTAV=DV


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSTAIL (LUN)
*
*
* Purpose:
*     Write a trailer to a Postscript plot file
*
*
* Description:
*     This routine writes trailer information to a Postscript plot
*     file.  The first part of the trailer gives commands to plot the
*     accumulated data and the second part gives plot size information.
*
*
* Parameters:
* I ->  LUN    - Unit number for the file
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:29:30 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSTAIL (LUN)


* PSCALE is the number of plotting units per Postscript point
      REAL PSCALE
      PARAMETER (PSCALE=0.12)

      CHARACTER*10 STXMIN,STYMIN,STXMAX,STYMAX

      INTEGER LUN
      INTEGER NCXMIN,NCXMAX,NCYMIN,NCYMAX

      INTEGER IXMIN,IYMIN,IXMAX,IYMAX,LWP
      COMMON /PSBBOX/ IXMIN,IYMIN,IXMAX,IYMAX,LWP


* Write a trailer to the file
      WRITE (UNIT=LUN,FMT=1000) 'stroke showpage end'
      WRITE (UNIT=LUN,FMT=1000) '%%Trailer'
      IF (IXMAX.GE.IXMIN .AND. IYMAX.GE.IYMIN) THEN
        CALL CONVIC(NINT(PSCALE*IXMIN)+36, STXMIN,NCXMIN)
        CALL CONVIC(NINT(PSCALE*IYMIN)+144,STYMIN,NCyMIN)
        CALL CONVIC(NINT(PSCALE*IXMAX)+36, STXMAX,NCXMAX)
        CALL CONVIC(NINT(PSCALE*IYMAX)+144,STYMAX,NCYMAX)
        WRITE (UNIT=LUN,FMT=1000) '%%BoundingBox: '//
     -      STXMIN(1:NCXMIN)//' '//STYMIN(1:NCYMIN)//' '//
     -      STXMAX(1:NCXMAX)//' '//STYMAX(1:NCYMAX)
      ELSE
        WRITE (UNIT=LUN,FMT=1000) '%%BoundingBox: 0 0 0 0'
      END IF
      WRITE (UNIT=LUN,FMT=1000) '%%EOF'


      RETURN

 1000 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DECPLT (OPTION, ICCSIZE, LINTYP, IPATTN,
*                        SYMBOL, ISSIZE, SANG,
*                        IXAX, IYAX, IXORIG, IYORIG, LENX, LENY,
*                        ATICKX, ATICKY, ALABLX, ALABLY,
*                        NTICKX, NTICKY)
*
*
* Purpose:
*     Decode a plot option string
*
*
* Description:
*     An option string containing a number of option specifications is
*     decoded.  Individual option specifications are separated by white
*     space (blanks, tabs or null characters) or commas.  The general
*     form of the option specifications is KEYWORD=arg or KEYWORD, where
*     KEYWORD is a keyword string.  Keywords can be specified in upper or
*     lower case and in most cases allow for short forms.  The argument
*     string following the keyword is used to specify values or subsidiary
*     option specifications.  Within the argument string, parentheses are
*     used to group lists of values or subsidiary option specifications.
*     Lists of values are enclosed in parentheses with the values
*     separated by white space or commas.  The same keyword may be given
*     more than once, with the last invokation taking precedence.
*
*     Default options are used if some or all of the keywords are
*     omitted.  The subroutine parameters are shown below along with the
*     corresponding specification in the option string.
*
*
* Parameters:
* C ->  OPTION - Input character string
* I <-  ICSIZE - Two element array specifying the character size
*                CHARACTER_SIZE = (width height) (default (32 48))
* I <-  LINTYP - 1  LINE-TYPE=POINTS
*                2  LINE-TYPE=LINE (default)
*                3  LINE-TYPE=LINE+POINTS
*                4  LINE-TYPE=SMOOTH
*                5  LINE-TYPE=SMOOTH+POINTS
* I <-  IPATTN - Five element integer array
*                LINE-TYPE=(PATTERN=(xx yy ...)) (default all zeros)
* C <-  SYMBOL - Character string specifying the plot symbols
*                LINE-TYPE=(SYMBOLS="xxxxx") (default CHAR(161)//
*                CHAR(162)//...)
* I <-  ISSIZE - Two element array specifying the symbol size
*                LINE-TYPE=(SYMBOL_SIZE=(width height)) (default
*                from ICSIZE)
* R <-  SANG   - Real value specifying the symbol angle
*                LINE-TYPE=(SYMBOL_ANGLE=angle) (default 0.0)
* I <-  IXAX   - Four element integer array,
*                X-AXIS=option
*                IXAX(0) = ILL + 4*IUL + 16*ITICK + 32*ILABEL + 64*ILOG
*                  ILL   -  0  (default)
*                           1  X-AXIS=(LIMITS=TICKS) or
*                              X-AXIS=(LIMITS=(LOWER_LIMIT=TICK))
*                           2  X-AXIS=(LIMITS=EXACT) or
*                              X-AXIS=(LIMITS=(LOWER_LIMIT=EXACT))
*                  IUL   -  0  (default)
*                           1  X-AXIS=(LIMITS=TICKS) or
*                              X-AXIS=(LIMITS=(UPPER_LIMIT=TICK))
*                           2  X-AXIS=(LIMITS=EXACT) or
*                              X-AXIS=(LIMITS=(UPPER_LIMIT=EXACT))
*                  ITICK  - 0  X-AXIS=TICKS (default)
*                           1  X-AXIS=(TICKS=(...))
*                  ILABEL - 0  X-AXIS=LABELS (default)
*                           1  X-AXIS=(LABELS=(...))
*                  ILOG   - 0  X-AXIS=LINEAR (default)
*                           1  X-AXIS=LOGARITHMIC
*                IXAX(1) - 0  X-AXIS=(BOTTOM=OFF)
*                          1  X-AXIS=(BOTTOM=LINE)
*                          2  X-AXIS=(BOTTOM=ON)
*                          3  X-AXIS=(BOTTOM=LABELLED) (default)
*                IXAX(2) - 0  X-AXIS=(ORIGIN=OFF)
*                          1  X-AXIS=(ORIGIN=LINE)
*                          2  X-AXIS=(ORIGIN=ON) (default)
*                          3  X-AXIS=(ORIGIN=LABELLED)
*                        Note: IXAX(2)=0 for a log X-axis.
*                IXAX(3) - 0  X-AXIS=(TOP=OFF)
*                          1  X-AXIS=(TOP=LINE)
*                          2  X-AXIS=(TOP=ON) (default)
*                          3  X-AXIS=(TOP=LABELLED)
* I <-  IYAX   - Four element integer array,
*                Y-AXIS=option
*                IXAX(0) = ILL + 4*IUL + 16*ITICK + 32*ILABEL + 64*ILOG
*                  ILL    - 0  (default)
*                           1  Y-AXIS=(LIMITS=TICKS) or
*                              Y-AXIS=(LIMITS=(LOWER_LIMIT=TICK))
*                           2  Y-AXIS=(LIMITS=EXACT) or
*                              Y-AXIS=(LIMITS=(LOWER_LIMIT=EXACT))
*                  IUL    - 0  (default)
*                           1  Y-AXIS=(LIMITS=TICKS) or
*                              Y-AXIS=(LIMITS=(UPPER_LIMIT=TICK))
*                           2  Y-AXIS=(LIMITS=EXACT) or
*                              Y-AXIS=(LIMITS=(UPPER_LIMIT=EXACT))
*                  ITICK  - 0  Y-AXIS=TICKS (default)
*                           1  Y-AXIS=(TICKS=(...))
*                  ILABEL - 0  Y-AXIS=LABELS (default)
*                           1  Y-AXIS=(LABELS=(...))
*                  ILOG   - 0  Y-AXIS=LINEAR (default)
*                           1  Y-AXIS=LOGARITHMIC
*                IYAX(1) - 0  Y-AXIS=(LEFT=OFF)
*                          1  Y-AXIS=(LEFT=LINE)
*                          2  Y-AXIS=(LEFT=ON)
*                          3  Y-AXIS=(LEFT=LABELLED) (default)
*                IYAX(2) - 0  Y-AXIS=(ORIGIN=OFF)
*                          1  Y-AXIS=(ORIGIN=LINE)
*                          2  Y-AXIS=(ORIGIN=ON) (default)
*                          3  Y-AXIS=(ORIGIN=LABELLED)
*                        Note: IYAX(2)=0 for a log Y-axis.
*                IYAX(3) - 0  Y-AXIS=(RIGHT=OFF)
*                          1  Y-AXIS=(RIGHT=LINE)
*                          2  Y-AXIS=(RIGHT=ON) (default)
*                          3  Y-AXIS=(RIGHT=LABELLED)
* I <-  IXORIG - X-coordinate of the plot position
*                POSITION=(IX IY) (default 720)
* I <-  IYORIG - Y-coordinate of the plot position
*                POSITION=(IX IY) (default 440)
* I <-  LENX   - X-dimension of the plot size
*                SIZE=(Lenx Leny) (default 3240)
* I <-  LENY   - Y-dimension of the plot size
*                SIZE=(Lenx Leny) (default 2400)
* R <-  ATICKX - Array of NTICKX tick values.
*                X-AXIS=(TICKS=(val1 val2 ...))
* R <-  ATICKY - Array of NTICKY tick values.
*                Y-AXIS=(TICKS=(val1 val2 ...))
* C <-  ALABLX - Character array with NTICKX elements. A null character
*                terminates short strings.
*                X-AXIS=(LABELS=("label1" "label2" ...)) (default, all
*                labels of zero length)
* C <-  ALABLY - Character array with NTICKY elements. A null character
*                terminates short strings.
*                Y-AXIS=(LABELS=("label1" "label2" ...)) (default, all
*                labels of zero length)
* I <-  NTICKX - Number of elements defined in ATICKX.  NTICKX is at
*                most 100.
*                X-AXIS=(TICKS=(val1 val2 ...)) (default 0)
* I <-  NTICXY - Number of elements defined in ATICKY.  NTICKY is at
*                most 100.
*                Y-AXIS=(TICKS=(val1 val2 ...)) (default 0)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:32 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DECPLT (OPTION, ICSIZE, LINTYP, IPATTN,
     -                   SYMBOL, ISSIZE, SANG,
     -                   IXAX, IYAX, IXORIG, IYORIG, LENX, LENY,
     -                   ATICKX, ATICKY, ALABLX, ALABLY,
     -                   NTICKX, NTICKY)


      INTEGER DEFAULT,TICKV,EXACTV,OFF,LINES,ON,LABEL,
     -        NOTDEF,DEF,LINS,LOGS
      PARAMETER (DEFAULT=0,TICKV=1,EXACTV=2,OFF=0,
     -           LINES=2,ON=2,LABEL=3,
     -           NOTDEF=0,DEF=1,LINS=0,LOGS=1)

      INTEGER LINTYP,NTICKX,NTICKY
      INTEGER ILL,IUL,ITICK,ILABEL,ILOG,IXORIG,IYORIG,LENX,LENY,
     -        NLABLX,NLABLY,NCL,NCT,N,NV,IER,I
      INTEGER IPATTN(5),ICSIZE(2),ISSIZE(2),
     -        IXAX(0:3),IYAX(0:3)
      INTEGER LENSTR

      REAL ATICKX(*),ATICKY(*)
      REAL SANG

      CHARACTER*(*) OPTION,SYMBOL,ALABLX(*),ALABLY(*)
      CHARACTER*2048 LINE
      CHARACTER*512 TOKEN

      INTEGER NEKEY
      PARAMETER (NEKEY=6)
      CHARACTER*15 KEYTAB(NEKEY)
      DATA KEYTAB/'CHAR*ACTER_SIZE', 'LINE*-TYPE'     ,
     -            'X-AX*IS'        , 'Y-AX*IS'        ,
     -            'POS*ITION'      , 'SIZE'           /


* Default values
      LINTYP=LINES
      CALL IZERO(IPATTN,5)
      SYMBOL=CHAR(161)//CHAR(162)//CHAR(163)//CHAR(164)//
     -       CHAR(165)//CHAR(166)//CHAR(167)//CHAR(168)//
     -       CHAR(169)//CHAR(170)//CHAR(0)

      ICSIZE(1)=32
      ICSIZE(2)=48
      ISSIZE(1)=-1
      ISSIZE(2)=-1
      SANG=0.0

      ILL=DEFAULT
      IUL=DEFAULT
      ITICK=NOTDEF
      ILABEL=NOTDEF
      ILOG=LINS
      IXAX(0)=ILL+4*IUL+16*ITICK+32*ILABEL+64*ILOG
      IXAX(1)=LABEL
      IXAX(2)=ON
      IXAX(3)=ON

      IYAX(0)=IXAX(0)
      IYAX(1)=IXAX(1)
      IYAX(2)=IXAX(2)
      IYAX(3)=IXAX(3)

      IXORIG=720
      IYORIG=440
      LENX=3240
      LENY=2400
      NTICKX=0
      NTICKY=0
      NLABLX=0
      NLABLY=0

      CALL RQUOTE(OPTION,LINE,NCL)

* Decode options
 100  NCL=LENSTR(LINE(1:NCL))
      IF (NCL.GT.0) THEN
        CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NCT,N)

*** CHARACTER_SIZE =
        IF (N.EQ.1) THEN
          CALL RDIVAL(TOKEN(1:NCT),2,2,ICSIZE,NV)

*** LINE-TYPE =
        ELSE IF (N.EQ.2) THEN
          CALL DECLIN(TOKEN(1:NCT),LINTYP,IPATTN,SYMBOL,ISSIZE,SANG)

*** X-AXIS =
        ELSE IF (N.EQ.3) THEN
          CALL DECXAX(TOKEN(1:NCT),IXAX,ATICKX,NTICKX,ALABLX,NLABLX)

*** Y-AXIS =
        ELSE IF (N.EQ.4) THEN
          CALL DECYAX(TOKEN(1:NCT),IYAX,ATICKY,NTICKY,ALABLY,NLABLY)

*** POSITION =
        ELSE IF (N.EQ.5) THEN
          CALL RDIVA2(TOKEN(1:NCT),IXORIG,IYORIG,IER)

*** SIZE =
        ELSE IF (N.EQ.6) THEN
          CALL RDIVA2(TOKEN(1:NCT),LENX,LENY,IER)

***
        END IF

      GO TO 100
      END IF

* Set the default symbol size
      IF (ISSIZE(1).EQ.-1 .AND. ISSIZE(2).EQ.-1) THEN
        ISSIZE(1)=ICSIZE(1)
        ISSIZE(2)=ICSIZE(2)
      END IF

* Define unspecified labels as nulls
      DO 220 I=NLABLX+1,NTICKX
        ALABLX(I)=CHAR(0)
 220  CONTINUE
      DO 240 I=NLABLY+1,NTICKY
        ALABLY(I)=CHAR(0)
 240  CONTINUE

* Turn off origin axes for log plots
      ILOG=MOD(IXAX(0)/64,2)
      IF (ILOG.NE.0) IYAX(2)=OFF
      ILOG=MOD(IYAX(0)/64,2)
      IF (ILOG.NE.0) IXAX(2)=OFF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLTLIM (VMIN, VMAX, ILL, IUL, ILOG, DMIN, DMAX)
*
*
* Purpose:
*     Find plot limits for a range of data values
*
*
* Description:
*     This routine chooses plot limits suitable for plotting a range of
*     data.
*
*
* Parameters:
* R ->  VMIN   - Minimum data value
* R ->  VMAX   - Maximum data value
* I ->  ILL    - Lower limit options,
*                1 - The lower limit is to be a tick value less than or
*                    equal to VMIN
*                2 - The lower limit is VMIN
* I ->  IUL    - Upper limit options,
*                1 - The upper limit is to be a tick value greater than
*                    or equal to VMAX
*                2 - The upper limit is VMAX
* I ->  ILOG   - Linear/log axis option,
*                0 - linear axis
*                1 - log axis
* R <-  DMIN   - Lower limit
* R <-  DMAX   - Upper limit
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:46:44 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLTLIM (VMIN, VMAX, ILL, IUL, ILOG, DMIN, DMAX)


      INTEGER MXTICK
      PARAMETER (MXTICK=64)

      INTEGER ILL,IUL,ILOG
      INTEGER IAX,NTICK,IEXP

      REAL VMIN,VMAX,DMIN,DMAX
      REAL ATICK(MXTICK)

      CHARACTER*11 ALABEL(MXTICK)


* Call AXSCAL to determine DMIN and DMAX
      IAX=ILL+4*IUL+64*ILOG
      CALL AXSCAL(VMIN,VMAX,IAX,DMIN,DMAX,ATICK,ALABEL,NTICK,IEXP)


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE FNSCAN (FNAME, KEYWORD, STRO, NCO)
*
*
* PURPOSE:
*	This routine returns components of a file name.
*
*
* DESCRIPTION:
*	This routine returns the requested components of a file
*	name using the $FILESCAN system service routine. The
*	components desired are specified by a list of keywords.
*	The file name given is treated as given, not logical name
*	translation is given out. If components are missing, a
*	request for that component results in a zero length output.
*
*	Keywords are specified in a string, with multiple keywords
*	separated by commas. The returned string consists of the
*	concatenation of the file name components requested. The
*	returned components are given in the the proper file name
*	sequence. The filename scan of the input string terminates
*	at a character that is invalid in a filename context. For
*	example a blank terminates the file name scan.
*	 keyword          returned string
*	FILESPEC     full file specification
*	NODE         node name, including the double colon (::) as
*	             well as any access control string (if present)
*	DEVICE       device name, including the single colon (:)
*	ROOT         root directory string, including opening and
*	             closing brackets ([]) or angle brackets (<>)
*	DIRECTORY    directory name, including opening and closing
*	             brackets ([]) or angle brackets (<>)
*	NAME         file name or quoted file specification following
*	             a node name
*	TYPE         file type, including the preceding period (.)
*	VERSION      file version number, including the preceding
*	             period (.) or semicolon (;)
*
*
* PARAMETERS:
* ->	FNAME  - Input file name string
* ->	KEYWORD - String containing a list of keywords. Keywords are
*	         separated by commas.
* <-	STRO   - Output string containing the requested file name
*	         components. This string is padded with blanks.
* <-	NCO    - Length of the output string not including padding
*	         blanks.
*
*
* ROUTINES REQUIRED:
*	IZERO  - Zero an integer array
*	KEYUPC - Match a keyword
*	LIB$SCOPY_R_DX - Copy a string
*	LIB$SIGNAL - Signal an error condition
*	SYS$FILESCAN - Scan a file name for components
*	WARN   - Signal a warning message
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	86/09/08
*
*
* UPDATES:
*	86/10/06  Fix
*	89/02/03  Pad with blanks
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE FNSCAN (FNAME, KEYWORD, STRO, NCO)


	CHARACTER*(*) FNAME,KEYWORD,STRO

	INTEGER SYS$FILESCAN,
     -	        LIB$SCOPY_R_DX

	PARAMETER (NEKEY=8)
	CHARACTER*20 KEYTAB(NEKEY)
	DATA KEYTAB/
     -	  'FILESPEC',  'NODE', 'DEVICE', 'ROOT',
     -	  'DIRECTORY', 'NAME', 'TYPE',   'VERSION'/

	STRUCTURE /ITEM/
	  UNION
	    MAP
	      INTEGER*2 NC
	      INTEGER*2 ITEM_CODE
	    END MAP
	    MAP
	      INTEGER END_OF_LIST_MARK
	    END MAP
	  END UNION
	  INTEGER ADDRESS
	END STRUCTURE
	STRUCTURE /ITEM_LIST/
	  RECORD /ITEM/ REC(NEKEY+1)
	END STRUCTURE
	RECORD /ITEM_LIST/ FSC_ITEM_LIST

	INCLUDE '($FSCNDEF)'

	INTEGER*2 ITEM_CODE(NEKEY)
	INTEGER IC(NEKEY)
	DATA ITEM_CODE/
     -	  FSCN$_FILESPEC,  FSCN$_NODE, FSCN$_DEVICE, FSCN$_ROOT,
     -	  FSCN$_DIRECTORY, FSCN$_NAME, FSCN$_TYPE,   FSCN$_VERSION/


	IST=1
	CALL IZERO(IC,NEKEY)
	DO WHILE (IST.LE.LEN(KEYWORD))

* Find a comma in the keyword string
	  K=INDEX(KEYWORD(IST:),',')
	  IF (K.EQ.0) THEN
	    IEND=LEN(KEYWORD)
	  ELSE
	    IEND=IST+K-2
	  END IF

* Get the next keyword
	  N=KEYUPC(KEYWORD(IST:IEND),KEYTAB,NEKEY)
	  IF (N.EQ.0) THEN
	    CALL WARN('FNSCAN - Invalid keyword: '//KEYWORD(IST:IEND))
	  ELSE
	    IC(N)=1
	  END IF
	  IST=IEND+2

	END DO


* Set up an item list for the items requested
	IF (IC(1).NE.0) THEN
	  NITEM=1
	  FSC_ITEM_LIST.REC(NITEM).ITEM_CODE=ITEM_CODE(1)
	ELSE
          NITEM=0
	  DO I=2,NEKEY
	    IF (IC(I).NE.0) THEN
	      NITEM=NITEM+1
	      FSC_ITEM_LIST.REC(NITEM).ITEM_CODE=ITEM_CODE(I)
	    END IF
	  END DO
	END IF
	FSC_ITEM_LIST.REC(NITEM+1).END_OF_LIST_MARK=0

* Get the items requested
	ISTAT=SYS$FILESCAN(FNAME,FSC_ITEM_LIST,)
	NCO=0

	IF (.NOT.ISTAT) THEN

* Error return
	  CALL LIB$SIGNAL(%VAL(ISTAT))

	ELSE

* Form the output string
	  NCT=0
	  DO I=1,NITEM
	    NC=FSC_ITEM_LIST.REC(I).NC
	    NCT=NCT+NC
	    NCA=MIN(NC,LEN(STRO)-NCO)
	    ISTAT=LIB$SCOPY_R_DX(NCA,%VAL(FSC_ITEM_LIST.REC(I).ADDRESS),
     -	                         STRO(NCO+1:NCO+NCA))
	    IF (.NOT.ISTAT) CALL LIB$SIGNAL(%VAL(ISTAT))
	    NCO=NCO+NCA
	  END DO
	  IF (NCT.GT.NCO) CALL WARN('FNSCAN - String truncated')
	  IF (NCO.LT.LEN(STRO)) STRO(NCO+1:)=' '

	END IF


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE AXTICK (FIRSTV, DELTAV, NTICK, ATICK, ALABEL, IEXP)
*
*
* Purpose:
*     Generate axis ticks and labels for a linear plot
*
*
* Description:
*     This routine fills in an array of axis values corresponding to
*     locations for axis ticks.  The tick values are uniformly spaced
*     given an initial value and an increment.  The character labels
*     corresponding to these ticks are also generated.  Normally only
*     every second tick has a non-null label.  The label strings are
*     terminated with a null character if they are shorter than the
*     length of the output character string.
*
*
* Parameters:
* R ->  FIRSTV - Data value corresponding to the first tick
* R ->  DELTAV - Data value increments between ticks.  DELTAV must be
*                greater than zero.
* I ->  NTICK  - Number of tick values
* R <-  ATICK  - Array of data values corresponding to the ticks
* C <-  ALABEL - Character array of labels corresponding to the ticks.
*                These are in one-to-one correspondence with the array
*                of tick values.  Each element of ALABEL should be at
*                least 6 characters in length.  Each of the generated
*                labels is terminated with a null character if it is
*                shorter than the length of the array elements.
* I <-  IEXP   - Exponent for the axis labels.  The value of the tick
*                corresponding to an axis label is the value coded in
*                the label string times 10**IEXP.  IEXP is returned as
*                a multiple of 3.  Note that IEXP will be zero if all
*                of the labels can be represented in 4 significant
*                digits.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:27:37 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE AXTICK (FIRSTV, DELTAV, NTICK, ATICK, ALABEL, IEXP)


      INTEGER NPL
      REAL EPS
      PARAMETER (EPS=1E-4,NPL=6)

      INTEGER NTICK,IEXP
      INTEGER ISTRT,INC,IE,ID,IT,I,NC
      INTEGER IFLORX

      CHARACTER*(NPL) CSTR
      CHARACTER*(*) ALABEL(*)

      REAL FIRSTV,DELTAV
      REAL ATICK(*)
      REAL ALASTV,PS


* Label every tick if the number of intervals is small
      IF (NTICK.LE.5) THEN
        ISTRT=1
        INC=1

      ELSE

* Only every second tick will be labelled.  Determine which ticks
* should be labelled.  In the usual case, FIRSTV is a multiple of
* DELTAV, where DELTAV is of the form 1, 2 or 5 times a power of 10.
* There are two cases: either ticks are labelled from the first
* one or ticks are labelled from the second one.
* 1) Normally, the ticks corresponding to even multiples of DELTAV
*    will be labelled.  This ensures that the origin if is within
*    range of the axis will be labelled.
* 2) If the number of ticks is odd, labelling starting with the
*    first tick will give one more labelled tick than starting
*    with the second tick.  If the origin does not appear within the
*    range of the axis AND DELTAV is an even number times a power
*    of 10 (viz. 2) AND the number of ticks is odd, labelling
*    starts with the first tick.
        ALASTV=FIRSTV+(NTICK-1)*DELTAV
        IE=IFLORX(LOG10((1.+EPS)*DELTAV))
        ID=(1.+EPS)*DELTAV/10.**IE
        IT=(1.+EPS)*ABS(FIRSTV/DELTAV)
        IF (MOD(IT,2).EQ.0 .OR.
     -      (MOD(ID,2).EQ.0 .AND. FIRSTV*ALASTV.GT.0.0 .AND.
     -       MOD(NTICK,2).NE.0)) THEN
          ISTRT=1
        ELSE
          ISTRT=2
        END IF
        INC=2

      END IF

* Find a scale factor for the axis labels
      CALL ENGSCL(FIRSTV+(ISTRT-1)*DELTAV,INC*DELTAV,
     -            (NTICK+INC-ISTRT)/INC,NPL-2,IEXP)
      PS=10.**(-IEXP)

* Generate the tick positions and the labels
      DO 400 I=1,NTICK

        ATICK(I)=FIRSTV+(I-1)*DELTAV

* Convert the tick value to a character string
        IF (MOD(I-ISTRT,INC).EQ.0) THEN
          CALL LABEL(PS*ATICK(I),NPL,CSTR,NC)
          ALABEL(I)=CSTR(1:NC)//CHAR(0)
        ELSE
          ALABEL(I)=CHAR(0)
        END IF

 400  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DECAXL (LINE, ILL, IUL)
*
*
* Purpose:
*     Decode axis limit plot options
*
*
* Description:
*     An option string containing a number of option specifications is
*     decoded.  Individual option specifications are separated by white
*     space (blanks, tabs or null characters) or commas.  The general
*     form of the option specifications is KEYWORD=arg or KEYWORD, where
*     KEYWORD is a keyword string.  Keywords can be specified in upper or
*     lower case and in most cases allow for short forms.  The argument
*     string following the keyword is used to specify values or subsidiary
*     option specifications.  Within the argument string, parentheses are
*     used to group lists of values or subsidiary option specifications.
*     Lists of values are enclosed in parentheses with the values
*     separated by white space or commas.  The same keyword may be given
*     more than once, with the last invokation taking precedence.
*
*     The subroutine parameters are shown below along with the
*     corresponding specification in the option string.  The values of
*     the subroutine parameters are changed only if the corresponding
*     keyword is present.
*
*
* Parameters:
* C <-> LINE   - Input character string.  The string is set to blanks
*                on return.
* I <-  ILL    - Lower limit option
*                1  TICKS or
*                   (LOWER_LIMIT=TICK)
*                2  EXACT or
*                   (LOWER_LIMIT=EXACT)
* I <-  IUL    - Upper limit option
*                the corresponding keyword is present.
*                1  TICKS or
*                   (UPPER_LIMIT=TICK)
*                2  EXACT or
*                   (UPPER_LIMIT=EXACT)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:25 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DECAXL (LINE, ILL, IUL)


      INTEGER TICKV,EXACTV
      PARAMETER (TICKV=1,EXACTV=2)

      INTEGER ILL,IUL
      INTEGER IFN,NCT,N,NN
      INTEGER LENSTR

      CHARACTER*(*) LINE
      CHARACTER*512 TOKEN

      INTEGER NELIM,NESLM
      PARAMETER (NELIM=4)
      CHARACTER*12 LIMTAB(NELIM)
      PARAMETER (NESLM=2)
      CHARACTER*5 SLMTAB(NESLM)


      DATA IFN/0/
      DATA LIMTAB/'TICK*S'         , 'EXACT'          ,
     -            'LOW*ER_LIMIT'   , 'UP*PER_LIMIT'   /
      DATA SLMTAB/'TICK'           , 'EXACT'          /


 100  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,LIMTAB,NELIM,TOKEN,NCT,N)

*** TICKS
        IF (N.EQ.1) THEN
          ILL=TICKV
          IUL=TICKV

*** EXACT
        ELSE IF (N.EQ.2) THEN
          ILL=EXACTV
          IUL=EXACTV

*** LOWER_LIMIT
        ELSE IF (N.EQ.3) THEN
          CALL FNDPAR(TOKEN,SLMTAB,NESLM,TOKEN(1:IFN),NCT,NN)
          IF (NN.EQ.1) THEN
            ILL=TICKV
          ELSE IF (NN.EQ.2) THEN
            ILL=EXACTV
          END IF

*** UPPER_LIMIT
        ELSE IF (N.EQ.4) THEN
          CALL FNDPAR(TOKEN,SLMTAB,NESLM,TOKEN(1:IFN),NCT,NN)
          IF (NN.EQ.1) THEN
            IUL=TICKV
          ELSE IF (NN.EQ.2) THEN
            IUL=EXACTV
          END IF

***
        END IF

      GO TO 100
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VSMULN (X, A, Y, N)
*
*
* Purpose:
*     Multiply each element of a vector by a scalar value
*
*
* Description:
*     This routine multiplies each element of a vector by a given
*     value,
*       Y(i) = A*X(i)  for i from 1 to N.
*
*
* Parameters:
* R ->  X      - Input vector
* R ->  A      - Input value
* R <-  Y      - Output vector
* I ->  N      - Number of elements in each of X and Y.  N may be zero.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:05:57 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VSMULN (X, A, Y, N)


      INTEGER N
      INTEGER I

      REAL A
      REAL X(*),Y(*)


      DO 100 I=1,N
        Y(I)=A*X(I)
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VCLIP (X, Y, N, YMIN, YMAX)
*
*
* Purpose:
*     Clip elements of a vector
*
*
* Description:
*     This routine clips an array of data.  Data values below YMIN are
*     replaced by YMIN, while data values above YMAX are replaced by
*     YMAX.
*
*
* Parameters:
* R ->  X       - Array of samples to be clipped
* R <-  Y       - Output array
* I ->  N       - Number of elements in X
* R ->  YMIN    - Lower clipping level
* R ->  YMAX    - Upper clipping level (YMAX >= YMIN)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:05:09 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VCLIP (X, Y, N, YMIN, YMAX)


      INTEGER N
      INTEGER I

      REAL YMIN,YMAX
      REAL X(*),Y(*)


      DO 100 I=1,N
        IF (X(I).GE.YMAX) THEN
          Y(I)=YMAX
        ELSE IF (X(I).LE.YMIN) THEN
          Y(I)=YMIN
        ELSE
          Y(I)=X(I)
        END IF
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VZERO (X, N)
*
*
* Purpose:
*     Zero each element in a REAL array
*
*
* Description:
*     Each element of the array is zeroed.
*
*
* Parameters:
* R <-  X      - Array to be zeroed
* I ->  N      - Number of elements to be zeroed.  N can be zero.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:06:06 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VZERO (X, N)


      INTEGER N
      INTEGER I


      REAL X(*)


      DO 100 I=1,N
        X(I)=0.0
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DECYAX (LINE, IYAX, ATICK, NTICK, ALABEL, NLABEL)
*
*
* Purpose:
*     Decode Y-axis plot options
*
*
* Description:
*     An option string containing a number of option specifications
*     is decoded.  Individual option specifications are separated by
*     white space (blanks, tabs or null characters) or commas.  The
*     general form of the option specifications is KEYWORD=arg or
*     KEYWORD, where KEYWORD is a keyword string.  Keywords can be
*     specified in upper or lower case and in most cases allow for
*     short forms.  The argument string following the keyword is used
*     to specify values or subsidiary option specifications.  Within
*     the argument string, parentheses are used to group lists of
*     values or subsidiary option specifications. Lists of values are
*     enclosed in parentheses with the values separated by white
*     space or commas.  The same keyword may be given more than once,
*     with the last invokation taking precedence.
*
*     The subroutine parameters are shown below along with the
*     corresponding specification in the option string.  The values
*     of the subroutine parameters are changed only if the corresponding
*     keyword is present.
*
*
* Parameters:
* C <-> LINE   - Input character string.  The string is set to blanks
*                on return.
* I <-  IYAX   - Four element integer array specifying the axis options
*                IYAX(0) = ILL + 4*IUL + 16*ITICK + 32*ILABEL + 64*ILOG
*                  ILL   -  1  LIMITS=TICKS or
*                              LIMITS=(LOWER_LIMIT=TICK)
*                           2  LIMITS=EXACT or
*                              LIMITS=(LOWER_LIMIT=EXACT)
*                  IUL   -  0  (default)
*                           1  LIMITS=TICKS or
*                              LIMITS=(UPPER_LIMIT=TICK)
*                           2  LIMITS=EXACT or
*                              LIMITS=(UPPER_LIMIT=EXACT)
*                  ITICK  - 0  TICKS
*                           1  TICKS=(...)
*                  ILABEL - 0  LABELS
*                           1  LABELS=(...)
*                  ILOG   - 0  LINEAR
*                           1  LOGARITHMIC
*                IYAX(1) - 0  LEFT=OFF
*                          1  LEFT=LINE
*                          2  LEFT=ON
*                          3  LEFT=LABELLED
*                IYAX(2) - 0  ORIGIN=OFF
*                          1  ORIGIN=LINE
*                          2  ORIGIN=ON
*                          3  ORIGIN=LABELLED
*                IYAX(3) - 0  RIGHT=OFF
*                          1  RIGHT=LINE
*                          2  RIGHT=ON
*                          3  RIGHT=LABELLED
* R <-  ATICK  - Array of NTICK tick values
*                TICKS=(val1 val2 ...)
* I <-  NTICK  - Number of elements defined in ATICK.  NTICK is at most
*                100.
*                TICKS=(val1 val2 ...)
* C <-  ALABEL - Character array with NLABEL elements. A null character
*                terminates short strings.
*                LABELS=("label1" "label2" ...)
* I <-  NLABEL - Number of elements defined in ALABEL.  NLABEL is at
*                most 100.
*                LABELS=(label1 label2 ...)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:30:38 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DECYAX (LINE, IYAX, ATICK, NTICK, ALABEL, NLABEL)


      INTEGER OFF,ON,LABEL,NOTDEF,DEF,LINS,LOGS
      INTEGER MXTICK
      PARAMETER (OFF=0,ON=2,LABEL=3,NOTDEF=0,DEF=1,LINS=0,LOGS=1)
      PARAMETER (MXTICK=100)

      INTEGER NTICK
      INTEGER IYAX(0:3)
      INTEGER IFN,ILL,IUL,ITICK,ILABEL,ILOG,
     -        NCT,N,INDEX,NN,NLABEL
      INTEGER LENSTR

      CHARACTER*(*) LINE,ALABEL(*)
      CHARACTER*512 TOKEN

      REAL ATICK(*)

      INTEGER NEYAX,NEAXT
      PARAMETER (NEYAX=10)
      CHARACTER*12 YAXTAB(NEYAX)
      PARAMETER (NEAXT=4)
      CHARACTER*9 AXTTAB(NEAXT)

      DATA IFN/0/
      DATA YAXTAB/'LIM*ITS'        , 'L*EFT'          ,
     -            'ORIG*IN'        , 'R*IGHT'         ,
     -            'TICK*S'         , 'LABEL*S'        ,
     -            'ON'             , 'OFF'            ,
     -            'LIN*EAR'        , 'LOG*ARITHMIC'   /
      DATA AXTTAB/'OFF'            , 'LINE'           ,
     -            '*ON'            , 'LABEL*LED'      /


* Separate the elements of the axis option code
      ILL=MOD(IYAX(0),4)
      IUL=MOD(IYAX(0)/4,4)
      ITICK=MOD(IYAX(0)/16,2)
      ILABEL=MOD(IYAX(0)/32,2)
      ILOG=MOD(IYAX(0)/64,2)


 100  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,YAXTAB,NEYAX,TOKEN,NCT,N)

*** LIMITS
        IF (N.EQ.1) THEN
          CALL DECAXL(TOKEN,ILL,IUL)

*** LEFT =, ORIGIN = or RIGHT =
        ELSE IF (N.EQ.2 .OR. N.EQ.3 .OR. N.EQ.4) THEN
          INDEX=N-1
          CALL FNDPAR(TOKEN,AXTTAB,NEAXT,TOKEN(1:IFN),NCT,NN)
          IF (NN.GT.0) IYAX(INDEX)=NN-1

*** TICKS =
        ELSE IF (N.EQ.5) THEN
          CALL RDRVAL(TOKEN,0,MXTICK,ATICK,NTICK)
          IF (NTICK.EQ.0) THEN
            ITICK=NOTDEF
          ELSE
            ITICK=DEF
          END IF

*** LABELS =
        ELSE IF (N.EQ.6) THEN
          CALL RDCSTR(TOKEN,0,MXTICK,ALABEL,NLABEL)
          IF (NLABEL.EQ.0) THEN
            ILABEL=NOTDEF
          ELSE
            ILABEL=DEF
          END IF

*** ON
        ELSE IF (N.EQ.7) THEN
          IYAX(1)=LABEL
          IYAX(2)=ON
          IYAX(3)=ON

*** OFF
        ELSE IF (N.EQ.8) THEN
          IYAX(1)=OFF
          IYAX(2)=OFF
          IYAX(3)=OFF

*** LINEAR
        ELSE IF (N.EQ.9) THEN
          ILOG=LINS

*** LOGARITHMIC
        ELSE IF (N.EQ.10) THEN
          ILOG=LOGS

***
        END IF

      GO TO 100
      END IF

* Form the composite axis option code
      IYAX(0)=ILL+4*IUL+16*ITICK+32*ILABEL+64*ILOG


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION IPOSN (MINX, MINY, MAXX, MAXY, IX, IY)
*
*
* Purpose:
*     Return a location code relative to a rectangle
*
*
* Description:
*     The returned function value is coded as the sum of the following
*     codes.
*       0 - The point is within the rectangle
*       1 - The point is to the Left of the rectangle
*       2 - The point is to the Right of the rectangle
*       4 - The point is Below the rectangle
*       8 - The point is Above the rectangle
*
*
* Parameters:
* I <-  IPOSN  - Returned function value, giving the relative position
*                of the test point with respect to the given rectangle.
*                Note that codes 3 and 7 are never returned.
*                1 - Left                6 - Right and Bottom
*                2 - Right               8 - Top
*                4 - Bottom              9 - Left and Top
*                5 - Left and Bottom    10 - Right and Top
*
* I ->  MINX,MINY - X and Y coordinates or the lower lefthand corner
*                   of the visible rectangle (plotting coordinates)
* I ->  MAXX,MAXY - X and Y coordinates of the upper righthand corner
*                   of the visible rectangle (plotting coordinates)
* I ->  IX,IY     - X and Y coordinates of the point to be tested
*                   (plotting coordinates)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:30:47 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION IPOSN (MINX, MINY, MAXX, MAXY, IX, IY)


      INTEGER IL,IR,IB,IT
      PARAMETER (IL=1,IR=2,IB=4,IT=8)

      INTEGER MINX,MINY,MAXX,MAXY,IX,IY

      IPOSN=0

      IF (IX.LT.MINX) THEN
        IPOSN=IL
      ELSE IF (IX.GT.MAXX) THEN
        IPOSN=IR
      END IF

      IF (IY.LT.MINY) THEN
        IPOSN=IPOSN+IB
      ELSE IF (IY.GT.MAXY) THEN
        IPOSN=IPOSN+IT
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VTEND
*
*
* Purpose:
*     Terminate a plot on a ReGIS display
*
*
* Description:
*     This subroutine exits ReGIS mode with the text cursor placed at
*     the home position.  The routine then closes the plotting unit.
*
*
* Parameters:
*     None
*
*
* Author / revision:
*     D. Sloan / P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:59 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VTEND


      INTEGER ESC,BSLASH
      PARAMETER (ESC=27,BSLASH=92)

      CHARACTER*1 CESC,CBSL

      INTEGER LUNVT
      CHARACTER*255 FNAMVT
      COMMON /VTCOM/ LUNVT,FNAMVT


* Exit Regis
      CESC=CHAR(ESC)
      CBSL=CHAR(BSLASH)
      WRITE (UNIT=LUNVT,FMT=1000) CESC//CBSL//CESC//'8'

* Close the unit
      IF (LUNVT.NE.6) THEN
        CLOSE (UNIT=LUNVT)
        CALL RELFUN(LUNVT)
      END IF

* Set the common area parameters to their default values
      LUNVT=-1
      FNAMVT='/dev/tty'


      RETURN

 1000 FORMAT (A)

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*       SUBROUTINE VTEND
*
*
* PURPOSE:
*       This subroutine terminates a plot on a ReGIS terminal.
*
*
* DESCRIPTION:
*       This subroutine exits ReGIS mode with the text cursor placed
*       at the home position. The routine then closes the plotting unit.
*
*
* PARAMETERS:
*       None
*
*
* ROUTINES REQUIRED:
*       RELFUN - Release a unit number
*
*
* AUTHOR / MAINTAINED BY:
*       D. Sloan / P. Kabal
*
*
* DATE CREATED:
*       1984/21/17
*
*
* UPDATES:
*       1990/03/01  New common area
*
*
*---------------------------INRS-Telecommunications---------------------------

        SUBROUTINE VTEND


        INTEGER ESC,BSLASH
        PARAMETER (ESC=27,BSLASH=92)

        CHARACTER*1 CESC,CBSL

        INTEGER LUNVT
        CHARACTER*255 FNAMVT
        COMMON /VTCOM/ LUNVT,FNAMVT


* Exit Regis
        CESC=CHAR(ESC)
        CBSL=CHAR(BSLASH)
        WRITE (UNIT=LUNVT,FMT=1000) CESC//CBSL//CESC//'8'

* Close the unit
        CLOSE (UNIT=LUNVT)
        CALL RELFUN(LUNVT)

* Set the common area parameters to their default values
        LUNVT=-1
        FNAMVT=' '

        RETURN

1000    FORMAT (A)

        END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE UNXY (IX, IY, LWIDTH)
*
*
* Purpose:
*     Send a vector to a Unix plot file
*
*
* Description:
*     This routine writes a plot vector to a Unix plot file.
*
*
* Parameters:
* I ->  IX     - X coordinate in plotting units (0 to 4095)
* I ->  IY     - Y coordinate in plotting units (0 to 4095)
* I ->  LWIDTH - Line width (plot units).  A zero width line indicates
*                an invisible line.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:29:57 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE UNXY (IX, IY, LWIDTH)


      INTEGER IX,IY,LWIDTH
      INTEGER IBO
      INTEGER*2 ICOORD(2)
      INTEGER IBYORD

      INTEGER LUNUN
      CHARACTER*255 FNAMUN
      COMMON /UNCOM/ LUNUN,FNAMUN


* Write the command
      IF (LWIDTH.NE.0) THEN
        CALL FPUTCN(LUNUN,'n')
      ELSE
        CALL FPUTCN(LUNUN,'m')
      END IF

* Write the coordinates in binary format (machine-dependent byte order)
      ICOORD(1)=IX
      ICOORD(2)=IY
      IBO=IBYORD()
      CALL FPUTI2(LUNUN,ICOORD,2,IBO)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE UNINIT (OPTION)
*
*
* Purpose:
*     Initialize a Unix plot file
*
*
* Description:
*     A Unix plot file is opened and an initial space command to set
*     the plot limits is written to the file.
*
*
* Parameters:
* C ->  OPTION - Character string specifying the options.  Options are
*                separated by commas and/or whitespace (blanks, tabs,
*                or nulls).  If any option is omitted, the default
*                value is used.  An all blank string gives the default
*                values.  The same keyword may appear more than once,
*                with the last instance taking precedence.
*                FILENAME=name - Specifies the name of the file to
*                  which plot data is sent.  The file name is not used
*                  if this plot device is already active.  The special
*                  file name "*" can be  used to direct output to the
*                  standard output (Fortran unit 6).  The default file
*                  name is "unplot.dat".
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:29:54 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE UNINIT (OPTION)


      INTEGER NEKEY
      PARAMETER (NEKEY=1)

      INTEGER NC,N,NCN,IBO
      INTEGER LENSTR
      INTEGER*2 ISPACE(4)
      INTEGER IBYORD

      CHARACTER*(*) OPTION
      CHARACTER*256 LINE,TOKEN
      CHARACTER*20 KEYTAB(NEKEY)

      INTEGER LUNUN
      CHARACTER*255 FNAMUN
      COMMON /UNCOM/ LUNUN,FNAMUN
      DATA LUNUN/-1/,FNAMUN/'unplot.dat'/

      DATA KEYTAB/'FILE*NAME'      /
      DATA ISPACE/0,0,4095,4095/


      CALL RQUOTE(OPTION,LINE,NC)

* Decode the options
 100  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NC,N)

        IF (N.EQ.1) THEN
          CALL RQUOTE(TOKEN(1:NC),FNAMUN,NCN)

        END IF

      GO TO 100
      END IF


      IF (LUNUN.LT.0) THEN

* Not previously selected
* Open the file
        IF (FNAMUN.EQ.'*') THEN
          LUNUN=6
        ELSE
          CALL FBAKUP(FNAMUN)
          CALL GETFUN(LUNUN)
          OPEN (UNIT=LUNUN,FILE=FNAMUN,STATUS='UNKNOWN')
        END IF

* Define the workspace (coordinates in machine-dependent byte order)
        IBO=IBYORD()
        CALL FPUTCN(LUNUN,'s')
        CALL FPUTI2(LUNUN,ISPACE,4,IBO)
        CALL FPUTCN(LUNUN,'e')

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE RDRVA1 (LINE, VAL, IER)
*
*
* Purpose:
*     Decode a real value
*
*
* Description:
*     This routine decodes a string containing a numeric value.  The
*     decoded datum is stored as a real value.  If an error is detected
*     (decoding error, too few values, or too many values), an error
*     flag is set.
*
*
* Parameters:
* C ->  LINE   - Input string.  Blanks in the string are ignored.
* R <-  VAL    - Output real value.  This value is not set in case of
*                an error.
* I <-  IER    - Error code,
*                0 - No error
*                1 - Error
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:47 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE RDRVA1 (LINE, VAL, IER)


      INTEGER IER
      INTEGER NV

      CHARACTER*(*) LINE

      REAL VAL
      REAL VT(1)


* Use RDRVAL to decode the value
      CALL RDRVAL(LINE,1,1,VT,NV)
      IF (NV.EQ.1) THEN
        VAL=VT(1)
        IER=0
      ELSE
        IER=1
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION IFLORX (X)
*
*
* Purpose:
*     Calculate the floor function
*
*
* Description:
*     This function calculate the floor function of x.  It returns the
*     largest integer that is less than or equal to x.
*
*
* Parameters:
* I <-  IFLORX - Returned integer value
*
* R ->  X      - Input value
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:26:50 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION IFLORX (X)


      REAL X


* For positive values, INT(.) works as the floor function
      IFLORX=INT(X)
      IF (X.LT.0.0 .AND. X.NE.IFLORX) IFLORX=IFLORX-1


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION DMCINT (K, X, Y, N)
*
*
* Purpose:
*     Calculate a derivative for a cubic
*
*
* Description:
*     This routine calculates a derivative value that can be used to
*     generate piecewise monotone cubic hermite interpolants to the
*     given data values. If the input data has a local extremum at the
*     point at which the derivative is to be calculated, the derivative
*     corresponding to that point will be returned as zero.
*
*
* Parameters:
* R <-  DMCINT - Output derivative value corresponding to point K
*
* I ->  K      - Evaluation point (1 to N)
* R ->  X      - Input abscissa values.  These values must be in
*                increasing order.
* R ->  Y      - Input ordinate values
* I ->  N      - Number of data values. Only values in the neighborhood
*                of K will be used.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:25:36 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION DMCINT (K, X, Y, N)


      INTEGER K,N

      REAL X(N),Y(N)
      REAL DMCINM,DMCINE


* Middle point
      IF (K.GT.1 .AND. K.LT.N) THEN
        DMCINT=DMCINM(X(K)-X(K-1),X(K+1)-X(K),
     -                Y(K)-Y(K-1),Y(K+1)-Y(K))

* End point: beginning
      ELSE IF (N.GT.2 .AND. K.EQ.1) THEN
        DMCINT=DMCINE(X(2)-X(1),X(3)-X(2),
     -                Y(2)-Y(1),Y(3)-Y(2))

* End point: end
      ELSE IF (K.EQ.N .AND. N.GT.2) THEN
        DMCINT=DMCINE(X(N)-X(N-1),X(N-1)-X(N-2),
     -                Y(N)-Y(N-1),Y(N-1)-Y(N-2))

* Special case: linear interpolation
      ELSE IF ((K.EQ.1 .OR. K.EQ.2) .AND. N.EQ.2) THEN
        DMCINT=DMCINM(X(2)-X(1),X(2)-X(1),
     -                Y(2)-Y(1),Y(2)-Y(1))

* Single reference point
      ELSE IF (K.EQ.1 .AND. N.EQ.1) THEN
        DMCINT=0.0

      ELSE
        CALL HALT('DMCINT - Invalid input value')

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE XYDASH (IX1,IY1, IX2,IY2, IPATTN, K, REMAIN)
*
*
* Purpose:
*     Draw a dashed line
*
*
* Description:
*     The given points defining a vector are joined with a patterned
*     line.  The pattern consists of on/off segments of arbitrary
*     length.  No checking is done in this routine to determine if the
*     plotting will extend outside the bounds of the plotting device.
*
*
* Parameters:
* I ->  IX1,IY1 - X and Y coordinates of the start of the vector
*                 (plotting coordinates)
* I ->  IX2,IY2 - X and Y coordinates of the end of the vector
*                 (plotting coordinates)
* I ->  IPATTN - Line pattern.  This is a five element array describing
*                the line pattern to be used. The patterns are coded as
*                lengths of on and off segments.  A positive value
*                indicates on, while a negative value indicates off.
*                Zero values are ignored, except that an all zero
*                vector denotes a continuous line.
* I <-> K      - Element of the array IPATTN being accessed.  This
*                value is updated.
* R <-> REMAIN - Real value specifying what portion of IPATTN(K)
*                remains to be used.  This value is updated.  The
*                combination of K and REMAIN allow this routine to be
*                used in a loop to draw several line segments with the
*                pattern continuous between line segments.  Suitable
*                values for the first call to this routine are K=1,
*                REMAIN=ABS(IPATTN(K)).
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:05 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE XYDASH (IX1,IY1, IX2,IY2, IPATTN, K, REMAIN)


      INTEGER IX1,IY1,IX2,IY2,K
      INTEGER IPATTN(5)
      INTEGER IDX,IDY,IXS,IYS,I,IXF,IYF

      REAL REMAIN
      REAL VECTL,VECTD


      IDX=IX2-IX1
      IDY=IY2-IY1
      IXS=IX1
      IYS=IY1

* VECTL is the length of the full line to be drawn
* VECTD is the length of the line that will be drawn if
*   the present pattern element is used fully.
      VECTL=SQRT(REAL(IDX)**2+REAL(IDY)**2)
      VECTD=REMAIN

 100  CONTINUE

      IF (REMAIN.LE.0.0) THEN

* New pattern element.  If IPATTN is all zero, draw
* the whole vector.
        DO 120 I=1,5
          K=MOD(K,5)+1
          IF (IPATTN(K).NE.0) THEN
            REMAIN=ABS(IPATTN(K))
            VECTD=VECTD+REMAIN
            GO TO 140
          END IF
 120    CONTINUE
        VECTD=VECTL
 140    CONTINUE

      END IF


      IF (VECTD.LT.VECTL) THEN

* Partial vector
* Note: The algorithm employed, resolves the end points of the line
*       segment onto the plotting grid.  This is done in the same
*       manner as in the drawing routine so that the end points of
*       the line segment have the same plotting coordinates as the
*       corresponding points on the full line.
        IF (ABS(IDX).GE.ABS(IDY)) THEN
          IF (IDX.NE.0) THEN
            IXF=NINT((VECTD/VECTL)*IDX) + IX1
            IYF=NINT((REAL(IXF-IX1)/IDX) * IDY) + IY1
          ELSE
            IXF=IX1
            IYF=IY1
          END IF
        ELSE
          IYF=NINT((VECTD/VECTL)*IDY) + IY1
          IXF=NINT((REAL(IYF-IY1)/IDY) * IDX) + IX1
        END IF
        REMAIN=0.0

      ELSE

* Vector to the end of the line segment
        IXF=IX2
        IYF=IY2
        REMAIN=VECTD-VECTL

      END IF

* Draw a line segment
      IF (IPATTN(K).GE.0)
     -  CALL XYVECT(IXS,IYS,IXF,IYF)
      IXS=IXF
      IYS=IYF

* See if the whole vector has been drawn
      IF (VECTD.LT.VECTL) GO TO 100


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSHEAD (LUN)
*
*
* Purpose:
*     Write a header to a Postscript plot file
*
*
* Description:
*     This routine writes header information to an encapsulated
*     Postscript plot file.  This information includes the creator and
*     the date.  In addition the preamble text defines macros to carry
*     out the plotting.
*
*     Note: The bounding box information is placed in the trailer.
*           Before inclusion in another document, this information
*           should be moved to the header.
*
*
* Parameters:
* I ->  LUN    - Unit number for the file
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:29:25 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSHEAD (LUN)


      CHARACTER*60 USER
      CHARACTER*20 DATTIM

      INTEGER LUN
      INTEGER NC

      INTEGER IXMIN,IYMIN,IXMAX,IYMAX,LWP
      COMMON /PSBBOX/ IXMIN,IYMIN,IXMAX,IYMAX,LWP


* Reset the bounding box calculations
      IXMIN=+1000000
      IYMIN=+1000000
      IXMAX=-1000000
      IYMAX=-1000000
      LWP=0

* Write a header to the file
      WRITE (UNIT=LUN,FMT=1000) '%!PS-Adobe-3.0 EPSF-3.0'
      WRITE (UNIT=LUN,FMT=1000) '%%Title: Graphics'
      WRITE (UNIT=LUN,FMT=1000) '%%Creator: PK plot package'
      CALL GETDAT(DATTIM)
      WRITE (UNIT=LUN,FMT=1000) '%%CreationDate: '//DATTIM
      CALL GETUSR(USER,NC)
      WRITE (UNIT=LUN,FMT=1000) '%%For: '//USER(1:NC)
      WRITE (UNIT=LUN,FMT=1000) '%%Pages: 1'
      WRITE (UNIT=LUN,FMT=1000) '%%BoundingBox: (atend)'

* Set up macros in a new dictionary
* Postscript notes:
* - The new dictionary helps keep tight rein on the definitions
* - A maximum of 1400 points are allowed in each path (PS limit
*   is 1500). /npath is a counter for the number of points.
*   /pathlimit is the maximum number of points allowed.  When this
*   limit gets exceeded, an extra /stroke and /moveto are inserted.
      WRITE (UNIT=LUN,FMT=1000) '8 dict begin'
      WRITE (UNIT=LUN,FMT=1000) '/npath 0 def'
      WRITE (UNIT=LUN,FMT=1000) '/pathlimit 1400 def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '/L {/npath npath 1 add def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '    npath pathlimit gt {currentpoint m} if'
      WRITE (UNIT=LUN,FMT=1000)
     -      '    lineto} bind def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '/H {currentpoint exch pop L} bind def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '/V {currentpoint pop exch L} bind def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '/m {stroke moveto /npath 0 def} bind def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '/B {currentpoint m 0 setgray setlinewidth} bind def'
      WRITE (UNIT=LUN,FMT=1000)
     -      '/W {currentpoint m 1 setgray setlinewidth} bind def'

* Define the transformation from user coordinates
* The Apple laserwriter has a letter size of 8.0 by 10.92 inches
* or 2400 by 3276 dots (300 dots/inch)
* Set up the mapping to have 600 plotting units per inch (2 plotting
* units per dot), i.e. scale points (1/72 inches) by 72/600=0.12.
* Shift the origin to (0.5,2) inches
      WRITE (UNIT=LUN,FMT=1000) '36 144 translate 0.12 0.12 scale'
      WRITE (UNIT=LUN,FMT=1000) '1 setlinecap 2 setlinejoin'


      RETURN

 1000 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GTPSTE (STRING, QCHARS, IS1, IE1, IS2, IE2, ISEP)
*
*
* Purpose:
*     Parse a string with equal sign and comma separators
*
*
* Description:
*     This routine finds the first occurrence of separator strings in
*     an input string.  A separator string occurs between substrings in
*     the original string and consists of either white space separator
*     or a comma separator.  A white space separator consists entirely
*     of white space (blanks, tabs or null characters).  A comma
*     separator consists of a comma, optionally surrounded by white
*     space.  An equal sign separator consists of an equal sign with
*     optional surrounding white space.  A white space separator cannot
*     occur at the beginning or end of the input string.
*
*     Optionally paired quote characters can be specified to allow
*     white space and the separator character to appear in the string
*     without acting as separators.
*
*     The string syntax is " AAAA  = BBBB [,] CCCC..."
*
*     The non-blank extent of the string before the equal sign is
*     STRING(IS1:IE1), with the possibility that the substring has a
*     zero length (IE1=IS1-1).  The non-blank extent of the string
*     after the equal but before the comma or whitespace separator is
*     STRING(IS2:IE2), with the possibility that the substring has zero
*     length (IE2=IS2-1).  The whitespace surrounded equal sign
*     delimiter is in the substring STRING(IE1+1:IS2-1).  However, if
*     an equal sign delimiter is not found, the substring limits may
*     indicate a zero or negative length.  The last character in the
*     comma separator is STRING(ISEP:ISEP).  If a separator is not
*     found, ISEP is set to LEN(STRING)+1.  If a separator is found,
*     the non-blank portion of the string following the separator
*     starts with STRING(ISEP+1:ISEP+1).
*
*     String                       IS1  IE1  IS2  IE2 ISEP
*     "  AAAA = BBBB , CCCC...."    3    6   10   13   16
*     "  "                          1    0    1    0    3
*     "AAAA , CCCC"                 1    4    4    3    7
*     "AAAA(II II) = BBB  CCCC"     1   11   15   17   19
*     "AAAA       "                 1    4    4    3   12
*
*
* Parameters:
* C ->  STRING - Input character string
* C ->  QCHARS - Character string specifying pairs of quote characters
*                (the left and right quote characters).  For instance,
*                QCHARS='""()' specifies that double quotes and
*                parentheses serve as quote characters.  In the part of
*                the input string between a matched pair of quote
*                characters, any other characters, including quote
*                characters other than from the pair in question, are
*                treated as ordinary characters.  Up to 5 pairs of
*                quote characters can be specified.  A blank string
*                signifies no quote characters are to be recognized.
*                Trailing blanks in the string QCHARS are ignored.
* I <-  IS1    - Pointer to the characters that starts the non-blank
*                portion of the input string before the equal sign.
*                IS1 will be equal to 1 in the case of no non-blank
*                characters being found in front of an equal sign.
* I <-  IE1    - Pointer to the character that terminates the portion
*                of the input string before the equal sign.  Normally
*                IE1 will point to a non-blank character.  However, in
*                the case of no non-blank characters being found in
*                front of the equal sign, IE1 will be set to zero.
* I <-  IS2    - Pointer to the characters that starts the non-blank
*                portion of the input string after the equal sign.
* I <-  IE2    - Pointer to the character that terminates the portion
*                of the input string after the equal sign
* I <-  ISEP   - Pointer to the character that ends the separator.  In
*                the case of a separator with trailing white space,
*                ISEP points to the last white space character in the
*                separator.  In the case of no separator being found,
*                ISEP is equal to LEN(STRING)+1.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.8 $  $Date: 1995/03/08 15:41:12 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GTPSTE (STRING, QCHARS, IS1, IE1, IS2, IE2, ISEP)


      INTEGER IS1,IE1,IS2,IE2,ISEP
      INTEGER ITS,ITE,ISEP1,KK,ISEP2

      CHARACTER*(*) STRING,QCHARS


* Pick up the first delimiter, comma or equal sign
      CALL GTPSTR(STRING,',=',QCHARS,ITS,ITE,ISEP1)
      IS1=ITS
      IE1=ITE
      IF (ITE.GT.0) THEN
        IS2=ITE
      ELSE
        IS2=1
      END IF
      IE2=IS2-1
      ISEP=ISEP1


      IF (ISEP1.LE.LEN(STRING)) THEN

* If we found an equal sign, scan for a comma separator
        KK=INDEX(STRING(ITE+1:ISEP1),'=')
        IF (KK.NE.0) THEN
          CALL GTPSTR(STRING(ISEP1+1:),',',QCHARS,ITS,ITE,ISEP2)
          IS2=ITS+ISEP1
          IE2=ITE+ISEP1
          ISEP=ISEP2+ISEP1
        END IF

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION KEYUPC (INSTR, KEYTAB, NOKEY)
*
*
* Purpose:
*     Match keyword strings (case insensitive)
*
*
* Description:
*     This subroutine searches a table for a match to a character
*     string.  The table of keywords is searched for the first match.
*     White space (blanks, tabs or null characters) at the beginning
*     or end of the input string, or at the end of the keyword string
*     is not significant.  The match is done against an uppercase
*     version of the input string.
*
*     This routine invokes the function KEYMAT using an uppercase
*     version of the input string (with leading white space removed).
*
*
* Parameters:
* I <-  KEYUPC - Output index of the matched keyword.  KEYUPC is set to
*                0 if no match was found.
*                   0 - No match
*                   1 - Match to the first keyword
*                   2 - Match to the second keyword
*                       ...
*
* C ->  INSTR  - Input character string.  There is no limit on the
*                length of INSTR if KEYTAB has elements which have
*                length less than 513 characters.  Otherwise, the
*                number of characters in INSTR, not including leading
*                or trailing white space, can be at most 513
*                characters.
* C ->  KEYTAB - Character array containing the candidate keywords.
*                An optional asterisk ('*') is used to indicate the
*                minimum number of characters needed for a match.
*                A second asterisk can be used to indicate that
*                characters in the input string after this point need
*                not match.  The keywords should be in uppercase and
*                should not contain leading white space.
*                Example: Keyword table entry 'ABC*DE*F'.
*                  - Input strings 'ABC', 'ABCD', ' ABC', 'abC',
*                    'ABCDE', and 'ABCDEx' match this entry.
*                  - Input strings 'AB' and 'ABCX' do not match this
*                    entry.
* I ->  NOKEY  - Number of keywords in the keyword array
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:37:07 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION KEYUPC (INSTR, KEYTAB, NOKEY)


      INTEGER MAXNCK
      PARAMETER (MAXNCK=512)

      INTEGER NOKEY
      INTEGER IS,IF,L
      INTEGER LOCNBL,KEYMAT

      CHARACTER*(*) KEYTAB(NOKEY),INSTR
      CHARACTER*(MAXNCK) TEMPST


* We never need to pass a string longer than the length of the keyword
* string plus one.  Recall that a second asterisk allows for matches to
* strings longer than the keywords.
      IS=LOCNBL(INSTR)
      IF=MIN(IS+LEN(KEYTAB(1)),LEN(INSTR))

* Force UPCASE to complain "string truncated" if INSTR is too long
      L=MIN(IF-IS+1,MAXNCK)
      CALL UPCASE(INSTR(IS:IF),TEMPST(1:L))
      KEYUPC=KEYMAT(TEMPST(1:L),KEYTAB,NOKEY)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PMCINT (X, Y, N, XI, YI, NI)
*
*
* Purpose:
*     Generate a piecewise monotonic cubic interpolant
*
*
* Description:
*     This routine calculates interpolated values. The sampled values
*     are found by passing a piecewise monotonic cubic interpolant
*     through the reference data points. The monotonicity requirement
*     guarantees that the interpolated data values do not go outside
*     the range of the bracketing reference data values.
*
*     References:
*       Subroutine PCHIM, F.N. Fritsch, Lawrence Livermore National
*       Laboratory.
*       F.N. Fritsch and J. Butland, "A method for constructing local
*       monotone piecewise cubic interpolants", SIAM J. Sci. Stat.
*       Comput., Vol. 5, pp. 300-304, June 1984.
*
*
* Parameters:
* R ->  X      - Input abscissa values for the reference points.  These
*                values must be in increasing order.
* R ->  Y      - Input ordinate values for the reference points
* I ->  N      - Number of reference points
* R ->  XI     - Abscissa values for the interpolated points.  These
*                values must be bounded by X(1) and X(N).  The values
*                XI(i), need not be in any particular order, although
*                some efficiency is gained if they are in increasing
*                or decreasing order.
* R <-  YI     - Resulting interpolated ordinate values
* I ->  NI     - Number of interpolated values
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:24:27 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PMCINT (X, Y, N, XI, YI, NI)


      INTEGER N,NI
      INTEGER K,I,KP
      INTEGER LQUANT

      REAL DL,DH
      REAL X(N),Y(N),XI(NI),YI(NI)
      REAL DMCINT,EVCINT


* Check the reference abscissa values
      DO 100 K=1,N-1
        IF (X(K+1).LT.X(K))
     -    CALL HALT('PMCINT - Reference abscissa values not in '//
     -              'increasing order')
 100  CONTINUE


* Special case: only one reference point
      IF (N.EQ.1) THEN

        DO 120 I=1,NI
          IF (XI(I).NE.X(1))
     -      CALL HALT('PMCINT - Abscissa value out of range')
          YI(I)=Y(1)
 120    CONTINUE


* General case: 2 or more reference points
      ELSE

        KP=-1
        DO 160 I=1,NI

* Search for the bracketing interval
          K=LQUANT(XI(I),X,N+1)-1
          IF (K.EQ.0 .AND. XI(I).EQ.X(1)) K=1
          IF (K.LE.0 .OR. K.GE.N)
     -      CALL HALT('PMCINT - Abscissa value out of range')

* Interval found: X(k) <= XI(i) <= X(k+1)
* Find the derivatives at the bracketing points, and then
* evaluate the cubic at the interpolation point
          IF (K.EQ.KP) THEN
            CONTINUE
          ELSE IF (KP.EQ.K-1) THEN
            DL=DH
            DH=DMCINT(K+1,X,Y,N)
          ELSE IF (KP.EQ.K+1) THEN
            DH=DL
            DL=DMCINT(K,X,Y,N)
          ELSE
            DL=DMCINT(K,X,Y,N)
            DH=DMCINT(K+1,X,Y,N)
          END IF
          YI(I)=EVCINT(XI(I),X(K),X(K+1),Y(K),Y(K+1),DL,DH)
          KP=K

 160    CONTINUE

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VEXTNT (X, NX, THR, IL, IU)
*
*
* Purpose:
*     Find the significant extent of the values in a vector
*
*
* Description:
*     This routine finds the indices of the first and last significant
*     elements of a vector.  Elements are considered significant if the
*     have a magnitude equal to or exceeding a given threshold.
*
*
* Parameters:
* R ->  X      - Input vector
* I ->  NX     - Number of elements in X
* R ->  THR    - Magnitude threshold
* I <-  IL     - X(IL) is the first element in X, with abs(X(IL)) >=
*                THR.  IL is a value from 1 to NX.  IL is set to 1 if
*                no element is larger than the magnitude threshold.
* I <-  IU     - X(IL) is the last element in X, with abs(X(IL)) >=
*                THR.  IU is normally a value from IL to NX, but IU is
*                set to 0 if no element is larger than the magnitude
*                threshold.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:05:25 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VEXTNT (X, NX, THR, IL, IU)


      INTEGER NX,IL,IU

      REAL THR
      REAL X(*)


      DO 140 IU=NX,1,-1
        IF (ABS(X(IU)).GE.THR) THEN
          DO 120 IL=1,IU-1
            IF (ABS(X(IL)).GE.THR) GO TO 900
 120      CONTINUE
          GO TO 900
        END IF
 140  CONTINUE
      IL=1


 900  RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FNDPAR (LINE, KEYTAB, NOKEY, TOKEN, NCT, N)
*
*
* Purpose:
*     Separate keyword/token strings
*
*
* Description:
*     The input string has syntax of the following form:
*       Keyword1 = Token1 [,] Keyword2 [,] = Token2 [,] ...
*     String Processing:
*     1) This routine looks for a separator consisting of a comma
*        and/or whitespace not in parentheses or quotes.  This
*        separator separates the input string into a left part and a
*        right part.  If no separator is found, the left part is the
*        whole string and the right part is null.  The left part will
*        be further processed.  The input string is replaced by the
*        right part.
*     2) The left part of the input string is parsed into a keyword
*        string and a token string separated by an equal sign.  If no
*        equal sign is found, the token string is considered to be
*        null.
*     Keyword Processing:
*     1) White space (blanks, tabs or nulls) surrounding the keyword is
*        removed.  The keyword is translated to uppercase and compared
*        with a table of keywords.  The index of the keyword in the
*        table is returned.
*     2) The keyword table is a character array containing candidate
*        keyword strings.
*        a) An optional asterisk ('*') is used to indicate the minimum
*           number of characters needed for a match.
*        b) A second asterisk can be used to indicate that characters
*           after this point need not match.
*        c) The special keyword table entry '***' can be used to match
*           any keyword in the input string.  For this case both the
*           keyword and the token parts of the input string are
*           are returned in the token string.  Normally such an entry
*           would be the last entry in the keyword table.  This feature
*           can be used to trap unmatched keywords for special action.
*     3) After searching the given table of keywords without success,
*        an additional comparison is made with the keywords HELP and ?.
*        If the input matches either of these keywords, the list of the
*        given keywords is printed on the standard output unit.  A
*        match with HELP or ? results in the keyword index being set to
*        -1 and the TOKEN string being returned as null.
*     Token String Processing:
*     1) White space surrounding the token string is removed.  Outer
*        parentheses surrounding the remaining token string are also
*        removed.  Note that white space is not removed inside the
*        parentheses.
*     2) If the match occured with the special keyword table entry
*        '***', the token string is set to the keyword string together
*        with the token string if supplied.  The output string is an
*        edited (leading and trailing white space removed, and white
*        space surrounding an equal sign collapsed) version of the
*        input string before the comma/white space delimiter.  This
*        feature can be used to trap unmatched keywords for special
*        treatment.
*
*
* Parameters:
* C <-> LINE   - Input string.  On return, LINE is equal to the input
*                string with the decoded first part removed.  The
*                substrings of LINE between comma or white space
*                separators can be up to 1024 characters long.
* C ->  KEYTAB - Table of keywords.  These should be in uppercase.
* I ->  NOKEY  - Number of keywords
* C <-  TOKEN  - Token string.  Leading and trailing white space
*                (blanks, tabs or nulls) are removed.  In addition,
*                redundant parentheses are removed.  TOKEN is returned
*                as blanks if no match to a keyword is found or if the
*                HELP or ? keywords are specified.  The maximum number
*                of characters returned is 1024.
* I <-  NCT    - Number of characters in the token string.  NCT is zero
*                if no match to a keyword is found or if the HELP or ?
*                keywords are specified.
* I <-  N      - Keyword index,
*                1 to NOKEY - Normal returned value
*                         0 - No match
*                        -1 - HELP or ?
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:36:48 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FNDPAR (LINE, KEYTAB, NOKEY, TOKEN, NCT, N)


      INTEGER NOKEY,NCT,N
      INTEGER LK,LT,LS,NN
      INTEGER KEYUPC

      CHARACTER*(*) LINE,TOKEN,KEYTAB(NOKEY)
      CHARACTER*1024 KEYWRD,STOKEN,STRING
      CHARACTER*4 HLPTAB(2)

      DATA HLPTAB/'HELP', '?'/


* Find a KEYWORD=TOKEN string
* Note that LINE is written back into LINE
      CALL PPARST(LINE,KEYWRD,LK,STOKEN,LT,STRING,LS,LINE)

* Find the keyword match
      N=KEYUPC(KEYWRD(1:LK),KEYTAB,NOKEY)

* Keyword not found (try HELP and ?)
      IF (N.EQ.0) THEN
        NN=KEYUPC(KEYWRD(1:LK),HLPTAB,2)
        IF (NN.NE.0) THEN
          WRITE (UNIT=*,FMT=*) 'Keywords:'
          CALL PRMENU(KEYTAB,NOKEY,21)
          IF (LT.GT.0 .AND. LT.LE.38) THEN
            CALL MESS('FNDPAR - Unexpected characters: "'//
     -                STOKEN(1:LT)//'"')
          ELSE IF (LT.GT.0) THEN
            CALL MESS('FNDPAR - Unexpected characters: "'//
     -                STOKEN(1:35)//'..."')
          END IF
          N=-1

* Error messages
        ELSE IF (LS.GT.0 .AND. LS.LE.35) THEN
          CALL MESS('FNDPAR - Invalid keyword in string: "'//
     -              STRING(1:LS)//'"')

        ELSE IF (LS.GT.0) THEN
          CALL MESS('FNDPAR - Invalid keyword in string: "'//
     -              STRING(1:32)//'..."')

        ELSE
* Note: The null keyword message will be printed for all except
*       trailing comma separators, e.g.
*         ",AAA,BBB"  Null keyword message
*         "AAA,,BBB"  Null keyword message
*         "AAA,BBB,"  No message
          CALL MESS('FNDPAR - Null keyword in string')

        END IF

        TOKEN=' '
        NCT=0

* Catch-all keyword check
      ELSE IF (KEYTAB(N).EQ.'***') THEN

        CALL STCOPY(STRING(1:LS),TOKEN,NCT)

      ELSE

* Process the token string
* Remove outer parentheses from the token string
        CALL STRPAR(STOKEN(1:LT),TOKEN,NCT)

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     COMPLEX FUNCTION RSPCAS (F, H, NSECT)
*
*
* Purpose:
*     Find the frequency response for an analog filter
*
*
* Description:
*     This function calculates the frequency response of a cascade
*     analog filter specified by its coefficients.  The filter is a
*     cascade of second order sections, with the Laplace transform of
*     the i'th filter section given as
*
*                h(1,i)*s**2 + h(2,i)*s + h(3,i)
*       H(i,s) = ------------------------------- .
*                   s**2 + h(4,i)*s + h(5,i)
*
*     The frequency response is the product of such sections, evaluated
*     with s=jw.
*
*
* Parameters:
* X <-  RSPCAS - Resulting complex valued response
*
* R ->  F      - Frequency
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:21:53 $
*
*
*-----------------------------------------------------------------------

      COMPLEX FUNCTION RSPCAS (F, H, NSECT)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NSECT
      INTEGER K

      REAL F
      REAL W
      REAL H(5,*)

      COMPLEX RS


* Form the product of the response of each second order section
      W=PI2*F
      RS=1.0
      DO 100 K=1,NSECT

* Handle the case of a first order section separately
* (A first order section is necessarily specified as a second
* order section with a zero constant coefficient since the
* term in s**2 in the denominator is fixed at one.)
        IF (H(3,K).EQ.0.0 .AND. H(5,K).EQ.0.0) THEN
          RS=RS * ( CMPLX( -W*H(1,K), H(2,K) ) /
     -              CMPLX( -W, H(4,K) ) )
        ELSE
          RS=RS * ( CMPLX( H(3,K)-(W*W)*H(1,K), W*H(2,K) ) /
     -              CMPLX( H(5,K)-(W*W), W*H(4,K) ) )
        END IF
 100  CONTINUE

      RSPCAS=RS


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE GETDAT (DATTIM)
*
*
* PURPOSE:
*	This routine returns the date as a string.
*
*
* DESCRIPTION:
*	This routine returns a string containing the date and time.
*	The format of the returned string depends on the length of
*	the string.
*	  20 characters or more:
*	    11-May-1988 13:55:45
*	  17-19 characters:
*	    11-May-1988 13:55
*	  11-18 characters:
*	    11-May-1988
*
*
* PARAMETERS:
* C <-	DATTIM - Output character string containing the date and
*	         time. The full length string is 20 characters long.
*
*
* ROUTINES REQUIRED:
*	DATE   - System routine to return the date
*	KEYUPC - Keyword match
*	TIME   - System routine to return the time
*	WARN   - Signal a warning message
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	1988/08/01
*
*
* UPDATES:
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE GETDAT (DATTIM)


	CHARACTER*(*) DATTIM
	CHARACTER*20 STIME
	CHARACTER*3 MONTAB(12),MLCTAB(12)

	DATA MONTAB/
     -	  'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     -	  'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/
	DATA MLCTAB/
     -	  'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
     -	  'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'/


* Get the date and time
	CALL DATE(STIME)
	STIME(10:11)=STIME(8:9)
	STIME(8:9)='19'
	STIME(12:12)=' '
	CALL TIME(STIME(13:))
	N=KEYUPC(STIME(4:6),MONTAB,12)
	IF (N.EQ.0) THEN
	  CALL WARN('GETDAT - Invalid month abbreviation')
	ELSE
	  STIME(4:6)=MLCTAB(N)
	END IF

* Selectively leave out parts of the date/time
	LEND=LEN(DATTIM)
	IF (LEND.GE.20) THEN
	  DATTIM=STIME
	ELSE IF (LEND.GE.17) THEN
	  DATTIM=STIME(1:17)
	ELSE IF (LEND.GE.11) THEN
	  DATTIM=STIME(1:11)
	ELSE
	  DATTIM=STIME(1:11)
	  CALL WARN('GETDAT - Output string truncated')
	END IF


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DECOFF (LINE, IPAR)
*
*
* Purpose:
*     Decoder ON/OFF keywords
*
*
* Description:
*     The keywords are decoded from an input string.  The valid
*     keywords are
*       null or ON
*       OFF
*
*
* Parameters:
* C <-> LINE   - Character string.  The string is set to blanks on
*                return.
* I <-  IPAR   - Integer value.  IPAR is set to one for ON or a null
*                string and to zero for OFF.  If a keyword match is not
*                found, IPAR is not set.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:36:45 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DECOFF (LINE, IPAR)


      INTEGER NEOFF
      PARAMETER (NEOFF=2)

      INTEGER IPAR
      INTEGER LENSTR
      INTEGER IFN,NC,N

      CHARACTER*(*) LINE,TD*1

      CHARACTER*3 OFFTAB(NEOFF)
      DATA OFFTAB/'*ON', 'OFF'/
      DATA IFN/0/


* Decode the keywords
      NC=1
 100  IF (NC.GT.0) THEN
        CALL FNDPAR(LINE,OFFTAB,NEOFF,TD(1:IFN),NC,N)
        IF (N.EQ.1) THEN
          IPAR=1
        ELSE IF (N.EQ.2) THEN
          IPAR=0
        END IF
        NC=LENSTR(LINE)
      GO TO 100
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION KEYMAT (STRIN, KEYTAB, NOKEY)
*
*
* Purpose:
*     Match keyword strings (case sensitive)
*
*
* Description:
*     This subroutine searches a table for a match to a character
*     string.  The table of keywords is searched for the first match.
*     White space (blanks, tabs or null characters) at the end
*     of either the input string or the keyword strings is not
*     significant.  Upper and lower case strings and keywords are
*     treated as being distinct.
*
*
* Parameters:
* I <-  KEYMAT - Output index of the matched keyword.  KEYMAT is set to
*                0 if no match was found.
*                   0 - No match
*                   1 - Match to the first keyword
*                   2 - Match to the second keyword
*                       ...
*
* C ->  STRIN  - Input character string
* C ->  KEYTAB - Character array containing the candidate keywords.
*                An optional asterisk ('*') is used to indicate the
*                minimum number of characters needed for a match.
*                A second asterisk can be used to indicate that
*                characters in the input string after this point need
*                not match.
*                Example: Keyword table entry 'ABC*DE*F'.
*                  - Input strings 'ABC', 'ABCD', 'ABCDE', and 'ABCDEx'
*                    match this entry.
*                  - Input strings 'AB', 'ABc', ' ABC', and 'ABCX' do
*                    not match this entry.
* I ->  NOKEY  - Number of keywords in the keyword array
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:03 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION KEYMAT (STRIN, KEYTAB, NOKEY)


      INTEGER NOKEY
      CHARACTER*(*) KEYTAB(NOKEY),STRIN

      INTEGER LENSTR
      INTEGER LENI,I,LENK,K,L,LI


      LENI=LENSTR(STRIN)
      DO 100 I=1,NOKEY

* Find the positions of the *'s in the keyword
* K points to the first *, L points to the second *
        LENK=LENSTR(KEYTAB(I))
        K=INDEX(KEYTAB(I)(1:LENK),'*')

* Check for a match
* String matches are made only for strings with valid lengths
        IF (K.EQ.0) THEN

* No asterisks
          IF (LENI.EQ.LENK) THEN
            IF (STRIN(1:LENI).EQ.KEYTAB(I)(1:LENI)) GO TO 200
          END IF

        ELSE
          L=INDEX(KEYTAB(I)(K+1:LENK),'*')+K

* One asterisk
          IF (L.EQ.K) THEN
            IF (LENI.GE.K-1 .AND. LENI.LE.LENK-1) THEN
              IF (STRIN(1:K-1).EQ.KEYTAB(I)(1:K-1) .AND.
     -            STRIN(K:LENI).EQ.KEYTAB(I)(K+1:LENI+1)) GO TO 200
            END IF

* Two asterisks
          ELSE
            LI=MIN(LENI,L-2)
            IF (LI.GE.K-1) THEN
              IF (STRIN(1:K-1).EQ.KEYTAB(I)(1:K-1) .AND.
     -            STRIN(K:LI).EQ.KEYTAB(I)(K+1:LI+1)) GO TO 200
            END IF

          END IF

        END IF

 100  CONTINUE
      I=0

* Return the index of the match
 200  KEYMAT=I


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION GDLFIR (F, H, N)
*
*
* Purpose:
*     Find the group delay for an FIR filter
*
*
* Description:
*     The group delay is calculated for the equivalent non-causal filer
*     with reference point at the mid-point of the filter.  The delay
*     to the mid-point is added to this figure.  The group delay in
*     seconds at frequency f for a response with sampling frequency Fs
*     can be calculated as
*
*       T = GDLFIR(f/Fs,H,N) / Fs  .
*
*     If the given frequency corresponds to a zero of the response, a
*     warning message is printed and the group delay is set to 1E20.
*
*
* Parameters:
* R <-  GDLFIR - Group delay in samples
*
* R ->  F      - Normalized frequency (normally in the range 0 to 0.5)
* R ->  H      - Array of impulse response coefficients
* I ->  N      - Number of impulse response coefficients
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:21:11 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION GDLFIR (F, H, N)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER N
      INTEGER I

      REAL F
      REAL HE,HO,AI,COSWI,SINWI,ANUM,ADEN
      REAL H(-((N-1)/2):*)

      DOUBLE PRECISION DSUMHR,DSUMHI,DSUMDR,DSUMDI


      IF (MOD(N,2).EQ.0) THEN
        DSUMHR=0.
      ELSE
        DSUMHR=H(0)
      END IF
      DSUMHI=0.
      DSUMDR=0.
      DSUMDI=0.

* Calculate the terms for the group delay computation in terms
* of the non-causal filter with reference point at the mid-point
* of the filter
*  DSUMHR - Re[H(f)]
*  DSUMHI - Im[H(f)]
*  DSUMDR - Re[H'(f)]
*  DSUMDI - Im[H'(f)]
      DO 100 I=1,N/2
        IF (MOD(N,2).EQ.0) THEN
          HE=H(I)+H(-I+1)
          HO=H(I)-H(-I+1)
          AI=I-0.5
        ELSE
          HE=H(I)+H(-I)
          HO=H(I)-H(-I)
          AI=I
        END IF
        COSWI=COS(PI2*F*AI)
        SINWI=SIN(PI2*F*AI)
        DSUMHR=DSUMHR+DPROD(HE,COSWI)
        DSUMHI=DSUMHI-DPROD(HO,SINWI)
        DSUMDR=DSUMDR-DPROD(AI*HE,SINWI)
        DSUMDI=DSUMDI-DPROD(AI*HO,COSWI)
 100  CONTINUE

* Calculate the group delay
      ANUM=DSUMDR*DSUMHI-DSUMDI*DSUMHR
      ADEN=DSUMHR**2+DSUMHI**2
      IF (ADEN.EQ.0.0) THEN
        CALL WARN('GDLFIR - Undefined delay')
        GDLFIR=1E20
      ELSE
        GDLFIR=0.5*(N-1)+ANUM/ADEN
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION LENNUL (LINE)
*
*
* Purpose:
*     Find the length of a null terminated string
*
*
* Description:
*     This function returns the number of characters in a string.
*     The end of the string is marked by a null character.  The null
*     character must be followed by blanks (or be the last character
*     in the string) for it to be considered a delimiter.  Specifically
*     if the string contains a sequence of null characters, only the
*     last one is eligible for consideration as a string terminator.
*     If no null character appears in the string, the number of
*     characters string is set to the length of the character string.
*
*
* Parameters:
* I <-  LENNUL - The returned function value is the number of
*                characters in the character string up to the
*                delimiting null character
*
* C ->  LINE   - Input character string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:14 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION LENNUL (LINE)


      INTEGER I,LENL
      INTEGER INDEXR

      CHARACTER*(*) LINE
      CHARACTER*1 NUL


      LENL=LEN(LINE)

* Find the position of a terminating null character
      NUL=CHAR(0)
      I=INDEXR(LINE,NUL)

* No null found
      IF (I.EQ.0) THEN
        LENNUL=LENL

* Null found, make sure blanks follow
      ELSE IF (I.LT.LENL) THEN
        IF (LINE(I+1:).EQ.' ') THEN
          LENNUL=I-1
        ELSE
          LENNUL=LENL
        END IF

* Null at end of string
      ELSE
        LENNUL=LENL-1

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DECOUP (MINX,MINY, MAXX,MAXY, IX1,IY1, IX2,IY2,
*                        IX1C,IY1C, IX2C,IY2C, INVIS)
*
*
* Purpose:
*     Clip a vector to a rectangle
*
*
* Description:
*     This routine clips a vector, returning the end points of the
*     visible portion of the vector.  If the vector is completely
*     inside the given rectangle, the end points are the original
*     vector end points.  If only part of the vector is visible, the
*     end points are determined as the intersection of the vector with
*     the rectangle.  If no part of the vector is visible, a flag is
*     set.  This routine uses the clipping algorithm due to D. Cohen
*     and I. Sutherland as described in "Principles of Interactive
*     Computer Graphics" by W. M. Newman and R. F. Sproull.
*
*
* Parameters:
* I ->  MINX,MINY - X and Y coordinates or the lower lefthand corner of
*                   the visible rectangle (plotting coordinates)
* I ->  MAXX,MAXY - X and Y coordinates of the upper righthand corner
*                   of the visible rectangle (plotting coordinates)
* I ->  IX1,IY1   - X and Y coordinates of the start of the vector
*                   (plotting coordinates)
* I ->  IX2,IY2   - X and Y coordinates of the end of the vector
*                   (plotting coordinates)
* I <-  IX1C,IY1C - X and Y coordinates of the start of the visible
*                   part of the vector (plotting coordinates).  If no
*                   part of the vector is visible, these are set equal
*                   to the start of the vector, IX1C=IX1 and IY1C=IY1.
* I <-  IX2C,IY2C - X and Y coordinates of the end of the visible part
*                   of the vector (plotting coordinates).  If no part
*                   of the vector is visible, these are set equal to
*                   the end of the vector, IX2C=IX2 and IY2C=IY2.
* I <-  IVISIB    - Variable indicating if any part of the vector is
*                   visible
*                   0 - The entire vector is invisible
*                   1 - Part of the line is visible; the start of the
*                       vector has been changed.
*                   2 - Part of the line is visible; the end of the
*                       vector has been changed.
*                   3 - Part of the line is visible; both the start of
*                       the vector and the end of the vector have been
*                       changed.
*                   4 - The entire vector is visible
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:27:44 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DECOUP (MINX,MINY, MAXX,MAXY, IX1,IY1, IX2,IY2,
     -                   IX1C,IY1C, IX2C,IY2C, IVISIB)


* IC(i) values:
*    1 - Left                6 - Bottom and Right
*    2 - Right               7 - invalid
*    3 - invalid             8 - Top
*    4 - Bottom              9 - Top and Left
*    5 - Bottom and Left    10 - Top and Right
      INTEGER IL,IR,IB,IBL,IBR,IT,ITL,ITR
      PARAMETER (IL=1,IR=2,IB=4,IBL=5,IBR=6,IT=8,ITL=9,ITR=10)

      INTEGER MINX,MINY,MAXX,MAXY,IX1,IY1,IX2,IY2,IX1C,IY1C,IX2C,IY2C,
     -        IVISIB
      INTEGER I
      INTEGER IX(2),IY(2),IC(2),IV(2)
      INTEGER IANDTB(0:ITR,0:ITR)
      INTEGER IPOSN

      REAL DIFX,DIFY

* For two position codes, this table implements the logical AND of the
* codes (certain input codes are unallowed)
*                  0   L   R  --   B  BL  BR  --   T  TL  TR
      DATA IANDTB/ 0,  0,  0, -1,  0,  0,  0, -1,  0,  0,  0, 
     -             0, IL,  0, -1,  0, IL,  0, -1,  0, IL,  0,
     -             0,  0, IR, -1,  0,  0, IR, -1,  0,  0, IR,
     -            -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
     -             0,  0,  0, -1, IB, IB, IB, -1,  0,  0,  0,
     -             0, IL,  0, -1, IB,IBL, IB, -1,  0, IL,  0,
     -             0,  0, IR, -1, IB, IB,IBR, -1,  0,  0, IR,
     -            -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
     -             0,  0,  0, -1,  0,  0,  0, -1, IT, IT, IT,
     -             0, IL,  0, -1,  0, IL,  0, -1, IT,ITL, IT,
     -             0,  0, IR, -1,  0,  0, IR, -1, IT, IT,ITR/


      IX1C=IX1
      IY1C=IY1
      IX2C=IX2
      IY2C=IY2

* Determine the visibility of the end points
      IC(1)=IPOSN(MINX,MINY,MAXX,MAXY,IX1C,IY1C)
      IC(2)=IPOSN(MINX,MINY,MAXX,MAXY,IX2C,IY2C)

* Quick exit for a completely visible vector
      IF (IC(1).EQ.0 .AND. IC(2).EQ.0) THEN
        IVISIB=4
        GO TO 900

* Check for the condition that the ends of the vector are
* both Left, both Right, both Bottom, or both Top
      ELSE IF (IANDTB(IC(1),IC(2)) .GT. 0) THEN
        IVISIB=0
        GO TO 900

      END IF

* At most only part of the vector is visible
      DIFX=IX2C-IX1C
      DIFY=IY2C-IY1C
      IX(1)=IX1C
      IY(1)=IY1C
      IX(2)=IX2C
      IY(2)=IY2C

      IV(1)=0
      IV(2)=0
      IVISIB=0
      DO 500 I=1,2

 100    IF (IC(I).NE.0) THEN

          IV(I)=I
          IF (IC(I).EQ.IT) THEN

* Crosses top edge (find the intersection with IY=MAXY)
            IX(I)=IX1C + NINT((MAXY-IY1C)*(DIFX/DIFY))
            IY(I)=MAXY

          ELSE IF (IC(I).EQ.IB) THEN

* Crosses bottom edge (find the intersection with IY=MINY)
            IX(I)=IX1C + NINT((MINY-IY1C)*(DIFX/DIFY))
            IY(I)=MINY

          ELSE IF (IC(I).EQ.IL .OR. IC(I).EQ.IBL .OR. IC(I).EQ.ITL) THEN

* Crosses left edge (find the intersection with IX=MINX)
            IY(I)=IY1C + NINT((MINX-IX1C)*(DIFY/DIFX))
            IX(I)=MINX

          ELSE IF (IC(I).EQ.IR .OR. IC(I).EQ.IBR .OR. IC(I).EQ.ITR) THEN

* Crosses right edge (find the intersection with IX=MAXX)
            IY(I)=IY1C + NINT((MAXX-IX1C)*(DIFY/DIFX))
            IX(I)=MAXX

          END IF

* Check if the redefined end point is outside the boundaries
          IC(I)=IPOSN(MINX,MINY,MAXX,MAXY,IX(I),IY(I))
          IF (IANDTB(IC(1),IC(2)) .GT. 0) GO TO 900

        GO TO 100
        END IF
 500  CONTINUE

* Vector (IX(1),IY(1)) to (IX(2),IY(2)) is visible
* Return the updated coordinates
      IVISIB=IV(1)+IV(2)
      IX1C=IX(1)
      IY1C=IY(1)
      IX2C=IX(2)
      IY2C=IY(2)


 900  RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FLTALL (X, NOUT, H, NCOF)
*
*
* Purpose:
*     Filter a signal using an all-pole filter
*
*
* Description:
*     For an all-pole IIR filter, the response is specified by the
*     direct-form feedback coefficients, h(i),
*
*               1                    N-1       -i
*       H(z) = ----  ,  where C(z) = SUM h(i) z    .
*              C(z)                  i=0
*
*     Normally, the first coefficient is unity, i.e. h(0)=1.  A non-
*     unity value will result in a gain scaling of the response.
*
*     The filter needs NCOF-1 past output samples to calculate each
*     output sample.  For this routine, the input array has NCOF-1
*     "memory" elements representing past output values.
*
*     The first NCOF-1 elements of X are the past outputs of the
*     filter.   The next NOUT values (X(NCOF), ... , X(NOUT+NCOF+1))
*     are new input values.  When finished, the NOUT new output
*     points appear as X(NCOF), ... ,X(NCOF+1+NOUT).  The top NCOF-1
*     elements of the output array (X(NOUT+1), ... , X(NOUT+NCOF+1))
*     are suitable for priming the array for processing the next group
*     of input samples.  This is accomplished by moving the top NCOF-1
*     elements of the array to the bottom of the array and appending
*     NOUT new input values.
*
*
* Parameters:
* R <-> X      - Input/output array with NOUT+NCOF-1 elements.  On
*                input, the first NCOF-1 elements represent filter
*                memory values (past output values).  The next NOUT
*                values starting with X(NCOF) are new input values.
*                On output, NOUT new outputs are placed starting at
*                X(NCOF).  The top NCOF-1 elements of the output array
*                can be used as filter memory values for the next call
*                to this routine.
* I ->  NOUT   - Number of output samples
* R ->  H      - Array of NCOF filter coefficients
* I ->  NCOF   - Number of filter coefficients for the denominator of
*                the filter system response
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:21:02 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FLTALL (X, NOUT, H, NCOF)


      INTEGER NOUT,NCOF
      INTEGER I,J

      REAL X(-NCOF+1:NOUT-1),H(0:NCOF-1)
      REAL SUM


      IF (H(0).EQ.0.0)
     -    CALL HALT('FLTALL - Non-causal impulse response')

      DO 120 I=0,NOUT-1
        SUM=X(I)
        DO 100 J=1,NCOF-1
          SUM=SUM - H(J)*X(I-J)
 100    CONTINUE
        X(I)=SUM/H(0)
 120  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE STCOPY (STRIN, STROUT, NC)
*
*
* Purpose:
*     Copy a string, checking for truncation
*
*
* Description:
*     This routines copies the input character string to the output
*     character string.  The number of characters copied is returned.
*     If the input string is shorter than the output string, the
*     remaining part of the output string is padded with blanks.  If
*     the input string is longer than the output string, a warning
*     message is signalled and the string is truncated to the output
*     length.
*
*
* Parameters:
* C ->  STRIN  - Input character string
* C <-  STROUT - Output character string
* I <-  NC     - Number of characters in the output string (at most
*                LEN(STROUT))
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:38:14 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE STCOPY (STRIN, STROUT, NC)


      INTEGER NC
      INTEGER NCI,NCO

      CHARACTER*(*) STRIN,STROUT


* Copy the string
      NCI=LEN(STRIN)
      NCO=LEN(STROUT)
      STROUT=STRIN

* Check for a truncated string
      IF (NCI.GT.NCO) THEN
        CALL HALT('STCOPY - String truncated')
        NC=NCO
      ELSE
        NC=NCI
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE ORSCAL (Y, NPT, YMIN, YMAX, SFREQ, IPLOT,
*                         YLABEL, NCYL, YUNITS, NCYU)
*
*
* Purpose:
*     Determine an ordinate scale for a filter response plot
*
*
* Description:
*     If the data represents group delay, the scale is expressed in
*     scaled seconds if possible.  In addition, the data array is
*     clipped to [ YMIN-1000(YMAX-YMIN), YMAX+1000(YMAX-YMIN) ] if
*     YMAX > YMIN.
*
*
* Parameters:
* R <-> Y      - Ordinate data array, scaled and clipped if necessary
* I ->  NPT    - Number of data values
* R <-> YMIN   - Minimum ordinate, scaled if necessary
* R <-> YMAX   - Maximum ordinate, scaled if necessary
* R ->  SFREQ  - Sampling frequency
* I ->  IPLOT  - Type of plot,
*                1 - linear amplitude
*                2 - dB amplitude
*                3 - log amplitude
*                4 - group delay
*                5 - phase response
*                6 - radian phase
*                7 - impulse response
* C <-  YLABEL - "Amplitude" (IPLOT=1,2,3, or 7)
*                "Group Delay" (IPLOT=4)
*                "Phase Response" (IPLOT=5 or 6)
* I <-  NCYL   - Number of characters in YLABEL (max 18)
* C <-  YUNITS - "", "dB", "samples", "sec", "ms", "us",
*                "ns", "ps", "P rad", or "degrees"
* I <-  NCYU   - Number of characters in YUNITS (max 7)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:46:12 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE ORSCAL (Y, NPT, YMIN, YMAX, SFREQ, IPLOT,
     -                   YLABEL, NCYL, YUNITS, NCYU)


      INTEGER TICKV,EXACTV
      PARAMETER (TICKV=1,EXACTV=2)
      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -          IMPLR=7)
      INTEGER LINS,LOGS
      PARAMETER (LINS=0,LOGS=1)

      INTEGER NPT,IPLOT,NCYL,NCYU
      INTEGER ILL,IUL,ILOG,IEXP
      INTEGER IEXPSC,LENSTR

      CHARACTER*(*) YLABEL,YUNITS
      CHARACTER*1 CPI,CMU

      REAL Y(NPT)
      REAL YMIN,YMAX,SFREQ
      REAL VMIN,VMAX,SF,YR


* Get the exponent of the scaling factor
      VMIN=MIN(YMIN,YMAX)
      VMAX=MAX(YMIN,YMAX)
      ILL=EXACTV
      IUL=EXACTV
      IF (VMIN.GE.VMAX) THEN
        CALL AMINMX(Y,NPT,VMIN,VMAX)
        ILL=TICKV
        IUL=TICKV
      END IF
      IF (IPLOT.EQ.LOGAR) THEN
        ILOG=LOGS
      ELSE
        ILOG=LINS
      END IF
      IEXP=IEXPSC(VMIN,VMAX,ILL,IUL,ILOG)

* Linear amplitude
      IF (IPLOT.EQ.LINAR) THEN
        YLABEL='Amplitude'
        YUNITS=' '
        SF=1.

* DB amplitude
      ELSE IF (IPLOT.EQ.DBAR) THEN
        YLABEL='Amplitude'
        YUNITS='dB'
        SF=1.

* Log amplitude
      ELSE IF (IPLOT.EQ.LOGAR) THEN
        YLABEL='Amplitude'
        YUNITS=' '
        SF=1.

* Group delay
      ELSE IF (IPLOT.EQ.DELYR) THEN
        YLABEL='Group Delay'
        IF (SFREQ.EQ.1.0) THEN
          YUNITS='samples'
          SF=1.
        ELSE IF (IEXP.EQ.-3) THEN
          YUNITS='ms'
          SF=1E+3
        ELSE IF (IEXP.EQ.-6) THEN
          CMU=CHAR(181)
          YUNITS=CMU//'s'
          SF=1E+6
        ELSE IF (IEXP.EQ.-9) THEN
          YUNITS='ns'
          SF=1E+9
        ELSE IF (IEXP.EQ.-12) THEN
          YUNITS='ps'
          SF=1E+12
        ELSE
          YUNITS='sec'
          SF=1.
        END IF

* Phase response (degrees)
      ELSE IF (IPLOT.EQ.PHASD) THEN
        YLABEL='Phase Response'
        YUNITS='degrees'
        SF=1.

* Phase response (radians)
      ELSE IF (IPLOT.EQ.PHASR) THEN
        YLABEL='Phase Response'
        CPI=CHAR(182)
        YUNITS=CPI//' rad'
        SF=1.

* Impulse response
      ELSE IF (IPLOT.EQ.IMPLR) THEN
        YLABEL='Amplitude'
        YUNITS=' '
        SF=1.

* Unknown plot option
      ELSE
        CALL HALT('ORSCAL - Invalid plot option')

      END IF

* Scale the data
      IF (SF.NE.1.) THEN
        YMIN=SF*YMIN
        YMAX=SF*YMAX
        CALL VSMULN(Y,SF,Y,NPT)
      END IF

* Clip the data
      IF (YMAX.GT.YMIN) THEN
        YR=1000.*(YMAX-YMIN)
        CALL VCLIP(Y,Y,NPT,YMIN-YR,YMAX+YR)
      END IF

* See if a power of ten annotation will be added
      IEXP=IEXPSC(SF*VMIN,SF*VMAX,ILL,IUL,ILOG)

* Return the number of characters in the strings
      NCYL=LENSTR(YLABEL)
      IF (IEXP.NE.0) NCYL=NCYL+6
      NCYU=LENSTR(YUNITS)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION LENSTR (LINE)
*
*
* Purpose:
*     Find the length of a whitespace terminated string
*
*
* Description:
*     This function returns the number of characters in a string up to
*     the last significant character.  Blanks, tabs and null characters
*     are not considered to be significant.
*
*
* Parameters:
* I <-  LENSTR - The returned function value is the number of
*                characters in the character string, not including
*                trailing blanks, tabs or null characters
*
* C ->  LINE   - Input character string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:17 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION LENSTR (LINE)


      INTEGER NCHR,L

      CHARACTER*(*) LINE


* Find the last significant character
      NCHR=LEN(LINE)
      DO 100 L=NCHR,1,-1
        IF (LINE(L:L).NE.' ' . AND. LINE(L:L).NE.CHAR(9)
     -      .AND. LINE(L:L).NE.CHAR(0)) GO TO 200
 100  CONTINUE

* Return the pointer to the last significant character
 200  LENSTR=L


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     PROGRAM PLTFILTER
*
*
* Purpose:
*     Calculate and plot a filter response
*
*
* Description:
*     This routine plots the response of a filter specified by its
*     coefficients.
*
*     *** FIR or WIN:
*     For an FIR filter, the coefficients are the direct-form
*     coefficients, h(i)
*
*              N-1       -i
*       H(z) = SUM h(i) z    .
*              i=0
*
*     *** ALL:
*     For an all-pole IIR filter, the response is specified by the
*     direct-form feedback coefficients, h(i),
*
*               1                    N-1       -i
*       H(z) = ----  ,  where C(z) = SUM h(i) z    .
*              C(z)                  i=0
*
*     Normally, the first coefficient is unity, i.e. h(0)=1.  A
*     non-unity value will result in a gain scaling of the response.
*
*     *** IIR:
*     For a general IIR filter, the response is specified in terms of
*     the coefficients of cascaded second order sections,
*
*              NSECT
*       H(z) = PROD H(k,z) .
*              k=1
*
*     Each second order section has a response defined by five
*     coefficients,
*
*               h(1,k)*z**2 + h(2,k)*z + h(3,k)
*      H(k,z) = -------------------------------  .
*                  z**2 + h(4,k)*z + h(k,5)
*
*     *** CAS:
*     For a cascade analog filter, the response is specified in terms
*     of the coefficients of cascaded second order sections,
*
*              NSECT
*       H(s) = PROD H(k,s) .
*              k=1
*
*     Each second order section has a response defined by five
*     coefficients,
*
*               h(1,k)*s**2 + h(2,k)*s + h(3,k)
*      H(k,s) = -------------------------------  .
*                  s**2 + h(4,k)*s + h(k,5)
*
*
* Parameters:
*     This routine reads the parameters for a filter response plot.
*
*     % pltfilter Filename PlotDevice OptionString1 OptionString2 ...
*
*     If any of the arguments is missing, the program prompts for the
*     arguments.
*
*     File_name - This program reads filter coefficients from the named
*        input file.  The file may specify an FIR response, an all-
*        pole IIR response, a general IIR response, or a cascade analog
*        filter.  The first 4 characters in the first record in the
*        file specify the type of filter.
*        Valid filter types are:
*          !ALL - all-pole IIR filter
*          !CAS - cascade analog filter
*          !FIR - FIR digital filter
*          !IIR - IIR cascade digital filter
*          !WIN - window response (treated the same as !FIR)
*        The file can also contain comment records with an exclamation
*        mark in the first position.
*     PlotDevice - Plot device as recognized by the plot initialization
*        routine PLINIT.
*     Options - These are options to select the type of plot and
*        control scaling. If supplied on the command line, the options
*        can be broken into separate option strings separated by white
*        space or commas.  If options are not specified on the command
*        line, the program prompts for options.  Prompting continues
*        until a null line is entered.
*
*        Option strings on the command line should be surrounded
*        by single marks to prevent special characters such as
*        parentheses and double quotes from being interpreted before
*        being passed to this program, for example,
*          'X=(-80,20)' and 'TITLE="Title string"'
*
*        The following table shows the option keywords.  The keywords
*        can be specified in either uppercase or lowercase.  In the
*        table, * indicates the position corresponding to the minimum
*        length short form for the keyword.
*
*     Response options:
*        AMP*LITUDE_RESPONSE - Linear amplitude
*        DB*_AMPLITUDE_RESPONSE - Amplitude in dB (default)
*        LOG*_AMPLITUDE_RESPONSE - Logarithmic amplitude
*        DELAY*_RESPONSE - Group delay
*        PHASE*_RESPONSE - Phase response (degrees)
*        RADIAN_PHASE*_RESPONSE - Phase response (units of pi radians)
*        IMP*ULSE_RESPONSE - Impulse response (not available for analog
*          filters)
*     Scaling options:
*        SAMP*LING_FREQUENCY=SFreq - Sets the sampling frequency.  The
*          default is a normalized sampling frequency equal to 1 for
*          digital filters.
*        X*-LIMITS=(Xmin,Xmax) - Minimum and maximum abscissa values.
*          For frequency response plots, these are in units of Hz or pi
*          radians (for RADIAN_FREQUENCY).  For impulse response plots,
*          these are in seconds.
*          default values:
*          - frequency response of a digital filter: 0 to half the
*            sampling frequency.
*          - frequency response of a cascade analog filter: 0 to 5 Hz
*          - impulse response of an FIR digital filter: 0 to the extent
*            of the impulse response
*          - impulse response of an IIR digital filter or the sampled
*            impulse response of a cascade analog filter: 0 to the
*            extent of the impulse response as determined by the point
*            at which the impulse response falls below 1/1000 of the
*            largest value.
*        Y*-LIMITS=(Ymin,Ymax) - Minimum and maximum ordinate values.
*          The units depend on the type of plot.  For linear or
*          logarithmic amplitude responses these are amplitude units.
*          For dB amplitude plots these are in dB units.  For phase
*          response plots, the units are in degrees or pi radians
*          (RADIAN_PHASE_REPONSE).  For delay response plots, the units
*          are seconds.  For impulse responses these are in amplitude
*          units.
*          default values:
*            The default values vary with the type of plot, the type of
*            filter, and the actual response values.  For dB amplitude
*            plots, the default is to plot the amplitude with a range
*            which spans at most 100 dB.
*        LOG_FREQ*UENCY or LOG_FREQ*UENCY=ON or OFF
*          Specifies whether the frequency responses use a log
*          frequency scale or a linear frequency scale.
*          (default ON)
*        RADIAN_FREQ*UENCY or RADIAN_FREQ*UENCY=ON or OFF
*          Specifies whether the frequency responses use a frequency
*          scale in units of pi radians or Hz.
*          (default ON)
*     Other options:
*        LAB*ELS or LAB*ELS=ON or OFF
*          Controls the printing of the axis labels for the plot.
*          (default ON)
*        T*ITLE="title_string" or OFF
*          Controls the printing of a title across the top of the plot.
*          The default title string is the filename of the coefficient
*          file. This default string is used if the TITLE option is not
*          specified or if the title string is null. The keyword OFF is
*          used to suppress the printing of titles.  The default is to
*          print titles.
*        DEVICE_OPT*IONS="device options string"
*          The option string is passed to the plot initialization
*          routine PLINIT.
*        PLOT_OPT*IONS="plot options string"
*          The option string is passed to the plotting routine PLOTYX.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:46:39 $
*
*
*-----------------------------------------------------------------------

      PROGRAM PLTFILTER


      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -           IMPLR=7)
      INTEGER LINS,LOGS
      PARAMETER (LINS=0,LOGS=1)
      INTEGER MXNPT,MAXCOF
      PARAMETER (MXNPT=2001,MAXCOF=1000)
      REAL EPS
      PARAMETER (EPS=1E-3)

      INTEGER IPLOT,IFAXIS,NCOF,NPT,NCXL,NCXU,NCYL,NCYU,ILOG,NCT
      INTEGER LENNUL,LENSTR

      LOGICAL NFREQ

      CHARACTER*3 FLTTYP*3
      CHARACTER*255 FNAME,PLTDEV,TSTR
      CHARACTER*512 DEVOPT
      CHARACTER*1024 PLTOPT
      CHARACTER*40 XLABEL,XUNITS,YLABEL,YUNITS

      REAL SFREQ,XMIN,XMAX,YMIN,YMAX
      REAL H(MAXCOF),X(0:MXNPT-1),Y(0:MXNPT-1)

      LOGICAL XSPEC,YSPEC,LABELS,TITLES


*==========
* Get the parameters
      CALL PFGETP(FNAME,PLTOPT,PLTDEV,DEVOPT,IPLOT,IFAXIS,
     -            SFREQ,XMIN,XMAX,XSPEC,YMIN,YMAX,YSPEC,
     -            LABELS,TITLES,TSTR)

*==========
* Read the filter coefficients
      CALL READCF(FNAME,MAXCOF,H,NCOF,FLTTYP)
      IF (NCOF.LE.0)
     -  CALL HALT('PLTFILTER - No filter coefficients in file')
      IF (FLTTYP.EQ.' ') THEN
        FLTTYP='FIR'
        CALL WARN('PLTFILTER - FIR filter assumed')
      END IF

*==========
* Set the default sampling frequency
      NFREQ=.FALSE.
      IF (SFREQ.LT.0.0) THEN
        SFREQ=1.0
        IF (FLTTYP.NE.'CAS') NFREQ=.TRUE.
      END IF

*==========
* Fill in the time or frequency array
      CALL PFSETX(IPLOT,IFAXIS,FLTTYP,NCOF,SFREQ,X,MXNPT,NPT,
     -            XMIN,XMAX,XSPEC)

* Fill in the ordinate values
      CALL PFSETY(IPLOT,FLTTYP,H,NCOF,SFREQ,X,Y,NPT)

* Find the extent of an impulse response
* PFILIM modifies NPT and XMAX
      IF (.NOT.XSPEC .AND. IPLOT.EQ.IMPLR .AND.
     -    (FLTTYP.EQ.'ALL' .OR. FLTTYP.EQ.'IIR'))
     -    CALL PFILIM(SFREQ,Y,NPT,EPS,XMAX)

*==========
* Frequency or time scale labels
      CALL ABSCAL(X,NPT,XMIN,XMAX,NFREQ,IPLOT,IFAXIS,
     -            XLABEL,NCXL,XUNITS,NCXU)

*==========
* Find the minimum and maximum ordinate values
      IF (.NOT.YSPEC) CALL PFYLIM(Y,NPT,YMIN,YMAX,NCOF,SFREQ,
     -                            IPLOT,FLTTYP)

* Ordinate scale labels
      CALL ORSCAL(Y,NPT,YMIN,YMAX,SFREQ,IPLOT,
     -            YLABEL,NCYL,YUNITS,NCYU)

*==========
* Plot the frequency response
      CALL PLINIT(PLTDEV,DEVOPT)

* Plot the response
      ILOG=MOD(IFAXIS,2)
      IF (ILOG.EQ.LOGS) CALL CONSTR('X-AXIS=LOG',',',PLTOPT,PLTOPT)
      IF (IPLOT.EQ.LOGAR) CALL CONSTR('Y-AXIS=LOG',',',PLTOPT,PLTOPT)
      IF (IPLOT.EQ.DBAR) CALL CONSTR('X-AXIS=(ORIGIN=OFF)',',',
     -                               PLTOPT,PLTOPT)
      CALL PLOTYX(X,Y,NPT,NPT,1,XMIN,XMAX,YMIN,YMAX,PLTOPT)

* Axis titles and filename
      IF (LABELS)
     -  CALL PLTITL(XLABEL(1:NCXL),XUNITS(1:NCXU),
     -              YLABEL(1:NCYL),YUNITS(1:NCYU))
      IF (TITLES) THEN
        NCT=LENNUL(TSTR)
        IF (NCT.EQ.0) THEN
          CALL FFNAME(FNAME,TSTR)
          NCT=LENSTR(TSTR)
        END IF
        IF (NCT.GT.0) CALL PLTLEG(TSTR(1:NCT))
      END IF

      CALL PLEND


      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE TKEND
*
*
* Purpose:
*     Terminate a plot on a Tektronix terminal
*
*
* Description:
*     This subroutine draws a dark vector to (0,767) and sets the
*     Tektronix terminal back to alpha-numeric mode.
*
*
* Parameters:
*     None
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:29:39 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE TKEND


      INTEGER DARK
      PARAMETER (DARK=0)

      CHARACTER*1 US

      INTEGER LUNTK
      CHARACTER*255 FNAMTK
      COMMON /TKCOM/ LUNTK,FNAMTK


* Draw a vector to the home position
* Set the terminal to alpha-numeric mode
      CALL TKVECT(LUNTK,0,767,DARK)
      US=CHAR(31)
      CALL FPUTCN(LUNTK,US)

* Close the file
      IF (LUNTK.NE.6) THEN
        CLOSE (UNIT=LUNTK)
        CALL RELFUN(LUNTK)
      END IF

* Set the common area parameters to their default values
      LUNTK=-1
      FNAMTK='/dev/tty'


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE READCF (FNAME, MAXCOF, COEFF, NCOF, FLTTYP)
*
*
* Purpose:
*     Read a filter coefficient file
*
*
* Description:
*     This subroutine reads coefficients from a file.  The values are
*     assumed to be stored in records with a maximum of 80 characters
*     in the record.  Up to 256 values may appear in a record.
*     Multiple values in a record are separated by commas or white
*     space (blanks, tabs or null characters).  Records prefixed with
*     a ! are treated as comments.  The first record is assumed to be
*     of the form !xxx... .  The xxx characters are returned as the
*     filter type indicator.
*
*
* Parameters:
* C ->  FNAME  - Character string specifying the file name.  Trailing
*                whitespace is not considered significant.
* I ->  MAXCOF - Maximum number of coefficients to be read
* R <-  COEFF  - Output array of filter coefficients
* I <-  NCOF   - Number of filter coefficients
* C <-  FLTTYP - Identification character string from the first record.
*                This value is extracted from position 2 onwards if the
*                first character is an exclamation mark.  If the first
*                record is not a comment, this string is returned as
*                blank.  The following identification strings are
*                standard for filter files.
*                  ALL - all-pole filter
*                  CAS - cascade analog filter
*                  FIR - finite impulse response filter coefficients
*                  IIR - infinite impulse response filter coefficients
*                  WND - window coefficients
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:18:08 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE READCF (FNAME, MAXCOF, COEFF, NCOF, FLTTYP)


      INTEGER MAXMXN
      PARAMETER (MAXMXN=256)

      INTEGER MAXCOF,NCOF
      INTEGER LUN,NC,IREC,I,NVR,NV
      INTEGER LENSTR

      CHARACTER*(*) FNAME,FLTTYP
      CHARACTER*80 RECORD

      REAL COEFF(MAXCOF)


* Open the coefficient file
* Note: DEC Ultrix will not allow us to open a file which is protected
*       against write unless the READONLY option is specified.
      CALL GETFUN(LUN)
      NC=LENSTR(FNAME)
#ifdef ultrix
      OPEN (UNIT=LUN,FILE=FNAME(1:NC),STATUS='OLD',READONLY)
#else
      OPEN (UNIT=LUN,FILE=FNAME(1:NC),STATUS='OLD')
#endif

* Read the coefficients until end-of-file
      FLTTYP=' '
      IREC=0
      I=0

 100  CONTINUE
        NVR=MIN(MAXCOF-I,MAXMXN)
        READ (UNIT=LUN,FMT=1000,END=200) RECORD
        IREC=IREC+1
        NC=LENSTR(RECORD)
        IF (NC.GT.0) THEN
          IF (RECORD(1:1).EQ.'!') THEN
            IF (IREC.EQ.1) FLTTYP=RECORD(2:)
          ELSE IF (NVR.GT.0) THEN
            CALL RDRVAL(RECORD(1:NC),1,NVR,COEFF(I+1),NV)
            IF (NV.EQ.0) CALL HALT('READCF - Error detected')
            I=I+NV
          ELSE
            CALL HALT('READCF - Too many data records')
          END IF
        END IF
      GO TO 100

* Close the file
 200  NCOF=I
      CLOSE (UNIT=LUN)
      CALL RELFUN(LUN)


      RETURN

 1000 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLTEXT (IX, IY, ICENT, STRING)
*
*
* Purpose:
*     Plot a character string
*
*
* Description:
*     This routine plots a text string at the given plotting
*     coordinates.  The standard character spacing is 1.5 times the
*     character width.  The character size and the plotting angle must
*     be selected beforehand with a call to subroutine SETCHR.
*
*     This routine checks for the presence of special control
*     characters in the text string.
*                         Control  ASCII
*        Character         Key     Code     Function
*      NUL (null)         CTRL-@     0   null character
*      LF (line feed)     CTRL-J,   10   start a new line
*      VT (vertical tab)  CTRL-K,   11   start small characters
*      SO (shift out)     CTRL-N,   14   end superscript, subscript
*                                        or small characters
*      SI (shift in)      CTRL-O,   15   start superscripts
*      SUB (substitute)   CTRL-Z,   26   start subscripts
*
*     The NUL character (ASCII 0) is treated as a zero width character
*     of normal height.  The line feed character NL marks the end of a
*     line of characters.  Lines of characters are stacked vertically
*     (from top to bottom), a fixed distance apart (1.5 times the
*     standard character height), with each line of text left
*     justified.
*
*     The VT control character turns on small character mode.  These
*     characters are of reduced size.   The SO character or the LF
*     character terminates small character mode.  The SI character
*     starts superscript mode.  Superscript characters are raised
*     above the baseline and are plotted at a reduced size.  The SUB
*     character starts subscript mode.  Subscript characters are
*     lowered below the baseline and are plotted at a reduced size.
*     Both superscripts and subscripts are turned off with SO or LF
*     control characters.
* 
*
*
* Parameters:
* I ->  IX     - X coordinate of the reference point for the
*                character string (plotting units)
* I ->  IY     - Y coordinate of the reference point for the
*                character string (plotting units)
* I ->  ICENT  - Centering option specifying the location of the
*                reference point for the plotted text.  The plotted
*                text which may consist of several individual lines of
*                text can be considered to be contained in a box.
*                ICENT specifies the position of the reference point
*                in that box as shown in the table below.  The
*                designations (left, centre, right and top, centre,
*                bottom) refer to positions of the box containing the
*                string before the string is rotated to the desired
*                plotting angle.
*                          Left     Centre    Right
*                    Top     2---------5---------8
*                    Centre  1         4         7
*                    Bottom  0---------3---------6
* C ->  STRING - Character string to be plotted.  This string may
*                include control characters to turn on and turn off
*                superscript or subscript characters and split text
*                into lines.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:28:26 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLTEXT (IX, IY, ICENT, STRING)


      INTEGER ICNWL,ICSML,ICSUP,ICSUB,ICNOR
      PARAMETER (ICNWL=10,ICSML=11,ICSUP=15,ICSUB=26,ICNOR=14)

* Character spacing and size parameterization

* CHNOR  - height of a normal character
* CHSML  - height of a small character
* CRSUP  - vertical offset for superscript characters
* CRSUB  - vertical offset for subscript characters
* CWNOR  - width of a normal character
* CWSML  - width of a small character
* CSPNN  - spacing inserted between normal characters
* CSPSS  - spacing inserted between small characters
* CSPNS  - spacing inserted between a normal and a small character
* CSPSN  - spacing inserted between a small and a normal character
* CBLSP  - baseline skip between lines of text
      REAL CHNOR,CHSML,CRSUP,CRSUB,CWNOR,CWSML,
     -     CSPNN,CSPSS,CSPNS,CSPSN,CBLSP
      PARAMETER (CHNOR=1.0,CHSML=0.75*CHNOR,
     -           CWNOR=1.0,CWSML=0.75*CWNOR,
     -           CRSUP=0.5,CRSUB=-0.25,
     -           CSPNN=0.5,CSPSS=(CWSML/CWNOR)*CSPNN,
     -           CSPNS=0.5*(CSPNN+CSPSS),CSPSN=CSPNS,
     -           CBLSP=1.5*CHNOR)

      INTEGER IX,IY,ICENT
      INTEGER IW,IH,ICENTW,ICENTH,IXR,IYR,IXC,IYC,ISIZ,IPRS,I,NL

      CHARACTER*(*) STRING

      REAL WB,HB,W,H,ANG,X,Y

      REAL CSPACE(0:1,-1:1)
      REAL CWIDTH(0:1)
      DATA CSPACE/0.0,0.0,CSPNN,CSPNS,CSPSN,CSPSS/
      DATA CWIDTH/CWNOR,CWSML/


* Get the character size and orientation
      CALL GETCHR(IW,IH,ANG)

* Find the size of the text box
      CALL WHTEXT(STRING,WB,HB)

* Determine the number of lines of text
      NL=1
      DO 100 I=1,LEN(STRING)
        IF (STRING(I:I).EQ.CHAR(ICNWL)) NL=NL+1
 100  CONTINUE

* Width centering
      ICENTW=ICENT/3
      IF (ICENTW.EQ.0) THEN
        W=0.0
      ELSE IF (ICENTW.EQ.1) THEN
        W=0.5*WB
      ELSE
        W=WB
      END IF

* Height centering
      ICENTH=MOD(ICENT,3)
      IF (ICENTH.EQ.0) THEN
        H=0.0
      ELSE IF (ICENTH.EQ.1) THEN
        H=0.5*HB
      ELSE
        H=HB
      END IF

* Calculate the rotated offset
      CALL ROTPTC(W,H,ANG,IXR,IYR)
      IXC=IX-IXR
      IYC=IY-IYR

* Plot the characters one at a time
      ISIZ=0
      IPRS=-1
      X=0.0
      Y=0.0
      DO 200 I=1,LEN(STRING)
        IF (STRING(I:I).EQ.CHAR(ICSML)) THEN
          ISIZ=1
          CALL SETCHR(NINT(CWSML*IW),NINT(CHSML*IH),ANG)
          Y=0.0
        ELSE IF (STRING(I:I).EQ.CHAR(ICSUP)) THEN
          ISIZ=1
          CALL SETCHR(NINT(CWSML*IW),NINT(CHSML*IH),ANG)
          Y=CRSUP
        ELSE IF (STRING(I:I).EQ.CHAR(ICSUB)) THEN
          ISIZ=1
          CALL SETCHR(NINT(CWSML*IW),NINT(CHSML*IH),ANG)
          Y=CRSUB
        ELSE IF (STRING(I:I).EQ.CHAR(ICNOR)) THEN
          ISIZ=0
          CALL SETCHR(IW,IH,ANG)
          Y=0.0
        ELSE IF (STRING(I:I).EQ.CHAR(ICNWL)) THEN
          ISIZ=0
          CALL SETCHR(IW,IH,ANG)
          Y=0.0
          X=0.0
          IPRS=-1
          NL=NL-1
        ELSE
          IF (STRING(I:I).NE.CHAR(0)) THEN
            X=X+CSPACE(ISIZ,IPRS)
            CALL ROTPTC(X*IW,(Y+(NL-1)*CBLSP)*IH,ANG,IXR,IYR)
            CALL PLCHAR(IXC+IXR,IYC+IYR,STRING(I:I))
            X=X+CWIDTH(ISIZ)
          END IF
          IPRS=ISIZ
        END IF
 200  CONTINUE

* Restore the character size
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION GDLCAS (F, H, NSECT)
*
*
* Purpose:
*     Find the group delay for an analog cascade filter
*
*
* Description:
*     This function calculates the group delay of a cascade analog
*     filter specified by its coefficients.  The filter is a cascade
*     of second order sections, with the Laplace transform of the i'th
*     filter section given as
*
*                h(1,i)*s**2 + h(2,i)*s + h(3,i)
*       H(i,s) = ------------------------------- .
*                   s**2 + h(4,i)*s + h(5,i)
*
*     The group delay in seconds at frequency f for the filter is
*     calculated as
*
*       T = GDLCAS(f,H,NSECT) .
*
*     If the given frequency corresponds to an uncancelled pole or zero
*     of the response, a warning message is printed and the group delay
*     is set to 1E20 for zeros and -1E20 for poles.
*
*
* Parameters:
* R <-  GDLCAS - Group delay in seconds
*
* R ->  F      - Frequency
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:21:08 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION GDLCAS (F, H, NSECT)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NSECT
      INTEGER NZ,K

      REAL F
      REAL W,B2,B1,B0,C2,C1,C0,RW,RPW,XW,XPW,
     -     ANUM,ADEN
      REAL H(5,*)


* Add the group delay of each second order section
      W = PI2*F
      NZ = 0
      GDLCAS = 0.0

      DO 100 K=1,NSECT

* The transfer function is
*
*                b2*s**2 + b1*s + b0   B(s)
*         H(s) = ------------------- = ----
*                  s**2 + c1*s + c0    C(s)
*

* If the constant terms are zero, cancel an s term between numerator
* and denominator
        IF (H(3,K).EQ.0.0 .AND. H(5,K).EQ.0.0) THEN
          B2 = 0.0
          B1 = H(1,K)
          B0 = H(2,K)
          C2 = 0.0
          C1 = 1.0
          C0 = H(4,K)
        ELSE
          B2 = H(1,K)
          B1 = H(2,K)
          B0 = H(3,K)
          C2 = 1.
          C1 = H(4,K)
          C0 = H(5,K)
        END IF

* The group delay for H(jw) is the group delay for the numerator
* term less the group delay for the denominator term.  On the
* imaginary axis express the numerator term as B(jw) = R(w) + jX(w).
* The group delay for the numerator term for w=2Pi f is
*
*               d arctan(X(w)/R(w))      X'(w)R(w)-R'(w)X(w)
*     Td(w) = - -------------------  = - ------------------- ,
*                d w                      R(w)**2 + X(w)**2
*
* where X'(w) is the derivative of X(w) and R'(w) is the
* derivative of R(w).
* In the sequel, the numerator (and denominator) are expressed as
*
*       B(jw) =  b0  - b2 w**2 + j b1 w
*
*  Then
*
*       R(w)  = b0 - b2 w**2
*       R'(w) = -2 b2 w
*       X(w)  = b1 w
*       X'(w) = b1

* Delay due to numerator
        RW =B0-B2*W**2
        RPW=-2.*B2*W
        XW =B1*W
        XPW=B1
        ANUM = XPW*RW - RPW*XW
        ADEN = RW**2 + XW**2
        IF (ADEN.LE.0.0) THEN
          NZ = NZ+1
        ELSE
          GDLCAS = GDLCAS - ANUM/ADEN
        END IF

* Delay due to denominator
        RW =C0-C2*W**2
        RPW=-2.*C2*W
        XW =C1*W
        XPW=C1
        ANUM = XPW*RW - RPW*XW
        ADEN = RW**2 + XW**2
        IF (ADEN.LE.0.0) THEN
          NZ = NZ-1
        ELSE
          GDLCAS = GDLCAS + ANUM/ADEN
        END IF

 100  CONTINUE

      IF (NZ.NE.0) THEN
        CALL WARN('GDLCAS - Undefined delay')
        IF (NZ.GT.0) THEN
          GDLCAS = 1E20
        ELSE
          GDLCAS = -1E20
        END IF
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE SETPLW (IWIDTH)
*     SUBROUTINE GETPLW (IWIDTH)
*
*
* Purpose:
*     Set the line width for a plot
*     Get the line width for a plot
*
*
* Description:
*     This routine sets or determines the line width for subsequent
*     plotting.  For some devices, a negative line width has the effect
*     of erasing or writing with the background colour or intensity.
*     In that case, the line width is determined from the magnitude of
*     the specified line width parameter.
*
*
* Parameters:
*     Subroutine SETPLW
* I ->  IWIDTH - Line width in plotting units
*
*     Subroutine GETPLW
* I <-  IWIDTH - Line width in plotting units
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:56 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE SETPLW (IWIDTH)


      INTEGER IWIDTH
      INTEGER LWIDTH

      SAVE LWIDTH
      DATA LWIDTH/6/


* Set the line width
      LWIDTH=IWIDTH

      GO TO 900

*----------
* Return the current line width
      ENTRY GETPLW (IWIDTH)


      IWIDTH=LWIDTH


 900  RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GTPSTR (STRING, SCHARS, QCHARS, ISS, IES, ISEP)
*
*
* Purpose:
*     Parse a string with a separator (with white space)
*
*
* Description:
*     This routine finds the first occurrence of a separator string in
*     an input string.  A separator string occurs between substrings in
*     the original string and consists of either white space separator
*     or an ordinary  separator.  A white space separator consists
*     entirely of white space (blanks, tabs or null characters).  An
*     ordinary separator consists of a given character, optionally
*     surrounded by white space.  A white space separator cannot occur
*     at the beginning or end of the input string, while an ordinary
*     separator can occur at the beginning or end of the input string.
*
*     Optionally paired quote characters can be specified to allow
*     white space and the separator character to appear in the string
*     without acting as separators.
*
*     The non-blank extent of the string before the separator is
*     STRING(ISS:IES), with the possibility that the substring has a
*     zero length (IES=ISS-1).  The last character in the separator
*     is STRING(ISEP:ISEP).  If a separator is not found, ISEP is set
*     to LEN(STRING)+1.  If a separator is found, the non-blank portion
*     of the string following the separator starts with
*     STRING(ISEP+1:ISEP+1).
*     Summarizing,
*     1 (a) non-blank string before a separator: ISS <= IES,
*       (b) blank string before a separator: ISS=1, IES=0,
*     2 (a) separator: 1 <= ISEP <= LEN(STRING),
*       (b) no separator: ISEP = LEN(STRING)+1.
*
*
* Parameters:
* C ->  STRING - Input character string
* C ->  SCHARS - Separator characters.  Each character in SCHARS is a
*                potential separator character.
* C ->  QCHARS - Character string specifying pairs of quote characters
*                (the left and right quote characters).  For instance,
*                QCHARS='""()' specifies that double quotes and
*                parentheses serve as quote characters.  In the part of
*                the input string between a matched pair of quote
*                characters, any other characters, including quote
*                characters other than from the pair in question, are
*                treated as ordinary characters.  Up to 5 pairs of
*                quote characters can be specified.  A blank string
*                signifies no quote characters are to be recognized.
*                Trailing blanks in the string QCHARS are ignored.
* I <-  ISS    - Pointer to the characters that starts the non-blank
*                portion of the input string before the first
*                separator.  ISS will be equal to 1 in the case of no
*                non-blank characters being found in front of a
*                separator.
* I <-  IES    - Pointer to the character that terminates the portion
*                of the input string before the first separator.
*                Normally IES will point to a non-blank character.
*                However, in the case of no non-blank characters being
*                found in front of the separator, IES will be set to
*                zero.
* I <-  ISEP   - Pointer to the character that ends the separator.  In
*                the case of a separator with trailing white space,
*                ISEP points to the last white space character in the
*                separator.  In the case of no separator being found,
*                ISEP is equal to LEN(STRING)+1.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:41:16 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GTPSTR (STRING, SCHARS, QCHARS, ISS, IES, ISEP)


      INTEGER SIWS,SNBC,SWSA,SSEP,SFIN
      PARAMETER (SIWS=1,SNBC=2,SWSA=3,SSEP=4,SFIN=5)
      INTEGER WSC,SEP,OTH
      PARAMETER (WSC=1,SEP=2,OTH=3)
      INTEGER MXQ
      PARAMETER (MXQ=5)

      INTEGER ISS,IES,ISEP
      INTEGER LENS,NS,ISTATE,LQ,NQ,K,I,ICC
      INTEGER LEVQ(MXQ)
      INTEGER LENBLK

      LOGICAL ERRQ

      CHARACTER*(*) STRING,SCHARS,QCHARS
      CHARACTER*1 CH,QL(MXQ),QR(MXQ)

      INTEGER ITRANS(OTH,SFIN-1),IPTR(SFIN)
      DATA ITRANS/SIWS,SSEP,SNBC, SWSA,SSEP,SNBC, SWSA,SSEP,SFIN,
     -            SSEP,SFIN,SFIN/


* The presence of a separator is identified using a state driven
* parser.  The next state is given by  ITRANS(char, state).  The
* position in the string of the end of a given state is given
* by IPTR(state).
* Character Description
*   WSC     White space
*   SEP     Separator
*   OTH     Other
* State   Description
*  SIWS   Initial white space
*  SNBC   Non-blank character before a separator
*  SWSA   White space after non-blank characters
*  SSEP   Separator character, or white space after a separator
*  SFIN   Finished

      LENS=LEN(STRING)
      NS=LEN(SCHARS)
      ISTATE=SIWS
      IPTR(SIWS)=0
      IPTR(SNBC)=0
      IPTR(SWSA)=0
      IPTR(SSEP)=0
      IPTR(SFIN)=LENS+1

* Pick up the quote characters
      LQ=LENBLK(QCHARS)
      NQ=MIN(LQ/2,MXQ)
      IF (2*NQ.NE.LQ)
     -  CALL WARN('GTPSTR - Invalid quote character string')
      ERRQ=.FALSE.
      DO 100 K=1,NQ
        QL(K)=QCHARS(2*K-1:2*K-1)
        QR(K)=QCHARS(2*K:2*K)
        LEVQ(K)=0
 100  CONTINUE


* Main loop to check each character in the string
* The search is terminated when the string is exhausted or the first
* non-blank character is found after a separator
      DO 300 I=1,LENS

        CH=STRING(I:I)

* Check for quote characters
* Notes:
*  - The order of the check is changed depending on whether we are
*    within quotes already.  This allows the left and right quote
*    characters to be the same.
*  - The first "other" character after state SWSA or SSEP pushes us
*    into state SFIN.  A left quote character in this situation should
*    not trigger an unpaired quote error.  This situation arises only
*    we are not within quotes already.
        ICC=0
        DO 220 K=1,NQ
          IF (LEVQ(K).EQ.0) THEN
            IF (CH.EQ.QL(K)) THEN
              IF (ISTATE.NE.SWSA .AND. ISTATE.NE.SSEP)
     -          LEVQ(K)=LEVQ(K)+1
              ICC=OTH
            ELSE IF (CH.EQ.QR(K)) THEN
              ERRQ=.TRUE.
              ICC=OTH
            END IF
          ELSE
            IF (CH.EQ.QR(K)) THEN
              LEVQ(K)=LEVQ(K)-1
            ELSE IF (CH.EQ.QL(K)) THEN
              LEVQ(K)=LEVQ(K)+1
            END IF
            ICC=OTH
          END IF
          IF (ICC.EQ.OTH) GO TO 280
 220    CONTINUE

* Check for a separator character
        DO 240 K=1,NS
          IF (CH.EQ.SCHARS(K:K)) THEN
            ICC=SEP
            GO TO 280
          END IF
 240    CONTINUE
          

* Check for other characters
        IF (CH.EQ.' ' .OR. CH.EQ.CHAR(9) .OR. CH.EQ.CHAR(0)) THEN
          ICC=WSC
        ELSE
          ICC=OTH
        END IF

* Make a state transition
 280    ISTATE=ITRANS(ICC,ISTATE)
        IPTR(ISTATE)=I
        IF (ISTATE.GE.SFIN) GO TO 320

 300  CONTINUE

* Return the pointers
 320  CONTINUE

* Let the string be A <sep> B
* Find the limits of A: see if we have passed through state SNBC
      IF (IPTR(SNBC).GT.0) THEN
        ISS=IPTR(SIWS)+1
        IES=IPTR(SNBC)
      ELSE
        ISS=1
        IES=ISS-1
      END IF

* Find the end of the separator
      IF (ISTATE.EQ.SSEP .OR. ISTATE.EQ.SFIN) THEN
        ISEP=IPTR(SFIN)-1
      ELSE
        ISEP=LENS+1
      END IF

* Error checks
      DO 400 K=1,NQ
        IF (LEVQ(K).NE.0) ERRQ=.TRUE.
 400  CONTINUE
      IF (ERRQ) CALL WARN('GTPSTR - Unpaired quote character')


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DECLIN (LINE, LINTYP, IPATTN, SYMBOL, ISSIZE, SANG)
*
*
* Purpose:
*     Decode line-type plot options
*
*
* Description:
*     An option string containing a number of option specifications is
*     decoded.  Individual option specifications are separated by white
*     space (blanks, tabs or null characters) or commas.  The general
*     form of the option specifications is KEYWORD=arg or KEYWORD, where
*     KEYWORD is a keyword string.  Keywords can be specified in upper or
*     lower case and in most cases allow for short forms.  The argument
*     string following the keyword is used to specify values or subsidiary
*     option specifications.  Within the argument string, parentheses are
*     used to group lists of values or subsidiary option specifications.
*     Lists of values are enclosed in parentheses with the values
*     separated by white space or commas.  The same keyword may be given
*     more than once, with the last invokation taking precedence.
*
*     The subroutine parameters are shown below along with the
*     corresponding specification in the option string.  The values
*     of the subroutine parameters are changed only if the corresponding
*     keyword is present.
*
*
* Parameters:
* C <-> LINE   - Input character string.  The string is set to blanks
*                on return.
* I <-  LINTYP - Integer line type code
*                1  POINTS
*                2  LINE
*                3  LINE+POINTS
*                4  SMOOTH
*                5  SMOOTH+POINTS
* I <-  IPATTN - Five element integer array specifying the line pattern
*                PATTERN=(xx yy ...)
* C <-  SYMBOL - Character string specifying the plot symbols
*                SYMBOLS="xxxxx"
* I <-  ISSIZE - Two element array specifying the symbol size
*                SYMBOL_SIZE=(width height)
* R <-  SANG   - Real value specifying the symbol plotting angle
*                SYMBOL_ANGLE=angle
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:30:29 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DECLIN (LINE, LINTYP, IPATTN, SYMBOL, ISSIZE, SANG)


      INTEGER LINTYP
      INTEGER IPATTN(5),ISSIZE(2)
      INTEGER NCT,N,NC,IER
      INTEGER LENSTR

      REAL SANG

      CHARACTER*(*) LINE,SYMBOL
      CHARACTER*512 TOKEN

      INTEGER NEKEY
      PARAMETER (NEKEY=9)
      CHARACTER*(14) KEYTAB(NEKEY)
      DATA KEYTAB/'POINT*S'        , 'LINE'           ,
     -            'LINE+*POINTS'   , 'SMOOTH'         ,
     -            'SMOOTH+*POINTS' , 'SYM*BOLS'       ,
     -            'SYMBOL_SIZE'    , 'SYMBOL_ANGLE'   ,
     -            'PATTERN'        /


 100  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NCT,N)

*** POINTS, LINE, LINE+POINTS, SMOOTH, ...
        IF (N.GE.1 .AND. N.LE.5) THEN
          LINTYP=N

*** SYMBOL =
        ELSE IF (N.EQ.6) THEN
          CALL RQUOTE(TOKEN,SYMBOL,NC)
          IF (NC.LT.LEN(SYMBOL)) SYMBOL(NC+1:)=CHAR(0)

*** SYMBOL_SIZE =
        ELSE IF (N.EQ.7) THEN
          CALL RDIVAL(TOKEN,2,2,ISSIZE,N)

*** SYMBOL_ANGLE =
        ELSE IF (N.EQ.8) THEN
          CALL RDRVA1(TOKEN,SANG,IER)

*** PATTERN =
        ELSE IF (N.EQ.9) THEN
          CALL RDIVAL(TOKEN,1,5,IPATTN,N)
          IF (N.LT.5) CALL IZERO(IPATTN(N+1),5-N)

***
        END IF

      GO TO 100
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VSHIFT (X, NKEEP, NSHIFT)
*
*
* Purpose:
*     Shift the elements of a vector
*
*
* Description:
*     This routine shifts the elements of a real vector.  If the number
*     of elements to be retained is zero, no action is taken.
*
*     For a shift down (NSHIFT positive), the elements of the array are
*     shifted down to the bottom of the array.  The input array must
*     have at least NKEEP+NSHIFT elements.
*       X(NSHIFT+i) --> X(i) , for i from 1 to NKEEP.
*
*     For a shift up (NSHIFT negative), the elements of the array are
*     shifted up to the top of the array.  The input array must have at
*     least NKEEP-NSHIFT elements (note that NSHIFT is negative).
*       X(i) --> X(i-NSHIFT), for i from NKEEP to 1.
*
*
* Parameters:
* R <-> X      - Input array
* I ->  NKEEP  - Number of elements to be retained.  NKEEP equal to
*                zero is allowed.
* I ->  NSHIFT - Number of positions to be shifted.  NSHIFT is positive
*                for a shift down and negative for a shift up.  NSHIFT
*                equal to zero is allowed.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:05:54 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VSHIFT (X, NKEEP, NSHIFT)


      INTEGER NKEEP,NSHIFT
      INTEGER I

      REAL X(*)


* Shift down
      IF (NSHIFT.GT.0) THEN
        DO 100 I=1,NKEEP
          X(I)=X(NSHIFT+I)
 100    CONTINUE

* Shift up
      ELSE IF (NSHIFT.LT.0) THEN
        DO 200 I=NKEEP,1,-1
          X(I-NSHIFT)=X(I)
 200    CONTINUE

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE EQDINC (X, N, XI, MAXNI, NI)
*
*
* Purpose:
*     Generate equidistant points between given values
*
*
* Description:
*     This subroutine generates an output array with an ordered set of
*     values which are equidistantly spaced in the intervals between
*     values of the input array.  Samples are also generated to
*     tcoincide with the input values.  For the interval k between X(k)
*     and X(k+1), the number of output values is given by (for a fixed
*     value DX)
*
*       Mk = ceil(DXk/DX) , where DXk=X(k+1)-X(k) .
*
*     Mk includes the first point of the interval (which coincides with
*     X(k)), but not the last point of the interval (which coincides
*     with X(k+1)).  The total number of sample points is given by
*
*                N-1        X(N)-X(1)
*       Ni = 1 + SUM Mk  <= --------- + N = Nimax .
*                k=1           DX
*
*     The upper bound is used to solve for an appropriate value for DX.
*     This value DX is the minimum spacing between sample values.  This
*     value of DX is then used to generate the actual sample points.
*     The number of output points then lies in the range given by
*
*       Nimax - (N-1) <= Ni <= Nimax .
*
*
* Parameters:
* R ->  X      - Input array of data values.  These values must be in
*                increasing order
* I ->  N      - Number of input data values
* R <-  XI     - Output array of sample values.  These values will be
*                in increasing order.
* I ->  MAXNI  - Maximum number of sample values.  MAXNI must be at
*                least N.
* I <-  NI     - Actual number of sample values generated,
*                MAXNI-(N-1) <= NI <= MAXNI.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:24:12 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE EQDINC (X, N, XI, MAXNI, NI)


      INTEGER N,MAXNI,NI
      INTEGER K,MINNI,NK,I
      INTEGER ICEILX

      REAL DELX,DXK
      REAL X(N),XI(MAXNI)


      IF (MAXNI.LT.N)
     -  CALL HALT('EQDINC - Too few output elements')

* Check the input data
      DO 100 K=1,N-1
        IF (X(K+1).LT.X(K))
     -    CALL HALT('EQDINC - Abscissa values not in '//
     -              'increasing order')
 100  CONTINUE

* Special case, one input point
      IF (N.EQ.1) THEN
        XI(1)=X(1)
        NI=1

* Normal case
      ELSE
        MINNI=MAXNI-(N-1)
        DELX=(X(N)-X(1))/MINNI
        NI=0
        DO 140 K=1,N-1
          DXK=X(K+1)-X(K)
          NK=ICEILX(DXK/DELX)
          DO 120 I=0,NK-1
            NI=NI+1
            XI(NI)=I*(DXK/NK)+X(K)
 120      CONTINUE
 140    CONTINUE

        NI=NI+1
        IF (NI.LT.MINNI .OR. NI.GT.MAXNI)
     -    CALL HALT('EQDINC - Consistency check fails')
        XI(NI)=X(N)

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FLTIIR (X, NOUT, H, NSECT)
*
*
* Purpose:
*     Filter a signal using a cascade of biquad filters
*
*
* Description:
*     The i'th filter section has a z-transform
*
*                h(1,i)*z**2 + h(2,i)*z + h(3,i)
*       H(i,z) = ------------------------------- .
*                   z**2 + h(4,i)*z + h(5,i)
*
*     Each filter section needs an input sample, two past input samples
*     and two past output samples to calculate each output sample.  In
*     the cascade connection, the output of one section is the input to
*     another.  For NSECT sections, the total filter "memory" required
*     is MEM=2*(NSECT+1) values.  In this routine the input array has
*     MEM extra elements representing these past inputs and outputs.
*
*     The first two elements (X(1) and X(2)) are the two previous
*     outputs of the overall filter; the next two elements (X(3) and
*     X(4)) are previous outputs of the second to last filter section,
*     and so on up to elements X(MEM-1) and X(MEM) which are previous
*     input samples. The next NOUT values (X(MEM+1),...,X(MEM+NOUT))
*     are new input values.  The filter is processed one section at
*     a time, with intermediate outputs overlaying one another.
*     When finished, the NOUT new output points appear as X(3),...,
*     X(NOUT+2).  The top MEM elements of the output array 
*     (X(NOUT+1),...,X(NOUT+MEM)) are outputs of intermediate sections
*     and previous inputs.  These values are suitable for priming the
*     array for processing the next group of input samples.  This is
*     accomplished by moving the top MEM elements of the array to the
*     bottom of the array and appending NOUT new input values.
*
*
* Parameters:
* R <-> X      - Input/output array with NOUT+2*(NSECT+1) elements.  On
*                input, the first 2*(NSECT+1) elements represent filter
*                memory values.  The next NOUT values are new elements.
*                On output, NOUT new outputs are placed starting at the
*                third element.  The top 2*(NSECT+1) elements of the
*                output array can be used as filter memory values for
*                the next call to this routine.
* I ->  NOUT   - Number of output samples
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:21:05 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FLTIIR (X, NOUT, H, NSECT)


      INTEGER NOUT,NSECT
      INTEGER K,I

      REAL X(-2*(NSECT+1):NOUT-1),H(5,NSECT)


      K=0
      DO 100 I=1,NSECT
        K=K-2
        CALL BIQUAD(X(K),X(K-2),NOUT,H(1,I))
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION PHSCAS (F, H, NSECT)
*
*
* Purpose:
*     Find the phase response for an analog cascade filter
*
*
* Description:
*     This function calculates the phase response of a cascade analog
*     filter specified by its coefficients.  The filter is a cascade of
*     second order sections, with the Laplace transform of the i'th
*     filter section given as
*
*                h(1,i)*s**2 + h(2,i)*s + h(3,i)
*       H(i,s) = ------------------------------- .
*                   s**2 + h(4,i)*s + h(5,i)
*
*     If the given frequency corresponds to an uncancelled pole or zero
*     of the response, a warning message is printed and the phase value
*     is set to zero.
*
*
* Parameters:
* R <-  PHSCAS - Phase in radians.  This is the unwrapped (true) phase
*                of the cascaded sections.
*
* R ->  F      - Frequency
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:21:34 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION PHSCAS (F, H, NSECT)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NSECT
      INTEGER NZ,K

      REAL F
      REAL W,B2,B1,B0,C2,C1,C0,AR,AI
      REAL H(5,*)


* Add the group delay of each second order section
      W = PI2*F
      NZ = 0
      PHSCAS = 0.0

      DO 100 K=1,NSECT

* The transfer function is
*
*                b2*s**2 + b1*s + b0   B(s)
*         H(s) = ------------------- = ----
*                  s**2 + c1*s + c0    C(s)
*
        B2 = H(1,K)
        B1 = H(2,K)
        B0 = H(3,K)
        C2 = 1.
        C1 = H(4,K)
        C0 = H(5,K)

* The phase for H(jw) is the phase for the numerator term less
* the phase for the denominator term.  On the imaginary axis
* express the numerator term as B(jw) = R(w) + jX(w).  The
* phase for the numerator term for w=2Pi f is
*
*     Phi(w) = arctan(X(w)/R(w))
*
* In the sequel, the numerator (and denominator) are expressed as
*
*       B(jw) =  b0  - b2 w**2 + j b1 w
*

* Phase due to numerator
        AR = B0 - B2*W**2
        AI = B1*W
        IF (AR.EQ.0.0 .AND. AI.EQ.0.0) THEN
          NZ = NZ+1
        ELSE
          PHSCAS = PHSCAS+ATAN2(AI,AR)
        END IF

* Phase due to denominator
        AR = C0 - C2*W**2
        AI = C1*W
        IF (AR.EQ.0.0 .AND. AI.EQ.0.0) THEN
          NZ = NZ-1
        ELSE
          PHSCAS = PHSCAS-ATAN2(AI,AR)
        END IF

 100  CONTINUE

      IF (NZ.NE.0) THEN
        CALL WARN('PHSCAS - Undefined phase')
        PHSCAS = 0.0
      END IF


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*		SUBROUTINE MESS (STRING)
*		FUNCTION MESS (STRING)
*
*
* PURPOSE:
*	This routine prints a message using the system message
*	facility.
*
*
* DESCRIPTION:
*	This routine prints a message.
*
*
* PARAMETERS:
* I <-	MESS   - Status return from SYS$PUTMSG
*
* C ->	STRING - Character string to be printed
*
*
* ROUTINES REQUIRED:
*	SYS$PUTMSG - System message routine
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	1983/08/02
*
*
* UPDATES:
*
*
*---------------------------INRS-Telecommunications---------------------------

	FUNCTION MESS (STRING)
 
 
	INTEGER FOR_I_TEXT, ARG_COUNT, FLAGS, ARG3, FAO_COUNT, SYS$PUTMSG
	PARAMETER (FOR_I_TEXT='181133'X, ARG_COUNT=3, FLAGS=1,
     -	           FAO_COUNT=1, ARG3=FAO_COUNT+65536*FLAGS)
 
 
	CHARACTER STRING*(*)
 
	INTEGER DESCRIP(2)
 
	INTEGER*4 ARG_VEC(ARG_COUNT+1) /ARG_COUNT, FOR_I_TEXT, ARG3, 0/
 
 
* Fill in the last element of the argument vector
 
	DESCRIP(1) = LEN (STRING)
	DESCRIP(2) = %LOC (STRING)
	ARG_VEC(4) = %LOC (DESCRIP)
 
 
* Print the message text without the message identifier
 
	MESS = SYS$PUTMSG (ARG_VEC, , ,)
 
 
	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GEOINC (XMIN, XMAX, N, RSTEP, X)
*
*
* Purpose:
*     Generate geometrically increasing values
*
*
* Description:
*     The range [Xmin,Xmax] is to sampled with geometrically increasing
*     increments,
*
*                     i-1
*       X(i) = Xmin + SUM Xd(k) ,  for i=0,1,2,...,N-1 ,
*                     k=0
*
*     where Xd(k) is the increment between samples.  This increment
*     increases geometrically with k,
*
*                k
*       Xd(k) = R  Xd(0) .
*
*     The step increment is determined from the ratio of the largest
*     step to the smallest step,
*
*       Rstep = Xd(N-1)/Xd(0) .
*
*     Note that the step size in the numerator is really the step size
*     that would be used beyond Xmax.  The ratio of the actual largest
*     step size is
*
*       Xd(N-2)/Xd(0) = Rstep**((N-2)/(N-1)) .
*
*     For logarithmically spaced values, Rstep should be equal to
*     Xmax/Xmin.
*
*
* Parameters:
* R ->  XMIN   - Minimum value
* R ->  XMAX   - Maximum value
* I ->  N      - Number of points
* R ->  RSTEP  - Ratio of the largest step size to the smallest step
*                size.  For logarithmically spaced values, RSTEP should
*                be equal to XMAX/XMIN.
* R <-  X      - Array of N samples, from XMIN to XMAX
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:24:18 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GEOINC (XMIN, XMAX, N, RSTEP, X)


      INTEGER N
      INTEGER K

      REAL XMIN,XMAX,RSTEP
      REAL X(0:N-1)


      IF (RSTEP.NE.1.) THEN
        DO 120 K=0,N-1
          X(K)=XMIN+(XMAX-XMIN)*
     -            (RSTEP**(K/REAL(N-1))-1.)/(RSTEP-1.)
 120    CONTINUE

      ELSE
        DO 140 K=0,N-1
          X(K)=XMIN+K*(XMAX-XMIN)/(N-1)
 140    CONTINUE

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GETPOS (IX, IY)
*     SUBROUTINE SETPOS (IX, IY)
*
*
* Purpose:
*     Get the current plot position
*     Set the plot position
*
*
* Description:
*     This subroutine gets or sets the coordinates of the current plot
*     position.  The SETPOS routine should not normally be used by the
*     end user.  The plot position is automatically changed by the
*     plotting routines.
*
*
* Parameters:
*     Subroutine GETPOS
* I <-  IX     - X coordinate of the current plot position
* I <-  IY     - Y coordinate of the current plot position
*
*     Subroutine SETPOS
* I ->  IX     - X coordinate of the current plot position
* I ->  IY     - Y coordinate of the current plot position
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:44 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GETPOS (IX, IY)


      INTEGER IX,IY
      INTEGER IX0,IY0

      SAVE IX0,IY0

      DATA IX0,IY0/0,0/


* Return the current plot position
      IX=IX0
      IY=IY0

      GO TO 900

*----------
* Set the position
      ENTRY SETPOS (IX, IY)


      IX0=IX
      IY0=IY


 900  RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE MINMAX (X, N, XMIN, XMAX)
*
*
* Purpose:
*     Find the minimum and maximum values in an array
*
*
* Description:
*     This routine determines the minimum and maximum valued elements
*     in an array.
*
*
* Parameters:
* R ->  X      -  Input array
* I ->  N      -  Number of elements of X
* R <-  XMIN   -  Minimum value
* R <-  XMAX   -  Maximum value
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:04:47 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE MINMAX (X, N, XMIN, XMAX)


      INTEGER N
      INTEGER I

      REAL XMIN,XMAX
      REAL X(N)


      XMAX=X(1)
      XMIN=X(1)

      DO 100 I=2,N
        IF (X(I).GT.XMAX) THEN
          XMAX=X(I)
        ELSE IF (X(I).LT.XMIN) THEN
          XMIN=X(I)
        END IF
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE UNEND
*
*
* Purpose:
*     Terminate a Unix plot file
*
*
* Description:
*     This routine closes a standard Unix plot file.
*
*
* Parameters:
*     None
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:51 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE UNEND


      INTEGER LUNUN
      CHARACTER*255 FNAMUN
      COMMON /UNCOM/ LUNUN,FNAMUN


* Close the Unix plot file
      IF (LUNUN.NE.6) THEN
        CLOSE (UNIT=LUNUN)
        CALL RELFUN(LUNUN)
      END IF

* Set the common area parameters to their default values
      LUNUN=-1
      FNAMUN='unplot.dat'


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION IEXPSC (VMIN, VMAX, ILL, IUL, ILOG)
*
*
* Purpose:
*     Find the exponent for a data scale
*
*
* Description:
*     This routine uses the algorithm used by the plotting routines to
*     choose a power of ten exponent for labelling the axes.  For log
*     plots, this routine attempts to find a power of ten exponent
*     which will allow the decade marks to avoid power of 10 labels.
*
*
* Parameters:
* I <-  IEXPSC - Exponent for representing the data (multiple of 3)
*
* R ->  VMIN   - Minimum data value
* R ->  VMAX   - Maximum data value
* I ->  ILL    - Lower limit option
*                1 - The lower limit of the graph is to be a tick value
*                    less than or equal to VMIN
*                2 - The lower limit of the graph is to be VMIN
* I ->  IUL    - Upper limit option
*                1 - The upper limit of the graph is to be a tick value
*                    greater than or equal to VMAX
*                2 - The upper limit of hte graph is to be VMAX
* I ->  ILOG   - Log axis option,
*                0 - linear axis
*                1 - log axis
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:45:39 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION IEXPSC (VMIN, VMAX, ILL, IUL, ILOG)


      INTEGER LINS,LOGS,MXTICK
      PARAMETER (LINS=0,LOGS=1)
      PARAMETER (MXTICK=100)

      INTEGER ILL,IUL,ILOG
      INTEGER IAX,NTICK,IE,ILMIN,ILMAX
      INTEGER IFLORX,ICEILX

      CHARACTER*20 ALABEL(MXTICK)

      REAL VMIN,VMAX
      REAL DMIN,DMAX,TMIN,TMAX
      REAL ATICK(MXTICK)


      IAX=ILL+4*IUL+64*ILOG
      NTICK=0
      CALL AXLIMS(ATICK,MXTICK,0,1,VMIN,VMAX,ATICK,NTICK,
     -            IAX,DMIN,DMAX)
      CALL AXSCAL(DMIN,DMAX,IAX,TMIN,TMAX,
     -            ATICK,ALABEL,NTICK,IE)

      IF (IE.EQ.0 .AND. ILOG.EQ.LOGS) THEN
        ILMIN=IFLORX(LOG10(TMIN))
        ILMAX=ICEILX(LOG10(TMAX))
        IF (ILMIN.GE.2 .AND. ILMAX.LE.6) THEN
          IE=3
        ELSE IF (ILMIN.GE.5 .AND. ILMAX.LE.9) THEN
          IE=6
        ELSE IF (ILMIN.GE.8 .AND. ILMAX.LE.12) THEN
          IE=9
        END IF
      END IF

      IEXPSC=IE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PFYLIM (Y, NPT, YMIN, YMAX, NCOF, SFREQ,
*                        IPLOT, FLTTYP)
*
*
* Purpose:
*     Find the ordinate limits for a filter response plot
*
*
* Description:
*     This routine finds plot limits for a filter response plot.
*
*
* Parameters:
* R ->  Y      - Ordinate values
* I ->  NPT    - Number of values
* R <-  YMIN   - Lower plot limit
* R <-  YMAX   - Upper plot limit
* I ->  NCOF   - Number of filter coefficients
* R ->  SFREQ  - Sampling frequency
* I ->  IPLOT  - Type of plot,
*                1 - linear amplitude
*                2 - dB amplitude
*                3 - log amplitude
*                4 - group delay
*                5 - phase response
*                6 - radian phase
*                7 - impulse response
* C ->  FLTTYP - Character string indicating the type of filter,
*                ALL - all-pole filter
*                CAS - cascade analog filter
*                FIR - finite impulse response filter
*                IIR - infinite impulse response filter
*                WIN - window response
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:46:30 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PFYLIM (Y, NPT, YMIN, YMAX, NCOF, SFREQ,
     -                   IPLOT, FLTTYP)


      INTEGER TICKV,EXACTV,LINS,LOGS
      PARAMETER (TICKV=1,EXACTV=2,LINS=0,LOGS=1)
      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -           IMPLR=7)
      REAL PI
      PARAMETER (PI=3.141 592 654)

      INTEGER NPT,NCOF,IPLOT
      INTEGER ILL,IUL,ILOG,NSECT

      CHARACTER*(*) FLTTYP

      REAL Y(0:NPT-1)
      REAL YMIN,YMAX,SFREQ
      REAL DMIN,DMAX
      REAL CEILX,FLOORX


* Find the minimum and maximum ordinate values
      CALL MINMAX(Y,NPT,DMIN,DMAX)

* Linear plot scale, include 0
      IF (IPLOT.EQ.LINAR) THEN
        DMIN=MIN(DMIN,0.0)
        ILL=TICKV
        IUL=TICKV
        ILOG=LINS

* DB plot scale (at least 10 dB but at most 100 dB range)
      ELSE IF (IPLOT.EQ.DBAR) THEN
        DMAX=10.*CEILX(0.1*(DMAX+1.))
        IUL=EXACTV
        DMIN=10.*FLOORX(0.1*(DMIN-1.))
        DMIN=MAX(DMAX-100.0,MIN(DMIN,DMAX-10.0))
        ILL=EXACTV
        ILOG=LINS

* Log plot scale (minimum 1 decade, maximum 5 decades)
      ELSE IF (IPLOT.EQ.LOGAR) THEN
        IUL=TICKV
        DMIN=MAX(DMIN,1E-4*DMAX)
        ILL=TICKV
        ILOG=LOGS

* Group delay, limit the range
      ELSE IF (IPLOT.EQ.DELYR) THEN
        IF (FLTTYP.EQ.'FIR' .OR. FLTTYP.EQ.'WIN') THEN
          DMIN=0.0
          ILL=EXACTV
          DMAX=MIN(-5*(NCOF-1)/SFREQ,DMAX,0.0)
          IUL=TICKV
        ELSE IF (FLTTYP.EQ.'ALL') THEN
          DMIN=MAX(5*(NCOF-1)/SFREQ,DMIN,0.0)
          ILL=TICKV
          DMAX=0.0
          IUL=EXACTV
        ELSE
          NSECT=NCOF/5
          DMIN=MAX(DMIN,-10*NSECT/SFREQ)
          ILL=TICKV
          DMAX=MIN(DMAX,10*NSECT/SFREQ)
          IUL=TICKV
        END IF
        ILOG=LINS

* Phase response, limit the range to +/- 360 degrees per section
      ELSE IF (IPLOT.EQ.PHASD) THEN
        IF (FLTTYP.EQ.'FIR' .OR. FLTTYP.EQ.'WIN' .OR.
     -      FLTTYP.EQ.'ALL') THEN
          DMIN=-180.
          ILL=EXACTV
          DMAX=+180
          IUL=EXACTV
        ELSE
          NSECT=NCOF/5
          DMAX=180.*CEILX(MIN(DMAX,NSECT*360.)/180.)
          IUL=EXACTV
          DMIN=180.*FLOORX(MAX(DMIN,-NSECT*360.)/180.)
          DMIN=MIN(DMIN,DMAX-180.)
          ILL=EXACTV
        END IF
        ILOG=LINS

* Phase response, limit the range to +/- 2 Pi per section
      ELSE IF (IPLOT.EQ.PHASR) THEN
        IF (FLTTYP.EQ.'FIR' .OR. FLTTYP.EQ.'WIN' .OR.
     -      FLTTYP.EQ.'ALL') THEN
          DMIN=-1.
          ILL=EXACTV
          DMAX=+1.
          IUL=EXACTV
        ELSE
          NSECT=NCOF/5
          DMAX=CEILX(MIN(DMAX,2.*NSECT))
          IUL=EXACTV
          DMIN=FLOORX(MAX(DMIN,-2.*NSECT))
          DMIN=MIN(DMIN,DMAX-1.)
          ILL=EXACTV
        END IF
        ILOG=LINS

* Impulse response, include zero
      ELSE IF (IPLOT.EQ.IMPLR) THEN
        DMIN=MIN(DMIN,0.0)
        ILL=TICKV
        DMAX=MAX(DMAX,0.0)
        IUL=TICKV
        ILOG=LINS

* Unknown plot option
      ELSE
        CALL HALT('PFYLIM - Invalid plot option')

      END IF

* Find the plot limits
      CALL PLTLIM(DMIN,DMAX,ILL,IUL,ILOG,YMIN,YMAX)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE RDPLUN (LUN, PROMPT, LINE, NCHR, IEOF)
*
*
* Purpose:
*     Prompt and read a line of input from a Fortran unit
*
*
* Description:
*     This subroutine reads lines of input from a given Fortran unit.
*     A prompt string is printed if the input unit is associated with
*     a terminal.
*
*
* Parameters:
* I ->  LUN    - Fortran unit number
* C ->  PROMPT - Character string used as a prompt.  The prompt is
*                printed if unit LUN is associated with a terminal
*                and standard output (unit 6) is associated with a
*                terminal.
* C <-  LINE   - Character string for the input line.  The behaviour is
*                different for input from terminals and for input that
*                has been redirected to a file.  For terminal input, if
*                the length of LINE is insufficient, the input line is
*                truncated with a warning.  For input from a file, the
*                input line is truncated silently.  If NCHR is less
*                than the length of LINE, LINE is padded out with
*                blanks.
* I <-  NCHR   - Number of characters in the line.  NCHR is set to 0
*                on reaching end-of-file.  For terminal input, NCHR is
*                set to the length of the input line, including any
*                trailing blanks that have been entered.  For input
*                redirected to a file, NCHR is determined from the
*                position of the last non-blank character in LINE.
* I <-  IEOF   - End-of-file flag,
*                 0  - Normal value
*                -1  - End-of-file
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.2 $  $Date: 1995/03/08 15:08:04 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE RDPLUN (LUN, PROMPT, LINE, NCHR, IEOF)


      INTEGER ISTDOU
      PARAMETER (ISTDOU=6)

      INTEGER LUN,NCHR,IEOF
      INTEGER LENBLK

      CHARACTER*(*) PROMPT,LINE

      LOGICAL TTYFUN


* Write a prompt if the input is from a terminal
      IF (TTYFUN(LUN)) THEN
        IF (TTYFUN(ISTDOU)) WRITE (UNIT=ISTDOU,FMT=1000) PROMPT
        READ (UNIT=LUN,FMT=2000,END=200) NCHR,LINE

        IF (NCHR.GT.LEN(LINE)) THEN
          CALL WARN('LINEIN - Input line truncated')
          NCHR=LEN(LINE)
        END IF

      ELSE
* Non-terminal input
* Note:
*   With SunOS Fortran 4.1, the Q format is not valid for in-line
*   data in a script (requires seek ability).  It is not possible to
*   distinguish redirection to a file from redirection to in-line data
*   in a script.  For all non-terminal inputs, the read is done without
*   the Q format and the length of the line is determined by finding
*   the last non-blank character.
        READ (UNIT=LUN,FMT=2100,END=200) LINE
        NCHR=LENBLK(LINE)

      END IF
      IEOF=0
      GO TO 900

* End-of-file found
 200  NCHR=0
      LINE=' '
      IEOF=-1


 900  RETURN

 1000 FORMAT (A,$)
 2000 FORMAT (Q,A)
 2100 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION PHSIIR (F, H, NSECT)
*
*
* Purpose:
*     Find the phase response for an cascade IIR filter
*
*
* Description:
*     This function calculates the phase response of an IIR filter
*     specified by its coefficients.  The filter is a cascade of second
*     order sections, with the z-transform of the i'th filter section
*     given as
*
*                h(1,i)*z**2 + h(2,i)*z + h(3,i)
*       H(i,z) = ------------------------------- .
*                   z**2 + h(4,i)*z + h(5,i)
*
*     If the given frequency corresponds to an uncancelled pole or zero
*     of the response, a warning message is printed and the phase value
*     is set to zero.
*
*
* Parameters:
* R <-  PHSIIR - Phase in radians.  This is the unwrapped (true) phase
*                of the cascaded sections.
*
* R ->  F      - Normalized frequency (normally in the range
*                0 to 0.5)
* R ->  H      - Array of groups of 5 filter coefficients, each
*                defining a biquadratic filter section
* I ->  NSECT  - Number of filter sections
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:21:40 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION PHSIIR (F, H, NSECT)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NSECT
      INTEGER NZ,K

      REAL F
      REAL COSW,SINW,B2,B1,B0,C1,C0,AR,AI
      REAL H(5,*)


* Add the group delay of each second order section
      COSW = COS(PI2*F)
      SINW = SIN(PI2*F)
      NZ = 0
      PHSIIR = 0.0

      DO 100 K=1,NSECT

* The transfer function is
*
*                b2*z**2 + b1*z + b0   B(z)
*         H(z) = ------------------- = ----
*                  z**2 + c1*z + c0    C(z)
*
        B2 = H(1,K)
        B1 = H(2,K)
        B0 = H(3,K)
        C1 = H(4,K)
        C0 = H(5,K)

* The phase for H(w) is the phase for the numerator term
* less the phase for the denominator term.  On the unit
* circle express the numerator term as B(w) = R(w) + jX(w).
* The phase for the numerator term for w=2Pi f is
*
*     Phi(w) = arctan(X(w)/R(w))
*
* In the sequel, the numerator (and denominator) are expressed as
*
*               jw
*       B(w) = e   [ (b2+b0)cosw + b1 + j (b2-b0)sinw ]
*
* The exponential terms will cancel between the numerator and denominator.

* Phase due to numerator
        AR = B1 + (B2+B0)*COSW
        AI = (B2-B0)*SINW
        IF (AR.EQ.0.0 .AND. AI.EQ.0.0) THEN
          NZ = NZ+1
        ELSE
          PHSIIR = PHSIIR+ATAN2(AI,AR)
        END IF

* Phase due to denominator
        AR = C1 + (1.+C0)*COSW
        AI = (1.-C0)*SINW
        IF (AR.EQ.0.0 .AND. AI.EQ.0.0) THEN
          NZ = NZ-1
        ELSE
          PHSIIR = PHSIIR-ATAN2(AI,AR)
        END IF

 100  CONTINUE

      IF (NZ.NE.0) THEN
        CALL WARN('PHSIIR - Undefined phase')
        PHSIIR = 0.0
      END IF


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*       SUBROUTINE VTINIT (OPTION)
*
*
* PURPOSE:
*       This subroutine sets up a VTxxx terminal with Remote Graphics
*       Instruction Set (ReGIS) for plotting.
*
*
* DESCRIPTION:
*       This subroutine (optionally) clears the screen of the terminal
*       and draws a dark vector to the plot origin. The plot commands
*       are written to the standard output by default.
*
*
* PARAMETERS:
* C ->  OPTION - Character string specifying the options. Options are
*                separated by commas. If any option is omitted, the
*                default value is used. An all blank string gives the
*                default values. The same keyword may appear more than
*                once with the last instance taking precedence. The
*                CLEAR and OVERLAY options apply only to one invokation
*                of this routine.
*                CLEAR - The screen is erased. CLEAR is the default
*                  option if this plot device is not active.
*                OVERLAY - The screen is not erased. OVERLAY is the
*                  default option if this plot device is already active.
*                FILENAME=name - Specifies the name of the file or
*                  terminal to which plot data is sent. The file name is
*                  not used if this plot device is already active. The
*                  default file name is the logical name VTPLOT if the
*                  logical name VTPLOT is defined and TT otherwise. In
*                  the latter case, the plot data is directed to the
*                  controlling terminal.
*
*
* ROUTINES REQUIRED:
*       FNDPAR - Separate items in the option string
*       GETFUN - Allocate a Fortran unit number
*       LENSTR - Find the length of a character string
*       RQUOTE - Copy a string, removing outer quotes
*       TRNNAM - Translate a logical name
*       VTVECT - Draw a vector on a ReGIS display
*
*
* AUTHOR / MAINTAINED BY:
*       P. Kabal
*
*
* DATE CREATED:
*       1984/03/21
*
*
* UPDATES:
*       1984/03/12  Reset coordinate memory in VTCOM
*       1986/06/14  Clear/Overlay changes
*       1988/12/12  Change in file name defaults
*       1990/03/01  New common area
*
*
*---------------------------INRS-Telecommunications---------------------------

        SUBROUTINE VTINIT (OPTION)


        CHARACTER*(*) ERASE
        INTEGER DARK,ESC,NEKEY
        PARAMETER (DARK=0,ESC=27,ERASE='S(E)')
        PARAMETER (NEKEY=3)

        INTEGER NC,N,NCN
        INTEGER LENSTR

        CHARACTER*(*) OPTION
        CHARACTER*256 LINE,TOKEN
        CHARACTER*20 KEYTAB(NEKEY)
        CHARACTER*1 CESC

        LOGICAL CLEAR

        INTEGER LUNVT
        CHARACTER*255 FNAMVT
        COMMON /VTCOM/ LUNVT,FNAMVT
        DATA LUNVT/-1/,FNAMVT/' '/

        DATA KEYTAB/'CL*EAR'         , 'OVER*LAY'        ,
     -              'FILE*NAME'      /


        CLEAR=(LUNVT.LT.0)
        CALL RQUOTE(OPTION,LINE,NC)

* Decode the options
100     IF (LENSTR(LINE).GT.0) THEN
          CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NC,N)

          IF (N.EQ.1) THEN
            CLEAR=.TRUE.

          ELSE IF (N.EQ.2) THEN
            CLEAR=.FALSE.

          ELSE IF (N.EQ.3) THEN
            CALL RQUOTE(TOKEN(1:NC),FNAMVT,NCN)

          END IF

        GO TO 100
        END IF


        IF (LUNVT.LT.0) THEN

* Not previously selected
* Resolve the file name
          IF (LENSTR(FNAMVT).LE.0) THEN
            CALL TRNNAM('VTPLOT',FNAMVT,NCN)
            IF (NCN.LT.0) THEN
              FNAMVT='TT'
            ELSE
              FNAMVT='VTPLOT'
            END IF
          END IF

* Open the file
          CALL GETFUN(LUNVT)
          OPEN (UNIT=LUNVT,FILE=FNAMVT,STATUS='NEW',
     -          CARRIAGECONTROL='LIST')

          CESC=CHAR(ESC)
          WRITE (UNIT=LUNVT,FMT=1000) CESC//'P'//
     -                                '1pS(A[0,0][799,479])'
          IF (CLEAR) WRITE (UNIT=LUNVT,FMT=1000) ERASE
          CALL VTVECT(LUNVT,0,0,0)

        ELSE IF (CLEAR) THEN

* Previously selected, with CLEAR option
          WRITE (UNIT=LUNVT,FMT=1000) ERASE

        END IF


        RETURN

1000    FORMAT (A)

        END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PFGETP (FNAME, PLTOPT, PLTDEV, DEVOPT, IPLOT, IFAXIS,
*                        SFREQ, XMIN, XMAX, XSPEC,
*                        YMIN, YMAX, YSPEC, LABELS, TITLES, TSTR)
*
*
* Purpose:
*     Get the filter response plot parameters
*
*
* Description:
*     This routine reads the parameters for a filter response plot.
*
*     % pltfilter Filename PlotDevice Options
*
*     If any of the arguments is missing, the program prompts for the
*     arguments.
*
*      AMP*LITUDE_RESPONSE
*      DB*_AMPLITUDE_RESPONSE
*      LOG*_AMPLITUDE_RESPONSE
*      DELAY*_RESPONSE
*      PHASE*_RESPONSE
*      RADIAN_PHASE*_RESPONSE
*      IMP*ULSE_RESPONSE
*      SAMP*LING_FREQUENCY=Sfreq
*      X*-LIMITS=(Xmin,Xmax)
*      Y*-LIMITS=(Ymin,Ymax)
*      LOG_FREQ*UENCY= null, ON or OFF
*      RADIAN_FREQ*UENCY=null, ON or OFF
*      LAB*ELS=null, ON or OFF
*      T*ITLE="title string" or OFF
*      DEVICE_OPT*TIONS="device option string"
*      PLOT_OPT*IONS="plot option string"
*
*
* Parameters:
* C <-  FNAME  - Coefficient file name
* C <-  PLTOPT - Plot option string, default ' '
* C <-  PLTDEV - Plot device string
* C <-  DEVOPT - Device option string, default ' '
* I <-  IPLOT  - Type of plot,
*                1 - linear amplitude
*                2 - dB amplitude (default)
*                3 - log amplitude
*                4 - group delay
*                5 - phase response
*                6 - radian phase
*                7 - impulse response
* I <-  IFAXIS - Frequency axis options,
*                0 - linear frequency (Hz) (default)
*                1 - log frequency (Hz)
*                2 - linear radian frequency
*                3 - log radian frequency
* R <-  SFREQ  - Sampling frequency (SFREQ=-1 if not specified)
* R <-  XMIN   - Minimum abscissa value.  For frequency plots, XMIN and
*                XMAX are in Hz.
* R <-  XMAX   - Maximum abscissa value
* L <-  XSPEC  - Logical flag,
*                  .FALSE. - XMIN and XMAX not set
*                  .TRUE.  - XMIN and XMAX set
* R <-  YMIN   - Minimum ordinate value
* R <-  YMAX   - Maximum ordinate value
* L <-  YSPEC  - Logical flag,
*                  .FALSE. - YMIN and YMAX not set
*                  .TRUE.  - YMIN and YMAX set
* L <-  LABELS - Logical variable, .TRUE. if labels have been selected
*                (default .TRUE.)
* L <-  TITLES - Logical variable, .TRUE. if titles have been selected
*                (default .FALSE.)
* C <-  TSTR   - Title string (terminated by a null character)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:46:15 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PFGETP (FNAME, PLTOPT, PLTDEV, DEVOPT, IPLOT, IFAXIS,
     -                   SFREQ, XMIN, XMAX, XSPEC,
     -                   YMIN, YMAX, YSPEC, LABELS, TITLES, TSTR)


      INTEGER LINS,LOGS,CFREQ,RFREQ
      PARAMETER (LINS=0,LOGS=1,CFREQ=0,RFREQ=1)
      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -           IMPLR=7)

      INTEGER IPLOT,IFAXIS
      INTEGER NARG,IA,IER,IEOF,ILOG,IRAD,NC,N,IT
      INTEGER IARGC,LENSTR,KEYUPC

      LOGICAL XSPEC,YSPEC,LABELS,TITLES

      CHARACTER*(*) FNAME,PLTOPT,PLTDEV,DEVOPT,TSTR
      CHARACTER*512 LINE,TOKEN

      REAL SFREQ,XMIN,XMAX,YMIN,YMAX

      CHARACTER*3 OFFTAB(1)
      DATA OFFTAB/'OFF'/

      INTEGER NEKEY
      PARAMETER (NEKEY=16)
      CHARACTER*23 KEYTAB(NEKEY)
      DATA KEYTAB/
     - 'AMP*LITUDE_RESPONSE',      'DB*_AMPLITUDE_RESPONSE',
     - 'LOG*_AMPLITUDE_RESPONSE',  'DELAY*_RESPONSE',
     - 'PHASE*_RESPONSE',          'RADIAN_PHASE*_RESPONSE',
     - 'IMP*ULSE_RESPONSE',        'SAMP*LING_FREQUENCY',
     - 'X*-LIMITS',                'Y*-LIMITS',
     - 'LOG_FREQ*UENCY',           'RADIAN_FREQ*UENCY',
     - 'T*ITLE',                   'DEVICE_OPT*IONS',
     - 'PLOT_OPT*IONS',            'LAB*ELS'/


* Default values
      FNAME=' '
      PLTDEV=' '
      IPLOT=DBAR
      SFREQ=-1.
      ILOG=LINS
      IRAD=CFREQ
      LABELS=.TRUE.
      TITLES=.TRUE.
      TSTR=CHAR(0)
      XSPEC=.FALSE.
      YSPEC=.FALSE.
      DEVOPT=' '
      PLTOPT=' '

* Try to get the file name and plot device from the command line
      NARG=IARGC()
      IF (NARG.GE.1) THEN
        CALL GETARG(1,FNAME)
      ELSE
        CALL LINEIN('Filename: ',FNAME,NC,IEOF)
        IF (NC.LE.0) GO TO 600
      END IF
      IF (NARG.GE.2) THEN
        CALL GETARG(2,PLTDEV)
      ELSE
        CALL LINEIN('Plot Device: ',PLTDEV,NC,IEOF)
        IF (NC.LE.0) GO TO 600
      END IF

      IA=3

* Read an option
 200  IF (NARG.GE.3) THEN
        IF (IA.GT.NARG) GO TO 600
        CALL GETARG(IA,LINE)
        IA=IA+1
      ELSE
        CALL LINEIN('Options: ',LINE,NC,IEOF)
        IF (NC.LE.0) GO TO 600
      END IF

* Decode the keyword items
 300  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NC,N)

*** AMPLITUDE_RESPONSE
        IF (N.EQ.1) THEN
          IPLOT=LINAR

*** DB_AMPLITUDE_RESPONSE
        ELSE IF (N.EQ.2) THEN
          IPLOT=DBAR

*** LOG_AMPLITUDE_RESPONSE
        ELSE IF (N.EQ.3) THEN
          IPLOT=LOGAR

*** DELAY_RESPONSE
        ELSE IF (N.EQ.4) THEN
          IPLOT=DELYR

*** PHASE_RESPONSE
        ELSE IF (N.EQ.5) THEN
          IPLOT=PHASD

*** RADIAN_PHASE_RESPONSE
        ELSE IF (N.EQ.6) THEN
          IPLOT=PHASR

*** IMPULSE_RESPONSE
        ELSE IF (N.EQ.7) THEN
          IPLOT=IMPLR

*** SAMPLING_FREQUENCY
        ELSE IF (N.EQ.8) THEN
          CALL RDRVA1(TOKEN,SFREQ,IER)
          IF (IER.NE.0 .OR. SFREQ.LE.0.0)
     -        CALL WARN('PFGETP - Invalid sampling frequency')

* X-LIMITS
        ELSE IF (N.EQ.9) THEN
          CALL RDRVA2(TOKEN,XMIN,XMAX,IER)
          IF (IER.NE.0) THEN
            CALL WARN('PFGETP - Invalid X-LIMITS specification')
          ELSE
            XSPEC=.TRUE.
          END IF

* Y-LIMITS
        ELSE IF (N.EQ.10) THEN
          CALL RDRVA2(TOKEN,YMIN,YMAX,IER)
          IF (IER.NE.0) THEN
            CALL WARN('PFGETP - Invalid Y-LIMITS specification')
          ELSE
            YSPEC=.TRUE.
          END IF

*** LOG_FREQUENCY
        ELSE IF (N.EQ.11) THEN
          CALL DECOFF(TOKEN,ILOG)

*** RADIAN_FREQUENCY
        ELSE IF (N.EQ.12) THEN
          CALL DECOFF(TOKEN,IRAD)

*** TITLES
        ELSE IF (N.EQ.13) THEN
          N=KEYUPC(TOKEN,OFFTAB,1)
          IF (N.EQ.1) THEN
            TITLES=.FALSE.
          ELSE
            CALL RQUOTE(TOKEN,TSTR,NC)
            TITLES=.TRUE.
          END IF

*** DEVICE_OPTIONS
        ELSE IF (N.EQ.14) THEN
          CALL RQUOTE(TOKEN,DEVOPT,NC)

*** PLOT_OPTIONS
        ELSE IF (N.EQ.15) THEN
          CALL RQUOTE(TOKEN,PLTOPT,NC)

*** LABELS
        ELSE IF (N.EQ.16) THEN
          CALL DECOFF(TOKEN,IT)
          LABELS=IT.NE.0

***
        END IF

        GO TO 300
      END IF
      GO TO 200

* Error checks
 600  IF (IPLOT.EQ.IMPLR) THEN
        IF (ILOG.EQ.LOGS)
     -    CALL WARN('PFGETP - Log frequency option '//
     -              'incompatible with impulse response')
        IF (IRAD.EQ.RFREQ)
     -    CALL WARN('PFGETP - Radian frequency option '//
     -              'incompatible with impulse response')
      END IF

* Convert radian limits to Hz
      IF (XSPEC .AND. IRAD.EQ.RFREQ) THEN
        XMIN=0.5*XMIN
        XMAX=0.5*XMAX
      END IF

* Return the frequency axis option
      IFAXIS=ILOG+2*IRAD


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLAXES (IXAX, ATICKX, ALABLX, NTICKX, IEXPX,
*                        IYAX, ATICKY, ALABLY, NTICKY, IEXPY,
*                        DATREG)
*
*
* Purpose:
*     Draw axes around a graph
*
*
* Description:
*     This routine draws axes around a rectangular plotting area.
*     Additional axes through the data origin can be drawn if the
*     range f data includes the origin.  The axes may optionally be
*     labelled.  This routine uses the character size in effect to
*     determine the character size for the labels.  In addition, axis
*     tick marks scale with the character size.
*
*
* Parameters:
* I ->  IXAX   - Three element integer array specifying the X-axis
*                options
*                IXAX(1) - Bottom axis options
*                          0 - not drawn
*                          1 - unlabelled axis without tick marks
*                          2 - unlabelled axis with tick marks
*                          3 - labelled axis, labels appear below the
*                              axis
*                IXAX(2) - Origin axis options. The origin axis is only
*                          drawn if Y=0 is included in the range of
*                          data.
*                          0 - not drawn
*                          1 - unlabelled axis without tick marks
*                          2 - unlabelled axis with tick marks
*                          3 - labelled axis, labels appear below the
*                              axis
*                IXAX(3) - Top axis options
*                          0 - not drawn
*                          1 - unlabelled axis without tick marks
*                          2 - unlabelled axis with tick marks
*                          3 - labelled axis, labels appear below the
*                              axis
* R ->  ATICKX - Array of data values at which ticks are to be placed
*                for a horizontal axis.  If a data value lies outside
*                the range spanned by the axis [DATREG(1,1) to
*                DATREG(1,2)], the corresponding tick is not drawn.
* C ->  ALABLX - Character array of labels to be centred above or below
*                the horizontal axis tick marks.  For the purpose of
*                determining the length of the label, a null character
*                if present, marks the end of the string.  The label
*                array is in one-to-one correspondence with the array
*                of tick values.  Even for an unlabelled axis, whether
*                a label has zero length or not affects the size of the
*                corresponding axis tick.
* I ->  NTICKX - Number of horizontal axis tick values
* I ->  IEXPX  - Exponent for the horizontal axes.  If IEXPX is
*                non-zero, a power of ten annotation is printed for
*                each labelled horizontal axis.
* I ->  IYAX   - Three element integer array specifying the Y-axis
*                options
*                IYAX(1) - Left axis options
*                          0 - not drawn
*                          1 - unlabelled axis without tick marks
*                          2 - unlabelled axis with tick marks
*                          3 - labelled axis, labels appear to the left
*                              of the axis
*                IYAX(2) - Origin axis options. The origin axis is only
*                          drawn if X=0 is included in the range of
*                          data.
*                          0 - not drawn
*                          1 - unlabelled axis without tick marks
*                          2 - unlabelled axis with tick marks
*                          3 - labelled axis, labels appear to the left
*                              of the axis
*                IYAX(3) - Right axis options
*                          0 - not drawn
*                          1 - unlabelled axis without tick marks
*                          2 - unlabelled axis with tick marks
*                          3 - labelled axis, labels appear to the
*                              right of the axis
* R ->  ATICKY - Array of data values at which ticks are to be placed
*                for a vertical axis.  If a data value lies outside
*                the range spanned by the axis [DATREG(2,1) to
*                DATREG(2,2)], the corresponding tick is not drawn.
* C ->  ALABLY - Character array of labels to be centred beside the
*                vertical axis tick marks.  For the purpose of
*                determining the length of the label, a null character
*                if present, marks the end of the string.  The label
*                array is in one-to-one correspondence with the array
*                of tick values.  Even for an unlabelled axis, whether
*                a label has zero length or not affects the size of the
*                corresponding axis tick.
* I ->  NTICKY - Number of vertical axis tick values
* I ->  IEXPY  - Exponent for the vertical axes.  If IEXPY is non-zero,
*                a power of ten annotation is printed for each labelled
*                vertical axis.
* R ->  DATREG - Data limits.  The four elements of DATREG define the
*                plot region.
*                DATREG(1,1) - Lower limit for the X data
*                DATREG(2,1) - Lower limit for the function values
*                DATREG(1,2) - Upper limit for the X data
*                DATREG(2,2) - Upper limit for the function values
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:09 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLAXES (IXAX, ATICKX, ALABLX, NTICKX, IEXPX,
     -                   IYAX, ATICKY, ALABLY, NTICKY, IEXPY,
     -                   DATREG)


      INTEGER OFF,LINE,ON,LABEL,ILEFT,IRIGHT,IBOTH
      PARAMETER (OFF=0,LINE=1,ON=2,LABEL=3,ILEFT=-1,IRIGHT=+1,IBOTH=0)

      INTEGER IXAX(3),IYAX(3)
      INTEGER NTICKX,NTICKY,IEXPX,IEXPY
      INTEGER IXORIG,IYORIG,LENX,LENY
      INTEGER IAX(3),IOFFS(3),IFN(3)
      INTEGER I,IY,IX,IW,IH

      CHARACTER*(*) ALABLX(*),ALABLY(*)

      REAL ATICKX(*),ATICKY(*),DATREG(2,2)
      REAL YD(3),XD(3)
      REAL ANG,PVX,PVY

      DATA IFN/IRIGHT,IBOTH,ILEFT/
      DATA YD/-6.666666667,-6.666666667,4.6666666667/
      DATA XD/-6.666666667,-6.666666667,8.6666666667/

* Note on the power of ten label
*   For the x-axis, the lower right hand corner of the power
*   of ten label is 6 double width character positions from the
*   right hand edge of the axis (5*1.5*(2*CWID)+2*CWID=17*CWID)

* Get the character size
      CALL GETCHR(IW,IH,ANG)

* Find the plot scaling
      CALL GETGRS(IXORIG,IYORIG,LENX,LENY)
      PVX=LENX/(DATREG(1,2)-DATREG(1,1))
      PVY=LENY/(DATREG(2,2)-DATREG(2,1))

* Determine which horizontal axes are to appear on the plot
      IAX(1)=IXAX(1)
      IAX(2)=IXAX(2)
      IAX(3)=IXAX(3)
      IOFFS(1)=0
      IOFFS(2)=NINT(-DATREG(2,1)*PVY)
      IOFFS(3)=LENY
      IF (IOFFS(2).LT.0 .OR. IOFFS(2).GT.LENY) THEN
        IAX(2)=OFF
      ELSE IF (IOFFS(2).EQ.0) THEN
        IAX(1)=MAX(IAX(1),IAX(2))
        IAX(2)=OFF
      ELSE IF (IOFFS(2).EQ.LENY) THEN
        IAX(3)=MAX(IAX(2),IAX(3))
        IAX(2)=OFF
      END IF

* Draw the horizontal axes
      CALL SETCHR(IW,IH,0.0)
      DO 120 I=1,3
        IY=IYORIG+IOFFS(I)
        IF (IAX(I).EQ.LINE) THEN
          CALL XYVECT(IXORIG,IY,IXORIG+LENX,IY)
        ELSE IF (IAX(I).EQ.ON) THEN
          CALL DRWHAX(IXORIG,IY,LENX,DATREG(1,1),DATREG(1,2),
     -                ATICKX,ALABLX,-NTICKX,IFN(I))
        ELSE IF (IAX(I).EQ.LABEL) THEN
          CALL DRWHAX(IXORIG,IY,LENX,DATREG(1,1),DATREG(1,2),
     -                ATICKX,ALABLX,NTICKX,IFN(I))
          IF (IEXPX.NE.0)
     -      CALL SFPW10(IXORIG+LENX-17*IW,
     -                  IY+NINT(YD(I)*IH),6,IEXPX)
        END IF
 120  CONTINUE


* Determine which vertical axes are to appear on the plot
      IAX(1)=IYAX(1)
      IAX(2)=IYAX(2)
      IAX(3)=IYAX(3)
      IOFFS(1)=0
      IOFFS(2)=NINT(-DATREG(1,1)*PVX)
      IOFFS(3)=LENX
      IF (IOFFS(2).LT.0 .OR. IOFFS(2).GT.LENX) THEN
        IAX(2)=OFF
      ELSE IF (IOFFS(2).EQ.0) THEN
        IAX(1)=MAX(IAX(1),IAX(2))
        IAX(2)=OFF
      ELSE IF (IOFFS(2).EQ.LENX) THEN
        IAX(3)=MAX(IAX(2),IAX(3))
        IAX(2)=OFF
      END IF

* Draw the vertical axes
      CALL SETCHR(IW,IH,90.)
      DO 220 I=1,3
        IX=IXORIG+IOFFS(I)
        IF (IAX(I).EQ.LINE) THEN
          CALL XYVECT(IX,IYORIG,IX,IYORIG+LENY)
        ELSE IF (IAX(I).EQ.ON) THEN
          CALL DRWVAX(IX,IYORIG,LENY,DATREG(2,1),DATREG(2,2),
     -                ATICKY,ALABLY,-NTICKY,IFN(I))
        ELSE IF (IAX(I).EQ.LABEL) THEN
          CALL DRWVAX(IX,IYORIG,LENY,DATREG(2,1),DATREG(2,2),
     -                ATICKY,ALABLY,NTICKY,IFN(I))
          IF (IEXPY.NE.0)
     -      CALL SFPW10(IX+NINT(XD(I)*IH),
     -                  IYORIG+LENY-17*IW,6,IEXPY)
        END IF
 220  CONTINUE

* Restore the character plotting angle
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE BIQUAD (X, Y, NOUT, H)
*
*
* Purpose:
*     Filter data using a biquadratic filter section
*
*
* Description:
*     The output is formed using the following relationship,
*
*       y(i) = h(1)*x(i) + h(2)*x(i-1) + h(3)*x(i-2)
*              - h(4)*y(i-1) - h(5)*y(i-2) .
*
*     The z-transform of the filter section is
*
*              h(1)*z**2 + h(2)*z + h(3)
*       H(z) = ------------------------- .
*                z**2 + h(4)*z + h(5)
*
*     The filtering procedure needs the present and past two input
*     samples and the past two output samples to form a new output
*     sample.  These are supplied as extensions to the input and output
*     arrays.
*
*     The arrays input array X and the output array Y can share
*     storage.  Consider an array A with NOUT+4 elements.  Let the
*     first two elements (A(1) and A(2)) represent past output values.
*     The next two elements (A(3) and A(4)) are past input values.  The
*     The next NOUT elements starting with A(5) are new input values.
*     In this case, the call is
*       CALL BIQUAD(A(3),A(1),NOUT,H) .
*     NOUT new output values are placed starting at A(3), overlaying
*     input values.  The last two input values (A(NOUT+3) and
*     A(NOUT+4)) remain intact.  These along with the last two output
*     values (A(NOUT+1) and A(NOUT+2)) are suitable for priming the
*     array for processing the next group of samples.  This can be
*     achieved by moving the top 4 elements of the array to the bottom
*     of the array and appending NOUT new input values.
*
*
* Parameters:
* R ->  X      - Input array with NOUT+2 elements.  The first two
*                elements, X(1) and X(2), represent past input samples.
*                The next NOUT samples are the current input samples.
* R <-> Y      - Output array with NOUT+2 elements.  The first two
*                elements, Y(1) and Y(2), represent past outputs and
*                must be supplied as input. The remaining NOUT elements
*                are defined by this routine.
* I ->  NOUT   - Number of output samples
* R ->  H      - Array of 5 filter coefficients defining the
*                biquadratic filter section
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:20:50 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE BIQUAD (X, Y, NOUT, H)


      INTEGER NOUT
      INTEGER I

      REAL X(-2:NOUT-1),Y(-2:NOUT-1),H(5)


      DO 100 I=0,NOUT-1
        Y(I) = H(1)*X(I)+H(2)*X(I-1)+H(3)*X(I-2)
     -         -H(4)*Y(I-1)-H(5)*Y(I-2)
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE CMPRWS (STRING, CSTR, NC)
*
*
* Purpose:
*     Collapse white space in a string to a single blank
*
*
* Description:
*     This subroutine copies an input string to an output string,
*     collapsing contiguous white space characters (blanks, tabs and
*     null characters to a single blank.
*
*
* Parameters:
* C ->  STRING - Input string
* C <-  CSTR   - Output string, padded with trailing blanks
* I <-  NC     - Number of characters in CSTR, maximum LEN(STRING)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:41:06 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE CMPRWS (STRING, CSTR, NC)


      INTEGER NC
      INTEGER K,LC,I


      LOGICAL WS

      CHARACTER*(*) STRING,CSTR
      CHARACTER*1 CH


* Collapse white space at beginning or in middle
      WS=.FALSE.
      K=0
      LC=LEN(CSTR)
      DO 100 I=1,LEN(STRING)
        CH=STRING(I:I)
        IF (CH.EQ.' ' .OR. CH.EQ.CHAR(9) .OR. CH.EQ.CHAR(0)) THEN
          WS=.TRUE.
        ELSE
          IF (WS) THEN
            K=K+1
            IF (K.LE.LC) CSTR(K:K)=' '
            WS=.FALSE.
          END IF
          K=K+1
          IF (K.LE.LC) CSTR(K:K)=CH
        END IF
 100  CONTINUE

* Add whitespace at end if appropriate
      IF (WS) THEN
        K=K+1
        IF (K.LE.LC) CSTR(K:K)=' '
      END IF

* Return the length of the string
      IF (K.GT.LC) CALL HALT('CMPRWS - String truncated')
      NC=K


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE SETCHR (IWDTH, IHGHT, ANGLE)
*     SUBROUTINE GETCHR (IWDTH, IHGHT, ANGLE)
*
*
* Purpose:
*     Set the character size and orientation for a plot
*     Get the character size and orientation for a plot
*
*
* Description:
*     The character size is specified by a width and height.  The
*     character orientation is specified by a plotting angle.
*     Characters are defined on discrete grid.  Characters are
*     defined on a 10 by 14 point grid.  Characters are drawn by
*     joining points on the grid.  The example below shows an
*     uppercase "E" which extends to the edge of the grid and a
*     lowercase "o" which occupies only a portion of the grid.
*
*                      width       width
*                    |-------|   |-------|
*
*            -       o-------o   .........
*            |       |.......    .........
*            |       |........   .........
*            |       |.......    .........
*            |       |........   ..o---o..
*            |       |........   ./.....\.
*          height    o-------o   o.......o
*            |       |........   |.......|
*            |       |........   |.......|
*            |       |........   |.......|
*            |       |........   o.......o
*            |       |........   .\...../.
*            -       o-------o   ..o---o..
*
*
* Parameters:
*     Subroutine SETCHR
* I ->  IWDTH  - Width of the characters in plotting units (full scale
*                is 4096)
* I ->  IHGHT  - Height of the characters in plotting units (full scale
*                is 4096)
* R ->  ANGLE  - Plotting angle for the characters relative to the
*                horizontal (in degrees)
*
*     Subroutine GETCHR
* I <-  IWDTH  - Width of the characters in plotting units (full scale
*                is 4096)
* I <-  IHGHT  - Height of the characters in plotting units (full scale
*                is 4096)
* R <-  ANGLE  - Plotting angle for the characters relative to the
*                horizontal (in degrees)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:50 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE SETCHR (IWDTH, IHGHT, ANGLE)


      INTEGER IWDTH,IHGHT
      INTEGER LWDTH,LHGHT

      REAL ANGLE
      REAL CANGLE

      SAVE LWDTH,LHGHT,CANGLE

      DATA LWDTH,LHGHT,CANGLE/32,48,0.0/


* Set the character widths
      LWDTH=IWDTH
      LHGHT=IHGHT
      CANGLE=ANGLE

      GO TO 900

*----------
* Return the current character dimensions
      ENTRY GETCHR (IWDTH, IHGHT, ANGLE)


      IWDTH=LWDTH
      IHGHT=LHGHT
      ANGLE=CANGLE


 900  RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE LOGTIC (XMIN, XMAX, ATICK, ALABEL, NTICK)
*
*
* Purpose:
*     Generate axis ticks and labels for a log plot
*
*
* Description:
*     This subroutine finds an appropriate scale for plotting data
*     on a logarithmic scale.  The output is an array of values
*     corresponding to tick values and the labels corresponding to the
*     tick values.
*
*     Consider a data with a range from Xmin to Xmax.  For example with
*     Xmin=1 and Xmax=1000, the data extends over 3 decades.   The
*     problem is to determine appropriate positions for the axis ticks.
*     Ticks at 1, 10, 100 and 1000 correspond to the decade points.
*     The corresponding labels are "1", "10", "100", and "1000".
*     Intermediate ticks are be placed between decades.  For the
*     decade between 10 and 1000, ticks are placed at the values of 20,
*     30, ..., 90.  The convention is to label only the 2*10**n and the
*     5*10**n points (here 20 and 50), since these are approximately
*     equally spaced between decades.
*
*     The algorithm used to generate tick values and labels is as
*     follows.  The data range is extended to be an integral number
*     of decades that includes Xmin and Xmax.  The range is set to be
*     at least one decade.  The decade points are always labelled.
*     Depending on the number of decades, intermediate values may get
*     labelled.

*     The following table shows which ticks get labelled in each decade
*     (the I symbol indicates a longer tick than a | symbol).
*
*       No. Decades       Ticks and Labels in each Decade
*
*          1              I       I  I  I  I  I I I I I
*                        10^n     2  3  4  5  6 7 8 9 10^(n+1)
*
*         2-4             I       I  |  |  I  | | | | I
*                        10^n     2        5         10^(n+1)
*
*         5-7             I       I  |  |  I  | | | | I
*                        10^n                        10^(n+1)
*
*         8-10            I       |        |          I
*                        10^n                        10^(n+1)
*
*         11-20           I                           I
*                        10^n                        10^(n+1)
*
*     In the general case, the decades are marked with a power of 10
*     notation and the intermediate values are given as integers.
*     If the intermediate points are given, these are printed in a
*     character size that is slightly smaller than the decade points.
*     A special case occurs if there are 1-4 decades.  Then if
*     Xmin>=0.1 and Xmax<=1000, the labels give the numbers directly.
*
*
* Parameters:
* R ->  XMIN   - Minimum value
* R ->  XMAX   - Maximum value
* R <-  ATICK  - Array of values corresponding to the ticks
* C <-  ALABEL - Character array of labels corresponding to the ticks.
*                These are in one-to-one correspondence with the array
*                of tick values.  Each element of the array ALABEL
*                should allow for least 10 characters (includes space
*                for control characters).  Each of the generated labels
*                is terminated with a null character if it is shorter
*                than the length of the array elements.
* I <-  NTICK  - Number of elements in each of the arrays ATICK and
*                ALABEL. NTICK may be as large as 64. In case of error,
*                NTICK=0.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:28:03 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE LOGTIC (XMIN, XMAX, ATICK, ALABEL, NTICK)


      INTEGER NULL,TICK,BTICK,VALUE,P10
      PARAMETER (NULL=0,TICK=1,BTICK=2,VALUE=3,P10=4)
      INTEGER ICSML,ICSUP,ICNOR
      PARAMETER (ICSML=11,ICSUP=15,ICNOR=14)
      INTEGER NPL
      PARAMETER (NPL=6)

      CHARACTER*1 VT,SI,SO,NUL
      CHARACTER*(NPL) CSTR
      CHARACTER*(*) ALABEL(*)

      INTEGER NTICK
      INTEGER ILMAX,ILMIN,NDEC,MODE,NTD,K,I,IL,NC
      INTEGER ICEILX,IFLORX

      LOGICAL TV

      REAL XMIN,XMAX
      REAL ATICK(*)
      REAL XLMIN,XLMAX,P

* Coding tables
      INTEGER NTDEC(5)
      REAL VAL(9,5)
      INTEGER ICODE(9,5)

      DATA NTDEC/9,9,9,3,1/
      DATA VAL/
     -  1.,2.,3.,4.,5.,6.,7.,8.,9.,
     -  1.,2.,3.,4.,5.,6.,7.,8.,9.,
     -  1.,2.,3.,4.,5.,6.,7.,8.,9.,
     -  1.,2.,      5.,             0.,0.,0.,0.,0.,0.,
     -  1.,                         0.,0.,0.,0.,0.,0.,0.,0./
      DATA ICODE/
     -    P10, VALUE,VALUE,VALUE,VALUE,VALUE,VALUE,VALUE,VALUE,
     -    P10, VALUE, TICK, TICK,VALUE, TICK, TICK, TICK, TICK,
     -    P10, BTICK, TICK, TICK,BTICK, TICK, TICK, TICK, TICK,
     -    P10,  TICK, TICK, NULL, NULL, NULL, NULL, NULL, NULL,
     -    P10,  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL/


* Find the number of decades needed to span the data
      IF (XMIN.LE.0.0 .OR. XMAX.LE.0.0) THEN
        CALL WARN('LOGTIC - Error, negative values for log scale')
        NTICK=0
        GO TO 900
      END IF
      XLMIN=LOG10(XMIN)
      XLMAX=LOG10(XMAX)
      ILMAX=ICEILX( MAX(XLMIN,XLMAX) )
      ILMIN=IFLORX( MIN(XLMIN,XLMAX) )
      IF (ILMIN.EQ.ILMAX) ILMAX=ILMIN+1
      NDEC=ILMAX-ILMIN

* Find the mode in which to print the labels
      IF (NDEC.EQ.1) THEN
        MODE=1
      ELSE IF (NDEC.LE.4) THEN
        MODE=2
      ELSE IF (NDEC.LE.7) THEN
        MODE=3
      ELSE IF (NDEC.LE.10) THEN
        MODE=4
      ELSE IF (NDEC.LE.20) THEN
        MODE=5
      ELSE
        CALL WARN('LOGTIC - Too many decades')
        NTICK=0
        GO TO 900
      END IF

      TV=ILMIN.GE.-1 .AND. ILMAX.LE.3
      VT=CHAR(ICSML)
      SI=CHAR(ICSUP)
      SO=CHAR(ICNOR)
      NUL=CHAR(0)

      NTD=NTDEC(MODE)
      NTICK=NTD*NDEC+1
      DO 100 K=1,NTICK
        I=MOD(K-1,NTD)+1
        IL=(K-1)/NTD+ILMIN
        P=10.**IL

* Fill in the tick array
        ATICK(K)=P*VAL(I,MODE)

* Generate the character string for each label
        IF (ICODE(I,MODE).EQ.TICK) THEN
          ALABEL(K)=NUL

        ELSE IF (ICODE(I,MODE).EQ.BTICK) THEN
          ALABEL(K)=' '//NUL

        ELSE IF (ICODE(I,MODE).EQ.VALUE) THEN
          IF (TV) THEN
            CALL LABEL(P*VAL(I,MODE),NPL,CSTR,NC)
          ELSE
            CALL LABEL(VAL(I,MODE),NPL,CSTR,NC)
          END IF
          ALABEL(K)=VT//CSTR(1:NC)//NUL

        ELSE IF (ICODE(I,MODE).EQ.P10) THEN
          IF (TV) THEN
            CALL LABEL(P*VAL(I,MODE),NPL,CSTR,NC)
            ALABEL(K)=CSTR(1:NC)//NUL
          ELSE IF (IL.EQ.0) THEN
            ALABEL(K)=SI//' '//SO//'1'//SI//' '//NUL
          ELSE IF (IL.EQ.1) THEN
            ALABEL(K)=SI//' '//SO//'10'//SI//' '//NUL
          ELSE
            CALL LABEL(REAL(IL),NPL,CSTR,NC)
            ALABEL(K)='10'//SI//CSTR(1:NC)//NUL
          END IF
        END IF
 100  CONTINUE


 900  RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE PFGETP (FNAME, PLTOPT, PLTDEV, DEVOPT, IPLOT, IFAXIS,
*	                   SFREQ, XMIN, XMAX, XSPEC,
*	                   YMIN, YMAX, YSPEC, LABELS, TITLES, TSTR)
*
*
* PURPOSE:
*	This routine reads the parameters for a filter response plot.
*
*
* DESCRIPTION:
*	This routine reads the parameters for a filter response plot.
*	The command line parameters are as follows.
*	File_name - Coefficient file name.
*	Plotting_Device: The plotting device.
*	Qualifiers:
*       /AMPLITUDE_RESPONSE - IPLOT=1
*	/DB_AMPLITUDE_RESPONSE - IPLOT=2
*	/LOG_AMPLITUDE_RESPONSE - IPLOT=3
*	/DELAY_RESPONSE - IPLOT=4
*	/PHASE_RESPONSE - IPLOT=5
*	/RADIAN_PHASE_RESPONSE - IPLOT=6
*	/IMPULSE_RESPONSE - IPLOT=7
*	/X_LIMITS=(Xmin,Xmax) - XMIN,XMAX,XSPEC=.TRUE.
*	/Y_LIMITS=(Ymin,Ymax) - YMIN,YMAX,YSPEC=.TRUE.
*	/LOG_FREQUENCY - IFAXIS=1 or 3
*	/RADIAN_FREQUENCY - IFAXIS=2 or 3
*	/NOLOG_FREQUENCY
*	/NORADIAN_FREQUENCY
*	/SAMPLING_FREQUENCY=SFreq - SFREQ
*	/LABELS or /NOLABELS - LABELS=.TRUE. or LABELS=.FALSE.
*	/TITLES="title_string", or /TITLES or /NOTITLES - TITLES=.TRUE.
*	    or TITLES=.FALSE. and TSTR='title_string'
*	/OPTIONS="options_string" - Plot device or plotting options,
*	   depending on the placement of the qualifier. If this
*	   qualifier is placed after the filter file name, the option
*	   string is passed as part of the string PLTOPT. If this
*	   qualifier is placed after the plot device, the option
*	   string is passed as part of the string DEVOPT.
*
*
* PARAMETERS:
*   (*)	FNAME  - Coefficient file name
*   (*)	PLTOPT - Plot option string
*   (*)	PLTDEV - Plot device string
*   (*)	DEVOPT - Device option string
*   (*)	IPLOT  - Type of plot,
*	         1 - linear amplitude
*	         2 - dB amplitude
*	         3 - log amplitude
*	         4 - group delay
*	         5 - phase response
*	         6 - radian phase
*	         7 - impulse response
*   (*) IFAXIS - Frequency axis option
*	         0 - linear frequency (Hz)
*	         1 - log frequency (Hz)
*	         2 - linear radian frequency
*	         3 - log radian frequency
*   (*)	SFREQ  - Sampling frequency (SFREQ=-1 if not specified)
*   (*)	XMIN   - Minimum abscissa value. For frequency plots, XMIN
*	         and XMAX are in Hz.
*   (*)	XMAX   - Maximum abscissa value
*   (*)	XSPEC  - Logical flag,
*	           .FALSE. - XMIN and XMAX not set
*	           .TRUE.  - XMIN and XMAX set
*   (*)	YMIN   - Minimum ordinate value
*   (*)	YMAX   - Maximum ordinate value
*   (*)	YSPEC  - Logical flag,
*	           .FALSE. - YMIN and YMAX not set
*	           .TRUE.  - YMIN and YMAX set
*   (*)	LABELS - Logical variable, .TRUE. if labels have been selected
*   (*)	TITLES - Logical variable, .TRUE. if titles have been selected
*   (*)	TSTR   - Title string (terminated by a null character)
*
*
* ROUTINES REQUIRED:
*	CLI$GET_VALUE - Retrieve a command line value
*	CLI$PRESENT - Check for a command line item
*	CONSTR - Concatenate strings
*	GETVALUELIST - Get a list of values
*	HALT   - Signal an error condition
*	RDRVA1 - Read a real value
*	RDRVA2 - Read real values
*	STCOPY - Copy a string
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	86/06/18  PLTFILTER
*
*
* UPDATES:
*	88/04/29  Separated from PLTFILTER
*	89/12/08  Option handling changed
*
*	
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE PFGETP (FNAME, PLTOPT, PLTDEV, DEVOPT, IPLOT, IFAXIS,
     -	                   SFREQ, XMIN, XMAX, XSPEC,
     -	                   YMIN, YMAX, YSPEC, LABELS, TITLES, TSTR)


	INTEGER LINS,LOGS,CFREQ,RFREQ
	PARAMETER (LINS=0,LOGS=1,CFREQ=0,RFREQ=1)
	INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
	PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -	           IMPLR=7)

	CHARACTER*(*) FNAME,PLTOPT,PLTDEV,DEVOPT,TSTR
	CHARACTER*255 VALUE

	INTEGER CLI$GET_VALUE,CLI$PRESENT

	LOGICAL XSPEC,YSPEC,LABELS,TITLES

	EXTERNAL CLI$_ABSENT,CLI$_PRESENT,CLI$_NEGATED


*==========
* Dump the global OPTION string
	ISTAT=CLI$GET_VALUE('OPTION',VALUE,NC)
	IF (ISTAT.NE.%LOC(CLI$_ABSENT))
     -	  CALL HALT('PFGETP - /OPTION must follow parameters')

* Get the input file name
	CALL CLI$GET_VALUE('INFILE',FNAME)

* Get the plot OPTION string
	PLTOPT=' '
	ISTAT=CLI$GET_VALUE('OPTION',VALUE,NC)
	IF (ISTAT.NE.%LOC(CLI$_ABSENT))
     -	  CALL STCOPY(VALUE(1:NC),PLTOPT,NNC)

* Get the plot device
	CALL CLI$GET_VALUE('DEVICE',PLTDEV)

* Get the local OPTION string following the plot device
	ISTAT=CLI$GET_VALUE('OPTION',VALUE,NC)
	IF (ISTAT.NE.%LOC(CLI$_ABSENT))
     -	  CALL STCOPY(VALUE(1:NC),DEVOPT,NNC)

* Pick up the qualifiers
	IF (CLI$PRESENT('AMPLITUDE_RESPONSE').EQ.
     -	    %LOC(CLI$_PRESENT)) THEN
	  IPLOT=LINAR
	ELSE IF (CLI$PRESENT('LOG_AMPLITUDE_RESPONSE').EQ.
     -	    %LOC(CLI$_PRESENT)) THEN
	  IPLOT=LOGAR
	ELSE IF (CLI$PRESENT('DELAY_RESPONSE').EQ.
     -	         %LOC(CLI$_PRESENT)) THEN
	  IPLOT=DELYR
	ELSE IF (CLI$PRESENT('PHASE_RESPONSE').EQ.
     -	         %LOC(CLI$_PRESENT)) THEN
	  IPLOT=PHASD
	ELSE IF (CLI$PRESENT('RADIAN_PHASE_RESPONSE').EQ.
     -	         %LOC(CLI$_PRESENT)) THEN
	  IPLOT=PHASR
	ELSE IF (CLI$PRESENT('IMPULSE_RESPONSE').EQ.
     -	         %LOC(CLI$_PRESENT)) THEN
	  IPLOT=IMPLR
	ELSE
	  IPLOT=DBAR
	END IF

* Sampling frequency
	SFREQ=-1.0
	ISTATUS=CLI$GET_VALUE('SAMPLING_FREQUENCY',VALUE)
	IF (ISTATUS.NE.%LOC(CLI$_ABSENT)) THEN
	  CALL RDRVA1(VALUE,SFREQ,IER)
	  IF (IER.NE.0 .OR. SFREQ.LE.0.0)
     -	     CALL HALT('PFGETP - Invalid sampling frequency')
	END IF

* X range
	CALL GETVALUELIST('X_LIMITS',VALUE,NC)
	IF (NC.GT.0) THEN
	  CALL RDRVA2(VALUE,XMIN,XMAX,IER)
	  IF (IER.NE.0) CALL HALT('PFGETP - Invalid X_LIMITS specification')
	  XSPEC=.TRUE.
	ELSE
	  XSPEC=.FALSE.
	END IF

* Amplitude range
	CALL GETVALUELIST('Y_LIMITS',VALUE,NC)
	IF (NC.GT.0) THEN
	  CALL RDRVA2(VALUE,YMIN,YMAX,IER)
	  IF (IER.NE.0) CALL HALT('PFGETP - Invalid Y_LIMITS specification')
	  YSPEC=.TRUE.
	ELSE
	  YSPEC=.FALSE.
	END IF

* Log frequency option
	ISTATUS=CLI$PRESENT('LOG_FREQUENCY')
	IF (ISTATUS.EQ.%LOC(CLI$_PRESENT)) THEN
	  ILOG=LOGS
	ELSE
	  ILOG=LINS
	END IF

* Radian frequency option
	ISTATUS=CLI$PRESENT('RADIAN_FREQUENCY')
	IF (ISTATUS.EQ.%LOC(CLI$_PRESENT)) THEN
	  IRAD=RFREQ
	ELSE
	  IRAD=CFREQ
	END IF

* Labels option
	ISTATUS=CLI$PRESENT('LABELS')
	LABELS=.NOT.(ISTATUS.EQ.%LOC(CLI$_NEGATED))

* Titles option
	ISTATUS=CLI$PRESENT('TITLES')
	TITLES=.NOT.(ISTATUS.EQ.%LOC(CLI$_NEGATED))
	CALL CLI$GET_VALUE('TITLES',TSTR,NC)
	IF (NC.LT.LEN(TSTR)) TSTR(NC+1:NC+1)=CHAR(0)

* Error checks
	IF (IPLOT.EQ.IMPLR) THEN
	  IF (ILOG.EQ.LOGS)
     -	    CALL WARN('PFGETP - Log frequency option '//
     -	              'incompatible with impulse response')
	  IF (IRAD.EQ.RFREQ)
     -	    CALL WARN('PFGETP - Radian frequency option '//
     -	              'incompatible with impulse response')
	END IF

* Convert radian limits to Hz
	IF (XSPEC .AND. IRAD.EQ.RFREQ) THEN
	  XMIN=0.5*XMIN
	  XMAX=0.5*XMAX
	END IF

* Return the frequency axis option
	IFAXIS=ILOG+2*IRAD


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VGLB (X, N, XVAL, XLB, INDX)
*
*
* Purpose:
*     Find the largest element less than a given value
*
*
* Description:
*     This subroutine searches the input array for the largest element
*     which is less than or equal to XVAL.  If no element is less than
*     or equal to XVAL, the value XVAL is returned.
*
*
* Parameters:
* R ->  X      - Input array of values
* I ->  N      - Number of elements in X
* R ->  XVAL   - Reference value
* R <-  XGLB   - Returned value, XGLB=X(INDX) if INDX > 0
*                                XGLB=XVAL    if INDX = 0
* I <-  INDX   - Index of the element of X which is the greatest lower
*                bound to XVAL.  Indices are numbered from 1.  If two
*                or more elements of X are equal candidates, INDX is
*                set to the smallest of the indices.  INDX is set to
*                zero, if no candidate is found.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:05:28 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VGLB (X, N, XVAL, XGLB, INDX)


      INTEGER N,INDX
      INTEGER I

      REAL XVAL,XGLB
      REAL X(*)


* Search for the largest X(i) satisfying X(i) <= XVAL
      INDX=0
      XGLB=XVAL
      DO 100 I=1,N
        IF (X(I).LE.XVAL) THEN
          IF (INDX.EQ.0 .OR. X(I).GT.XGLB) THEN
            INDX=I
            XGLB=X(I)
          END IF
        END IF
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GFNTMP (TEMPL, FNAMEO)
*
*
* Purpose:
*     Generate a unique file name for a temporary file
*
*
* Description:
*     This routine generates a unique file name suitable for use as a
*     name for a temporary file.  The name is of the form
*         directory // prefix // pid // letter // .postfix
*     The directory string, prefix string and postfix strings are
*     supplied in PATTN.  If the directory part is blank, the
*     environment variable TMPDIR is used as the directory.  If this
*     variable is not defined, the directory /tmp is used.  If the
*     prefix string is blank, the name of the image (truncated to 9
*     characters) is used as the prefix string.  The postfix string is
*     a trailing string starting with a period.  There is no default
*     for this string.  The middle part of the file name is formed from
*     the process id (decimal) with an appended letter.  The appended
*     letter starts at 'a' and is incremented if a file with the given
*     name already exists.
*
*     For any process, this routine generates a maximum of 26 unique
*     file names when called with the same template.
*
*     Examples:
*       CALL GFNTMP('./ABC.xyz',FNAMEO)
*          FNAMEO = './ABC17896a.xyz'
*       CALL GFNTMP('ABC.xyz',FNAMEO)
*          FNAMEO = '/tmp/ABC17896a.xyz'
*       CALL GFNTMP(' ',FNAMEO)
*          FNAMEO = '/tmp/program17896a'
*
*
* Parameters:
* C ->  TEMPL  - File name template string
* C <-  FNAMEO - Output file name
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:07:43 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GFNTMP (TEMPL, FNAMEO)


      INTEGER MAXN
      PARAMETER (MAXN=256)

      INTEGER NCD,NCN,IPID,NC,NCT,NP,I,K
      INTEGER IST
      INTEGER LENBLK,GETPID

      CHARACTER*(*) TEMPL,FNAMEO
      CHARACTER*(MAXN+1) FDIR
      CHARACTER*(MAXN+11) FNAM
      CHARACTER*(MAXN) FTYP
      CHARACTER*(MAXN+MAXN+MAXN+12) TSTR

      LOGICAL FEX

      SAVE IST

      CHARACTER*1 IC(0:25)
      DATA IC/'a','b','c','d','e','f','g','h','i','j',
     -        'k','l','m','n','o','p','q','r','s','t',
     -        'u','v','w','x','y','z'/

      DATA IST/0/

* Parse the file name
* Leave space MAXN characters for the name part, to which are
* added the process id (10 characters max) and a single letter suffix.
      CALL FNPARS(TEMPL,FDIR,FNAM(1:MAXN),FTYP)

* Fill in defaults for the file name if necessary
      NCD=LENBLK(FDIR)
      IF (NCD.LE.0) THEN
        CALL GETENV('TMPDIR',FDIR(1:MAXN))
        NCD=LENBLK(FDIR(1:MAXN))
        IF (NCD.EQ.0) THEN
          NCD=5
          FDIR(1:NCD)='/tmp/'
        ELSE IF (FDIR(NCD:NCD).NE.'/') THEN
          NCD=NCD+1
          FDIR(NCD:NCD)='/'
        END IF
      END IF

* Get the prefix string (image name)
      NCN=LENBLK(FNAM(1:MAXN))
      IF (NCN.LE.0) THEN
        CALL GETIMG(FNAM,NCN)
        NCN=MIN(9,NCN)
      END IF

* Get the process id
* (The format assumes that the pid will be at most 10 characters long)
      IPID=GETPID()
      WRITE (UNIT=TSTR,FMT=1000) IPID
      CALL STTRIM(TSTR,FNAM(NCN+1:),NC)
      NCN=NCN+NC

* Leave room for a single letter
      NCN=NCN+1
      FNAM(NCN:NCN)='a'

* Trial file name: directory, name and postfix
      TSTR=FDIR(1:NCD)//FNAM(1:NCN)
      NCT=NCD+NCN
      IF (FTYP.NE.' ') THEN
        NC=LENBLK(FTYP)
        TSTR(NCT+1:)=FTYP(1:NC)
        NCT=NCT+NC
      END IF

* Insert different letters at TSTR(NP:NP)
      NP=NCD+NCN
      DO 200 I=0,25
        K=MOD(I+IST,26)
        TSTR(NP:NP)=IC(K)
        INQUIRE (FILE=TSTR(1:NCT),EXIST=FEX)
        IF (.NOT.FEX) GO TO 800
 200  CONTINUE
      CALL HALT('GFNTMP - Unable to generate temporary file name')

* Return the file name
 800  IST=K+1
      CALL STCOPY(TSTR(1:NCT),FNAMEO,NC)

      RETURN

 1000 FORMAT (I10.5)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     LOGICAL FUNCTION TTYFUN (LUN)
*
*
* Purpose:
*     Determine if a Fortran unit is connected to a terminal
*
*
* Description:
*     This function determines if the device connected to a given
*     Fortran unit number is a terminal.
*
*
* Parameters:
* L <-  TTYFUN - Returned logical value,
*                TRUE  - A terminal is associated with unit LUN
*                FALSE - A terminal is not associated with unit LUN
*
* I ->  LUN    - Fortran unit number
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:08:19 $
*
*
*-----------------------------------------------------------------------

      LOGICAL FUNCTION TTYFUN (LUN)


      INTEGER LUN

      LOGICAL ISATTY


      TTYFUN = ISATTY(LUN)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSEND
*
*
* Purpose:
*     Terminate a Postscript plot file
*
*
* Description:
*     This routine closes and optionally prints a Postscript plot file.
*
*
* Parameters:
*     None
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:22 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSEND


      INTEGER LUNPS,IPRTPS
      CHARACTER*255 FNAMPS
      COMMON /PSCOM/ LUNPS,IPRTPS,FNAMPS


* Force any buffered plot vectors to be written
      CALL PSXY(0,0,0)

* Write a trailer to the file
      CALL PSTAIL(LUNPS)

* Close the Postscript plot file
      IF (LUNPS.NE.6) THEN
        CLOSE (UNIT=LUNPS)
        CALL RELFUN(LUNPS)
      END IF

* Queue the file for printing (delete after printing)
      IF (IPRTPS.NE.0) CALL PRFILE(FNAMPS,' ',.TRUE.)

* Set the common area parameters to their default values
      LUNPS=-1
      IPRTPS=0
      FNAMPS=' '


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FBAKUP (FNAME)
*
*
* Purpose:
*     Rename an existing file
*
*
* Description:
*     This subroutine backs up a file.  If a file with the given name
*     already exists, say XXX, that file is renamed to XXX~.  Any
*     previous file with the name XXX~ is removed.  Files corresponding
*     to terminals are not backed up.  If a backup file is created, a
*     warning message indicating the new name is issued.
*
*     One use of this routine is to backup files before issuing an
*     OPEN.  Note that since terminal files of the given name may
*     exist, the OPEN statement should use STATUS='UNKNOWN'.
*
*
* Parameters:
* C ->  FNAME  - File name
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:07:11 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FBAKUP (FNAME)


      INTEGER NC,NT
      INTEGER LENSTR

      CHARACTER*(*) FNAME
      CHARACTER*255 FTEMP

      LOGICAL EX,TTYFNM


* Check for an existing file
      NC=LENSTR(FNAME)
      INQUIRE (FILE=FNAME(1:NC),EXIST=EX)

      IF (EX) THEN

* Check if the file is a teletype
        IF (.NOT.TTYFNM(FNAME(1:NC))) THEN

* Rename an existing file to XXX~
          FTEMP=FNAME(1:NC)//'~'
          CALL FRENAM(FNAME,FTEMP)
          NT=MIN(NC+1,LEN(FTEMP))
          CALL WARN('FBAKUP - Renamed old file to '//
     -              FTEMP(1:NT))

        END IF

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FNDSUB (LINE, QCHARS, IST, IFN, MAXN, N)
*
*
* Purpose:
*     Find comma/whitespace delimited substrings in a string
*
*
* Description:
*     This routine finds substrings in a given string.  Substrings
*     are separated by commas or white space (blanks, tabs or null
*     characters).  A warning message is printed if the maximum number
*     of substrings is found and data follows the last item found.
*     For each output substring, leading and trailing white space is
*     removed.
*
*     Optionally paired quote characters can be specified to allow
*     white space and the separator character to appear in the string
*     without acting as separators.
*
*
* Parameters:
* C ->  LINE   - Input string
* C ->  QCHARS - Character string specifying pairs of quote characters
*                (the left and right quote characters).  For instance,
*                QCHARS='""()' specifies that double quotes and
*                parentheses serve as quote characters.  In the part of
*                the input string between a matched pair of quote
*                characters, any other characters, including quote
*                characters other than from the pair in question, are
*                treated as ordinary characters.  Up to 5 pairs of
*                quote characters can be specified.  A blank string
*                signifies no quote characters are to be recognized.
*                Trailing blanks in the string QCHARS are ignored.
* I ->  MAXN   - Maximum permissible value for N
* I <-  IST    - Array of integer pointers (N values).  Element IST(i)
*                points to the start of substring i. Note that the last
*                element IST(N) will point to LEN(STRING)+1 if the last
*                substring is null.
* I <-  IFN    - Array of integer pointers (N values).  Element IFN(i)
*                points to the end of substring i.  Note that the first
*                element IFN(1) can point to 0 if the first substring
*                is null.
* I <-  N      - Number of substrings found.  Some of these substrings
*                may be null.  A null substring is signalled by having
*                IFN(i)=IST(i)-1 for substring i.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:41:09 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FNDSUB (LINE, QCHARS, IST, IFN, MAXN, N)


      INTEGER MAXN,N
      INTEGER IST(MAXN),IFN(MAXN)
      INTEGER ISEP,NCHR,IPTR,IS1,IE1

      CHARACTER*(*) LINE,QCHARS


* Initialization
      N=0
      ISEP=0
      NCHR=LEN(LINE)

 100  IF (ISEP.LT.NCHR .AND. N.LT.MAXN) THEN

* Find a separator not within quotes
        IPTR=ISEP+1
        CALL GTPSTR(LINE(IPTR:),',',QCHARS,IS1,IE1,ISEP)
        IS1=IS1+IPTR-1
        IE1=IE1+IPTR-1
        ISEP=ISEP+IPTR-1

* Save the pointers to the string
        IF (IS1.LE.IE1 .OR. ISEP.LE.NCHR) THEN
          N=N+1
          IST(N)=IS1
          IFN(N)=IE1
        END IF

      GO TO 100
      END IF

* String exhausted, check for a final null substring
      IF (NCHR.GT.0 .AND. N.LT.MAXN .AND. ISEP.EQ.NCHR) THEN
        N=N+1
        IST(N)=NCHR+1
        IFN(N)=NCHR
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FPUTI2 (LUN, I2VAL, N, IBO)
*
*
* Purpose:
*     Write INTEGER*2 values to a file (bypass Fortran I/O)
*
*
* Description:
*     This subroutine writes INTEGER*2 data to the file associated
*     with the given Fortran unit number.  The data are written using
*     routine FPUTC which bypasses normal Fortran I/O.  The data are
*     written to the file as a stream of bytes.  The byte order in the
*     file is determined by the IBO argument.
*
*
* Parameters:
* I ->  LUN    - Fortran unit number associated with the file
* I1 -> I2VAL  - Array of INTEGER*2 data to be written
* I ->  N      - Number of data values to be written
* I ->  IBO    - The byte order for the file
*                0 - The low-order byte is written first
*                1 - The high-order byte is written first
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:07:34 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FPUTI2 (LUN, I2VAL, N, IBO)


      INTEGER LUN,N,IBO
      INTEGER I,ISTAT1,ISTAT2
      INTEGER FPUTC
      INTEGER*2 I2VAL(*),I2

      CHARACTER*2 CHR
      EQUIVALENCE (I2,CHR)


      DO 100 I=1,N

* Write one byte at a time
        I2=I2VAL(I)
        IF (IBO.EQ.0) THEN
          ISTAT1=FPUTC(LUN,CHR(1:1))
          ISTAT2=FPUTC(LUN,CHR(2:2))
        ELSE
          ISTAT1=FPUTC(LUN,CHR(2:2))
          ISTAT2=FPUTC(LUN,CHR(1:1))
        END IF
        IF (ISTAT1.NE.0 .OR. ISTAT2.NE.0)
     -      CALL PSYERR('FPUTI2 - System error return from FPUTC')

 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PPARST (LINEI, KEYWRD, LK, TOKEN, LT, LLINE, LL,
*                        RLINE)
*
*
* Purpose:
*     Extract a keyword and token string from a string
*
*
* Description:
*     String Processing:
*     1) This routine looks for a separator consisting of a comma
*        and/or whitespace not in parentheses or quotes.  This
*        separator separates the input string into a left part and a
*        right part.  If no separator is found, the left part is the
*        whole string and the right part is null.
*     2) The left part of the input string is parsed into a keyword
*        string and a token string separated by an equal sign.  If no
*        equal sign is found, the token string is considered to be
*        null. The keyword string is returned as KEYWRD and the token
*        string as TOKEN.  Leading and trailing white space are removed
*        from TOKEN and KEYWRD.
*     3) The left side of the string is returned (after some editing)
*        as LLINE.  This string includes the keyword string, the equal
*        sign delimiter and the token string.  White space surrounding
*        the keyword string and token string is removed, and white
*        space on either side of the equal sign (if any) is collapsed
*        into a single blank.
*     If the input string is " AAA  = BBB , CCC = DDD", after
*     processing:
*       KEYWRD="AAA",      LK=3
*       TOKEN="BBB",       LT=3
*       LLINE="AAA = BBB", LL=9
*       RLINE="CCC = DDD"
*
*
* Parameters:
* C ->  LINEI  - Input string
* C <-  KEYWRD - Keyword string
* I <-  LK     - Length of the keyword string
* C <-  TOKEN  - Token string
* I <-  LT     - Length of the token string
* C <-  LLINE  - Keyword string, equal sign delimiter and token string
* I <-  LL     - Length of LLINE
* C <-  RLINE  - On return, RLINE is set to the input string with the
*                decoded first part removed.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:41:28 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PPARST (LINEI, KEYWRD, LK, TOKEN, LT, LLINE, LL,
     -                 RLINE)


      INTEGER LK,LT,LL
      INTEGER IS1,IE1,IS2,IE2,ISEP,NC,N

      CHARACTER*(*) LINEI,KEYWRD,TOKEN,LLINE,RLINE


* Parse the string
      CALL GTPSTE(LINEI,'""()',IS1,IE1,IS2,IE2,ISEP)

* Return the keyword string
      IF (IS1.LE.IE1) THEN
        CALL STCOPY(LINEI(IS1:IE1),KEYWRD,LK)
      ELSE
        KEYWRD=' '
        LK=0
      END IF

* Return the token string
      IF (IS2.LE.IE2) THEN
        CALL STCOPY(LINEI(IS2:IE2),TOKEN,LT)
      ELSE
        TOKEN=' '
        LT=0
      END IF

* Return the left side string (with some editing)
* - the keyword string is LINEI(IS1:IE1)
* - the equal sign delimiter (with enclosing white space) is
*   LINEI(IE1+1:max(IS2-1,IE1))
* - collapse the white space surrounding the equal sign
* - the token string is LINEI(IS2:IE2)
      LL=0
      IF (IS1.LE.IE1) THEN
        CALL STCOPY(LINEI(IS1:IE1),LLINE,NC)
        LL=LL+NC
      END IF
      N=(IS2-1)-(IE1+1)+1
      IF (N.GT.0) THEN
        CALL CMPRWS(LINEI(IE1+1:IS2-1),LLINE(LL+1:LL+N),NC)
        LL=LL+NC
      END IF
      N=IE2-IS2+1
      IF (N.GT.0) THEN
        CALL STCOPY(LINEI(IS2:IE2),LLINE(LL+1:LL+N),NC)
        LL=LL+NC
      END IF
      IF (LL.LE.LEN(LLINE)) LLINE(LL+1:)=' '

* Return the right side string
      IF (ISEP.LE.LEN(LINEI)) THEN
        CALL STCOPY(LINEI(ISEP+1:),RLINE,NC)
      ELSE
        RLINE=' '
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE LINEIN (PROMPT, LINE, NCHR, IEOF)
*
*
* Purpose:
*     Read a line of input from standard input
*
*
* Description:
*     This subroutine reads lines of input from standard input (Fortran
*     unit 5).  A prompt string is printed if the input unit is
*     associated with a terminal.
*
*
* Parameters:
* C ->  PROMPT - Character string used as a prompt.  The prompt
*                is printed if standard input (Fortran unit 6) is
*                associated with a terminal and standard output (unit
*                6) is associated with a terminal.
* C <-  LINE   - Character string for the input line.  The behaviour is
*                different for input from terminals and for input that
*                has been redirected to a file.  For terminal input, if
*                the length of LINE is insufficient, the input line is
*                truncated with a warning.  For input from a file, the
*                input line is truncated silently.  If NCHR is less
*                than the length of LINE, LINE is padded out with
*                blanks.
* I <-  NCHR   - Number of characters in the line.  NCHR is set to 0
*                on reaching end-of-file.  For terminal input, NCHR is
*                set to the length of the input line, including any
*                trailing blanks that have been entered.  For input
*                redirected to a file, NCHR is determined from the
*                position of the last non-blank character in LINE.
* I <-  IEOF   - End-of-file flag,
*                 0  - Normal value
*                -1  - End-of-file
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:07:46 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE LINEIN (PROMPT, LINE, NCHR, IEOF)


      INTEGER ISTDIN
      PARAMETER (ISTDIN=5)

      INTEGER NCHR,IEOF

      CHARACTER*(*) PROMPT,LINE


      CALL RDPLUN(ISTDIN,PROMPT,LINE,NCHR,IEOF)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE IZERO (IX, N)
*
*
* Purpose:
*     Zero an INTEGER array
*
*
* Description:
*     Each element of the given array is set to zero.
*
*
* Parameters:
* I <-  IX     - Integer array to be zeroed
* I ->  N      - Number of elements in IX.  N may be zero.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:04:44 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE IZERO (IX, N)


      INTEGER N
      INTEGER I
      INTEGER IX(*)


      DO 100 I=1,N
        IX(I)=0
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION LOCNBL (LINE)
*
*
* Purpose:
*     Find the first non-whitespace character in a string
*
*
* Description:
*     This function returns a pointer to the first significant
*     character in a string.  Blanks, tabs and null characters are
*     not considered to be significant.
*
*
* Parameters:
* I <-  LOCNBL - The returned function value is a pointer to the first
*                significant character in the input string.  If none is
*                found, LOCNBL is equal to one more than the length of
*                the input string.
*
* C ->  LINE   - Input character string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:20 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION LOCNBL (LINE)


      INTEGER NCHR,L

      CHARACTER*(*) LINE


* Find the first significant character
      NCHR=LEN(LINE)
      DO 100 L=1,NCHR
        IF (LINE(L:L).NE.' ' .AND. LINE(L:L).NE.CHAR(9)
     -      .AND. LINE(L:L).NE.CHAR(0)) GO TO 200
 100  CONTINUE

* Return the pointer to the first significant character
 200  LOCNBL=L


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION LQUANT (X, XQ, NLEV)
*
*
* Purpose:
*     Binary search for a bounding interval
*
*
* Description:
*     This subroutine returns the index of the quantizer output region
*     corresponding to a given input value.  The quantizer is specified
*     by an array of quantizer decision levels.  A binary search is
*     used to determine the quantizer region.
*
*
* Parameters:
* I <-  LQUANT - Output index of the quantizer output region
*                corresponding to X.  LQUANT takes on values from 1 to
*                NLEV.  If NLEV is one, LQUANT is set to one.
*                Otherwise, LQUANT is determined as follows,
*                   LQUANT = 1,       x =< XQ(1)
*                   LQUANT = 2,       XQ(1) < x =< XQ(2)
*                    ...           ...
*                   LQUANT = NLEV,    XQ(NLEV-1) < x .
*
* R ->  X      - Value to be quantized
* R ->  XQ     - Input array of NLEV-1 quantizer decision levels which
*                delimit the NLEV quantizer regions.  These must be in
*                ascending order (non-decreasing order).
* I ->  NLEV   - Number of quantizer regions
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:32:32 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION LQUANT (X, XQ, NLEV)


      INTEGER NLEV
      INTEGER IL,IU,I

      REAL X
      REAL XQ(*)


* Binary search for the interval ( XQ(IL),XQ(IU) ) which brackets
* the value X.
      IL=0
      IU=NLEV

* Check if the interval has been isolated
 100  IF (IU.LE.IL+1) GO TO 200

      I=(IL+IU)/2
      IF (X.LE.XQ(I)) THEN
        IU=I
      ELSE
        IL=I
      END IF
      GO TO 100

* Return the index of the region
 200  LQUANT=IU


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLOTYX (X, Y, IDIM, NPT, NGRAPH,
*                        XMIN, XMAX, YMIN, YMAX, OPTION)
*
*
* Purpose:
*     Plot tabulated data on a labelled graph
*
*
* Description:
*     This subroutine plots real data.  The function values are
*     supplied in a two-dimensional array, and the abscissa values
*     are given in another array.  The plotting scale may be specified
*     directly or the routine can be allowed to determine an
*     appropriate plotting scale.
*
*     This routine draws the graph of the function along with labelled
*     axes.  The default axes have an integral number of intervals,
*     such that increment corresponding to an interval is a number of
*     the form 1, 2 or 5 times a power of ten.
*
*
* Parameters:
* R <-> X      - Array of abscissa values (NPT values).  These values
*                are altered if a log X-axis is selected.  For a log
*                X-axis, the values are converted to log values and
*                then back again to linear values.  For the LINE-TYPE=
*                SMOOTH option, the abscissa values must be in
*                increasing order.
* R <-> Y      - Two dimensional array of function values.  Y(1,1)
*                through Y(NPT,1) are plotted on the first graph,
*                Y(1,2) through Y(NPT,2) are plotted on the second
*                graph, and so on.  If only one graph is to be plotted,
*                Y may be one dimensional. For a log Y-axis, the values
*                are converted to log values and then back again to
*                linear values.
* I ->  IDIM   - First dimension of the input array Y
* I ->  NPT    - Number of points per graph (less than or equal to
*                IDIM).  For the LINE-TYPE=SMOOTH option, NPT can be at
*                most 301.
* I ->  NGRAPH - Number of graphs to be simultaneously plotted.  If
*                NGRAPH is zero, only the axes are drawn.
* R ->  XMIN   - Lower limit for the X-axis
* R ->  XMAX   - Upper limit for the X-axis
*                If XMIN is equal to XMAX, the subroutine will find a
*                range for the X-axis of the graph such that all values
*                of X and also the value XMIN (and XMAX) are included
*                in the range of the graph.  Automatic scaling is
*                enabled by setting XMIN=XMAX=X(n), where X(n) is any
*                of the abscissa values.
* R ->  YMIN   - Lower limit for the Y-axis
* R ->  YMAX   - Upper limit for the Y-axis
*                If YMIN is equal to YMAX, the subroutine will find a
*                range for the Y-axis of the graph such that all values
*                of Y and also the value YMIN (and YMAX) are included
*                in the range of the graph.  Automatic scaling is
*                enabled by setting YMIN=YMAX=Y((i,j), where Y(i,j) is
*                any of the function values.
* C ->  OPTION - Character string specifying the options
*                Individual option specifications are separated by
*                white space (blanks, tabs or null characters) or
*                commas.  The general form of the option specifications
*                is KEYWORD=arg or KEYWORD, where KEYWORD is a keyword
*                string.  Keywords can be specified in upper or lower
*                case and in most cases allow for short forms.  The
*                argument string following the keyword is used to
*                specify values or subsidiary option specifications.
*                Within the argument string, parentheses are used to
*                group lists of values or subsidiary option
*                specifications.  Lists of values are enclosed in
*                parentheses with the values separated by white space
*                or commas.  The same keyword may be given more than
*                once, with the last invokation taking precedence.
*                Default options are used if some or all of the
*                keywords are omitted.
*
*                Keywords are listed below.  An asterisk character is
*                used to indicate the position corresponding to the
*                minimum length short forms for the keywords.
*                CHAR*ACTER_SIZE = (Iwidth Iheight) - Character size
*                  This option specifies the size of characters to be
*                  used for labelling the axes.  This character size
*                  also serves as the default plot symbol size.  Note
*                  that axis tick lengths scale with the character
*                  size.
*                  (default 32 by 48)
*                LINE*-TYPE - Type of line used to plot the data
*                  = POINT*S, symbols plotted at the points
*                  = LINE, straight lines joining the points (default)
*                  = LINE+*POINTS, both symbols and lines
*                  = SMOOTH, monotonic cubic interpolant (smooth
*                     plotting curve passing through the data values)
*                  = SMOOTH+*POINTS, both points and a smooth curve
*                  = (PATTERN=(xx yy ...)), line pattern
*                     The argument indicates the on/off pattern for
*                     the line to be used in drawing the graphs.  Each
*                     of the elements in the pattern represents the
*                     length (in plotting units) of an ON pattern
*                     (positive value) or an OFF pattern (negative
*                     value).  Up to 5  pattern elements may be
*                     specified.
*                     (default continuous line, PATTERN=0).
*                  = (SYM*BOLS="xxxxx"), plotting symbols
*                     The character string specifies the plot symbols
*                     to be used for the graphs. The first character is
*                     used for the first graph, the second character
*                     for the second graph, and so on. If the number of
*                     graphs is larger than the number of symbols
*                     specified, the symbols are used cyclically. Up to
*                     20 symbols may be specified. Leading and trailing
*                     white space is ignored unless the symbol string
*                     is enclosed in quotes (").  Special plotting
*                     symbols may be accessed as characters with ASCII
*                     codes in the range 161-170.
*                     161 square           162 octagon (circle)
*                     163 triangle         164 inverted triangle
*                     165 ex               166 cross
*                     167 filled squadre   168 filled octagon
*                     169 filled triangle  170 filled inverted triangle
*                     (default square, octagon, triangle,...).
*                  = (SYMBOL_SIZE=(Iwidth Iheight)), plotting symbol
*                     size in plotting units
*                     (default size is set by the CHARACTER_SIZE option
*                     which itself defaults to 32 by 48)
*                  = (SYMBOL_ANGLE=angle), plotting symbol angle
*                     This option sets the angle of the plot symbols in
*                     degrees measured from the horizontal axis.
*                     (default 0)
*                POS*ITION = (IX IY) - Position of the plot
*                  This option specifies the X-Y coordinates (in
*                  plotting units) of the lower lefthand corner of the
*                  plot.
*                  (default position (720 440))
*                SIZE = (LenX LenY) - Size of the plot
*                  This option specifies the size of the plotting area
*                  (in plotting units).
*                  (default size (3240 2400))
*                X-AX*IS - Plot limits and horizontal axes
*                  Axis generation is automatic unless the TICKS option
*                  is specified.
*                  (default (LIMITS=EXACT ON LINEAR), if the axis
*                  range is explicitly specified (XMAX > XMIN),
*                  (LIMITS=TICKS ON LINEAR) otherwise)
*                  = LIN*EAR - linear scale
*                     In the automatic mode, the axis ticks are chosen
*                     to correspond to uniformly spaced "nice" values
*                     of the form 1, 2 or 5 times a power of ten, but
*                     only every second tick is labelled with a value.
*                  = LOG*ARITHMIC - logarithmic scale
*                     In the automatic mode, the axis ticks correspond
*                     to the decade points 10**n.  For a data range
*                     encompassing a small number of decades,
*                     intermediate ticks at 2*10**n and 5*10**n are
*                     also generated.  For a single decade, ticks at
*                     2*10**n, 3*10**n, ..., 9*10**n are generated.
*                     The decade points are always labelled.  If the
*                     number of decades is small, intermediate ticks
*                     are also labelled.
*                  = (LIM*ITS = EXACT)
*                    (LIM*ITS = TICK*S)
*                    (LIM*ITS = (LOW*ER_LIMIT=EXACT or TICK))
*                    (LIM*ITS = (UP*PER_LIMIT=EXACT or TICK)) - plot
*                     limit options
*                     EXACT - The plot limits are set to the values
*                     determined from XSTART and XINCR.
*                     TICKS - The plot limits are set to coincide with
*                     axis tick values which include the range
*                     determined from XSTART and XINCR.
*                     The LOWER_LIMIT and UPPER_LIMIT options allow for
*                     separate specification of the plot limit type at
*                     each end of the axis.
*                  = ON, enable default plot axes
*                     This option is equivalent to specifying the
*                     X-AXIS options (BOTTOM=LABELLED TOP=ON
*                     ORIGIN=ON).
*                  = OFF, disable plot axes
*                     This option is equivalent to specifying the
*                     X-AXIS options (BOTTOM=OFF TOP=OFF ORIGIN=OFF).
*                  = (BOT*TOM = *ON, OFF, LABEL*LED, LINE), bottom axis
*                     This option determines whether an axis is to be
*                     drawn at the bottom of the graph.  Labels, if
*                     selected, appear below the axis.
*                     OFF  - No axis
*                     *ON  - Unlabelled axis with tick marks
*                     LABEL*LED - Labelled axis with tick marks
*                     LINE - Unlabelled axis with no tick marks
*                  = (TOP = *ON, OFF, LABEL*LED, LINE), top axis
*                     This option determines whether an axis is to be
*                     drawn at the top of the graph.  Labels, if
*                     selected, appear above the axis.
*                  = (ORIG*IN = *ON, OFF, LABEL*LED, LINE), origin axis
*                     This option determines whether an axis is to be
*                     drawn through y=0 if y=0 appears within the range
*                     of a graph. Labels, if selected, appear below the
*                     axis.
*                  = (TICK*S = (val1 val2 val3 ...)), axis tick values
*                     This option specifies the data values at which
*                     axis ticks are to appear. Up to 100 values may be
*                     specified.  Tick values outside the range of the
*                     graph are not plotted.  If this option is
*                     omitted, or the list of data values is not given,
*                     axis ticks are placed automatically.
*                  = (LABEL*S = ("label1" "label2" "label3" ...)), axis
*                     labels
*                     This option specifies character strings to be
*                     associated with the tick marks given by the
*                     TICKS option.  The labels are centred above or
*                     below the corresponding tick marks.  Leading and
*                     trailing white space in each label is ignored
*                     unless the label string is enclosed by quotes
*                     (").  Control characters can be included to allow
*                     for superscripts for power of ten notation (see
*                     subroutine PLTEXT).  Any or all labels may be
*                     empty ("").  Tick marks associated with empty
*                     labels are shorter than tick marks associated
*                     with non-empty labels.  This holds even if other
*                     options select an axis that is to be drawn as
*                     unlabelled (tick marks only).  The labels may be
*                     up to 20 characters in length.  The LABELS option
*                     has no effect unless the TICKS option is also
*                     specified.  If the LABELS option is omitted, or
*                     the list of labels is null, LABELS are generated
*                     automatically.
*                Y-AX*IS - Plot limits and vertical axes
*                  Axis generation is automatic unless the TICKS option
*                  is specified.
*                  (default (LIMITS=EXACT ON LINEAR), if the axis
*                  range is explicitly specified (YMAX > YMIN),
*                  (LIMITS=TICKS ON LINEAR) otherwise)
*                  = LIN*EAR - linear scale
*                     In the automatic mode, the axis ticks are chosen
*                     to correspond to uniformly spaced "nice" values
*                     of the form 1, 2 or 5 times a power of ten, but
*                     only every second tick is labelled with a value.
*                  = LOG*ARITHMIC - logarithmic scale
*                     The input Y array is converted to log values.  In
*                     the automatic mode, the axis ticks correspond to
*                     the decade points 10**n.  For a data range
*                     encompassing a small number of decades,
*                     intermediate ticks at 2*10**n and 5*10**n are
*                     also generated.  For a single decade, ticks at
*                     2*10**n, 3*10**n, ..., 9*10**n are generated.
*                     The decade points are always labelled.  If the
*                     number of decades is small, intermediate ticks
*                     are also labelled.
*                  = (LIM*ITS = EXACT)
*                    (LIM*ITS = TICK*S)
*                    (LIM*ITS = (LOW*ER_LIMIT=EXACT or TICK))
*                    (LIM*ITS = (UP*PER_LIMIT=EXACT or TICK)) - plot
*                     limit options
*                     EXACT - The plot limits are set to the values
*                     determined from YMIN and YMAX.  For YMAX > YMIN,
*                     the limits are [YMIN,YMAX].  Otherwise, the plot
*                     limits are determined as [min(YMIN,Y(i,j)),
*                     max(YMAX,Y(i,j))].
*                     TICKS - The plot limits are set to coincide with
*                     axis tick values which include the range
*                     determined from YMIN and YMAX.
*                     The LOWER_LIMIT and UPPER_LIMIT options allow for
*                     separate specification of the plot limit type at
*                     each end of the axis.
*                  = ON, enable default plot axes
*                     This option is equivalent to specifying the
*                     X-AXIS options (LEFT=LABELLED RIGHT=ON
*                     ORIGIN=ON).
*                  = OFF, disable plot axes
*                     This option is equivalent to specifying the
*                     X-AXIS options (LEFT=OFF RIGHT=OFF ORIGIN=OFF).
*                  = (L*EFT = *ON, OFF, LABEL*LED, LINE), left axis
*                     This option determines whether an axis is to be
*                     drawn to the left of the graph.  Labels, if
*                     selected, appear to the left of the axis.
*                     OFF  - No axis
*                     *ON  - Unlabelled axis with tick marks
*                     LABEL*LED - Labelled axis with tick marks
*                     LINE - Unlabelled axis with no tick marks
*                  = (R*IGHT = *ON, OFF, LABEL*LED, LINE), right axis
*                     This option determines whether an axis is to be
*                     drawn to the right of the graph.  Labels, if
*                     selected, appear to the right of the axis.
*                  = (ORIG*IN = *ON, OFF, LABEL*LED, LINE), origin axis
*                     This option determines whether an axis is to be
*                     drawn through x=0 if x=0 appears within the range
*                     of a graph.  Labels, if selected, appear to the
*                     left of the axis.
*                  = (TICK*S = (val1 val2 val3 ...)), axis tick values
*                     This option specifies the data values at which
*                     axis ticks are to appear. Up to 100 values may be
*                     specified.  Tick values outside the range of the
*                     graph are not plotted.  If this option is
*                     omitted, or the list of data values is not given,
*                     axis ticks are placed automatically.
*                  = (LABEL*S = ("label1" "label2" "label3" ...)), axis
*                     labels
*                     This option specifies character strings to be
*                     associated with the tick marks given by the
*                     TICKS option.  The labels are centred above or
*                     below the corresponding tick marks.  Leading and
*                     trailing white space in each label is ignored
*                     unless the label string is enclosed by quotes
*                     (").  Control characters can be included to allow
*                     for superscripts for power of ten notation (see
*                     subroutine PLTEXT).  Any or all labels may be
*                     empty ("").  Tick marks associated with empty
*                     labels are shorter than tick marks associated
*                     with non-empty labels.  This holds even if other
*                     options select an axis that is to be drawn as
*                     unlabelled (tick marks only).  The labels may be
*                     up to 20 characters in length.  The LABELS option
*                     has no effect unless the TICKS option is also
*                     specified.  If the LABELS option is omitted, or
*                     the list of labels is null, LABELS are generated
*                     automatically.
*
*                As an example, the following call to this routine
*                results in the same options as the default ones if
*                XMIN < XMAX and YMIN < YMAX.
*                CALL PLOTYX (X,Y,IDIM,NPT,NGRAPH,XMIN,XMAX,YMIN,YMAX,
*               -             'LINE-TYPE=(LINE PATTERN=0) '//
*               -             'SIZE=(3240 2400) ORIGIN=(720 440) '//
*               -             'X-AXIS=(LIMITS=EXACT LINEAR) '//
*               -             'Y-AXIS=(LIMITS=EXACT)')
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:28:23 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLOTYX (X, Y, IDIM, NPT, NGRAPH,
     -                   XMIN, XMAX, YMIN, YMAX, OPTION)


      INTEGER POINT,LINE,LINEPT,SMOOTH,SMOOPT,OFF
      INTEGER MXTICK,MAXNI
      PARAMETER (POINT=1,LINE=2,LINEPT=3,SMOOTH=4,SMOOPT=5,
     -           OFF=0)
      PARAMETER (MXTICK=100,MAXNI=301)

      INTEGER IDIM,NPT,NGRAPH
      INTEGER ICSIZE(2),IPATTN(5),ISSIZE(2),IXAX(0:3),IYAX(0:3)
      INTEGER LINTYP,IXORIG,IYORIG,LENX,LENY,NTICKX,NTICKY,
     -        IEXPX,IEXPY,LS,J,NIPT,K,ILOGX,ILOGY
      INTEGER LENNUL

      CHARACTER*(*) OPTION
      CHARACTER*20 SYMBOL,ALABLX(MXTICK),ALABLY(MXTICK)

      REAL X(*),Y(IDIM,*)
      REAL XMIN,XMAX,YMIN,YMAX
      REAL SANG,VMIN,VMAX
      REAL ATICKX(MXTICK),ATICKY(MXTICK)
      REAL XI(MAXNI),YI(MAXNI)
      REAL DATREG(2,2)


* Decode the options string
      CALL DECPLT(OPTION,ICSIZE,LINTYP,IPATTN,SYMBOL,ISSIZE,SANG,
     -            IXAX,IYAX,IXORIG,IYORIG,LENX,LENY,
     -            ATICKX,ATICKY,ALABLX,ALABLY,NTICKX,NTICKY)
      CALL SETGRS(IXORIG,IYORIG,LENX,LENY)

********** Scaling
* X - Find the minimum and maximum values
* X-axis scaling and labels
      CALL AXLIMS(X,IDIM,NPT,1,XMIN,XMAX,ATICKX,NTICKX,
     -            IXAX(0),VMIN,VMAX)
      CALL AXSCAL(VMIN,VMAX,IXAX(0),DATREG(1,1),DATREG(1,2),
     -            ATICKX,ALABLX,NTICKX,IEXPX)

* Y - Find the minimum and maximum values
* Y-axis scaling and labels
      CALL AXLIMS(Y,IDIM,NPT,NGRAPH,YMIN,YMAX,ATICKY,NTICKY,
     -            IYAX(0),VMIN,VMAX)
      CALL AXSCAL(VMIN,VMAX,IYAX(0),DATREG(2,1),DATREG(2,2),
     -            ATICKY,ALABLY,NTICKY,IEXPY)

* Log scaling of the abscissa values and plot limits
      ILOGX=MOD(IXAX(0)/64,2)
      IF (ILOGX.NE.0) THEN
        CALL VLOG10(X,X,NPT)
        DATREG(1,1)=LOG10(DATREG(1,1))
        DATREG(1,2)=LOG10(DATREG(1,2))
      END IF
      ILOGY=MOD(IYAX(0)/64,2)
      IF (ILOGY.NE.0) THEN
        DATREG(2,1)=LOG10(DATREG(2,1))
        DATREG(2,2)=LOG10(DATREG(2,2))
      END IF


********** Plotting
      CALL SETCHR(ISSIZE(1),ISSIZE(2),SANG)
      LS=LENNUL(SYMBOL)

      DO 300 J=1,NGRAPH

* Log scaling of the Y values
        IF (ILOGY.NE.0) CALL VLOG10(Y(1,J),Y(1,J),NPT)

* Straight line segments
        IF (LINTYP.EQ.LINE .OR. LINTYP.EQ.LINEPT) THEN
          CALL PLVCFX(X,Y(1,J),NPT,DATREG,IPATTN)

* Interpolation to give a smooth curve
        ELSE IF (LINTYP.EQ.SMOOTH .OR. LINTYP.EQ.SMOOPT) THEN
          CALL EQDINC(X,NPT,XI,MAXNI,NIPT)
          CALL PMCINT(X,Y,NPT,XI,YI,NIPT)
          CALL PLVCFX(XI,YI,NIPT,DATREG,IPATTN)
        END IF

* Plot symbols at the data points
        IF (LS.GT.0 .AND.
     -      (LINTYP.EQ.POINT .OR. LINTYP.EQ.LINEPT .OR.
     -       LINTYP.EQ.SMOOPT)) THEN
          K=MOD(J-1,LS)+1
          CALL PLVCPX(SYMBOL(K:K),X,Y(1,J),NPT,DATREG)
        END IF

* Undo the log scaling of the data values
        IF (ILOGY.NE.0) CALL VEXP10(Y(1,J),Y(1,J),NPT)

 300  CONTINUE

* Undo the log scaling of the abscissa values
      IF (ILOGX.NE.0) CALL VEXP10(X,X,NPT)

********** Axes
* Labelled axes around the plot
      IF (ILOGX.NE.0) CALL VLOG10(ATICKX,ATICKX,NTICKX)
      IF (ILOGY.NE.0) CALL VLOG10(ATICKY,ATICKY,NTICKY)
      CALL SETCHR(ICSIZE(1),ICSIZE(2),0.)
      CALL PLAXES(IXAX(1),ATICKX,ALABLX,NTICKX,IEXPX,
     -            IYAX(1),ATICKY,ALABLY,NTICKY,IEXPY,DATREG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE XYMOVE (IX, IY)
*
*
* Purpose:
*     Move the plot position
*
*
* Description:
*     This subroutine moves the pen position without drawing a line.
*
*
* Parameters:
* I ->  IX     - X coordinate of the new pen position (0 to 4095)
* I ->  IY     - Y coordinate of the new pen position (0 to 4095)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:11 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE XYMOVE (IX, IY)


      INTEGER IX,IY
      INTEGER IX0,IY0

* Plot device flags common area
      LOGICAL PS,TK,UN,VT
      COMMON /DEVCOM/ PS,TK,UN,VT


      CALL GETPOS(IX0,IY0)
      IF (IX.NE.IX0 .OR. IY.NE.IY0) THEN
        IF (PS) CALL PSXY(IX,IY,0)
        IF (TK) CALL TKXY(IX,IY,0)
        IF (UN) CALL UNXY(IX,IY,0)
        IF (VT) CALL VTXY(IX,IY,0)
        CALL SETPOS(IX,IY)
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE TKVECT (LUN, IX, IY, IVIS)
*
*
* Purpose:
*     Write a vector to a Tektronix display
*
*
* Description:
*     This routine accepts a pair of X-Y coordinates as input.  These
*     coordinates are broken up into high and low five bit addresses
*     for each coordinate.  In the worst case, the coordinates are sent
*     as a sequence of 4 characters to the Tektronix terminal.  This
*     routine takes advantage of the condition that the high or low
*     part of the Y coordinate or the high part of the X coordinate
*     does not change from one invokation of TKVECT to another.  In
*     this case the coordinates may be sent as an abbrieviated sequence
*     of 1, 2 or 3 characters.  The context can be initialized at the
*     beginning of plotting by a call to TKVECT(LUN,0,0,0).
*
*
* Parameters:
* I ->  LUN    - Unit number for the Tektronix terminal or file
* I ->  IX     - X coordinate, 0 to 1023 inclusive
* I ->  IY     - Y coordinate, 0 to 1023 inclusive, but only values
*                between 0 and 779 appear on the screen.  Note that
*                values of IX or IY outside the range 0 to 1023 are
*                taken modulo 1024.
* I ->  IVIS   - Visibility flag,
*                0 - Draw a dark vector to the point indicated.  The
*                    terminal is set to graphics mode.
*                1 - Draw a visible vector to the point indicated.  It
*                    is assumed that a dark vector has been drawn
*                    previously.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:45 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE TKVECT (LUN, IX, IY, IVIS)


      INTEGER MHY,MLY,MHX,MLX,GS
      PARAMETER (MHY=32,MLY=96,MHX=32,MLX=64,GS=29)

      INTEGER LUN,IX,IY,IVIS
      INTEGER N,IT
      INTEGER IHX,IHY,ILY

      CHARACTER*5 CBUFF

      SAVE IHX,IHY,ILY


* Initialize the context
      IF (IX.EQ.0 .AND. IY.EQ.0 .AND. IVIS.EQ.0) THEN
        IHX=-1
        IHY=-1
        ILY=-1
      END IF

      N=0

* Invoke graphics mode for IVIS=0
      IF (IVIS.EQ.0) THEN
        N=1
        CBUFF(1:1)=CHAR(GS)
      END IF

* The 10 bit coordinates are sent in 5 bit chunks
* Isolate the high order part of IY
      IT=MOD(IY/32,32)

      IF (IT.NE.IHY) THEN

* Put the high order part of IY in the buffer
        IHY=IT
        N=N+1
        CBUFF(N:N)=CHAR(IHY+MHY)
      END IF

* Isolate the high order part of IX
      IT=MOD(IX/32,32)

      IF (IT.NE.IHX) THEN

* Put the low order part of IY in the buffer
        ILY=MOD(IY,32)
        N=N+1
        CBUFF(N:N)=CHAR(ILY+MLY)

* Send the high order part of IX
        IHX=IT
        N=N+1
        CBUFF(N:N)=CHAR(IHX+MHX)

      ELSE

* Isolate the low order part of IY
        IT=MOD(IY,32)

        IF (IT.NE.ILY) THEN

* Put the low order part of IY in the buffer
          ILY=IT
          N=N+1
          CBUFF(N:N)=CHAR(ILY+MLY)
        END IF

      END IF

* Put the low order part of IX in the buffer
      N=N+1
      IT=MOD(IX,32)
      CBUFF(N:N)=CHAR(IT+MLX)

* Send the buffer to the terminal
      CALL FPUTCN(LUN,CBUFF(1:N))


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE UPCASE (STRIN, STROUT)
*
*
* Purpose:
*     Convert a string to uppercase (trim and obey quotes)
*
*
* Description:
*     This routine copies the input string to the output string,
*     removing leading blanks, tabs and nulls and converting to
*     uppercase in the process.  Characters within paired double quotes
*     (") are not converted to uppercase.  Blanks, tabs and null within
*     paired double quotes are not removed.  This routine also handles
*     accented characters in the ISO Latin-1 alphabet, converting them
*     to their uppercase equivalents.
*
*
* Parameters:
* C ->  STRIN  - Input string
* C <-  STROUT - Output string.  This may be the same string as STRIN.
*                STROUT is padded out with blanks if necessary.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:38:20 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE UPCASE (STRIN, STROUT)


      INTEGER IE,IS,NCI,LENO,N,I
      INTEGER LENSTR,LOCNBL

      CHARACTER*(*) STRIN,STROUT
      CHARACTER*1 CH

      LOGICAL INQUOT


* Find the first and last significant character
      IE=LENSTR(STRIN)
      IS=LOCNBL(STRIN(1:IE))
      NCI=IE-IS+1
      LENO=LEN(STROUT)

* Copy the string and convert to uppercase
      INQUOT=.FALSE.
      N=IS
      DO 100 I=1,MIN(NCI,LENO)
        CH=STRIN(N:N)
        N=N+1
        IF (CH.EQ.'"') THEN
          INQUOT=.NOT.INQUOT
          STROUT(I:I)=CH
        ELSE IF (.NOT.INQUOT) THEN
          CALL UPCSTR(CH,STROUT(I:I))
        ELSE
          STROUT(I:I)=CH
        END IF
 100  CONTINUE

* Check for string truncation
      IF (NCI.LT.LENO) THEN
        STROUT(NCI+1:)=' '
      ELSE IF (NCI.GT.LENO) THEN
        CALL HALT('UPCASE - String truncated')
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE GETFUN (LUN)
*     SUBROUTINE RELFUN (LUN)
*
*
* Purpose:
*     Allocate a Fortran unit number
*     Release a Fortran unit number
*
*
* Description:
*     These routines allocate and release Fortran unit numbers from a
*     pool of unit numbers.
*
*
* Parameters:
*     For SUBROUTINE GETFUN (LUN)
* I <-  LUN    - Returned logical unit number
*
*     For SUBROUTINE RELFUN (LUN)
* I ->  LUN    - Logical unit number to be released
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:07:40 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE GETFUN (LUN)


      INTEGER ALLOC,FREE,MAXFUN
      PARAMETER (ALLOC=1,FREE=0,MAXFUN=20)

      INTEGER LUN
      INTEGER I

      INTEGER FUNTAB(MAXFUN,2)
      SAVE FUNTAB
      DATA FUNTAB/
     -  31,30,29,28,27,26,25,24,23,22,
     -  21,20,19,18,17,16,15,14,13,12,
     -  FREE,FREE,FREE,FREE,FREE,FREE,FREE,FREE,FREE,FREE,
     -  FREE,FREE,FREE,FREE,FREE,FREE,FREE,FREE,FREE,FREE/


* Look for a free entry in the unit number table
      DO 100 I=1,MAXFUN
        IF (FUNTAB(I,2).EQ.FREE) THEN
          FUNTAB(I,2)=ALLOC
          LUN=FUNTAB(I,1)
          GO TO 200
        END IF
 100  CONTINUE
      CALL HALT('GETFUN - Allocatable units exhausted')


 200  RETURN


********************
      ENTRY RELFUN (LUN)


* Look for the unit number in the unit number table
      DO 500 I=1,MAXFUN
        IF (FUNTAB(I,1).EQ.LUN) THEN
          FUNTAB(I,2)=FREE
          GO TO 600
        END IF
 500  CONTINUE
      CALL WARN('RELFUN - Unit not previously allocated')


 600  RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION IBYORD ()
*
*
* Purpose:
*     Determine the byte order for data storage
*
*
* Description:
*     This function returns a code indicating whether the storage order
*     for the current host is little-endian or big-endian.  For big-
*     endian machines the constituent bytes in a multi-byte entity
*     are stored from most significant (lowest address) to least
*     significant address.  For little-endian machines, bytes are
*     stored from least significant to most significant.
*
*
* Parameters:
* I <-  IBYORD - Returned integer code
*                0 - Little-endian storage order
*                1 - Big-endian storage order
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.3 $  $Date: 1995/03/08 15:18:38 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION IBYORD ()


      INTEGER*4 IA1,IA2,ILEND
      PARAMETER (IA1=2,IA2=1,ILEND=IA1+IA2*65536)

      INTEGER*4 IV4
      INTEGER*2 IV2(2)

      EQUIVALENCE (IV4,IV2)
      DATA IV2/IA1,IA2/
      SAVE IV4,IV2


      IF (IV4.EQ.ILEND) THEN
        IBYORD=0
      ELSE
        IBYORD=1
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE LABEL (VAL, NPL, CBUFF, NC)
*
*
* Purpose:
*     Convert a real value to a string
*
*
* Description:
*     This subroutine converts an input value to a representation with
*     a maximum of NPL characters.  Trailing nonsignificant zeros and
*     periods as well as leading blanks are removed.  One character
*     position is reserved for the sign.
*
*     Depending on the magnitude of the input value, the output string
*     is coded using one of the following formats.  Define A to be the
*     magnitude of the input value.
*     1) 10**(NPL-1) < A
*        The output field is filled with NPL asterisks (*).
*     2) 10**(NPL-2) < A < 10**(NPL-1)
*        The value is represented in integer format with NPL-1 digits
*        without a decimal point, with a sign if the value is negative.
*     3) 1 < A < 10**(NPL-2).
*        The value is represented with at most NPL-2 significant
*        digits, possibly with a decimal point and a sign (if the value
*        is negative).
*     4) A < 1
*        The value is represented in fixed point notation with NPL-3
*        decimal places with a possible leading zero, decimal point and
*        sign (if the value is negative).
*
*
* Parameters:
* R ->  VAL    - Input value to be coded
* I ->  NPL    - Maximum number of characters in the representation
*                (maximum 7)
* C <-  CBUFF  - Output character string.  CBUFF can contain up to NPL
*                characters.
* I <-  NC     - Number of significant characters in CBUFF
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:27:59 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE LABEL (VAL, NPL, CBUFF, NC)


      INTEGER NPL,NC
      INTEGER K,I
      INTEGER LOCNBL

      REAL VAL
      REAL AV

      CHARACTER CBUFF*(*)
      CHARACTER*14 CWORK
      CHARACTER*7 CSTAR,FMTSTR

      DATA CSTAR/'*******'/


* Determine which region applies
      AV=ABS(VAL)
      IF (AV.LT.1.0) THEN

* Encode the value using an F format
        WRITE (UNIT=FMTSTR,FMT=3000) NPL-3
        WRITE (UNIT=CWORK,FMT=FMTSTR) VAL

      ELSE IF (AV.LT.10.**(NPL-2)-0.5) THEN

* Encode the value using a G format
        WRITE (UNIT=FMTSTR,FMT=3100) NPL-2
        WRITE (UNIT=CWORK,FMT=FMTSTR) VAL

      ELSE IF (AV.LT.10.**(NPL-1)-0.5) THEN

* Encode the value using a G format
        WRITE (UNIT=FMTSTR,FMT=3100) NPL-1
        WRITE (UNIT=CWORK,FMT=FMTSTR) VAL

      ELSE

* VAL is too large
        CWORK=CSTAR(1:NPL)

      END IF

* Strip off trailing blanks, zeros and periods
      DO 500 K=14,1,-1
        IF (CWORK(K:K).NE.'0' .AND. CWORK(K:K).NE.' ') GO TO 550
 500  CONTINUE
 550  IF (CWORK(K:K).EQ.'.') K=K-1

* Strip off leading blanks
      I=LOCNBL(CWORK(1:K))

      CBUFF=CWORK(I:K)
      NC=K-I+1
      IF (NC.GT.LEN(CBUFF)) THEN
        CALL WARN('LABEL - String truncated')
        NC=LEN(CBUFF)
      END IF


      RETURN

 3000 FORMAT ('(F14.',I1,')')
 3100 FORMAT ('(G14.',I1,')')

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE HALT (STRING)
*
*
* PURPOSE:
*	This routine prints an error message and terminates a program
*	with a system error code set.
*
*
* DESCRIPTION:
*	This routine signals a fatal error message FOR_F_ABORT and an
*	informational message FOR_I_TEXT with the given text. The
*	default action is to halt program execution on the signalling
*	of the fatal error. If other types of actions are desired, a
*	condition handler must be declared.
*
*
* PARAMETERS:
* C ->	STRING - Character string to be printed
*
*
* ROUTINES REQUIRED:
*	GETIMG - Get the image name
*	LIB$SIGNAL - Signal an error
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	1983/04/29
*
*
* UPDATES:
*	1986/09/08  Use system file name parsing
*	1989/04/04  Use GETIMG
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE HALT (STRING)
 
 
	INTEGER FOR_I_TEXT,FOR_F_ABORT
	PARAMETER (FOR_I_TEXT='181133'X,FOR_F_ABORT='1810DC'X)
 
	CHARACTER STRING*(*),IMAGE_NAME*255
 
 
* Get the image name
	CALL GETIMG(IMAGE_NAME,NCN)
 
* Terminate the program and signal the message text as informational text
	CALL LIB$SIGNAL(%VAL(FOR_F_ABORT),%VAL(1),
     -	                IMAGE_NAME(1:NCN),
     -	                %VAL(FOR_I_TEXT),%VAL(1),STRING)
 
	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PRMENU (CHTAB, NOENT, IWIDTH)
*
*
* Purpose:
*     Print a menu of keywords
*
*
* Description:
*     This routine writes character strings to standard output with the
*     strings aligned in fields of a given width.  The number of fields
*     is determined such as to fit into a total width of 70 characters.
*     If a string exceeds the field width, it spills over into the
*     next field, displacing the next string into a following field.
*     Strings that are longer than two field widths are truncated and
*     the last portion of the string is replaced by '...'.
*
*
* Parameters:
* C ->  CHRTAB - Array of character strings
* I ->  NOENT  - Number of character strings to be printed
* I ->  IWIDTH - Field width in characters (at least 2)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:41:31 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PRMENU (CHRTAB, NOENT, IWIDTH)


      INTEGER ICS,NCMX
      PARAMETER (ICS=3,NCMX=72)

      INTEGER NOENT,IWIDTH
      INTEGER LENSTR,ICEIL,LENBLK
      INTEGER MXWID,IC,K,NK,NC

      CHARACTER LINE*(NCMX),CHRTAB(NOENT)*(*)


      MXWID=MIN(2*IWIDTH-1,NCMX-ICS+1)
      LINE=' '

* Loop over the number of strings
      IC=ICS
      DO 100 K=1,NOENT

* Determine how many characters are needed to print the string
        NK=LENSTR(CHRTAB(K))
        NC=ICEIL(MIN(NK+1,MXWID),IWIDTH)*IWIDTH

* If necessary, print a line
        IF (IC+NC.GT.NCMX) THEN
          WRITE (UNIT=*,FMT=1000) LINE(1:LENBLK(LINE))
          IC=ICS
        END IF

* Insert a new string into the line
        IF (NK.LE.MXWID) THEN
          LINE(IC:)=CHRTAB(K)(1:NK)
        ELSE
          LINE(IC:)=CHRTAB(K)(1:MXWID-3)//'...'
        END IF
        IC=IC+NC

 100  CONTINUE

* Print the last line
      WRITE (UNIT=*,FMT=1000) LINE(1:LENBLK(LINE))


      RETURN

 1000 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION PHSFIR (F, H, N)
*
*
* Purpose:
*     Find the phase response for an FIR filter
*
*
* Description:
*     The phase response is calculated for the equivalent non-causal
*     filter with reference point at the mid-point of the filter.
*     The phase corresponding to the delay up to the mid-point of
*     the filter is added to this figure.  If the given frequency
*     corresponds to a zero of the response, a warning message is
*     printed and the phase is set to zero.
*
*
* Parameters:
* R <-  PHSFIR - Phase in radians.  This value is in the range -Pi to
*                Pi.
*
* R ->  F      - Normalized frequency (normally in the range 0 to 0.5)
* R ->  H      - Array of impulse response coefficients
* I ->  N      - Number of impulse response coefficients
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:21:37 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION PHSFIR (F, H, N)


      REAL PI,PI2
      PARAMETER (PI=3.141 592 654, PI2=6.283 185 307)

      INTEGER N
      INTEGER I

      REAL F
      REAL HE,HO,RSUMHI,RSUMHR
      REAL H(-((N-1)/2):*)

      DOUBLE PRECISION DSUMHR,DSUMHI


      DSUMHI=0.

* Calculate the real and imaginary parts of the frequency response
* of the non-causal filter with reference point at the mid-point
* of the filter
*  DSUMHR - Re[H(f)]
*  DSUMHI - Im[H(f)]
      IF (MOD(N,2).EQ.0) THEN

        DSUMHR=0.
        DO 100 I=1,N/2
          DSUMHR=DSUMHR+DPROD(H(I)+H(-I+1),COS(PI2*F*(I-0.5)))
          DSUMHI=DSUMHI-DPROD(H(I)-H(-I+1),SIN(PI2*F*(I-0.5)))
 100    CONTINUE

      ELSE

        DSUMHR=H(0)
        DO 200 I=1,(N-1)/2
          HE=H(I)+H(-I)
          HO=H(I)-H(-I)
          DSUMHR=DSUMHR+DPROD(H(I)+H(-I),COS(PI2*F*I))
          DSUMHI=DSUMHI-DPROD(H(I)-H(-I),SIN(PI2*F*I))
 200    CONTINUE

      END IF

* Calculate the phase
      RSUMHI=DSUMHI
      RSUMHR=DSUMHR
      IF (RSUMHR.EQ.0.0 .AND. RSUMHI.EQ.0.0) THEN
        CALL WARN('PHSFIR - Undefined phase')
        PHSFIR=0.0
      ELSE
        PHSFIR=-PI*(N-1)*F+ATAN2(RSUMHI,RSUMHR)
        IF (PHSFIR.GE.0) THEN
          PHSFIR=MOD(PHSFIR+PI,PI2)-PI
        ELSE
          PHSFIR=MOD(PHSFIR-PI,PI2)+PI
        END IF
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSINIT (OPTION)
*
*
* Purpose:
*     Initialize a Postscript plot file
*
*
* Description:
*     This subroutine opens an encapsulated Postscript plot file.  A
*     standard header is written to the file. This header sets up the
*     plot scaling to map the plotting coordinates (in the range 0 to
*     4095) to give 600 plotting units per inch.  The header also
*     defines macros to draw lines and move the current location.
*     The resulting Postscript file can optionally be submitted for
*     printing on a Postscript printer.  In this case, the file is
*     deleted after printing.
*
*
* Parameters:
* C ->  OPTION - Character string specifying the options.  Options are
*                separated by commas and/or whitespace (blanks, tabs,
*                or nulls).  If any option is omitted, the default
*                value is used.  An all blank string gives the default
*                values.  The same keyword may appear more than once,
*                with the last instance taking precedence.
*                FILENAME=name - Specifies the name of the file to
*                  which plot data is sent.  The file name is not used
*                  if this plot device is already active.  The special
*                  file name "*" can be  used to direct output to the
*                  standard output (Fortran unit 6).  The default file
*                  name is derived from the name of the image
*                  (xxx.epsf where xxx is the image name).
*                PRINT or NOPRINT - Specifies whether the Postscript
*                  file is to be queued for printing.  The default is
*                  NOPRINT.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:29:27 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSINIT (OPTION)


      INTEGER NEKEY
      PARAMETER (NEKEY=3)

      INTEGER NC,N,NCN
      INTEGER LENSTR

      CHARACTER*(*) OPTION
      CHARACTER*256 LINE,TOKEN
      CHARACTER*255 IMAGNM
      CHARACTER*20 KEYTAB(NEKEY)

      INTEGER LUNPS,IPRTPS
      CHARACTER*255 FNAMPS
      COMMON /PSCOM/ LUNPS,IPRTPS,FNAMPS
      DATA LUNPS/-1/,IPRTPS/0/,FNAMPS/' '/

      DATA KEYTAB/'FILE*NAME'      , 'PRINT'          ,
     -            'NOPRINT'        /


      CALL RQUOTE(OPTION,LINE,NC)

* Decode the options
 100  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NC,N)

        IF (N.EQ.1) THEN
          CALL RQUOTE(TOKEN(1:NC),FNAMPS,NCN)

        ELSE IF (N.EQ.2) THEN
          IPRTPS=1

        ELSE IF (N.EQ.3) THEN
          IPRTPS=0

        END IF

      GO TO 100
      END IF


      IF (LUNPS.LT.0) THEN

* Not previously selected
        IF (FNAMPS.EQ.' ') THEN
          IF (IPRTPS.EQ.0) THEN
            CALL GETIMG(IMAGNM,NC)
            FNAMPS=IMAGNM(1:NC)//'.epsf'
          ELSE
            CALL GFNTMP('.epsf',FNAMPS)
          END IF
        END IF

* Open the file
        IF (FNAMPS.EQ.'*') THEN
          LUNPS=6
          IPRTPS=0
        ELSE
          CALL FBAKUP(FNAMPS)
          CALL GETFUN(LUNPS)
          OPEN (UNIT=LUNPS,FILE=FNAMPS,STATUS='UNKNOWN')
        END IF

        CALL PSHEAD(LUNPS)

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE XYVECT (IX1, IY1, IX2, IY2)
*
*
* Purpose:
*     Draw a vector
*
*
* Description:
*     This subroutine draws a visible vector between the plotting
*     coordinates (IX1,IY1) and (IX2,IY2).
*
*
* Parameters:
* I ->  IX1    - X coordinate of the start of the vector (0 to 4095)
* I ->  IY1    - Y coordinate of the start of the vector (0 to 4095)
* I ->  IX2    - X coordinate of the end of the vector (0 to 4095)
* I ->  IY2    - Y coordinate of the end of the vector (0 to 4095)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:29:14 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE XYVECT (IX1, IY1, IX2, IY2)


      INTEGER IX1,IY1,IX2,IY2


      CALL XYMOVE(IX1,IY1)
      CALL XYDRAW(IX2,IY2)


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE GETVALUELIST (QUALIFIER, VALUELIST, NC)
*
*
* PURPOSE:
*	This subroutine gets a list of values corresponding to a qualifier.
*
*
* DESCRIPTION:
*	This subroutine returns a list of values associated with a qualifier.
*	It uses the system subroutine CLI$GET_VALUE to get individual values
*	associated with a given qualifier. These items are combined into
*	a list, with the items separated by commas.
*
*
* PARAMETERS:
*	QUALIFIER - Qualifier name
*   (*)	VALUELIST - List of values, with items separated by commas
*   (*)	NC        - Number of characters in VALUELIST. NC is zero if
*	            there was no list
*
*
* ROUTINES REQUIRED:
*	CLI$GET_VALUE - Get a value associated with a qualifier
*	CONSTR - Concatenate strings separated by a delimiter
*	HALT - Signal an error and stop
*	LENSTR - Length of a string
*	LIB$STOP - Signal an error and stop
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	86/10/13
*
*
* UPDATES:
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE GETVALUELIST (QUALIFIER, VALUELIST, NC)


	INTEGER CLI$GET_VALUE

	CHARACTER*(*) QUALIFIER, VALUELIST
	CHARACTER*255 VALUE

	EXTERNAL CLI$_ABSENT,CLI$_COMMA,CLI$_CONCAT,SS$_NORMAL


	VALUELIST=' '
	ISTATUS=CLI$GET_VALUE(QUALIFIER,VALUE,N)

* CLI$GET_VALUE returns CLI$_COMMA when the delimiter is a comma and
* SS$_NORMAL for the last value
	DO WHILE (ISTATUS.EQ.%LOC(CLI$_COMMA) .OR.
     -	          ISTATUS.EQ.%LOC(SS$_NORMAL))
	  CALL CONSTR(VALUELIST,',',VALUE(1:N),VALUELIST)
	  ISTATUS=CLI$GET_VALUE(QUALIFIER,VALUE,N)
	END DO
	IF (ISTATUS.EQ.%LOC(CLI$_CONCAT))
     -	  CALL HALT ('GETVALUELIST - Invalid list of values')

* Signal unknown errors
	IF (ISTATUS.NE.%LOC(CLI$_ABSENT)) CALL LIB$STOP(%LOC(ISTATUS))

	NC=LENSTR(VALUELIST)


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     INTEGER FUNCTION LENBLK (LINE)
*
*
* Purpose:
*     Find the length of a blank terminated string
*
*
* Description:
*     This function returns the number of characters in a string up
*     to the last significant character.  Trailing blanks are not
*     considered to be significant.
*
*
* Parameters:
* I <-  LENBLK - The returned function value is the number of
*                characters in the character string, not including
*                trailing blanks
*
* C ->  LINE   - Input character string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.2 $  $Date: 1995/03/08 15:37:10 $
*
*
*-----------------------------------------------------------------------

      INTEGER FUNCTION LENBLK (LINE)


      INTEGER NCHR,L

      CHARACTER*(*) LINE


* Find the last non-blank character
      NCHR=LEN(LINE)
      DO 100 L=NCHR,1,-1
        IF (LINE(L:L).NE.' ') GO TO 200
 100  CONTINUE

* Return the pointer to the last significant character
 200  LENBLK=L


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE CONSTR (STRL, DELIM, STRR, STRO)
*
*
* Purpose:
*     Concatenate strings with an optional delimiter
*
*
* Description:
*     This routine generates an output string which is formed from a
*     left string, a delimiter string and a right string.  Trailing
*     blanks, tabs and nulls are ignored in the left and right string.
*     The delimiter is inserted as is between the left and right
*     strings.  However, if either the left string or the right string
*     is blank, the delimiter is omitted.
*
*     The output character string can appear also as the left or the
*     right string.  The maximum number of characters in the right
*     string is limited to 2048.
*
*
* Parameters:
* C ->  STRL   - Left character string
* C ->  DELIM  - Delimiter string
* C ->  STRR   - Right character string (maximum 2048 characters not
*                including trailing non-significant characters)
* C <-  STRO   - Output character string.  STRO is padded with blanks.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:36:40 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE CONSTR (STRL, DELIM, STRR, STRO)


      INTEGER LTEMP
      PARAMETER (LTEMP=2048)

      INTEGER LL,LR,NT,NC
      INTEGER LENSTR

      CHARACTER*(*) STRL,DELIM,STRR,STRO
      CHARACTER*(LTEMP) TEMP


* Concatenate the strings
      LL=LENSTR(STRL)
      LR=LENSTR(STRR)
      IF (LL.GT.0 .AND. LR.GT.0) THEN
        NT=MIN(LR,LTEMP)
        TEMP(1:NT)=STRR(1:LR)
        STRO=STRL(1:LL)//DELIM//TEMP(1:NT)
        NC=LL+LEN(DELIM)+LR
      ELSE IF (LL.GT.0) THEN
        STRO=STRL(1:LL)
        NC=LL
      ELSE
        STRO=STRR(1:LR)
        NC=LR
      END IF

* Check the output length
      IF (NC.GT.LEN(STRO) .OR. LR.GT.LTEMP)
     -  CALL HALT('CONSTR - String truncated')


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FPUTCN (LUN, STRING)
*
*
* Purpose:
*     Write characters to a file (bypass Fortran I/O)
*
*
* Description:
*     This subroutine writes character data to the file associated with
*     the given Fortran unit number.  The characters are written using
*     routine FPUTC which bypasses normal Fortran I/O.
*
*
* Parameters:
* I ->  LUN    - Fortran unit number associated with the file
* C ->  STRING - Character string to be written
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:07:32 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FPUTCN (LUN, STRING)


      INTEGER LUN
      INTEGER I,ISTAT
      INTEGER FPUTC

      CHARACTER*(*) STRING


      DO 100 I=1,LEN(STRING)
        ISTAT=FPUTC(LUN,STRING(I:I))
        IF (ISTAT.NE.0)
     -    CALL PSYERR('FPUTCN - System error return from FPUTC')
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE TKXY (IX, IY, LWIDTH)
*
*
* Purpose:
*     Draw a vector on a Tektronix display
*
*
* Description:
*     This routine writes a plot vector to the Tektronix display.
*
*
* Parameters:
* I ->  IX     - X coordinate in plotting units (0 to 4095)
* I ->  IY     - Y coordinate in plotting units (0 to 4095)
* I ->  LWIDTH - Line width (plot units).  A zero width line indicates
*                an invisible line.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:48 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE TKXY (IX, IY, LWIDTH)


      INTEGER DARK,VIS
      PARAMETER (DARK=0,VIS=1)

      INTEGER IX,IY,LWIDTH

      INTEGER LUNTK
      CHARACTER*255 FNAMTK
      COMMON /TKCOM/ LUNTK,FNAMTK


      IF (LWIDTH.NE.0) THEN
        CALL TKVECT(LUNTK,IX/4,IY/4,VIS)
      ELSE
        CALL TKVECT(LUNTK,IX/4,IY/4,DARK)
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLVCPX (SYMBOL, X, F, NPT, DATREG)
*
*
* Purpose:
*     Plot points as plot symbols
*
*
* Description:
*     The real valued data is plotted by plotting characters at the
*     position corresponding to the data values.  Both the function
*     values and the abscissa values are specified by an array of
*     data.  This routine attempts to centre the characters at the
*     data positions.  To this end, lower case letters are offset
*     differently than upper case letters and special symbols.  The
*     plotting area can be set by calling SETGRS.  If a data point
*     falls outside of the plotting area, the corresponding character
*     is not plotted.
*
*
* Parameters:
* C ->  SYMBOL - Character variable specifying the character to be
*                plotted.  The character size must be set to the
*                desired size before calling this routine.
* R ->  X      - Array of abscissa data
* R ->  F      - Array of function values
* I ->  NPT    - Number of data points in the arrays X and F
* R ->  DATREG - Data limits.  The four elements of DATREG define the
*                plot region.
*                DATREG(1,1) - Lower limit for the X data
*                DATREG(2,1) - Lower limit for the function values
*                DATREG(1,2) - Upper limit for the X data
*                DATREG(2,2) - Upper limit for the function values
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:44 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLVCPX (SYMBOL, X, F, NPT, DATREG)


      INTEGER NPT
      INTEGER IXORIG,IYORIG,LENX,LENY
      INTEGER I,IX1,IY1,IX,IY

      REAL X(*),F(*),DATREG(2,2)
      REAL PVX,PVY

      CHARACTER*1 SYMBOL


* Plot by placing characters at the points
      CALL GETGRS(IXORIG,IYORIG,LENX,LENY)
      PVX=LENX/(DATREG(1,2)-DATREG(1,1))
      PVY=LENY/(DATREG(2,2)-DATREG(2,1))
      IX1=IXORIG+LENX
      IY1=IYORIG+LENY
      DO 100 I=1,NPT
        IX=NINT((X(I)-DATREG(1,1))*PVX) + IXORIG
        IY=NINT((F(I)-DATREG(2,1))*PVY) + IYORIG
        IF (IX.GE.IXORIG .AND. IX.LE.IX1 .AND.
     -      IY.GE.IYORIG .AND. IY.LE.IY1)
     -   CALL CENSYM(IX,IY,SYMBOL)
 100  CONTINUE


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE FFNAME (FNAMEI, FNAMEO)
*
*
* PURPOSE:
*	This routine returns a full file name.
*
*
* DESCRIPTION:
*	This routine takes an input file name and fills in the full
*	file specification.
*
*
* PARAMETERS:
* C ->	FNAMEI - Input character string containing the file name
* C <-	FNAMEO - Character string for the output file name
*
*
* ROUTINES REQUIRED:
*	None
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	1988/05/10
*
*
* UPDATES:
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE FFNAME (FNAMEI, FNAMEO)



	CHARACTER*(*) FNAMEI,FNAMEO


* Use the INQUIRE function to fill out the file name
	INQUIRE (FILE=FNAMEI,NAME=FNAMEO)


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE RDCSTR (LINE, MINN, MAXN, ASTR, N)
*
*
* Purpose:
*     Separate comma/whitespace delimited substrings
*
*
* Description:
*     This routine decodes a string containing character data.
*     Multiple data items in the string are separated by commas or
*     white space (blanks, tabs or null characters).  Within paired
*     double quote characters ("), any characters are permitted.  If
*     the number of output strings is less than the given minimum
*     number, an error message is printed and N is set to zero.
*
*     For each output string, leading and trailing white space is
*     removed.  Within quotes, any characters are permitted (two
*     adjacent quote characters within a quoted string are interpreted
*     as a single quote character).  Any outer paired quotes are
*     removed from each output string.
*
*
* Parameters:
* C ->  LINE   - Input string
* I ->  MINN   - Minimum number of values to be read (may be zero)
* I ->  MAXN   - Maximum number of values to be read (at most 256)
* C <-  ASTR   - Array of MAXN elements used to store the character
*                strings.  A null character is used to mark the end of
*                the character data in each array element if the string
*                is shorter than the length of ASTR.  Only the first N
*                elements of ASTR are modified.  If an error condition
*                is detected, the array ASTR is not modified.  An error
*                condition occurs if too few values are specified.
* I <-  N      - Actual number of values read.  If an error condition
*                is detected, N is set to zero.  An error condition
*                occurs if too few values are specified.  N is also set
*                to zero if the number of values to be read is allowed
*                to be zero and the input string contains only white
*                space.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:37:26 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE RDCSTR (LINE, MINN, MAXN, ASTR, N)


      INTEGER MXMAXN
      PARAMETER (MXMAXN=256)

      INTEGER MINN,MAXN,N
      INTEGER M,I,IS,IE,NC
      INTEGER IST(MXMAXN+1),IFN(MXMAXN+1)

      CHARACTER*(*) LINE,ASTR(MAXN)


* Find the substrings
      CALL FNDSUB(LINE,'""',IST,IFN,MXMAXN+1,M)

* Check the number of values found
      N=0
      IF (M.LT.MINN) THEN
        CALL WARN('RDCSTR - Error, too few data values')

      ELSE IF (M.GT.MXMAXN .AND. MAXN.GT.MXMAXN) THEN
        CALL WARN('RDCSTR - Error, too many data values')

      ELSE

        IF (M.GT.MAXN) THEN
          CALL WARN('RDCSTR - Warning, extra data ignored')
          M=MAXN
        END IF

* Copy the substrings, removing outer quotes
        DO 220 I=1,M
          IS=IST(I)
          IE=IFN(I)
          IF (IS.LE.IE) THEN
            CALL RQUOTE(LINE(IS:IE),ASTR(I),NC)
            IF (NC.LT.LEN(ASTR(I)))
     -        ASTR(I)(NC+1:NC+1)=CHAR(0)
          ELSE
            ASTR(I)=CHAR(0)
          END IF
 220    CONTINUE
        N=M
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FFNAME (FNAMEI, FNAMEO)
*
*
* Purpose:
*     Fill in a directory path for a file name
*
*
* Description:
*     This routine takes an input file name and fills in the full path
*     name.  If the input file specification does not include a path
*     name, the path is determined from the current working directory.
*     In addition, the ~/ specification is recognized as the user's
*     home directory.
*
*     Form:
*     ~/abc/def    use the home directory (from the environment
*                  variable HOME)
*     abc/def      use the current working directory
*     /abc/def     full path supplied
*
*     This routine does not check to see if the path name exists.  In
*     addition, imbedded ./ directory specifications are removed.
*
*
* Parameters:
* C ->  FNAMEI - Input character string containing the file name.  If
*                the input name is null, the output name is the current
*                working directory with a trailing /.
* C <-  FNAMEO - Character string for the output file name.  This
*                string can be the same as the input string.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.9 $  $Date: 1995/03/08 15:07:14 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FFNAME (FNAMEI, FNAMEO)


      INTEGER MAXC
      PARAMETER (MAXC=255)

      INTEGER LD,LN,LT,NC,I,LDD
      INTEGER LENBLK

      CHARACTER*(*) FNAMEI,FNAMEO
      CHARACTER*(MAXC) FDIR,FNAM,FTYP
      CHARACTER*(MAXC+1) CWD,TEMP,HOME


* Parse the file name into components
      CALL FNPARS(FNAMEI,FDIR,FNAM,FTYP)

* Replace a leading ~ component with the home directory
      LD=LENBLK(FDIR)
      IF (FDIR(1:LDD).EQ.'~') THEN
        CALL GETENV('HOME',HOME)
        NC=LENBLK(HOME)
        FDIR=HOME
        LD=NC
      ELSE IF (FDIR(1:2).EQ.'~/') THEN
        CALL GETENV('HOME',HOME)
        NC=LENBLK(HOME)
        TEMP=HOME(1:NC) // FDIR(2:)
        FDIR=TEMP
        LD=NC+LD-1
      END IF

* Add the current working directory if the path is not absolute
      IF (LD.EQ.0) THEN
        CALL GETCWD(CWD)
        NC=LENBLK(CWD)
        FDIR=CWD(1:NC) // '/'
        LD=NC+1
      ELSE IF (FDIR(1:1).NE.'/') THEN
        CALL GETCWD(CWD)
        NC=LENBLK(CWD)
        TEMP=CWD(1:NC) // '/' // FDIR
        FDIR=TEMP
        LD=LD+NC+1
      END IF
      LDD=LD

* Remove /./ path components
 100  I=INDEX(FDIR,'/./')
      IF (I.NE.0) THEN
        TEMP=FDIR(1:I) // FDIR(I+3:)
        FDIR=TEMP
        LD=LD-2
      GO TO 100
      END IF

* Form the output string
      LN=LENBLK(FNAM)
      LT=LENBLK(FTYP)
      FNAMEO=FDIR(1:LD) // FNAM(1:LN) // FTYP(1:LT)

* Error check
      IF (LDD.GT.LEN(FDIR) .OR. LD+LN+LT.GT.LEN(FNAMEO)) THEN
        CALL WARN('FFNAME - File name too long')
        FNAMEO=FNAMEI
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE HALT (STRING)
*
*
* Purpose:
*     Print an error message, stop with error status set
*
*
* Description:
*     This routine prints an error message on the standard error unit
*     and then terminates execution with error code -1 (255).
*
*
* Parameters:
* C ->  STRING - Character string to be printed
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:44:04 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE HALT (STRING)


      CHARACTER*(*) STRING


* Write the message text to the standard error unit and
* halt execution with a -1 (255) status code
* (Assume that the standard error unit does not use Fortran
* carriage control)
      WRITE (UNIT=0,FMT=1000) STRING
      WRITE (UNIT=0,FMT=1000) 'Fatal error - execution terminated'
      CALL EXIT(255)


      RETURN

 1000 FORMAT (A)

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*       SUBROUTINE PSINIT (OPTION)
*
*
* PURPOSE:
*       This subroutine is used to perform initialization for a
*       Postscript plot file.
*
*
* DESCRIPTION:
*       This subroutine opens an encapsulated Postscript plot file. A
*       standard header is written to the file. This header sets up the
*       plot scaling to map the plotting coordinates (in the range 0 to
*       4095) to give 600 plotting units per inch. The header also
*       defines macros to draw lines and move the current location.
*       The resulting Postscript file can optionally be submitted for
*       printing on a Postscript printer. In this case, the file is
*       deleted after printing.
*
*
* PARAMETERS:
* C ->    OPTION - Character string specifying the options. Options are
*                separated by commas. If any option is omitted, the
*                default value is used. The same keyword may appear more
*                than once, with the last instance taking precedence.
*                FILENAME=name - Specifies the name of the file to which
*                  plot data is sent. The file name is not used if this
*                  plot device is already active. The default file name
*                  is the logical name PSPLOT if the logical name PSPLOT
*                  is defined. If the logical name PSPLOT is not defined
*                  and the filename is not specified, the default
*                  filename is derived from the name of the image
*                  (xxx.EPSF where xxx is the image name).
*                QUEUE_NAME=name - Specifies the name of the queue to be
*                  used to print the Postscript file. The queue name is
*                  set only when this plot device is first selected. The
*                  queue name is used only if the PRINT option is
*                  selected. The default queue name is LW$PRINT.
*                PRINT or NOPRINT - Specifies whether the Postscript
*                  file is to be queued for printing. The default is
*                  PRINT for device LW and NOPRINT for device PS.
*
*
* ROUTINES REQUIRED:
*       FNDPAR - Separate items in the option string
*       GETFUN - Allocate a Fortran unit number
*       GETIMG - Get the image name
*       LENSTR - Find the length of a character string
*       PSHEAD - Write Postscript header text
*       RQUOTE - Copy a string, removing outer quotes
*       TRNNAM - Translate a logical name
*
*
* AUTHOR / MAINTAINED BY:
*       P. Kabal
*
*
* DATE CREATED:
*       1988/01/15
*
*
* UPDATES:
*       1988/12/09  VMS file open
*       1989/04/04  Optionally print the file
*       1989/11/12  Use STREAM_LF files (more compact)
*       1990/03/04  New common area
*
*
*---------------------------INRS-Telecommunications---------------------------

        SUBROUTINE PSINIT (OPTION)


        INTEGER NEKEY
        PARAMETER (NEKEY=4)

        INTEGER NC,N,NCN
        INTEGER LENSTR

        CHARACTER*(*) OPTION
        CHARACTER*256 LINE,TOKEN
        CHARACTER*255 IMAGNM
        CHARACTER*20 KEYTAB(NEKEY)

        INTEGER LUNPS,IPRTPS
        CHARACTER*255 FNAMPS,QNAMPS
        COMMON /PSCOM/ LUNPS,IPRTPS,FNAMPS,QNAMPS
        DATA LUNPS/-1/,FNAMPS/' '/,QNAMPS/'LW$PRINT'/

        DATA KEYTAB/'FILE*NAME'      , 'QUEUE*_NAME'     ,
     -              'PRINT'          , 'NOPRINT'         /


        CALL RQUOTE(OPTION,LINE,NC)

* Decode the options
100     IF (LENSTR(LINE).GT.0) THEN
          CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NC,N)

          IF (N.EQ.1) THEN
            CALL RQUOTE(TOKEN(1:NC),FNAMPS,NCN)

          ELSE IF (N.EQ.2) THEN
            CALL RQUOTE(TOKEN(1:NC),QNAMPS,NCN)

          ELSE IF (N.EQ.3) THEN
            IPRTPS=1

          ELSE IF (N.EQ.4) THEN
            IPRTPS=0

          END IF

        GO TO 100
        END IF


        IF (LUNPS.LT.0) THEN

* Not previously selected
          IF (FNAMPS.EQ.' ') THEN
            CALL TRNNAM('PSPLOT',FNAMPS,NCN)
            IF (NCN.LT.0) THEN
              CALL GETIMG(IMAGNM,NC)
              FNAMPS=IMAGNM(1:NC)//'.epsf'
            ELSE
              FNAMPS='PSPLOT'
            END IF
          END IF

* Open the file
          CALL GETFUN(LUNPS)
          OPEN (UNIT=LUNPS,FILE=FNAMPS,STATUS='NEW',
     -          CARRIAGECONTROL='LIST',RECORDTYPE='STREAM_LF')

          CALL PSHEAD(LUNPS)

        END IF


        RETURN

        END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FRENAM (FNAMS, FNAMN)
*
*
* Purpose:
*     Rename a file
*
*
* Description:
*     This subroutine renames a file to a given name.  This operation
*     will overwrite data in the target file name if such a file
*     already exists.
*
*
* Parameters:
* C ->  FNAMS  - Original file name
* C ->  FNAMN  - New file name
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:07:37 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FRENAM (FNAMS, FNAMN)


      INTEGER ISTAT,NCN,NCS
      INTEGER LENSTR,LINK,UNLINK

      CHARACTER*(*) FNAMS,FNAMN

      LOGICAL EX


* Rename an existing file
* (a) Unlink XXX~ if it exists
* (b) Link XXX~ to the old file
* (c) Unlink XXX
      NCN=LENSTR(FNAMN)
      NCS=LENSTR(FNAMS)
      INQUIRE (FILE=FNAMN(1:NCN),EXIST=EX)
      IF (EX) THEN
        ISTAT=UNLINK(FNAMN(1:NCN))
          IF (ISTAT.NE.0) CALL PSYERR('FRENAM - Cannot rename file')
      END IF
      ISTAT=LINK(FNAMS(1:NCS),FNAMN(1:NCN))
        IF (ISTAT.NE.0) CALL PSYERR('FRENAM - Cannot rename file')
      ISTAT=UNLINK(FNAMS(1:NCS))
        IF (ISTAT.NE.0) CALL PSYERR('FRENAM - Cannot rename file')


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FNPARS (FNAMIN, FPATH, FNAME, FTYPE)
*
*
* Purpose:
*     Parse a file name into constituent parts
*
*
* Description:
*     This routine takes a file name and parses into the path name
*     (directory string), the file name proper, and the file type.  The
*     file type is the part of the file name beginning with a period.
*
*
* Parameters:
* C ->  FNAMIN - Input character string containing the input file name
*                to be parsed
* C <-  FPATH  - Path name string.  If present, the path name is
*                terminated with a '/' character.  This string is
*                padded out with blanks.
* C <-  FNAME  - File name string.  This string is padded out with
*                blanks.
* C <-  FTYPE  - File type string.  If present, the file type string
*                begins with a '.' character.  This string is padded
*                out with blanks.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:07:29 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FNPARS (FNAMIN, FPATH, FNAME, FTYPE)


      INTEGER IP,IT,LT,IS,LP,LN
      INTEGER INDEXR,LENSTR,LOCNBL

      CHARACTER*(*) FNAMIN,FPATH,FNAME,FTYPE


      IP=INDEXR(FNAMIN,'/')
      IT=INDEXR(FNAMIN,'.')

* Fill in the file type
      IF (IT.GT.IP) THEN
        LT=LENSTR(FNAMIN(IT:))
        FTYPE=FNAMIN(IT:)
      ELSE
        IT=LENSTR(FNAMIN)+1
        LT=0
        FTYPE=' '
      END IF

* Fill in the path name
      IF (IP.GT.0) THEN
        IS=LOCNBL(FNAMIN(1:IP))
        LP=IP-IS+1
        FPATH=FNAMIN(IS:IP)
      ELSE
        LP=0
        FPATH=' '
      END IF

* Fill in the file name
      LN=IT-IP-1
      FNAME=FNAMIN(IP+1:IT-1)

* Error checks
      IF (LT.GT.LEN(FTYPE) .OR. LP.GT.LEN(FPATH) .OR.
     -    LN.GT.LEN(FNAME))
     -  CALL WARN('FNPARS - String truncated')


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLVCFX (X, F, NPT, DATREG, IPATTN)
*
*
* Purpose:
*     Plot a tabulated function
*
*
* Description:
*     The real valued data is plotted by joining the data points with
*     straight line segments.  Both the function values and the
*     abscissa values are specified by an array of data. The plotting
*     area can set by calling SETGRS.  Plotting vectors outside of the
*     plotting area are clipped.
*
*
* Parameters:
* R ->  X      - Array of abscissa data
* R ->  F      - Array of function values
* I ->  NPT    - Number of data points in the arrays X and F
* R ->  DATREG - Data limits.  The four elements of DATREG define the
*                plot region.
*                DATREG(1,1) - Lower limit for the X data
*                DATREG(2,1) - Lower limit for the function values
*                DATREG(1,2) - Upper limit for the X data
*                DATREG(2,2) - Upper limit for the function values
* I ->  IPATTN - Line pattern.  This is a five element array describing
*                the line pattern to be used. The patterns are coded as
*                lengths of on and off segments.  A positive value
*                indicates on, while a negative value indicates off.
*                Zero values are ignored, except that an all zero
*                vector denotes a continuous line.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:28:38 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLVCFX (X, F, NPT, DATREG, IPATTN)


      INTEGER NPT
      INTEGER IDX,IDY
      INTEGER K,IXS,IYS,I,IXF,IYF,IXSC,IYSC,IXFC,IYFC,IVISIB
      INTEGER IXORIG,IYORIG,LENX,LENY
      INTEGER IPATTN(5)

      REAL X(*),F(*),DATREG(2,2)
      REAL PVX,PVY
      REAL VLEN
      REAL PATLEN,REMAIN,VLCLIP


* Statement function to calculate the length of vector
      VLEN(IDX,IDY) = SQRT(REAL(IDX)**2+REAL(IDY)**2)


      IF (NPT.LE.0) RETURN

* Determine the pattern size
      PATLEN=0.0
      DO 100 K=1,5
        PATLEN=PATLEN+ABS(IPATTN(K))
 100  CONTINUE
      REMAIN=ABS(IPATTN(1))
      K=1

* Get the starting point coordinates
      CALL GETGRS(IXORIG,IYORIG,LENX,LENY)
      PVX=LENX/(DATREG(1,2)-DATREG(1,1))
      PVY=LENY/(DATREG(2,2)-DATREG(2,1))

      IXS=NINT((X(1)-DATREG(1,1))*PVX) + IXORIG
      IYS=NINT((F(1)-DATREG(2,1))*PVY) + IYORIG

* Plot by joining the data points with straight lines
      DO 400 I=MIN(NPT,2),NPT
        IXF=NINT((X(I)-DATREG(1,1))*PVX) + IXORIG
        IYF=NINT((F(I)-DATREG(2,1))*PVY) + IYORIG

* Clip the vector
        CALL DECOUP(IXORIG,IYORIG,IXORIG+LENX,IYORIG+LENY,
     -              IXS,IYS, IXF,IYF,
     -              IXSC,IYSC, IXFC,IYFC, IVISIB)

* Account for clipping of the start of the vector
        IF (PATLEN.GT.0.0) THEN
          VLCLIP=VLEN(IXS-IXSC,IYS-IYSC)
          REMAIN=REMAIN-AMOD(VLCLIP,PATLEN)
 220      IF (REMAIN.LT.0.0) THEN
            K=MOD(K,5)+1
            REMAIN=REMAIN+ABS(IPATTN(K))
          GO TO 220
          END IF
        END IF

* Plot the clipped vector
        IF (IVISIB.GT.0)
     -    CALL XYDASH(IXSC,IYSC, IXFC,IYFC, IPATTN, K, REMAIN)

* Account for clipping of the end of the vector
        IF (PATLEN.GT.0.0) THEN
          VLCLIP=VLEN(IXF-IXFC,IYF-IYFC)
          REMAIN=REMAIN-AMOD(VLCLIP,PATLEN)
 240      IF (REMAIN.LT.0.0) THEN
            K=MOD(K,5)+1
            REMAIN=REMAIN+ABS(IPATTN(K))
          GO TO 240
          END IF
        END IF

* Update the beginning of the next vector
        IXS=IXF
        IYS=IYF

 400  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE CONVIC (IVAL, STRING, NC)
*
*
* Purpose:
*     Convert an integer value to a string (trim blanks)
*
*
* Description:
*     This routine converts an integer value to a string.  Leading
*     blanks are trimmed from the string.
*
*
* Parameters:
* I ->  IVAL   - Integer value to be converted
* C <-  STRING - Output string corresponding to the integer value.
*                The representation of the value has a maximum of 10
*                characters left justified in the string.  Trailing
*                blanks, if necessary, pad out the string.
* I <-  NC     - Number of characters representing the integer value
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:36:43 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE CONVIC (IVAL, STRING, NC)


      INTEGER IVAL,NC
      INTEGER NS

      CHARACTER*(*) STRING
      CHARACTER*10 STRT


* Convert the integer to a string
      WRITE (UNIT=STRT,FMT=2000) IVAL

* Find the first non-blank character
      DO 100 NS=1,10
        IF (STRT(NS:NS).NE.' ') GO TO 120
 100  CONTINUE
      CALL HALT('CONVIC - Unexpected error')

* Copy the value string to the output string
 120  NC=11-NS
      CALL STCOPY(STRT(NS:10),STRING,NC)


      RETURN

 2000 FORMAT (I10)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE CENSYM (IX, IY, SYMBOL)
*
*
* Purpose:
*     Plot a centered character
*
*
* Description:
*     This subroutine plots a character, centered at a given point.
*     In centering the character, lower case letters are offset
*     differently than other characters.
*
*
* Parameters:
* I ->  IX     - X coordinate of the plot location
* I ->  IY     - Y coordinate of the plot location
* C ->  SYMBOL - Character variable specifying the character to be
*                plotted.  The character size must be set to the
*                desired size before calling this routine.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:22 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE CENSYM (IX, IY, SYMBOL)


      INTEGER IX,IY
      INTEGER IW,IH
      INTEGER IXOFFS,IYOFFS

      REAL H,ANG

      CHARACTER*1 SYMBOL
      CHARACTER*1 SYMUP


* Offset the character position (different for lowercase letters)
      CALL GETCHR(IW,IH,ANG)
      CALL UPCSTR(SYMBOL,SYMUP)
      IF (SYMBOL.NE.SYMUP) THEN
        H=0.6666666667*IH
      ELSE
        H=IH
      END IF
      CALL ROTPTC(0.5*IW,0.5*H,ANG,IXOFFS,IYOFFS)

* Plot the character
      CALL PLCHAR(IX-IXOFFS,IY-IYOFFS,SYMBOL)


      RETURN

      END

*---------------Bell-Northern Research / INRS Computer Laboratory-------------
*
*
* MODULE:
*	SUBROUTINE WARN (STRING)
*
*
* PURPOSE:
*	This routine prints an error message using the system
*	signalling mechanism.
*
*
* DESCRIPTION:
*	This routine prints by signalling a warning message.
*
*
* PARAMETERS:
*	STRING - Character string to be printed
*
*
* ROUTINES REQUIRED:
*	LIB$SIGNAL - Signal an error
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	83/05/20
*
*
* UPDATES:
*
*
*---------------Bell-Northern Research / INRS Computer Laboratory-------------

	SUBROUTINE WARN (STRING)


	INTEGER FOR_W_TEXT
	PARAMETER (FOR_W_TEXT='181130'X)

	CHARACTER STRING*(*)


* Signal the message text as a warning text
	CALL LIB$SIGNAL(%VAL(FOR_W_TEXT),%VAL(1),STRING)

	RETURN


	END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE PSYMSG (ISTAT)
*
*
* PURPOSE:
*	This routine prints a system message.
*
*
* DESCRIPTION:
*	This routine prints a system message on the standard output
*	device.
*
*
* PARAMETERS:
*	ISTAT  - VMS status code
*
*
* ROUTINES REQUIRED:
*	LIB$PUT_OUTPUT - System routine to print an error message
*	LIB$SYS_GETMSG - System routine to get error message text
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	88/08/10
*
*
* UPDATES:
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE PSYMSG (ISTAT)


	INTEGER*2 MSGFMT
	PARAMETER (MSGFMT=15)

	CHARACTER*256 STRING



	CALL LIB$SYS_GETMSG(ISTAT,NC,STRING,MSGFMT,)
	CALL LIB$PUT_OUTPUT(STRING(1:NC))

	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE SETGRS (IX, IY, LENX, LENY)
*     SUBROUTINE GETGRS (IX, IY, LENX, LENY)
*
*
* Purpose:
*     Set the graph size for a plot
*     Get the graph size for a plot
*
*
* Description:
*     This subroutine sets or determines the rectangular area to be
*     used for plotting graphs.  Normally data values that result in
*     values outside the rectangle will be clipped.
*
*
* Parameters:
*     Subroutine SETGRS
* I ->  IX     - X coordinate of the lower lefthand corner of the graph
*                rectangle
* I ->  IY     - Y coordinate of the lower lefthand corner of the graph
*                rectangle
* I ->  LENX   - Size of the graph rectangle, X coordinate
* I ->  LENY   - Size of the graph rectangle, Y coordinate
*
*     Subroutine GETGRS
* I <-  IX     - X coordinate of the lower lefthand corner of the graph
*                rectangle
* I <-  IY     - Y coordinate of the lower lefthand corner of the graph
*                rectangle
* I <-  LENX   - Size of the graph rectangle, X coordinate
* I <-  LENY   - Size of the graph rectangle, Y coordinate
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:53 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE SETGRS (IX, IY, LENX, LENY)


      INTEGER IX,IY,LENX,LENY
      INTEGER IXS,IYS,LENXS,LENYS

      SAVE IXS,IYS,LENXS,LENYS

      DATA IXS,IYS,LENXS,LENYS/720,440,3240,2400/


* Set the graph rectangle
      IXS=IX
      IYS=IY
      LENXS=LENX
      LENYS=LENY

      GO TO 900

*----------
* Return the current graph size
      ENTRY GETGRS (IX, IY, LENX, LENY)


* Return the size of the graph rectangle
      IX=IXS
      IY=IYS
      LENX=LENXS
      LENY=LENYS


 900  RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*       SUBROUTINE PSEND
*
*
* PURPOSE:
*       This routine closes a Postscript plot file.
*
*
* DESCRIPTION:
*       This routine closes and optionally prints a Postscript plot file.
*
*
* PARAMETERS:
*       None
*
*
* ROUTINES REQUIRED:
*       PSTAIL - Write a trailer to a Postscript plot file
*       PSXY   - Postscript vector
*       QPRINT - Queue a file for printing
*       RELFUN - Release a Fortran unit number
*
*
* AUTHOR / MAINTAINED BY:
*       P. Kabal
*
*
* DATE CREATED:
*       1988/01/15
*
*
* UPDATES:
*       1989/04/04  Optionally print the file
*       1989/11/12  Push out buffered vectors
*       1990/03/04  New common area
*
*
*---------------------------INRS-Telecommunications---------------------------

        SUBROUTINE PSEND


        INTEGER LUNPS,IPRTPS
        CHARACTER*255 FNAMPS,QNAMPS
        COMMON /PSCOM/ LUNPS,IPRTPS,FNAMPS,QNAMPS


* Force any buffered plot vectors to be written
        CALL PSXY(0,0,0)

* Write a trailer to the file
        CALL PSTAIL(LUNPS)

* Close the Postscript plot file
        CLOSE (UNIT=LUNPS)
        CALL RELFUN(LUNPS)

* Queue the file for printing (default form, notify, delete)
        IF (IPRTPS.NE.0)
     -    CALL QPRINT(FNAMPS,QNAMPS,' ',.TRUE.,.TRUE.)

* Set the common area parameters to their default values
        LUNPS=-1
        IPRTPS=0
        FNAMPS=' '
        QNAMPS='LW$PRINT'

        RETURN


        END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLTLEG (TITLE)
*
*
* Purpose:
*     Plot a legend string
*
*
* Description:
*     This subroutine is intended to provide an easy way to print a
*     legend at the top of a standard graph drawn using one of the high
*     level plotting routines (e.g. PLOTYX or PLOTYI).  An example of a
*     call to this routine is as follows.
*
*       CALL PLTLEG('Test data from Jan. 31')
*
*
* Parameters:
* C ->  TITLE  - Character string containing the string to be plotted.
*                For the default graph size, there is enough room for
*                67 characters at the default width to be plotted
*                across the top of the graph.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:32 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLTLEG (TITLE)


      INTEGER IW,IH
      INTEGER IXORIG,IYORIG,LENX,LENY

      REAL ANG
      CHARACTER*(*) TITLE


* Save the character plotting angle
      CALL GETCHR(IW,IH,ANG)
      CALL GETGRS(IXORIG,IYORIG,LENX,LENY)

* Plot the title
      CALL PLTEXT(IXORIG,IYORIG+LENY+NINT(3.333333333*IH),0,TITLE)

* Restore the character plotting angle
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PSVECT (LUN, IX, IY, LINEWD)
*
*
* Purpose:
*     Write a vector to a Postscript plot file
*
*
* Description:
*     This routine writes a plot vector to a Postscript plot file.  The
*     plot commands written to the file makes use of macros defined by
*     routine PSHEAD.  Subroutine PSHEAD also initializes variables in
*     common area PSBBOX which tally bounding box information.
*
*
* Parameters:
* I ->  LUN    - Unit number for the file
* I ->  IX     - X coordinate in plotting units (0 to 4095)
* I ->  IY     - Y coordinate in plotting units (0 to 4095)
* I ->  LINEWD - Line width in plotting units
*                0 - no plot vector is generated
*                negative - a white vector of width -LINEWD
*                           is generated
*                positive - a black vector of width LINEWD
*                           is generated
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:29:33 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PSVECT (LUN, IX, IY, LINEWD)


      CHARACTER*10 STRL,STRX,STRY

      INTEGER LUN,IX,IY,LINEWD
      INTEGER NCL,NCX,NCY

      INTEGER IXMIN,IYMIN,IXMAX,IYMAX,LWP
      COMMON /PSBBOX/ IXMIN,IYMIN,IXMAX,IYMAX,LWP

      INTEGER IXP,IYP
      SAVE IXP,IYP
      DATA IXP,IYP/0,0/


* Update the maximum and minimum excursions
      IXMIN=MIN(IX,IXMIN)
      IYMIN=MIN(IY,IYMIN)
      IXMAX=MAX(IX,IXMAX)
      IYMAX=MAX(IY,IYMAX)

      IF (LINEWD.EQ.0) THEN

* Move
        CALL CONVIC(IX,STRX,NCX)
        CALL CONVIC(IY,STRY,NCY)
        WRITE (UNIT=LUN,FMT=1000) STRX(1:NCX)//' '//
     -                            STRY(1:NCY)//' m'


      ELSE

* Write the line width (if changed)
        IF (LINEWD.NE.LWP) THEN
          LWP=LINEWD
          CALL CONVIC(ABS(LWP),STRL,NCL)
          IF (LWP.GT.0) THEN
            WRITE (UNIT=LUN,FMT=1000) STRL(1:NCL)//' B'
          ELSE
            WRITE (UNIT=LUN,FMT=1000) STRL(1:NCL)//' W'
          END IF
        END IF

* Write the coordinates for the next line segment
        IF (IX.EQ.IXP) THEN
          CALL CONVIC(IY,STRY,NCY)
          WRITE (UNIT=LUN,FMT=1000) STRY(1:NCY)//' V'
        ELSE IF (IY.EQ.IYP) THEN
          CALL CONVIC(IX,STRX,NCX)
          WRITE (UNIT=LUN,FMT=1000) STRX(1:NCX)//' H'
        ELSE
          CALL CONVIC(IX,STRX,NCX)
          CALL CONVIC(IY,STRY,NCY)
          WRITE (UNIT=LUN,FMT=1000) STRX(1:NCX)//' '//
     -                                STRY(1:NCY)//' L'
        END IF

      END IF

* Update the coordinate positions
      IXP=IX
      IYP=IY


      RETURN

 1000 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION CEILX (X)
*
*
* Purpose:
*     Calculate the ceiling function
*
*
* Description:
*     This function calculate the ceiling function of x.  It returns
*     the smallest integer that is greater than or equal to x.
*
*
* Parameters:
* R <-  CEILX  - Returned integer value (of type REAL)
*
* R ->  X      - Input value
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:26:29 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION CEILX (X)


      REAL X


* For negative values, AINT(.) works as the ceiling function
      CEILX=AINT(X)
      IF (X.GT.0.0 .AND. X.NE.CEILX) CEILX=CEILX+1.


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PFSETX (IPLOT, IFAXIS, FLTTYP, NCOF, SFREQ,
*                        X, MXNPT, NPT,
*                        XMIN, XMAX, XSPEC)
*
*
* Purpose:
*     Set the array of abscissa values for a filter response
*
*
* Description:
*     This routine sets the X-array for a filter response plot.
*
*
* Parameters:
* I ->  IPLOT  - Type of plot,
*                1 - linear amplitude
*                2 - dB amplitude
*                3 - log amplitude
*                4 - group delay
*                5 - phase response
*                6 - radian phase
*                7 - impulse response
* I ->  IFAXIS - Frequency axis options,
*                0 - linear frequency (Hz)
*                1 - log frequency (Hz)
*                2 - linear radian frequency
*                3 - log radian frequency
* C ->  FLTTYP - Character string indicating the type of filter,
*                ALL - all-pole filter
*                CAS - cascade analog filter
*                FIR - finite impulse response filter
*                IIR - infinite impulse response filter
*                WIN - window response
* I ->  NCOF   - Number of filter coefficients
* R ->  SFREQ  - Sampling frequency
* R <-  X      - Array of abscissa values
* I ->  MXNPT  - Maximum number of abscissa values
* I <-  NPT    - Number of abscissa values
* R <-> XMIN   - Lower plot limit.  This is both an input and an output
*                variable if XSPEC is .TRUE., and an output variable if
*                XSPEC is .FALSE..
* R <-> XMAX   - Upper plot limit.  This is both an input and an output
*                variable is XSPEC is .TRUE., and an output variable if
*                XSPEC is .FALSE..
* L ->  XSPEC  - Logical variable,
*                .TRUE.  - XMIN and XMAX specified on input
*                .FALSE. - XMIN and XMAX not specified on input
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:46:21 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PFSETX (IPLOT, IFAXIS, FLTTYP, NCOF, SFREQ,
     -                   X, MXNPT, NPT,
     -                   XMIN, XMAX, XSPEC)


      INTEGER TICKV,EXACTV
      PARAMETER (TICKV=1,EXACTV=2)
      INTEGER LINAR,DBAR,LOGAR,DELYR,PHASD,PHASR,IMPLR
      PARAMETER (LINAR=1,DBAR=2,LOGAR=3,DELYR=4,PHASD=5,PHASR=6,
     -           IMPLR=7)
      INTEGER LINS,LOGS,CFREQ,RFREQ
      PARAMETER (LINS=0,LOGS=1,CFREQ=0,RFREQ=1)
      INTEGER MNNPT
      PARAMETER (MNNPT=401)
      REAL PPC
      PARAMETER (PPC=32.0)

      INTEGER IPLOT,IFAXIS,NCOF,MXNPT,NPT
      INTEGER ILOG,IRAD,ILL,IUL,I,NSECT
      INTEGER ISS,IFS
      INTEGER IFLORX,ICEILX

      LOGICAL XSPEC

      CHARACTER*(*) FLTTYP

      REAL SFREQ,XMIN,XMAX
      REAL DMIN,DMAX,R,RESL
      REAL X(0:MXNPT-1)


* Set up the default limits
*  1. Time axis for impulse responses (FIR)
*     lower limit is 0
*     upper limit is (NCOF-1)/SFREQ
*  2. Time axis for impulse responses (IIR)
*     lower limit is 0
*     upper limit is set to (MXNPT-1)/SFREQ
*  3. Linear frequency axis (digital filters)
*     lower limit is 0
*     upper limit is 0.5*Sfreq
*  4. Log frequency axis (digital filters)
*     lower limit is tick value below 0.5*Sfreq/1000
*     upper limit is 0.5*Sfreq
*  5. Linear frequency axis (analog filters)
*     lower limit is 0
*     upper limit is 5 Hz
*  6. Log frequency axis (analog filters)
*     lower limit is tick value below 5/1000 Hz
*     upper limit is tick value above 5 Hz

*==========
* Time axis
      IF (IPLOT.EQ.IMPLR) THEN

        IF (XSPEC) THEN
          DMIN=XMIN
          DMAX=XMAX
          XMIN=MIN(DMIN,DMAX)
          XMAX=MAX(DMIN,DMAX)
          ISS=IFLORX(XMIN*SFREQ)
          IFS=ICEILX(XMAX*SFREQ)
          NPT=IFS-ISS+1
          IF (NPT.GT.MXNPT) THEN
            CALL WARN('PFSETX - Too many response samples requested')
            NPT=MXNPT
          END IF

        ELSE
* Choose the default number of points as either the number of filter
* coefficients (FIR filters) or the maximum number of points (IIR
* filters)
          IF (FLTTYP.EQ.'FIR' .OR. FLTTYP.EQ.'WIN') THEN
            NPT=NCOF
            IF (NPT.GT.MXNPT) THEN
              CALL WARN('PFSETX - Impulse response truncated')
              NPT=MXNPT
            END IF
          ELSE
            NPT=MXNPT
          END IF
          XMIN=0.0
          ISS=0
          XMAX=(NPT-1)/SFREQ

        END IF

* Fill in the X-array
        DO 100 I=0,NPT-1
          X(I)=(I+ISS)/SFREQ
 100    CONTINUE

*==========
* Frequency axis
      ELSE
        ILOG=MOD(IFAXIS,2)
        IRAD=MOD(IFAXIS/2,2)

        IF (XSPEC) THEN
          ILL=EXACTV
          IUL=EXACTV

        ELSE
          IF (FLTTYP.EQ.'CAS') THEN
            IF (ILOG.EQ.LOGS) THEN
              XMAX=5.0
              IUL=TICKV
              XMIN=XMAX/1000.
              ILL=TICKV
            ELSE
              XMIN=0.0
              ILL=EXACTV
              XMAX=5.0
              IUL=TICKV
            END IF
          ELSE
            IF (ILOG.EQ.LOGS) THEN
              XMAX=0.5*SFREQ
              IUL=EXACTV
              XMIN=XMAX/1000.
              ILL=TICKV
            ELSE
              XMIN=0.0
              ILL=EXACTV
              XMAX=0.5*SFREQ
              IUL=EXACTV
            END IF
          END IF

        END IF

* Find suitable abscissa limits
        IF (IRAD.EQ.CFREQ) THEN
          CALL PLTLIM(XMIN,XMAX,ILL,IUL,ILOG,DMIN,DMAX)
          XMIN=DMIN
          XMAX=DMAX
        ELSE
          CALL PLTLIM(2.*XMIN,2.*XMAX,ILL,IUL,ILOG,DMIN,DMAX)
          XMIN=0.5*DMIN
          XMAX=0.5*DMAX
        END IF
        IF (ILOG.EQ.LOGS) THEN
          R=XMAX/XMIN
        ELSE
          R=1.
        END IF

* Determine the number of abscissa values
* The number of values is at least MNNPT and at most MXNPT.  The number
* of points is calculated below for linear frequency scales, but is
* also used for log frequency scales.
* FIR filters:
* - The case of two maximally separated impulses gives rise to a
*   sinusoidal variation in the frequency response of the form
*   cos (2 pi f (N-1)/2).  The frequency resolution should be at
*   least PPC points per cycle.
* All-pole filters:
* - The response is the inverse to that for an FIR filter.  The
*   frequency resolution is set to be the same as for an FIR filter
*   with the same number of coefficients.
* IIR filters:
* - The denominator of the overall system function has NSECT*3-1
*   coefficients.  The resolution is set to be the same as an all-pole
*   filter with that many cofficients.
* CAS filters:
* - The denominator of the overall system function has NSECT*3-1
*   coefficients.  For such filters, there is no convenient estimate of
*   the resolution needed.  It is assumed that the filter response is
*   similar to that for a digital IIR filter spanning the range from 0
*   to half the sampling frequency.
        IF (FLTTYP.EQ.'IIR') THEN
          NSECT=NCOF/5
          RESL=2.0*SFREQ/((NSECT*3-1)*PPC)
          NPT=ICEILX((XMAX-XMIN)/RESL)+1
        ELSE IF (FLTTYP.EQ.'CAS') THEN
          NSECT=NCOF/5
          RESL=2.0/((NSECT*3-1)*PPC)
          NPT=ICEILX(0.5/RESL)+1
        ELSE
          RESL=2.0*SFREQ/((NCOF-1)*PPC)
          NPT=ICEILX((XMAX-XMIN)/RESL)+1
        END IF
        NPT=MAX(MNNPT,NPT)
        NPT=MIN(MXNPT,NPT)

* Fill in the X-array
        CALL GEOINC(XMIN,XMAX,NPT,R,X)

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE ENGSCL (FIRSTV, DELTAV, NVAL, NSIG, IEXP)
*
*
* Purpose:
*     Find a scale factor for a range of data
*
*
* Description:
*     The NVAL values are given as FIRSTV, FIRSTV+DELTAV, ... ,
*     FIRSTV+(NVAL-1)*DELTAV.  This subroutine determines the smallest
*     and largest magnitude, non-zero values (Pmin and Pmax).  From
*     these values a scale factor of the form 10**IEXP, where IEXP is
*     a multiple of 3, is determined as follows.
*     1) If all values can be represented by NSIG significant digits
*        without scaling, IEXP is set to zero.  That is IEXP is zero if
*        Pmin is greater than or equal to 0.1 and Pmax is less than
*        10***NSIG.
*     2) Otherwise, the scale factor is chosen such that
*        Pmax=Pm*10**IEXP where IEXP is a multiple of 3 and Pm lies
*        between 1 and 1000.
*
*
* Parameters:
* R ->  FIRSTV - First value
* R ->  DELTAV - Increment in values
* I ->  NVAL   - Number of values
* I ->  NSIG   - Number of significant digits to be used in
*                representing the values.  NSIG must be at least 3.
* I <-  IEXP   - Exponent for the scale factor.  IEXP is a multiple of
*                3.  The scale factor is 10**IEXP.
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:27:53 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE ENGSCL (FIRSTV, DELTAV, NVAL, NSIG, IEXP)


      REAL EPS
      PARAMETER (EPS=1E-5)

      INTEGER NVAL,NSIG,IEXP
      INTEGER IV

      REAL FIRSTV,DELTAV
      REAL ALASTV,SF,SL,SD,PMAX,PMIN,R


      ALASTV=FIRSTV+(NVAL-1)*DELTAV
      SF=ABS(FIRSTV)
      SL=ABS(ALASTV)
      SD=ABS(DELTAV)

* Find the maximum
      PMAX=MAX(SF,SL)

      IF (FIRSTV*ALASTV.GE.0.0) THEN

* End points have the same sign, minimum occurs at the ends
        PMIN=MIN(SF,SL)

      ELSE

* Minimum occurs at an intermediate point
        PMIN=ABS(SD*ANINT(SF/SD)-SF)

      END IF

* Check for a zero or near zero minimum
      IF (PMIN.LT.EPS*SD) PMIN=SD

* Find the exponent of the scale factor
      IEXP=0
      R=10.**NSIG

* (R-0.5) is the largest number that can be represented with NSIG
* digits
* (0.1-0.5/R) is the smallest number that can be represented with NSIG
* digits
      IF (PMAX.GE.(R-0.5) .OR. PMIN.LT.(0.1-0.5/R)) THEN

* The factor R/(R-0.5) ensures that numbers between R-0.5 and R take on
* the next higher value of IEXP
        IV=ALOG10(PMAX*R/(R-0.5)) + 900.0
        IEXP=(IV/3)*3 - 900

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE DRCHAR (IX0, IY0, CHTAB, NB)
*
*
* Purpose:
*     Draw a character
*
*
* Description:
*     The given character is plotted at the given plotting coordinates.
*     Characters are defined on a 10 by 14 grid.  However, many
*     characters use only the even valued grid points, resulting in an
*     effective 5 by 7 point grid for the characters.  Characters are
*     drawn by joining points on the grid.
*
*     Each point is stored as an X-Y pair in a byte, 4 bits for each
*     coordinate.  In addition special byte values define codes which
*     specify pen up and coordinate shifts.
*
*     The character size and orientation are stored as integer valued
*     X and Y increments for each of the width and height directions in
*     the character grid.  Subroutine SETCHR can be used to change the
*     character size and orientation.  The initial character size is
*     32 plotting units wide and 48 plotting units high.
*
*
* Parameters:
* I ->  IX0    - X coordinate of the corner of the character (lower
*                left hand corner for characters plotted parallel to
*                the X direction)
* I ->  IY0    - Y coordinate of the corner of the character (lower
*                left hand corner for characters plotted parallel to
*                the X direction)
* B ->  CHTAB  - Array of bytes storing the coordinates
* I ->  NB     - Number of bytes in CHTAB
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:30:41 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE DRCHAR (IX0, IY0, CHTAB, NB)


      INTEGER IASP,IBUP,IBSD,IBSU
      INTEGER IUP,IDOWN
      PARAMETER (IASP=15,IBUP=0,IBSD=1,IBSU=2)
      PARAMETER (IUP=0,IDOWN=1)

      INTEGER IX0,IY0,NB
      INTEGER IW,IH,IPEN,IBOFFS,I,IT,IA,IB,IXR,IYR

      BYTE CHTAB(*)

      REAL ANG,XC,YC


* Initialization
      CALL GETCHR(IW,IH,ANG)
      IPEN=IUP
      IBOFFS=0

* The coordinates are stored as an X-Y pair in bytes.  IA and IB
* represent the values of the X and Y values respectively.  IA
* equal to IASP signals a special action.  The special actions are:
*   PENUP  - Lift the pen.  Plotting commences with the next
*            coordinate.
*   SHIFTD - The Y coordinate is shifted down 4 grid units.  The pen is
*            also lifted.  This command can be used to plot characters
*            with descenders.
*   SHIFTU - The Y coordinate is shifted up 4 grid units.  The pen is
*            also lifted.
* There is an implicit UP command at the beginning of each character.
* The plotting pen is moved to the first coordinate after an UP
* command and plotting commences from that point.

* Drawing loop - pick up an X-Y coordinate
      DO 100 I=1,NB
        IT=CHTAB(I)
        IA=(IT.AND.255)/16
        IB=(IT.AND.15)

        IF (IA.NE.IASP) THEN

* Drawing routine
          XC=IW*IA/8.
          YC=IH*(IB+IBOFFS)/12.
          CALL ROTPTC(XC,YC,ANG,IXR,IYR)
          IF (IPEN.EQ.IDOWN) THEN
            CALL XYDRAW(IX0+IXR,IY0+IYR)
          ELSE
            CALL XYMOVE(IX0+IXR,IY0+IYR)
            IPEN=IDOWN
          END IF

        ELSE

* Special action, decode
          IF (IB.EQ.IBUP) THEN
            IPEN=IUP
          ELSE IF (IB.EQ.IBSD) THEN
            IBOFFS=IBOFFS-4
            IPEN=IUP
          ELSE
            IBOFFS=IBOFFS+4
            IPEN=IUP
          END IF

        END IF

 100  CONTINUE


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE GETIMG (IMAGNM, NC)
*
*
* PURPOSE:
*	This routine returns the image name.
*
*
* DESCRIPTION:
*	This routine returns a string containing the image name that
*	is currently running. This string contains only the name
*	portion of the full image name.
*
*
* PARAMETERS:
* C <-	IMAGNM - Output string
* I <-	NC     - Number of characters set in IMAGNM
*
*
* ROUTINES REQUIRED:
*	FNSCAN - Return file name components
*	LIB$GETJPI - Get job process information
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	1980/04/04
*
*
* UPDATES:
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE GETIMG (IMAGNM, NC)


	CHARACTER*(*) IMAGNM
	CHARACTER*255 IMAGE_FILE


	INCLUDE '($JPIDEF)'


* Get the image name
	CALL LIB$GETJPI(JPI$_IMAGNAME,,,,IMAGE_FILE,NCF)
	CALL FNSCAN(IMAGE_FILE(1:NCF),'NAME',IMAGNM,NC)


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VEXP10 (X, Y, N)
*
*
* Purpose:
*     Exponent (base 10) of each element of a vector
*
*
* Description:
*     This routine converts each element of the input vector to an
*     exponent (base 10) value.
*
*       y(i) =  10**x(i)  for i from 1 to N.
*
*
* Parameters:
* R ->  X      - Input vector
* R <-  Y      - Output vector (the output vector may be the same as
*                the input vector)
* I ->  N      - Number of elements in each of X and Y.  N may be zero.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:05:22 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VEXP10 (X, Y, N)


      INTEGER N
      INTEGER I

      REAL X(*),Y(*)


      DO 100 I=1,N
        Y(I)=10.**X(I)
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VDBV (X, Y, N)
*
*
* Purpose:
*     Convert the elements of a vector to dB (voltage)
*
*
* Description:
*     This routine converts each element of the input vector to a
*     voltage ratio decibel value.
*
*       y(i) =  20*log10(y(i))  for i from 1 to N.
*
*     However, if x(i) is nonpositive, y(i) is set to -1E6.
*
*
* Parameters:
* R ->  X      - Input vector, all elements should be positive
* R <-  Y      - Output vector (the output vector may be the same as
*                the input vector)
* I ->  N      - Number of elements in each of X and Y.  N may be zero.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:05:17 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VDBV (X, Y, N)


      INTEGER N
      INTEGER NN,I

      REAL X(*),Y(*)


      NN=0
      DO 100 I=1,N
        IF (X(I).GT.0.0) THEN
          Y(I)=20.*LOG10(X(I))
        ELSE
          NN=NN+1
          Y(I)=-1E6
        END IF
 100  CONTINUE

      IF (NN.NE.0) CALL WARN('VDBV - Nonpositive input value(s)')


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PFILIM (SFREQ, Y, NPT, EPS, XMAX)
*
*
* Purpose:
*     Find the extent of a response to be plotted
*
*
* Description:
*     This routine finds the extent of a response.  The extent is
*     determined to be that part of the response (starting at zero)
*     beyond which all samples habe a magnitude smaller than EPS times
*     the largest response value.  The plotting limits which include
*     this extent are returned.
*
*
* Parameters:
* R ->  SFREQ  - Sampling frequency
* R ->  Y      - Array of response values
* I <-> NPT    - Number of response values.  This is both an input and
*                an output variable.  On input it specified the number
*                of response values available.  On output it is set to
*                a value between 2 and its previous value (inclusive),
*                based on the extent of the significant part of the
*                response.
* R ->  EPS    - Tolerance value.  The extent of the response is
*                determined to include samples which are larger than
*                EPS times the largest magnitude sample.
* R <-  XMAX   - Maximum abscissa value, set to the extent of the
*                response to be plotted
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.7 $  $Date: 1995/03/08 15:46:18 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PFILIM (SFREQ, Y, NPT, EPS, XMAX)


      INTEGER TICKV,EXACTV,LINS
      PARAMETER (TICKV=1,EXACTV=2,LINS=0)

      INTEGER NPT
      INTEGER IL,IU,NP
      INTEGER ICEILX

      REAL Y(0:*)
      REAL SFREQ,EPS,XMAX
      REAL TMIN,TMAX,TAB,XMIN


* Find the extent of the impulse response
      CALL MINMAX(Y,NPT,TMIN,TMAX)
      TAB=MAX(ABS(TMIN),ABS(TMAX))
      CALL VEXTNT(Y,NPT,EPS*TAB,IL,IU)
      TMIN=0.0
      TMAX=(MAX(IU,2)-1)/SFREQ
      CALL PLTLIM(TMIN,TMAX,EXACTV,TICKV,LINS,XMIN,XMAX)

* Error check
      NP=ICEILX(XMAX*SFREQ)+1
      IF (NP.GT.NPT) THEN
        CALL WARN('PFILIM - Response truncated')
      ELSE
        NPT=NP
      END IF
      

      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE ICOPY (IX, IY, N)
*
*
* Purpose:
*     Copy an INTEGER array
*
*
* Description:
*     The elements of the input array are transferred to the output
*     array starting at the bottom.  If N is zero, no transfer is
*     performed.
*
*
* Parameters:
* I ->  IX     - Input array
* I <-  IY     - Output array
* I ->  N      - Number of elements to be transferred
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:04:36 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE ICOPY (IX, IY, N)


      INTEGER N
      INTEGER I
      INTEGER IX(*),IY(*)


      DO 100 I=1,N
        IY(I)=IX(I)
 100  CONTINUE


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE RDRVA2 (LINE, VAL1, VAL2, IER)
*
*
* Purpose:
*     Decode two real values
*
*
* Description:
*     This routine decodes a string containing numeric data.  The two
*     data values in the string are separated by a comma and/or white
*     space (blanks, tabs or null characters).  The decoded data is
*     stored as real values.  If an error is detected (decoding error,
*     too few values, or too many values), an error flag is set.
*
*
* Parameters:
* C ->  LINE   - Input string.  Blanks in the string are ignored.
* R <-  VAL1   - First real value.  This value is not set in case of an
*                error.
* R <-  VAL2   - Second real value.  This value is not set in case of
*                an error.
* I <-  IER    - Error code,
*                0 - No error
*                1 - Error
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:37:51 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE RDRVA2 (LINE, VAL1, VAL2, IER)


      INTEGER IER
      INTEGER NV

      CHARACTER*(*) LINE

      REAL VAL1,VAL2
      REAL VT(2)


* Use RDRVAL to decode the values
      CALL RDRVAL(LINE,2,2,VT,NV)
      IF (NV.EQ.2) THEN
        VAL1=VT(1)
        VAL2=VT(2)
        IER=0
      ELSE
        IER=1
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE STRPAR (STRIN, STROUT, NC)
*
*
* Purpose:
*     Remove outer parentheses from a string
*
*
* Description:
*     This routine copies an input string omitting leading and trailing
*     white space (blank, tab or null characters) and any outer
*     parentheses.  Only the outer parentheses are removed.  White
*     space inside these parentheses is included in the output string.
*
*
* Parameters:
* C ->  STRIN  - Input string
* C <-  STROUT - Output string
* I <-  NC     - Number of characters in the output string
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:41:33 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE STRPAR (STRIN, STROUT, NC)


      CHARACTER*(*) STRIN,STROUT

      INTEGER NC,IST,IFN
      INTEGER LOCNBL,LENSTR


* Find the substring to be copied
      IFN=LENSTR(STRIN)
      IST=1

      IF (IFN.GT.0) THEN
        IST=LOCNBL(STRIN(1:IFN))
        IF (IST.LT.IFN) THEN
          IF (STRIN(IST:IST).EQ.'(' .AND. STRIN(IFN:IFN).EQ.')') THEN
            IST=IST+1
            IFN=IFN-1
          END IF
        END IF
      END IF

* Copy the selected part of the input string
      IF (IST.LE.IFN) THEN
        CALL STCOPY(STRIN(IST:IFN),STROUT,NC)
      ELSE
        STROUT=' '
        NC=0
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE RDIVAL (LINE, MINN, MAXN, IVAL, N)
*
*
* Purpose:
*     Decode integer values (variable number)
*
*
* Description:
*     This routine decodes a string containing numeric data.  Multiple
*     data items in the string are separated by commas or white space
*     (blanks, tabs or null characters).  The decoded data is stored as
*     integer values.  If the number of data values in the string is
*     less than a given minimum number or a decoding error is detected,
*     an error message is printed and N is set to zero.  Warning
*     messages are printed if a null data value is encountered
*     (interpreted as zero), or extra data follows the requested values
*     (this data is ignored).
*
*
* Parameters:
* C ->  LINE   - Input string.  Blanks in the string are ignored.
* I <-  MINN   - Minimum number of values to be read (may be zero)
* I <-  MAXN   - Maximum number of values to be read (at most 256)
* I <-  IVAL   - Integer array of MAXN elements used to store the
*                values.  Only the first N values are modified.  If an
*                error condition is detected, the array IVAL is not
*                modified.  An error condition occurs if too few values
*                are specified or if a decoding error is detected.
* I <-  N      - Actual number of values read.  If an error condition
*                is detected, N is set to zero.  An error condition
*                occurs if too few values are specified or if a
*                decoding error is detected.  N is also set to zero if
*                the number of values to be read is allowed to be zero
*                and the input string contains only white space.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:37:45 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE RDIVAL (LINE, MINN, MAXN, IVAL, N)


      CHARACTER*(*) PRETXT
      INTEGER MXMAXN,MXNE,MXCHAR
      PARAMETER (MXMAXN=256,MXNE=72,MXCHAR=20)
      PARAMETER (PRETXT='RDIVAL - Error in data format, data: ')

      INTEGER MINN,MAXN,N
      INTEGER IVAL(MAXN)
      INTEGER M,I,IS,IE,IER,LENP,NCE
      INTEGER ITEMP(MXMAXN),IST(MXMAXN+1),IFN(MXMAXN+1)

      CHARACTER*(*) LINE
      CHARACTER*(MXNE) ERRTXT


* Find the substrings
      CALL FNDSUB(LINE,' ',IST,IFN,MXMAXN+1,M)

* Check the number of values found
      N=0
      IF (M.LT.MINN) THEN
        CALL WARN('RDIVAL - Error, too few data values')

      ELSE IF (M.GT.MXMAXN .AND. MAXN.GT.MXMAXN) THEN
        CALL WARN('RDIVAL - Error, too many data values')

      ELSE

        IF (M.GT.MAXN) THEN
          CALL WARN('RDIVAL - Warning, extra data ignored')
          M=MAXN
        END IF

* Decode the substrings
        DO 220 I=1,M
          IS=IST(I)
          IE=IFN(I)
          IF (IS.LE.IE) THEN
            IF (IE-IS+1.LE.MXCHAR) THEN
              READ (UNIT=LINE(IS:IE),FMT=1000,IOSTAT=IER) ITEMP(I)
            ELSE
              IER=1
            END IF

* Error messages
            IF (IER.NE.0) THEN
              LENP=LEN(PRETXT)
              NCE=LENP+IE-IS+1+2
              IF (NCE.LE.MXNE) THEN
                ERRTXT=PRETXT//'"'//LINE(IS:IE)//'"'
              ELSE
                ERRTXT=PRETXT//'"'//LINE(IS:IS+MXNE-LENP-6)//'..."'
                NCE=MXNE
              END IF
              CALL WARN(ERRTXT(1:NCE))
              GO TO 300
            END IF

          ELSE
            CALL WARN('RDIVAL - Warning, null data value')
            ITEMP(I)=0.0

          END IF

 220    CONTINUE

        N=M
        CALL ICOPY(ITEMP,IVAL,N)

      END IF


 300  RETURN

 1000 FORMAT (I20)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     COMPLEX FUNCTION RSPFIR (F, H, NCOF)
*
*
* Purpose:
*     Find the frequency response for an FIR filter
*
*
* Description:
*     This function calculates the frequency repsonse of a FIR filter
*     specified by its coefficients.  The response is given by
*
*              Nc-1       -n
*       H(z) = SUM  h(n) z   ,
*              n=0
*
*     evaluated with z=exp(j 2 pi f).
*
*
* Parameters:
* X <-  RSPFIR - Resulting complex valued response
*
* R ->  F      - Normalized frequency (normally in the range 0 to 0.5)
* R ->  H      - Filter coefficients
* I ->  NCOF   - Number of filter coefficients
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:21:56 $
*
*
*-----------------------------------------------------------------------

      COMPLEX FUNCTION RSPFIR (F, H, NCOF)


      REAL PI2
      PARAMETER (PI2=6.283 185 307)

      INTEGER NCOF
      INTEGER N

      REAL F
      REAL WT
      REAL H(0:NCOF-1)

      DOUBLE PRECISION DSUMR,DSUMI


      WT=PI2*F
      DSUMR=0D0
      DSUMI=0D0
      DO 100 N=0,NCOF-1
        DSUMR=DSUMR + DPROD(H(N),COS(WT*N))
        DSUMI=DSUMI + DPROD(H(N),-SIN(WT*N))
 100  CONTINUE

      RSPFIR=CMPLX(SNGL(DSUMR),SNGL(DSUMI))


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VTINIT (OPTION)
*
*
* Purpose:
*     Initialize a plot on a ReGIS display
*
*
* Description:
*     This subroutine (optionally) clears the screen of the terminal
*     and draws a dark vector.
*
*
* Parameters:
* C ->  OPTION - Character string specifying the options.  Options are
*                separated by commas and/or whitespace (blanks, tabs,
*                or nulls).  If any option is omitted, the default
*                value is used.  An all blank string gives the default
*                values.  The same keyword may appear more than once,
*                with the last instance taking precedence.  The CLEAR
*                and OVERLAY options apply only to one invokation of
*                this routine.
*                CLEAR - The screen is erased.  CLEAR is the default
*                  option if this plot device is not active.
*                OVERLAY - The screen is not erased.  OVERLAY is the
*                  default option if this plot device is already
*                  active.
*                FILENAME=name - Specifies the name of the file or
*                  terminal to which plot data is sent.  The file name
*                  is not used if this plot device is already active.
*                  The special file name "*" can be  used to direct
*                  output to the standard output (Fortran unit 6).  The
*                  default file name is "/dev/tty".
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:30:05 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VTINIT (OPTION)


      CHARACTER*(*) ERASE
      INTEGER DARK,ESC,NEKEY
      PARAMETER (DARK=0,ESC=27,ERASE='S(E)')
      PARAMETER (NEKEY=3)

      INTEGER NC,N,NCN
      INTEGER LENSTR

      CHARACTER*(*) OPTION
      CHARACTER*256 LINE,TOKEN
      CHARACTER*20 KEYTAB(NEKEY)
      CHARACTER*1 CESC

      LOGICAL CLEAR

      INTEGER LUNVT
      CHARACTER*255 FNAMVT
      COMMON /VTCOM/ LUNVT,FNAMVT
      DATA LUNVT/-1/,FNAMVT/'/dev/tty'/

      DATA KEYTAB/'CL*EAR'         , 'OVER*LAY'        ,
     -            'FILE*NAME'      /


      CLEAR=(LUNVT.LT.0)
      CALL RQUOTE(OPTION,LINE,NC)

* Decode the options
 100  IF (LENSTR(LINE).GT.0) THEN
        CALL FNDPAR(LINE,KEYTAB,NEKEY,TOKEN,NC,N)

        IF (N.EQ.1) THEN
          CLEAR=.TRUE.

        ELSE IF (N.EQ.2) THEN
          CLEAR=.FALSE.

        ELSE IF (N.EQ.3) THEN
          CALL RQUOTE(TOKEN(1:NC),FNAMVT,NCN)

        END IF

      GO TO 100
      END IF


      IF (LUNVT.LT.0) THEN

* Not previously selected
* Open the file
        IF (FNAMVT.EQ.'*') THEN
          LUNVT=6
        ELSE
          CALL FBAKUP(FNAMVT)
          CALL GETFUN(LUNVT)
          OPEN (UNIT=LUNVT,FILE=FNAMVT,STATUS='UNKNOWN')
        END IF

        CESC=CHAR(ESC)
        WRITE (UNIT=LUNVT,FMT=1000) CESC//'P'//
     -                              '1pS(A[0,0][799,479])'
        IF (CLEAR) WRITE (UNIT=LUNVT,FMT=1000) ERASE
        CALL VTVECT(LUNVT,0,0,0)

      ELSE IF (CLEAR) THEN

* Previously selected, with CLEAR option
        WRITE (UNIT=LUNVT,FMT=1000) ERASE

      END IF


      RETURN

 1000 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE ROTPTC (XC, YC, ANGD, IXR, IYR)
*
*
* Purpose:
*     Rotate coordinates
*
*
* Description:
*     This routine rotates a given coordinate pair (IX,IY) through the
*     angle ANGD (degrees).  This operation can be expressed in matrix
*     form as
*
*       | IXR |   | cos(ang) -sin(ang)|   | XC |
*       |     | = |                   | * |    |
*       | IYR |   | sin(ang)  cos(ang)|   | YC |
*
*
* Parameters:
* R ->  XC     - X coordinate (real value)
* R ->  YC     - Y coordinate (real value)
* R ->  ANGD   - angle in degrees
* I <-  IXR    - rotated X coordinate (integer value)
* I <-  IYR    - rotated Y coordinate (integer value)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:56 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE ROTPTC (XC, YC, ANGD, IXR, IYR)


      REAL PI
      PARAMETER (PI=3.141 592 654)

      INTEGER IXR,IYR

      REAL XC,YC,ANGD
      REAL CS,SI


* Rotate the coordinates
      CS=COS(ANGD*(PI/180.))
      SI=SIN(ANGD*(PI/180.))
      IXR=NINT(CS*XC-SI*YC)
      IYR=NINT(SI*XC+CS*YC)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLTITL (XLABEL, XUNITS, YLABEL, YUNITS)
*
*
* Purpose:
*     Plot a titles on a graph
*
*
* Description:
*     This subroutine is intended to provide an easy way to label the
*     axes for a standard graph drawn using one of the high level
*     plotting routines (e.g. PLOTYX or PLOTYI).  An example of a call
*     to this routine is as follows.
*
*       CALL PLTITL('Input','Volts','Output','mA')
*
*     This routine should be called AFTER the call to the plotting
*     routines if a non-standard position or size is specified in the
*     plotting routines.  The character size used is double the current
*     character size.
*
*
* Parameters:
* C ->  XLABEL - Character string containing the title for the X axis.
*                If XUNITS is null, this label is centered below the
*                axis.  Otherwise it is offset to allow room for the
*                units label.
* C ->  XUNITS - Character string containing the units for the X axis.
*                This label is placed to the right of the position
*                reserved for a power of ten multiplier on a labelled
*                axis.
* C ->  YLABEL - Character string containing the title for the Y axis.
*                If YUNITS is null, this label is centered below the
*                axis.  Otherwise it is offset to allow room for the
*                units label.
* C ->  YUNITS - Character string containing the units for the Y axis.
*                This label is placed above the position reserved for
*                a power of ten multiplier on a labelled axis.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:29 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLTITL (XLABEL, XUNITS, YLABEL, YUNITS)


      INTEGER IW,IH,IWN,IHN,LC,IX,IY
      INTEGER IXORIG,IYORIG,LENX,LENY

      REAL ANG

      CHARACTER*(*) XLABEL,XUNITS,YLABEL,YUNITS


* Get the character size and the graph position
      CALL GETCHR(IW,IH,ANG)
      CALL GETGRS(IXORIG,IYORIG,LENX,LENY)

* Notes:
* - At the double character size, 5 character positions are
*   allowed for in the units label
*   (the space required is 7*IW).
* - A space (double character size) takes up 1.5*IW.
* - The power of ten multiplier (for a three character exponent
*   (e.g. "-12") is of length 4.3125*IW.
* - The total space taken up (sum of above) is 12.8125*IW.
* - The remaining space is used to center the main label.

* Plot the X axis labels
      IWN=2*IW
      IHN=2*IH
      CALL SETCHR(IWN,IHN,0.0)
      IF (LEN(XUNITS).GT.0) THEN
        LC=NINT(12.8125*IWN)
      ELSE
        LC=0
      END IF
      IX=IXORIG+(LENX-LC)/2
      IY=IYORIG-NINT(2.333333333*IHN)
      CALL PLTEXT(IX,IY,5,XLABEL)

      IX=IXORIG+LENX-NINT(7.*IWN)
      CALL PLTEXT(IX,IY,2,XUNITS)

* Plot the Y axis labels
      CALL SETCHR(IWN,IHN,90.)
      IF (LEN(YUNITS).GT.0) THEN
        LC=NINT(12.8125*IWN)
      ELSE
        LC=0
      END IF
      IX=IXORIG-NINT(3.333333333*IHN)
      IY=IYORIG+(LENY-LC)/2
      CALL PLTEXT(IX,IY,3,YLABEL)

      IY=IYORIG+LENY-NINT(7.*IWN)
      CALL PLTEXT(IX,IY,0,YUNITS)

* Restore the character sizes
      CALL SETCHR(IW,IH,ANG)


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION GDELRP (H, NCOF, FLTTYP, SFREQ)
*
*
* Purpose:
*     Find the group response of a filter
*
*
* Description:
*     This routine calculates the group delay response of a filter
*     specified by its coefficients.
*
*     *** FIR or WIN:
*     For an FIR filter, the coefficients are the direct-form
*     coefficients, h(i)
*
*              N-1       -i
*       H(z) = SUM h(i) z    .
*              i=0
*
*     *** ALL:
*     For an all-pole IIR filter, the response is specified by the
*     direct-form feedback coefficients, h(i),
*
*               1                    N-1       -i
*       H(z) = ----  ,  where C(z) = SUM h(i) z    .
*              C(z)                  i=0
*
*     *** IIR:
*     For a general IIR filter, the response is specified in terms of
*     the coefficients of cascaded second order sections,
*
*              NSECT
*       H(z) = PROD H(k,z) .
*              k=1
*
*     Each second order section has a response defined by five
*     coefficients,
*
*               h(1,k)*z**2 + h(2,k)*z + h(3,k)
*      H(k,z) = -------------------------------  .
*                  z**2 + h(4,k)*z + h(k,5)
*
*     *** CAS:
*     For a cascade analog filter, the response is specified in terms
*     of the coefficients of cascaded second order sections,
*
*              NSECT
*       H(s) = PROD H(k,s) .
*              k=1
*
*     Each second order section has a response defined by five
*     coefficients,
*
*               h(1,k)*s**2 + h(2,k)*s + h(3,k)
*      H(k,s) = -------------------------------  .
*                  s**2 + h(4,k)*s + h(k,5)
*
*
*     The response is evaluated directly from the z-transform, with z
*     on the unit circle or from the Laplace transform with s on the
*     imaginary axis.
*
*
* Parameters:
* R <-  GDELRP - Output group delay value
*
* R ->  F      - Frequency at which the group delay is to be calculated
* R ->  H      - Array of filter coefficients.  For general IIR filters
*                and cascade analog filters, each group of 5
*                coefficients describes a second order section.
* I ->  NCOF   - Number of filter coefficients
* C ->  FLTTYP - Character string,
*                 ALL - all-pole filters
*                 CAS - cascade analog filters
*                 FIR - FIR filters
*                 IIR - IIR filters
*                 WIN - windows (same as FIR)
* R ->  SFREQ  - Sampling frequency
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:45:35 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION GDELRP (F, H, NCOF, FLTTYP, SFREQ)


      INTEGER NCOF
      INTEGER NSECT

      CHARACTER*(*) FLTTYP

      REAL F,SFREQ
      REAL H(0:NCOF-1)
      REAL GDLFIR,GDLIIR,GDLCAS


      IF (FLTTYP.EQ.'FIR' .OR. FLTTYP.EQ.'WIN') THEN

* FIR filters
        GDELRP=GDLFIR(F/SFREQ,H,NCOF)/SFREQ

      ELSE IF (FLTTYP.EQ.'ALL') THEN

* All-pole filter
        GDELRP=-GDLFIR(F/SFREQ,H,NCOF)/SFREQ

      ELSE IF (FLTTYP.EQ.'IIR') THEN

* General IIR filters
        IF (MOD(NCOF,5).NE.0)
     -    CALL HALT('GDELRP - Invalid number of coefficients')
        NSECT=NCOF/5
        GDELRP=GDLIIR(F/SFREQ,H,NSECT)/SFREQ

      ELSE IF (FLTTYP.EQ.'CAS') THEN

* Cascade analog filters
        IF (MOD(NCOF,5).NE.0)
     -    CALL HALT('GDELRP - Invalid number of coefficients')
        NSECT=NCOF/5
        GDELRP=GDLCAS(F,H,NSECT)

      ELSE

        CALL HALT('GDELRP - Invalid filter type')

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE FRRESP (X, Y, NPT, H, NCOF, FLTTYP, SFREQ, FUNCT)
*
*
* Purpose:
*     Set frequency response values for a filter
*
*
* Description:
*     This routine sets tye Y-array for a filter frequency response.
*     Initially, the values of the response corresponding to the
*     given frequency values are determined.  Then the extrema of the
*     response values are determined and the frequency values iterated
*     to better correspond to the extrema of the response.
*
*
* Parameters:
* R <-> X      - Abscissa samples.  On return the values corresponding
*                to extrema have been moved if necessary.
* R <-  Y      - Output array of response values
* I ->  NPT    - Number of abscissa and response values
* R ->  H      - Array of filter coefficients
* C ->  FLTTYP - Character string indicating the type of filter,
*                ALL - all-pole filter
*                CAS - cascade analog filter
*                FIR - finite impulse response filter
*                IIR - infinite impulse response filter
*                WIN - window response
* I ->  NCOF   - Number of filter coefficients
* R ->  SFREQ  - Sampling frequency
* F ->  FUNCT  - Name of the function to calculate the frequency
*                response value.  This function name must be declared
*                as EXTERNAL in the calling routine.  This routine is
*                called as
*                val = FUNCT(f,H,NCOF,FLTTYP,SFREQ),
*                where f is a frequency value.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:45:32 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE FRRESP (X, Y, NPT, H, NCOF, FLTTYP, SFREQ, FUNCT)


      INTEGER MXNEXT
      PARAMETER (MXNEXT=2001)

      CHARACTER*(*) FLTTYP

      INTEGER NPT,NCOF
      INTEGER I,NEXT,IP
      INTEGER IEXT(MXNEXT)

      REAL X(NPT),Y(NPT),H(0:NCOF-1)
      REAL SFREQ
      REAL XL,YL,XU,YU,XM,YM,XT,YT,AD,XDEL

      EXTERNAL FUNCT
      REAL FUNCT


* Fill in the array of frequency response values
      DO 100 I=1,NPT
        Y(I)=FUNCT(X(I),H,NCOF,FLTTYP,SFREQ)
 100  CONTINUE

* Find the extrema of the response values
      CALL LOCEXT (Y, NPT, MXNEXT,IEXT,NEXT)
      IF (NEXT.GT.MXNEXT) CALL HALT('FRRESP - Too many extrema')

* Refine the locations of the extrema
* For functions with many oscillations, the regular grid used to
* calculate the response may cause poor reproduction of the envelope
* of the response.  Here we iterate the frequencies corresponding to
* the local extrema found above to better align the frequency values
* with the true extremal points.  As a result, the maxima and minima of
* the response are better represented in the final plot.
      DO 300 I=1,NEXT
        IP=ABS(IEXT(I))
        IF (IP.NE.1 .AND. IP.NE.NPT) THEN

          XL=X(IP-1)
          YL=Y(IP-1)
          XU=X(IP+1)
          YU=Y(IP+1)
          XM=X(IP)
          YM=Y(IP)
          IF (IEXT(I).GT.0) THEN
            AD=+1.
          ELSE
            AD=-1.
          END IF

* Set the resolution of the refinement to be 10 times the original
* resolution.  This takes between 4 and 8 function evaluations for
* uniformly spaced abscissa values.
          XDEL=0.1*MIN(ABS(XU-XM),ABS(XM-XL))

 200      IF (MIN(ABS(XU-XM),ABS(XM-XL)).GE.XDEL) THEN

* Swap the end points so that YU is closer to the extremum than YL
            IF (AD*(YU-YL).LT.0.0) THEN
              YT=YU
              XT=XU
              YU=YL
              XU=XL
              YL=YT
              XL=XT
            END IF

* Try a step "up"
            XT=XM + 0.5*(XU-XM)
            YT=FUNCT(XT,H,NCOF,FLTTYP,SFREQ)
            IF (AD*(YT-YM).GT.0.0) THEN
              YL=YM
              XL=XM
              YM=YT
              XM=XT
            ELSE
              YU=YT
              XU=XT
              XT=XM - 0.5*(XM-XL)
              YT=FUNCT(XT,H,NCOF,FLTTYP,SFREQ)
              IF (AD*(YT-YM).GT.0.0) THEN
                YU=YM
                XU=XM
                YM=YT
                XM=XT
              ELSE
                YL=YT
                XL=XT
              END IF
            END IF

          GO TO 200
          END IF

          Y(IP)=YM
          X(IP)=XM

        END IF

 300  CONTINUE


      RETURN
      
      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION DMCINM (DXL, DXR, DYL, DYR)
*
*
* Purpose:
*     Calculate a derivative for a cubic at a middle point
*
*
* Description:
*     This routine calculates a derivative value that can be used to
*     generate piecewise monotone cubic hermite interpolants.  Consider
*     three points (xl,yl), (x0,y0) and (xr,yr), where xl < x0 < xr.
*     The derivative is calculated at the point (x0,y0).
*
*
* Parameters:
* R <-  DMCINM - Output derivative value at the reference point
*
* R ->  DXL    - Increment in abscissa value to the left of the
*                reference point (x0-xl, must be positive)
* R ->  DXR    - Increment in abscissa value to the right of the
*                reference point (xr-x0, must be positive)
* R ->  DYL    - Increment in ordinate value to the left (y0-yl)
* R ->  DYR    - Increment in ordinate value to the right (yr-y0)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:25:33 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION DMCINM (DXL, DXR, DYL, DYR)


      REAL DXL,DXR,DYL,DYR
      REAL SL,SR,SMAX,SMIN


* Check for increasing X values
      IF (DXL.LE.0.0 .OR. DXR.LE.0.0)
     -  CALL HALT('DMCINM - Abscissa values not in increasing order')


* SL is the slope to the left of point (x0,y0)
* SR is the slope to the right of point (x0,y0)
      SL=DYL/DXL
      SR=DYR/DXR

* Derivative is set to zero if slope changes sign
      IF ((SL.GT.0.0 .AND. SR.GT.0.0) .OR.
     -    (SL.LT.0.0 .AND. SR.LT.0.0)) THEN

* Slopes of the same sign
* Use Brodlie modification of Butland formula
*
*            Sl Sr                  1       xl-x0
*   d = --------------- , where a = - (1 + -------) .
*       a Sl + (1-a) Sr             3      xl - xr
*
* This formula gives the harmonic mean of the slopes when
* x0-xl=xr-x0. The factor a modifies the formula to take into
* account the relative spacing of the values (a varies from
* 1/3 to 2/3). This formula satisfies the properties
* (a) the formula is invariant to an exchange of the
*     the left and right points,
* (b) min(Sl,Sr) <= d <= max(Sl,Sr),
* (c) |d| <= 3 min(|Sl|,|Sr|). This is a sufficient condition
*     for monotonicity if d is calculated in this way for
*     neighboring points.
*
* The following calculation is designed to avoid overflows, but
* is equivalent to the above formula when Sl and Sr have the
* same sign.
        SMAX=MAX(ABS(SL),ABS(SR))
        SMIN=MIN(ABS(SL),ABS(SR))
        DMCINM=SMIN/( (DXL+DXR+DXR)/(3.*(DXL+DXR))*(SL/SMAX)
     -              + (DXL+DXR+DXL)/(3.*(DXL+DXR))*(SR/SMAX) )

* Slopes of opposite signs - force the derivative to zero to
* give a local maximum at the middle data point
      ELSE
        DMCINM=0.0

      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     LOGICAL FUNCTION TTYFNM (FNAME)
*
*
* Purpose:
*     Determine if a file is a terminal device
*
*
* Description:
*     This function determines if the given file name is a terminal.
*
*
* Parameters:
* L <-  TTYFUN - Returned logical value,
*                TRUE  - The file is a terminal
*                FALSE - The file is not a terminal
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:08:16 $
*
*
*-----------------------------------------------------------------------

      LOGICAL FUNCTION TTYFNM (FNAME)


      INTEGER LUN,NC
      INTEGER LENSTR

      CHARACTER*(*) FNAME

      LOGICAL EX
      LOGICAL TTYFUN


      NC=LENSTR(FNAME)
      INQUIRE (FILE=FNAME(1:NC),EXIST=EX)

      IF (EX) THEN
        CALL GETFUN(LUN)
        OPEN (UNIT=LUN,FILE=FNAME(1:NC),STATUS='OLD')
        TTYFNM=TTYFUN(LUN)
        CLOSE (UNIT=LUN)
        CALL RELFUN(LUN)
      ELSE
        TTYFNM=.FALSE.
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION DMCINE (DXR, DXRR, DYR, DYRR)
*
*
* Purpose:
*     Calculate a derivative for a cubic at an end point
*
*
* Description:
*     This routine calculates a derivative value that can be used to
*     generate piecewise monotone cubic hermite interpolants.  Consider
*     three points (x0,y0), (x1,y1) and (x2,y2), where x0 < x1 < x2.
*     The derivative is calculated at the point (x0,y0).
*
*
* Parameters:
* R <-  DMCINE - Output derivative value at the reference point
*
* R ->  DXR    - Increment in abscissa value to the right of the
*                reference point (x1-x0, must be positive)
* R ->  DXRR   - Increment in abscissa value to the far right of the
*                reference point (x2-x1, must be positive)
* R ->  DYR    - Increment in ordinate value to the right (y1-y0)
* R ->  DYRR   - Increment in ordinate value to the far right (y2-y1)
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:25:30 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION DMCINE (DXR, DXRR, DYR, DYRR)


      REAL DXR,DXRR,DYR,DYRR
      REAL SR,SRR


* Check for increasing X values
      IF (DXR.LT.0.0 .OR. DXRR.LT.0.0)
     -  CALL HALT('DMCINE - Abscissa values not in '//
     -            'increasing order')


* SR is the slope to the right of point 0
* SRR is the slope to the far right of point 0
      SR=DYR/DXR
      SRR=DYRR/DXRR

* Set the derivative using a non-centered three-point formula,
* adjusted to be shape-preserving
*
*                                        x1-x0
*   d = a Sr + (1-a) Srr , where a = 1 + ----- .
*                                        x2-x0
*
* The factor a modifies the formula to take into account the
* relative spacing of the values (a varies from 2 to 1). This
* value may have to be modified to preserve monotonicity.
      DMCINE=SR*((DXRR+DXR+DXR)/(DXRR+DXR))
     -     - SRR*(DXR/(DXRR+DXR))
      IF ((DMCINE.GE.0.0 .AND. SR.LE.0.0) .OR.
     -    (DMCINE.LE.0.0 .AND. SR.GE.0.0)) THEN
        DMCINE=0.0
      ELSE IF ((SR.GT.0.0 .AND. SRR.LT.0.0) .OR.
     -         (SR.LT.0.0 .AND. SRR.GT.0.0)) THEN
        IF (ABS(DMCINE).GT.ABS(3.*SR)) DMCINE=3.*SR
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE VTVECT (LUN, IX, IY, IVIS)
*
*
* Purpose:
*     Draw a vector on a ReGIS display
*
*
* Description:
*     This routine accepts a pair of X-Y coordinates as input.  A
*     string of ReGIS commands in constructed which is then sent to
*     the terminal.  The code used tries to compact the sequence of
*     commands by using shortened commands for vertical and horizontal
*     vectors.  This means that the previous position is stored
*     internally.  This previous position can be initialized at the
*     beginning of plotting by a call to VTVECT(LUN,0,0,0).
*
*
* Parameters:
* I ->  LUN    - Unit number for the terminal
* I ->  IX     - X coordinate, 0 to 799 inclusive
* I ->  IY     - Y coordinate, 0 to 479 inclusive
* I ->  IVIS   - Visibility flag,
*                0 - Draw a dark vector to the point indicated
*                1 - Draw a visible vector to the point indicated.  It
*                    is assumed that a dark vector has been drawn
*                    previously.
*
*
* Author / revision:
*     D. Sloan / P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:30:08 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE VTVECT (LUN, IX, IY, IVIS)


      INTEGER MAXLEN,MAXCOM
      PARAMETER (MAXLEN=10,MAXCOM=2*MAXLEN+6)

      INTEGER LUN,IX,IY,IVIS
      INTEGER N,NC
      INTEGER IXOLD,IYOLD,IVPT

      CHARACTER COMMDS*(MAXCOM)

      SAVE IXOLD,IYOLD,IVPT


* Initialize the context
      IF (IX.EQ.0 .AND. IY.EQ.0 .AND. IVIS.EQ.0) THEN
        IXOLD=-1
        IYOLD=-1
        IVPT=0
      END IF

* Position for IVIS=0 (dark), Vector for IVIS=1 (visible)
      IF (IVIS.EQ.0) THEN
        N=2
        COMMDS(1:2)='P['
        IVPT=0
      ELSE

* This code makes sure that the PEL at the start of the first segment
* of a series of visible vectors is turned on.
* Some (if not all) VT240's do not turn on the PEL corresponding to the
* start of a vector.  In this code, that PEL is turned on by drawing a
* vector from the current position to the current position.
        IF (IVPT.GT.0) THEN
          N=2
          COMMDS(1:2)='V['
        ELSE
          N=4
          COMMDS(1:4)='V[]['
        END IF
        IVPT=IVPT+1
      END IF


* Construct the coordinates
* Problems occur if the coordinate is negative, since a coordinate with
* an explicit sign invokes a relative move.  In that case, the correct
* relative move is used.
      IF (IX.NE.IXOLD) THEN
        IF (IX.GE.0) THEN
          CALL CONVIC(IX,COMMDS(N+1:),NC)
          N=N+NC
        ELSE IF (IX-IXOLD.LT.0) THEN
          CALL CONVIC(IX-IXOLD,COMMDS(N+1:),NC)
          N=N+NC
        ELSE
          N=N+1
          COMMDS(N:N)='+'
          CALL CONVIC(IX-IXOLD,COMMDS(N+1:),NC)
          N=N+NC
        END IF
        IXOLD=IX
      END IF

      N=N+1
      COMMDS(N:N)=','
      IF (IY.NE.IYOLD) THEN
        IF (IY.GE.0) THEN
          CALL CONVIC(IY,COMMDS(N+1:),NC)
          N=N+NC
        ELSE IF (IY-IYOLD.LT.0) THEN
          CALL CONVIC(IY-IYOLD,COMMDS(N+1:),NC)
          N=N+NC
        ELSE
          N=N+1
          COMMDS(N:N)='+'
          CALL CONVIC(IY-IYOLD,COMMDS(N+1:),NC)
          N=N+NC
        END IF
        IYOLD=IY
      END IF

      N=N+1
      COMMDS(N:N)=']'

* Send the buffer to the terminal
      WRITE (UNIT=LUN,FMT=1200) COMMDS(1:N)


      RETURN

 1200 FORMAT (A)

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PLEND
*
*
* Purpose:
*     Terminate a plot
*
*
* Description:
*     This subroutine terminates a plot initiated with the subroutine
*     PLINIT.
*
*
* Parameters:
*     None
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:28:12 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PLEND


* Plot device flags common area
      LOGICAL PS,TK,UN,VT
      COMMON /DEVCOM/ PS,TK,UN,VT


* Terminate plotting
      IF (PS) THEN
        CALL PSEND
        PS=.FALSE.
      END IF
      IF (TK) THEN
        CALL TKEND
        TK=.FALSE.
      END IF
      IF (UN) THEN
        CALL UNEND
        UN=.FALSE.
      END IF
      IF (VT) THEN
        CALL VTEND
        VT=.FALSE.
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE RQUOTE (LINE, STROUT, NC)
*
*
* Purpose:
*     Copy a string, removing outer quotes
*
*
* Description:
*     This routine processes a character string.  Leading and trailing
*     blanks, tabs and null characters are removed from the string.
*     Within quotes ("), any characters are permissible.  Any outer
*     paired quotes are removed. Two adjacent quote characters within
*     a quoted string are collapsed to become single quote character.
*
*
* Parameters:
* C ->  LINE   - Input string
* C <-  STROUT - Output string.  The output string is padded with
*                blanks.
* I <-  NC     - Number of characters in the output string, not
*                including padding blanks
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:38:06 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE RQUOTE (LINE, STROUT, NC)


      INTEGER NC
      INTEGER LS,K,I,L
      INTEGER LENSTR,LOCNBL

      LOGICAL INQUOT

      CHARACTER*(*) LINE,STROUT


* Initialization
      LS=LEN(STROUT)
      INQUOT=.FALSE.

* Skip over leading and trailing blanks, nulls and tabs
      K=LENSTR(LINE)
      I=LOCNBL(LINE(1:K))

* If the whole string is within quotes, strip off outer quotes
      IF (I.LT.K) THEN
        IF (LINE(I:I).EQ.'"' .AND. LINE(K:K).EQ.'"') THEN
          K=K-1
          I=I+1
          INQUOT=.TRUE.
        END IF
      END IF

      IF (INQUOT) THEN

* Collapse adjacent pairs of quote characters within a quoted string
        NC=0
 100    IF (I.LE.K) THEN
          L=INDEX(LINE(I:K),'""')+I-1
          IF (L.EQ.I-1) L=K
          IF (NC.LT.LS) STROUT(NC+1:)=LINE(I:L)
          NC=NC+L-I+1
          I=L+2
        GO TO 100
        END IF

      ELSE

* Copy the string directly to the output string
        NC=K-I+1
        IF (NC.GT.0) STROUT=LINE(I:K)

      END IF

* Check the string length
      IF (NC.LE.0) THEN
        STROUT=' '
      ELSE IF (NC.GT.LS) THEN
        CALL HALT('RQUOTE - String truncated')
        NC=LS
      END IF


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     REAL FUNCTION GDLSEC (B2, B1, B0, COSW, SINW)
*
*
* Purpose:
*     Find the group delay for a quadratic function
*
*
* Description:
*     This function calculates the group delay for a quadratic function
*     of the form,
*
*       B(z) = b2*z**2 + b1*z + b0 .
*
*     If the function is evaluated on the unit circle with z=exp(jw),
*
*       B(w) = exp(jw) [ (b2+b0)*cosw + b1 + j(b2-b0)*sinw ] .
*
*     The group delay is the negative derivative with respect to w of
*     the phase angle of this function.  If the polynomial has zero
*     coefficients, the group delay is set to zero.  Note that since
*     the polynomial is a function of positive powers of z, where z
*     can be interpreted to be a time advance of -1 samples, the group
*     delay is generally a negative value.
*
*
* Parameters:
* R <-  GDLSEC - Group delay in samples
*
* R ->  B2     - First polynomial coefficient
* R ->  B1     - Second polynomial coefficient
* R ->  B0     - Third polynomial coefficient
* R ->  COSW   - Cosine of the normalized angular frequency
* R ->  SINW   - Sine of the normalized angular frequency
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.3 $  $Date: 1995/03/08 15:22:29 $
*
*
*-----------------------------------------------------------------------

      REAL FUNCTION GDLSEC (B2, B1, B0, COSW, SINW)


      REAL B2,B1,B0,COSW,SINW
      REAL RW,RPW,XW,XPW


* The polynomial is
*   B(z) = b2*z**2 + b1*z + b0
* On the unit circle, z=exp(jw), express the function as
*   B(w) = R(w) + jX(w),
* where
*
*       B(w) = exp(jw) [ (b2+b0)cosw + b1 + j (b2-b0)sinw ]
*
* The exponential term adds a delay of -1 sample.  Neglecting this
* exponential term,
*       R(w)  = b1 + (b2+b0)cosw
*       X(w)  = (b2-b0)sinw
* The group delay is
*
*               d arctan(X(w)/R(w))      X'(w)R(w)-R'(w)X(w)
*     Td(w) = - -------------------  = - ------------------- ,
*                d w                      R(w)**2 + X(w)**2
*
* where X'(w) is the derivative of X(w) and R'(w) is the derivative of
* R(w),
*       R'(w) = -(b2+b0)sinw
*       X'(w) = (b2-b0)cosw

* Roots on the unit circle present computational problems.  It can be
* verified that the group delay is continuous through the roots.  For
* that reason, the following code detects roots on the unit circle and
* handles them as special cases.  For instance conjugate roots give
* rise to a symmetrical polynomial, which has a constant group delay.
* For values near but not on the roots, numerical problems can still
* occur.

* The behaviour of the group delay for roots near the unit circle, but
* not on it is very different.  In this case the group delay can be
* very large.  Consider B(z) = (1+e) z**2 + 1.  The group delay for
* w=pi, works out to be -1 - (2+e)/e .

* Symmetric polynomial
* - includes the case with conjugate roots on the unit circle
      IF (B2.EQ.B0) THEN
        IF (B2.EQ.0.0 .AND. B1.EQ.0.0) THEN
          GDLSEC=0.0
        ELSE
          GDLSEC=-1.0
        END IF

* Root at z=1 (delay -0.5)
* - also handles the case of roots at both z=1 and z=-1 (b1=0)
* - the remaining polynomial is b2*z + b0
      ELSE IF (B2+B0.EQ.B1) THEN
        IF (B1.EQ.0.0) THEN
          GDLSEC=-1.0
        ELSE
          RW=B2+B0*COSW
          RPW=-B0*SINW
          XW=-B0*SINW
          XPW=-B0*COSW
          GDLSEC=-1.5-(XPW*RW - RPW*XW)/(RW**2 + XW**2)
        END IF

* Root at z=-1 (delay -0.5)
* - remaining polynomial is b2*z - b0
      ELSE IF (B2+B0.EQ.-B1) THEN
        RW=B2-B0*COSW
        RPW=B0*SINW
        XW=B0*SINW
        XPW=B0*COSW
        GDLSEC=-1.5-(XPW*RW - RPW*XW)/(RW**2 + XW**2)

* General case (no unit circle zeros)
      ELSE
        RW=B1+(B2+B0)*COSW
        RPW=-(B2+B0)*SINW
        XW=(B2-B0)*SINW
        XPW=(B2-B0)*COSW
        GDLSEC=-1.0-(XPW*RW - RPW*XW)/(RW**2 + XW**2)

      END IF

      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE PRFILE (FNAME, PRINTR, DELFLG)
*
*
* Purpose:
*     Print a file (optionally delete the file)
*
*
* Description:
*     This routine prints a file.  The printer to be used can be
*     selected.  Optionally, the file is deleted after printing.  This
*     routine executes the command "pr [-r] [-P printer] filename".
*     The printer selection "-P printer" is only used if the parameter
*     PRINTR is not blank.  The "-r" option is placed in the command
*     line if DELFLG is .TRUE. .
*
*
* Parameters:
* C ->  FNAME  - File name for file to be printed
* C ->  PRINTR - Printer to be used.  If this string is blank, the
*                default printer is selected.
* L ->  DELFLG - Logical variable.  If .TRUE. delete the file when it
*                has been printed.
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.5 $  $Date: 1995/03/08 15:07:58 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE PRFILE (FNAME, PRINTR, DELFLG)


      INTEGER MXLINE
      PARAMETER (MXLINE=1024)

      INTEGER NL,NC,NT
      INTEGER LENSTR

      LOGICAL DELFLG

      CHARACTER*(*) FNAME,PRINTR
      CHARACTER*(MXLINE) LINE


* Insert the verb
      LINE(1:4)='lpr '
      NL=4
      IF (DELFLG) THEN
        LINE(NL+1:NL+3)='-r '
        NL=NL+3
      END IF

* Insert the printer
      NC=LENSTR(PRINTR)
      IF (NC.GT.0) THEN
        LINE(NL+1:NL+3)='-P '
        NL=NL+3
        CALL STTRIM(PRINTR(1:NC),LINE(NL+1:),NT)
        NL=NL+NT
        IF (NL.GE.MXLINE) CALL HALT('PRFILE - String truncated')
        LINE(NL+1:NL+1)=' '
        NL=NL+1
      END IF

* Insert the file name
      CALL STTRIM(FNAME,LINE(NL+1:),NC)
      NL=NL+NC

* Execute the print command
      CALL SYSTEM(LINE(1:NL))


      RETURN

      END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE IMPLRP (H, NCOF, FLTTYP, IST, Y, NPT)
*
*
* Purpose:
*     Find the impulse response of a filter
*
*
* Description:
*     This routine calculates the impulse response of an FIR or IIR
*     filter specified by its coefficients.
*
*     *** FIR or WIN:
*     For an FIR filter, the coefficients are the direct-form
*     coefficients, h(i)
*
*              N-1       -i
*       H(z) = SUM h(i) z    .
*              i=0
*
*     *** ALL:
*     For an all-pole IIR filter, the response is specified by the
*     direct-form feedback coefficients, h(i),
*
*               1                    N-1       -i
*       H(z) = ----  ,  where C(z) = SUM h(i) z    .
*              C(z)                  i=0
*
*     Normally, the first coefficient is unity, i.e. h(0)=1.  A
*     non-unity value will result in a gain scaling of the response.
*
*     *** IIR:
*     For a general IIR filter, the response is specified in terms of
*     the coefficients of cascaded second order sections,
*
*              NSECT
*       H(z) = PROD H(k,z) .
*              k=1
*
*     Each second order section has a response defined by five
*     coefficients,
*
*               h(1,k)*z**2 + h(2,k)*z + h(3,k)
*      H(k,z) = -------------------------------  .
*                  z**2 + h(4,k)*z + h(k,5)
*
*
* Parameters:
* R ->  H      - Array of filter coefficients.  For IIR filters, each
*                group of 5 coefficients describes a second order
*                section.
* I ->  NCOF   - Number of filter coefficients.
* C ->  FLTTYP - Character string,
*                 ALL - all-pole filters
*                 FIR - FIR filters
*                 IIR - IIR filters
*                 WIN - windows (same as FIR)
* I ->  IST    - Starting impulse response coefficient, with IST=0
*                corresponding to time zero
* R <-  Y      - Output array of impulse response values
* I ->  NPT    - Number of impulse response values
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.6 $  $Date: 1995/03/08 15:46:09 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE IMPLRP (H, NCOF, FLTTYP, IST, Y, NPT)


      INTEGER NTMP
      PARAMETER (NTMP=2000)

      INTEGER NCOF,IST,NPT
      INTEGER I,K,NMEM,NSBLK,N,ISY,IFS,NSECT

      CHARACTER*(*) FLTTYP

      REAL H(0:NCOF-1),Y(0:NPT-1)
      REAL VAL
      REAL TMP(NTMP)


      IF (FLTTYP.EQ.'FIR' .OR.  FLTTYP.EQ.'WIN') THEN

* FIR filters:
*   Copy over the impulse response
        DO 100 I=0,NPT-1
          K=I+IST
          IF (K.GE.0 .AND. K.LT.NCOF) THEN
            Y(I)=H(K)
          ELSE
            Y(I)=0.0
          END IF
 100    CONTINUE

      ELSE IF (FLTTYP.EQ.'ALL') THEN


* All-pole filter:
        NMEM=NCOF-1
        NSBLK=NTMP-NMEM
        IF (NSBLK.LE.0)
     -      CALL HALT('IMPLRP - Too many filter coefficients')

*   Calculate the impulse response
*   IST - First impulse sample number H(IST) <=> Y(0)
*   IFS - Last impulse sample number H(IFS) <=> Y(NPT-1)

* Impulse response for I from -IST to -1 is zero.
        N=MIN(-IST,NPT)
        IF (N.LT.0) N=0
        CALL VZERO(Y,N)
        ISY=N

* Filter a unit pulse.  This is done in two parts: I from 0 to IST-1
* and then I from IST to IFN.  Depending on the value of IST, either
* or both of the two loops may not be executed.
        CALL VZERO(TMP,NMEM)
        VAL=1.0
        N=0
        DO 200 I=0,IST-1,NSBLK
          CALL VSHIFT(TMP,NMEM,N)
          N=MIN((IST-1)-I+1,NSBLK)
          CALL VZERO(TMP(NMEM+1),N)
          TMP(NMEM+1)=VAL
          CALL FLTALL(TMP,N,H,NCOF)
          VAL=0.0
 200    CONTINUE

        IFS=IST+NPT-1
        DO 220 I=MAX(0,IST),IFS,NSBLK
          CALL VSHIFT(TMP,NMEM,N)
          N=MIN(IFS-I+1,NSBLK)
          CALL VZERO(TMP(NMEM+1),N)
          TMP(NMEM+1)=VAL
          CALL FLTALL(TMP,N,H,NCOF)
          CALL VCOPY(TMP(NMEM+1),Y(ISY),N)
          ISY=ISY+N
          VAL=0.0
 220    CONTINUE


      ELSE IF (FLTTYP.EQ.'IIR') THEN

* General IIR filters
        IF (MOD(NCOF,5).NE.0)
     -      CALL HALT('IMPLRP - Invalid number of coefficients')
        NSECT=NCOF/5
        NMEM=2*(NSECT+1)
        NSBLK=NTMP-NMEM
        IF (NSBLK.LE.0)
     -      CALL HALT('IMPLRP - Too many filter coefficients')

*   Calculate the impulse response
*   IST - First impulse sample number H(IST) <=> Y(0)
*   IFS - Last impulse sample number H(IFS) <=> Y(NPT-1)

* Impulse response for I from -IST to -1 is zero.
        N=MIN(-IST,NPT)
        IF (N.LT.0) N=0
        CALL VZERO(Y,N)
        ISY=N

* Filter a unit pulse.  This is done in two parts: I from 0 to IST-1
* and then I from IST to IFN.  Depending on the value of IST, either
* or both of the two loops may not be executed.
        CALL VZERO(TMP,NMEM)
        VAL=1.0
        N=0
        DO 300 I=0,IST-1,NSBLK
          CALL VSHIFT(TMP,NMEM,N)
          N=MIN((IST-1)-I+1,NSBLK)
          CALL VZERO(TMP(NMEM+1),N)
          TMP(NMEM+1)=VAL
          CALL FLTIIR(TMP,N,H,NSECT)
          VAL=0.0
 300    CONTINUE

        IFS=IST+NPT-1
        DO 320 I=MAX(0,IST),IFS,NSBLK
          CALL VSHIFT(TMP,NMEM,N)
          N=MIN(IFS-I+1,NSBLK)
          CALL VZERO(TMP(NMEM+1),N)
          TMP(NMEM+1)=VAL
          CALL FLTIIR(TMP,N,H,NSECT)
          CALL VCOPY(TMP(3),Y(ISY),N)
          ISY=ISY+N
          VAL=0.0
 320    CONTINUE

      ELSE

        CALL HALT('IMPLRP - Invalid filter type')

      END IF


      RETURN

      END

*---------------------------INRS-Telecommunications---------------------------
*
*
* MODULE:
*	SUBROUTINE LINEIN (PROMPT, LINE, NCHR, IEOF)
*
*
* PURPOSE:
*	This subroutine retrieves a line of input.
*
*
* DESCRIPTION:
*	This subroutine reads lines of input. A prompt message is also
*	printed if the standard input is associated with a terminal.
*
*
* PARAMETERS:
* C ->	PROMPT - Character string used as a prompt
* C <-	LINE   - Character string for the input line. If the length of
*	         LINE is insufficient for input line, the input line
*	         is truncated. For input lines shorter than the length
*	         of LINE, LINE is padded out with blanks.
* I <-	NCHR   - Number of characters in the line. NCHR is set to 0 on
*	         reaching end-of-file.
* I <-	IEOF   - End-of-file flag,
*	          0  - Normal value
*	         -1  - End-of-file
*
*
* ROUTINES REQUIRED:
*	LIB$GET_INPUT - System routine to prompt and read a line
*	PSYMSG - Print a system message
*
*
* AUTHOR / MAINTAINED BY:
*	P. Kabal
*
*
* DATE CREATED:
*	1987/11/23
*
*
* UPDATES:
*	1988/08/09  VAX/VMS version
*
*
*---------------------------INRS-Telecommunications---------------------------

	SUBROUTINE LINEIN (PROMPT, LINE, NCHR, IEOF)


	CHARACTER*(*) PROMPT,LINE

	INTEGER*2 LLEN

	EXTERNAL RMS$_EOF


* Write a prompt if the input is from a terminal
	ISTAT=LIB$GET_INPUT(LINE,PROMPT,LLEN)
	NCHR=LLEN

* Check the error status
	IF (ISTAT.EQ.%LOC(RMS$_EOF)) THEN
	  IEOF=-1
	  NCHR=0
	ELSE
	  IEOF=0
	  IF (.NOT.ISTAT) CALL PSYMSG(ISTAT)
	END IF


	RETURN

	END

*------------- Telecommunications & Signal Processing Lab --------------
*                          McGill University
*
*
* Module:
*     SUBROUTINE WARN (STRING)
*
*
* Purpose:
*     Print a warning message on the standard error unit
*
*
* Description:
*     This routine prints on the standard error unit.
*
*
* Parameters:
* C ->  STRING - Character string to be printed
*
*
* Author / revision:
*     P. Kabal
*     $Revision: 1.4 $  $Date: 1995/03/08 15:44:15 $
*
*
*-----------------------------------------------------------------------

      SUBROUTINE WARN (STRING)


      CHARACTER*(*) STRING


* Print the message text to the standard error unit
* (Assume that the standard error unit does not use Fortran
* carriage control)
      WRITE (UNIT=0,FMT=1000) STRING


      RETURN

 1000 FORMAT (A)

      END
